# ------------------------------------------------------------------------------
#
# Converter Descriptions
#
# ------------------------------------------------------------------------------
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#


regex(.*\.cpp$)    -except

# -------------------------------------------------------------------------------------
# Errors and messages:
# -------------------------------------------------------------------------------------

Converter_Messages.genmsg           ascii

Converter_Messages.hpp              inc=SAPDBErr_MessageList.hpp

Converter_Exception.hpp             inc=SAPDBErr_MessageList.hpp


Converter_MapError.hpp             inc=Converter_Exception.hpp,\
                                       SAPDB_ToString.hpp,\
                                       Converter_Types.hpp,\
                                       Data_Types.hpp,\
                                       Converter_Messages.hpp

# -------------------------------------------------------------------------------------
# Interfaces and basic types:
# -------------------------------------------------------------------------------------
#
Converter_Types.hpp                 inc=Kernel_Common.hpp,\
                                        SAPDB_EnhancedTypes.hpp,\
                                        SAPDBDiag_CheckTopic.hpp,\
                                        SAPDBTrace_Topic.hpp,\
                                        SAPDBTrace_Stream.hpp

Converter_ICommon.hpp               inc=gsp00,\
                                        ggg00,\
                                        Converter_Types.hpp,\
                                        Data_Types.hpp

Converter_IDump.hpp                 inc=gsp00,\
                                        Kernel_Common.hpp,\
                                        Kernel_Dump.hpp

Converter_IPageNoMapping.hpp        inc=ggg00,\
                                        Converter_Types.hpp,\
                                        SAPDB_Types.hpp,\
                                        Data_Types.hpp,\
                                        IOMan_BlockAddress.hpp

Converter_IPageNoManager.hpp        inc=ggg00,\
                                        SAPDB_Types.hpp,\
                                        Data_Types.hpp

Converter_Entry.hpp                 inc=Converter_Types.hpp,\
                                        Converter_PageFrameAllocator.hpp

Converter_Chain.hpp                 inc=SAPDB_Types.hpp

Converter_ParentReference.hpp       inc=Converter_Types.hpp

Converter_ISavePoint.hpp            inc=gsp00,\
                                        Converter_Types.hpp,\
                                        IOMan_BlockAddress.hpp

Converter_IBackUp.hpp               inc=gsp00,ggg00,\
                                        Data_Types.hpp,\
                                        IOMan_BlockAddress.hpp,\
                                        Converter_UsedPageNoContainer.hpp,\
                                        Converter_BitMapPage.hpp

Converter_IEvent.hpp                inc=Kernel_Event.hpp

Converter_IManager.hpp              inc=+gsp00,\
                                        ggg00,\
                                        Converter_Types.hpp,\
                                        Data_Types.hpp,\
                                        IOMan_BlockAddress.hpp,\
                                        IOMan_Types.hpp,\
                                        Kernel_Common.hpp

Converter_IMigration.hpp            inc=gsp00,\
                                        Data_Types.hpp,\
                                        IOMan_BlockAddress.hpp,\

# -------------------------------------------------------------------------------------
# Manager and Config:
# -------------------------------------------------------------------------------------
#
Converter_Configuration.hpp         inc=Kernel_Configuration.hpp,\
                                        IOMan_BlockAddress.hpp,\
                                        SAPDBMem_IRawAllocator.hpp,\
                                        SAPDBMem_IBlockAllocator.hpp,\
                                        Converter_Types.hpp


Converter_IVerify.hpp               inc=Data_Types.hpp


Converter_Converter.hpp             inc=Converter_ICommon.hpp,\
                                        Converter_IDump.hpp,\
                                        Converter_IPageIO.hpp,\
                                        Converter_IBackUp.hpp,\
                                        Converter_ISavePoint.hpp,\
                                        Converter_IPageNoManager.hpp,\
                                        Converter_IPageNoMapping.hpp,\
                                        Converter_IManager.hpp,\
                                        Converter_IMigration.hpp,\
                                        Converter_IVerify.hpp,\
                                        Converter_IEvent.hpp,\
                                        Converter_Index.hpp,\
                                        Converter_MapControl.hpp,\
                                        Converter_TempMapControl.hpp,\
                                        Converter_PermMapControl.hpp,\
                                        Converter_PermStaticMapControl.hpp,\
                                        Converter_Types.hpp,\
                                        Converter_WaitQueue.hpp,\
                                        Converter_PageFrameAllocator.hpp,\
                                        IOMan_BlockAddress.hpp,\
                                        IOMan_Types.hpp,\
                                        RTEMem_AllocatorWrapper.hpp,\
                                        RTESync_InterlockedCounter.hpp,\
                                        SAPDBMem_IRawAllocator.hpp,\
                                        Data_Types.hpp,\
                                        Kernel_Event.hpp

Converter_Converter.cpp             inc=hgg01.h,\
                                        hbd20_6.h,\
                                        hbd91.h,\
                                        Converter_Converter.hpp,\
                                        Converter_Dump.hpp,\
                                        Converter_LeafPage.hpp,\
                                        Converter_BlockAddressIterator.hpp,\
                                        Pager_IRestart.hpp,\
                                        Pager_ISavepoint.hpp,\
                                        FBM_Manager.hpp,\
                                        IOMan_IDataInfo.hpp,\
                                        IOMan_IConverterIO.hpp,\
                                        Log_Types.hpp,\
                                        Log_Savepoint.hpp,\
                                        RTE_Crash.hpp,\
                                        RTE_Message.hpp,\
                                        Converter_Exception.hpp,\
                                        Converter_Messages.hpp \
&if $OSSPEC = LINUX #PTS 1110600
nodebug
&endif

# -------------------------------------------------------------------------------------
# Page Types:
# -------------------------------------------------------------------------------------
#
Converter_Page.hpp                  inc=Data_Types.hpp,\
                                        IOMan_BlockAddress.hpp,\
                                        Kernel_Page74.hpp,\
                                        Converter_Types.hpp,\
                                        Converter_ParentReference.hpp,\
                                        Converter_FlagInfo.hpp

Converter_Page.cpp                  inc=Converter_Page.hpp,\
                                        Converter_Messages.hpp,\
                                        Converter_Exception.hpp,\
                                        RTE_Message.hpp,\
                                        RTE_Crash.hpp

Converter_IndexPage.hpp             inc=Converter_Page.hpp
Converter_IndexPage.cpp             inc=Converter_IndexPage.hpp

Converter_LeafPage.hpp              inc=Converter_Page.hpp,\
                                        SAPDBFields_Field.hpp
Converter_LeafPage.cpp              inc=Converter_LeafPage.hpp,\
                                        Converter_BlockAddressIterator.hpp,\
                                        Converter_Messages.hpp,\
                                        Converter_Exception.hpp,\
                                        RTE_Message.hpp

Converter_BlockAddressIterator.cpp  inc=Converter_BlockAddressIterator.hpp

Converter_BlockAddressIterator.hpp  inc=IOMan_IBlockAddressIterator.hpp,\
                                        IOMan_BlockAddress.hpp,\
                                        Converter_LeafPage.hpp


Converter_BitMapPage.hpp            inc=SAPDB_BitOperations.hpp,\
                                        Kernel_Page74.hpp,\
                                        Data_Types.hpp,\
                                        Converter_Types.hpp

# used for data base migration from 7.2/7.3 to 7.4

Converter_Page72.hpp                inc=Data_Types.hpp,\
                                        Kernel_Page72.hpp,\
                                        Kernel_Common.hpp,\
                                        IOMan_BlockAddress.hpp

Converter_Page72.cpp                inc=ggg00,\
                                        hgg01_3.h,\
                                        Converter_Types.hpp,\
                                        Converter_Page72.hpp,\
                                        Converter_Messages.hpp,\
                                        Converter_Exception.hpp,\
                                        RTE_Message.hpp,\
                                        SAPDB_ToString.hpp

# -------------------------------------------------------------------------------------
# Map:
# -------------------------------------------------------------------------------------
#
Converter_Map.hpp                   inc=Container_Vector.hpp,\
                                        Converter_BitMapPage.hpp,\
                                        Converter_Chain.hpp,\
                                        Converter_MapEntry.hpp,\
                                        Converter_PageFrameAllocator.hpp,\
                                        Converter_PermMapSection.hpp

Converter_Map.cpp                   inc=Converter_Dump.hpp,\
                                        Converter_LeafPage.hpp,\
                                        Converter_Exception.hpp,\
                                        Converter_Messages.hpp,\
                                        Converter_Map.hpp,\
                                        Converter_FlagInfo.hpp,\
                                        Converter_MapSection.hpp,\
                                        Converter_PermMapSection.hpp,\
                                        FBM_Manager.hpp,\
                                        Kernel_FileIO.hpp,\
                                        Kernel_Dump.hpp,\
                                        RTE_Crash.hpp

Converter_MapEntry.hpp              inc=Converter_Chain.hpp,\
                                        Converter_Entry.hpp,\
                                        Converter_LeafPage.hpp,\
                                        Converter_PageFrameAllocator.hpp

# -------------------------------------------------------------------------------------
# MapControl:
# -------------------------------------------------------------------------------------

Converter_MapControl.hpp            inc=gsp00,\
                                        Converter_Map.hpp,\
                                        Converter_MapSectionData.hpp,\
                                        Container_Vector.hpp,\
                                        Kernel_Common.hpp

Converter_MapControl.cpp            inc=Converter_MapControl.hpp,\
                                        Converter_MapSection.hpp,\
                                        Converter_Dump.hpp,\
                                        Kernel_Dump.hpp

Converter_TempMapControl.hpp        inc=gsp00,\
                                        Converter_MapControl.hpp

Converter_TempMapControl.cpp        inc=Converter_TempMapControl.hpp,\
                                        Converter_TempMapControl.hpp,\
                                        Converter_Map.hpp,\
                                        Converter_MapError.hpp,\
                                        Converter_MapSection.hpp,\
                                        Data_Types.hpp,\
                                        FBM_Manager.hpp,\
                                        RTE_Crash.hpp

Converter_PermMapControl.hpp        inc=gsp00,\
                                        Converter_MapControl.hpp,\
                                        Converter_UsedPageNoContainer.hpp,\
                                        Converter_BackUpPageNoContainer.hpp,\
                                        Converter_Map.hpp,\
                                        Converter_PermMapSectionData.hpp,\
                                        Converter_WaitQueue.hpp,\
                                        Container_Vector.hpp,\
                                        Kernel_Common.hpp,\
                                        RTESync_InterlockedCounter.hpp

Converter_PermMapControl.cpp        inc=Converter_PermMapControl.hpp,\
                                        Converter_BitMapPage.hpp,\
                                        Converter_LeafPage.hpp,\
                                        Converter_Index.hpp,\
                                        Converter_WaitQueue.hpp,\
                                        Converter/Converter_Exception.hpp,\
                                        Converter_MapError.hpp,\
                                        Converter_Messages.hpp,\
                                        Converter_PermMapSection.hpp,\
                                        Data_Types.hpp,\
                                        FBM_Manager.hpp,\
                                        Kernel_Dump.hpp,\
                                        IOMan_BlockAddress.hpp,\
                                        IOMan_IConverterIO.hpp,\
                                        RTE_Crash.hpp,\
                                        RTE_Message.hpp \
&if $OSSPEC = LINUX #PTS 1110600
nodebug
&endif
&if $OSSPEC = WIN32 and not defined BIT64 and $_MSC_VER = 12
-IGNORE=C4786
&endif

Converter_PermStaticMapControl.hpp  inc=gsp00,\
                                        Converter_PermMapControl.hpp,\
                                        Converter_WaitQueue.hpp,\
                                        Kernel_Common.hpp

Converter_PermStaticMapControl.cpp  inc=Converter_PermStaticMapControl.hpp,\
                                        Converter_Exception.hpp,\
                                        Converter_MapError.hpp,\
                                        Converter_Messages.hpp,\
                                        Converter_Map.hpp,\
                                        Converter_PermMapSection.hpp,\
                                        IOMan_IConverterIO.hpp,\
                                        DataAccess/Data_Types.hpp,\
                                        RTE_Crash.hpp,\
                                        RTE_Message.hpp
# -------------------------------------------------------------------------------------
# MapSection/Data:
# -------------------------------------------------------------------------------------

Converter_MapSectionData.hpp        inc=gsp00,\
                                        Converter_Types.hpp,\
                                        Converter_Chain.hpp,\
                                        Converter_Dump.hpp,\
                                        Converter_MapEntry.hpp,\
                                        Container_Vector.hpp

Converter_MapSectionData.cpp        inc=Converter_MapSectionData.hpp,\
                                        Converter_Map.hpp

Converter_PermMapSectionData.hpp    inc=Converter_Types.hpp,\
                                        Converter_Chain.hpp,\
                                        Converter_Dump.hpp,\
                                        Converter_PageNoContainer.hpp,\
                                        Converter_ParentReference.hpp,\
                                        Container_Vector.hpp,\
                                        RTESync_InterlockedCounter.hpp

Converter_PermMapSectionData.cpp    inc=Converter_PermMapSectionData.hpp,\
                                        Converter_Map.hpp

Converter_MapSection.hpp            inc=gsp00,\
                                        Converter_Types.hpp,\
                                        Converter_MapSectionData.hpp

Converter_MapSection.cpp            inc=heo51.h,\
                                        heo55k.h,\
                                        Converter_MapSection.hpp,\
                                        Converter_Map.hpp


Converter_PermMapSection.hpp        inc=gsp00,\
                                        Converter_Types.hpp,\
                                        Converter_Chain.hpp,\
                                        Converter_MapSection.hpp,\
                                        Converter_MapSectionData.hpp,\
                                        Converter_PermMapSectionData.hpp,\
                                        Container_Vector.hpp

Converter_PermMapSection.cpp        inc=Converter_PermMapSection.hpp,\
                                        Converter_Map.hpp

# -------------------------------------------------------------------------------------
# Index:
# -------------------------------------------------------------------------------------
#

Converter_IndexEntry.hpp            inc=Converter_Entry.hpp,\
                                        Converter_IndexPage.hpp

Converter_Index.hpp                 inc=Container_Vector.hpp,\
                                        Container_SortableVector.hpp,\
                                        Converter_Chain.hpp,\
                                        Converter_IndexEntry.hpp,\
                                        Converter_LeafPage.hpp,\
                                        Converter_PageFrameAllocator.hpp,\
                                        Converter_LeafReference.hpp,\
                                        Kernel_Dump.hpp

Converter_Index.cpp                 inc=hgg01.h,\
                                        Converter_Lock.hpp,\
                                        Converter_Dump.hpp,\
                                        Converter_Index.hpp,\
                                        Converter_Exception.hpp,\
                                        Converter_Messages.hpp,\
                                        FBM_Manager.hpp,\
                                        IOMan_IDataInfo.hpp,\
                                        IOMan_IConverterIO.hpp,\
                                        RTE_Message.hpp,\
                                        RTE_Crash.hpp

Converter_LeafReference.hpp         inc=IOMan_BlockAddress.hpp,\
                                        Converter_ParentReference.hpp
                                        
Converter_Lock.cpp                  inc=Converter_Lock.hpp,\
                                        heo55k.h,\
                                        hgg08.h

Converter_Lock.hpp                  inc=gsp00


# -------------------------------------------------------------------------------------
# Utility structures:
# -------------------------------------------------------------------------------------
#
Converter_PageNoContainer.hpp       inc=Data_Types.hpp,\
                                        Container_Vector.hpp

Converter_BackUpPageNoContainer.hpp inc=Data_Types.hpp,\
                                        Converter_Types.hpp,\
                                        Container_Vector.hpp,\
                                        Converter_FlagInfo.hpp,\
                                        RTESync_InterlockedCounter.hpp

Converter_BackUpPageNoContainer.cpp inc=Converter_BackUpPageNoContainer.hpp,\
                                        Converter_Exception.hpp,\
                                        Converter_Messages.hpp,\
                                        RTE_Message.hpp

Converter_UsedPageNoContainer.hpp   inc=Data_Types.hpp,\
                                        Container_Vector.hpp,\
                                        Converter_Types.hpp,\
                                        Converter_BitMapPage.hpp,\
                                        Converter_LeafPage.hpp,\
                                        Converter_PageFrameAllocator.hpp

Converter_UsedPageNoContainer.cpp   inc=Converter_UsedPageNoContainer.hpp

Converter_PageFrameAllocator.hpp    inc=gsp00,\
                                        Kernel_IPage.hpp,\
                                        Kernel_Common.hpp

Converter_PageFrameAllocator.cpp    inc=heo51.h,\
                                        Converter_PageFrameAllocator.hpp,\
                                        Converter_Converter.hpp,\
                                        FrameCtrl_IConverter.hpp


Converter_WaitQueue.hpp             inc=gsp00,\
                                        ggg00,\
                                        heo56.h,\
                                        Kernel_WaitQueue.hpp

Converter_Dump.hpp                  inc=SAPDB_Types.hpp

Converter_FlagInfo.hpp              inc=Data_Types.hpp 

Converter_FlagInfo.cpp              inc=Converter_FlagInfo.hpp

# -------------------------------------------------------------------------------------
# Interface to old pascal modules
# -------------------------------------------------------------------------------------
Converter_PascalInterface.cpp        inc=ggg00,\
                                         gbd00,\
                                         hbd10.h,\
                                         hgg01.h,\
                                         hgg01_3.h,\
                                         hgg08.h,\
                                         Converter_Converter.hpp,\
                                         IOMan_IDataInfo.hpp,\
                                         IOMan_BlockAddress.hpp,\
                                         Data_Types.hpp

Converter_PascalDiagnose.cpp         inc=gsp00,\
                                         Converter_Page.hpp,\
                                         Converter_LeafPage.hpp,\
                                         Converter_IndexPage.hpp,\
                                         Converter_ParentReference.hpp,\
                                         Kernel_Page.hpp,\
                                         IOMan_BlockAddress.hpp,\
                                         Data_Types.hpp

# -------------------------------------------------------------------------------------
# ------  Factory Problems ------ 
# -------------------------------------------------------------------------------------

#PTS 1114591 performance improvement ...
&if  $MACH in [PA20W, PA11]
Converter_PermMapControl.cpp                +inline_level0
&endif

&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif


