#
#   FrameControl
#
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#

regex(*\.hpp$)              inc=Kernel_Common.hpp

# ------------------------------------------------------------------------------
# Errors and messages:
# ------------------------------------------------------------------------------
#
FrameCtrl_Messages.genmsg       ascii

FrameCtrl_Messages.hpp          inc=SAPDBErr_MessageList.hpp

FrameCtrl_Exception.hpp         inc=SAPDBErr_MessageList.hpp

# -------------------------------------------------------------------------------------
# Interfaces and basic types:
# -------------------------------------------------------------------------------------
#

FrameCtrl_Types.hpp             inc=SAPDBTrace_Topic.hpp

FrameCtrl_ICommon.hpp           inc=Kernel_Common.hpp

FrameCtrl_IConverter.hpp        inc=gsp00,\
                                Kernel_IPage.hpp

FrameCtrl_IIOManager.hpp        inc=gsp00,\
                                Kernel_IPage.hpp

FrameCtrl_ILog.hpp              inc=gsp00,\
                                Kernel_IPage.hpp

FrameCtrl_IDataCache.hpp        inc=gsp00,\
                                Kernel_IPage.hpp

# ------------------------------------------------------------------------------
# Manager:
# ------------------------------------------------------------------------------
#

FrameCtrl_Manager.hpp       inc=+FrameCtrl_ICommon.hpp,\
                                FrameCtrl_IConverter.hpp,\
                                FrameCtrl_IIOManager.hpp,\
                                FrameCtrl_ILog.hpp,\
                                FrameCtrl_IDataCache.hpp,\
                                FrameCtrl_Types.hpp,\
                                Kernel_IPage.hpp,\
                                FrameCtrl_IConverter.hpp

FrameCtrl_Manager.cpp       inc=+hbd20_3.h,\
                                 hgg01_3.h,\
                                 hgg08.h,\
                                 heo55k.h,\
                                 FrameCtrl_Exception.hpp,\
                                 FrameCtrl_Messages.hpp,\
                                 FrameCtrl_Manager.hpp,\
                                 RTE_Crash.hpp,\
                                 RTEMem_Allocator.hpp,\
                                 RTEMem_PageAllocator.hpp,\
                                 RTEMem_AWEAllocator.hpp,\
                                 SAPDB_ToString.hpp

# ------------------------------------------------------------------------------
# Wrapper:
# ------------------------------------------------------------------------------
#

FrameCtrl_Wrapper.cpp       inc=gsp00,\
                                gsp03,\
                                gbd00,\
                                hgg01_1.h,\
                                hgg01_3.h,\
                                FrameCtrl_Manager.hpp,\
                                FrameCtrl_ICommon.hpp,\
                                FrameCtrl_IDataCache.hpp


&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

