#
#   FreeBlockManagement
#
#
#    ========== licence begin LGPL
#    Copyright (C) 2002 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#


* -except               # enable exception handling

regex(*\.hpp$)          inc=+Kernel_Common.hpp,FBM_Types.hpp

# -------------------------------------------------------------------------------------
# Master files
# -------------------------------------------------------------------------------------

FBM_Manager.hpp     inc=+gsp00,\
                         ggg00,\
                         heo55k.h,\
                         hgg08.h,\
                         FBM_DataDevice.hpp,\
                         IOMan_BlockAddress.hpp,\
                         IOMan_ClusterAddress.hpp,\
                         IOMan_ReservedBlockAddress.hpp,\
                         IOMan_IBlockAddressIterator.hpp,\
                         Kernel_Dump.hpp,\
                         RTEMem_AllocatorWrapper.hpp,\
                         SAPDBMem_IRawAllocator.hpp,\
                         -FBM_Types.hpp

FBM_Manager.cpp     inc=+hgg08.h,\
                         Container_Vector.hpp,\
                         FBM_Manager.hpp,\
                         FBM_DataDevice.hpp,\
                         FBM_Dump.hpp,\
                         FBM_Types.hpp,\
                         FBM_Exception.hpp,\
                         RTE_Crash.hpp,\
                         RTE_Message.hpp,\
                         RTEMem_Allocator.hpp,\
                         Log_Types.hpp,\
                         Log_Savepoint.hpp

# -------------------------------------------------------------------------------------
# Exceptions and errors
# -------------------------------------------------------------------------------------                          

FBM_Messages.genmsg                 ascii

FBM_Messages.hpp                    inc=SAPDBErr_MessageList.hpp

FBM_Exception.hpp                   inc=FBM_Messages.hpp,\
                                        FBM_Types.hpp

# -------------------------------------------------------------------------------------
# Interface to the old pascal sources
# -------------------------------------------------------------------------------------                          

FBM_PascalInterface.cpp inc=FBM_Manager.hpp,gbd00,gsp03_3,gsp03,hgg01_1.h,hbd11.h

# -------------------------------------------------------------------------------------
# Interfaces and basic types:
# -------------------------------------------------------------------------------------

FBM_Types.hpp          inc=SAPDBDiag_CheckTopic.hpp,\
                           SAPDBTrace_Topic.hpp

FBM_Dump.hpp           inc=SAPDB_Types.hpp

# -------------------------------------------------------------------------------------
# Utility structures:
# -------------------------------------------------------------------------------------

FBM_BlockStateList.hpp  inc=+SAPDBMem_IRawAllocator.hpp
                               
FBM_DataDevice.hpp      inc=+Container_Vector.hpp,\
                             FBM_BlockStateList.hpp,\
                             Kernel_Dump.hpp,\
                             SAPDBMem_IRawAllocator.hpp

FBM_DataDevice.cpp      inc=+FBM_DataDevice.hpp,\
                             FBM_Dump.hpp,\
                             FBM_Exception.hpp,\
                             RTE_Message.hpp,\
                             RTE_Crash.hpp,\
                             FBM_Messages.hpp

&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

