# ------------------------------------------------------------------------------
#
# Kernel Descriptions
#
# ------------------------------------------------------------------------------
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#


regex(.*\.cpp$)    -except

# -------------------------------------------------------------------------------------
# Errors and messages:
# -------------------------------------------------------------------------------------
#

Kernel_Messages.genmsg          ascii

Kernel_Messages.hpp             inc=SAPDBErr_MessageList.hpp
Kernel_Event_Messages.hpp       inc=SAPDBErr_MessageList.hpp

Kernel_Exception.hpp            inc=SAPDBErr_MessageList.hpp

# -------------------------------------------------------------------------------------
# Interfaces and basis types:
# -------------------------------------------------------------------------------------
#
Kernel_Common.hpp               inc=SAPDB_Types.hpp,SAPDBErr_Assertions.hpp,SAPDBTrace_Usage.hpp

Kernel_Types.hpp                inc=SAPDB_Types.hpp

Kernel_DateTime.hpp             inc=ggg00,\
                                    heo52.h,\
                                    SAPDB_Types.hpp,\
                                    SAPDB_EnhancedTypes.hpp


# -------------------------------------------------------------------------------------
# Page:
# -------------------------------------------------------------------------------------
#
Kernel_IPage.hpp                inc=SAPDB_Types.hpp,\
                                    SAPDBFields_RAMBuffer.hpp

Kernel_Page.hpp                 inc=ggg00,\
                                    SAPDB_PersistentTypes.hpp,\
                                    Kernel_IPage.hpp

Kernel_Page72.hpp               inc=Kernel_Page.hpp,\
                                    SAPDB_PersistentTypes.hpp,\
                                    Kernel_Exception.hpp,\
                                    Kernel_Messages.hpp,\
                                    RTE_Message.hpp

Kernel_Page74.hpp               inc=Kernel_Page.hpp,\
                                    Kernel_Exception.hpp,\
                                    Kernel_Messages.hpp,\
                                    RTE_Message.hpp

Kernel_Page74.cpp               inc=Kernel_Page74.hpp

Kernel_RestartPage.hpp          inc=gkb00,\
                                    Kernel_Page72.hpp,\
                                    SAPDBErr_Assertions.hpp,\
                                    SAPDB_Types.hpp

Kernel_RestartPage.cpp          inc=ggg00,\
                                    hgg01_3.h,\
                                    Kernel_Page.hpp,\
                                    Kernel_RestartPage.hpp

Kernel_DumpPage.hpp             inc=Kernel_Common.hpp,\
                                    Kernel_Page.hpp,\
                                    SAPDBFields_RAMBuffer.hpp

# -------------------------------------------------------------------------------------
# Task Main:
# -------------------------------------------------------------------------------------
#
Kernel_TaskMain.h               inc=
Kernel_TaskMain.cpp             inc=Kernel_TaskMain.h

# -------------------------------------------------------------------------------------
# Test:
# -------------------------------------------------------------------------------------
#
Kernel_ConfigTest.cpp           inc=SAPDB_Types.hpp,\
                                    Kernel_Configuration.hpp,\
                                    SAPDBConfig_Parameters.hpp,\
                                    SAPDBErr_Assertions.hpp \
                                dep=SAPDBConfig_ParamId.gencid

Kernel_Test.hpp             inc=ggg00
Kernel_Test.cpp             inc=Kernel_Test.hpp,\
                                Kernel_WaitQueue.hpp,\
                                SAPDBErr_Assertions.hpp,\
                                gsp00_0.h

# -------------------------------------------------------------------------------------
# Wait Queue
# -------------------------------------------------------------------------------------

Kernel_WaitQueue.hpp     inc=SAPDB_Types.hpp,\
                             gsp00

Kernel_WaitQueue.cpp     inc=Kernel_WaitQueue.hpp,\
                             RTEMem_Allocator.hpp,\
                             SAPDBMem_NewDestroy.hpp,\
                             SAPDBErr_Assertions.hpp,\
                             gsp00,ggg00,\
                             hgg08.h,heo51.h,heo55k.h,heo56.h,gsp00_0.h


# -------------------------------------------------------------------------------------
# Monitoring
# -------------------------------------------------------------------------------------

Kernel_Event.hpp         inc=SAPDB_Types.hpp,\
                             vsp0031

Kernel_Event.cpp         inc=Kernel_Event.hpp,\
                             heo60.h,\
                             hgg01_2.h,\
                             SAPDBErr_MessageList.hpp,\
                             RTE_Message.hpp,\
                             SAPDB_ToString.hpp,\
                             Kernel_Event_Messages.hpp

# ------------------------------------------------------------------------------
# Kernel Statistic
# ------------------------------------------------------------------------------

Kernel_TableStatistic.hpp   inc=ggg00,\
                                Kernel_Common.hpp

# -------------------------------------------------------------------------------------
# old style tracing
# -------------------------------------------------------------------------------------
#
Kernel_VTrace.hpp inc=ggg00,SAPDB_OStream.hpp
Kernel_VTrace.cpp inc=heo51.h,Kernel_VTrace.hpp,Trace_Entry.hpp
Kernel_OpMsg.hpp  inc=gsp03,ggg00,SAPDB_OStream.hpp
Kernel_OpMsg.cpp  inc=Kernel_OpMsg.hpp,heo60.h

# -------------------------------------------------------------------------------------
# new style tracing
# -------------------------------------------------------------------------------------
#
Kernel_TraceTopics.cpp          inc=gsp00,ggg00,hgg941.h,heo51.h,\
                                    RTEMem_Allocator.hpp,\
                                    RTESync_Spinlock.hpp,\
                                    Trace_Entry.hpp,\
                                    SAPDBDiag_CheckTopic.hpp,\
                                    SAPDBTrace_Topic.hpp,\
                                    SAPDBTrace_Stream.hpp,\
                                    Kernel_TraceTopics.hpp

Kernel_Trace.hpp                inc=ggg00,SAPDB_Types.hpp
Kernel_Trace.cpp                inc=Kernel_Trace.hpp,\
                                    SAPDBTrace_Topic.hpp,\
                                    SAPDBTrace_Stream.hpp,\
                                    SAPDB_sprintf.h,\
                                    Kernel_VTrace.hpp,\
                                    gsp00,ggg00,hgg17.h

# -------------------------------------------------------------------------------------
# Kernel FileIO and Kernel dump
# -------------------------------------------------------------------------------------

Kernel_FileIO.hpp               inc=gsp00,\
                                    Kernel_Common.hpp,\
                                    Kernel_IPage.hpp

Kernel_FileIO.cpp               inc=heo51.h,\
                                    heo55k.h,\
                                    heo66.h,\
                                    hsp77.h,\
                                    hgg08.h,\
                                    Kernel_FileIO.hpp,\
                                    Kernel_Exception.hpp,\
                                    Kernel_Messages.hpp,\
                                    RTE_Message.hpp

Kernel_Dump.hpp                 inc=gsp00,\
                                    Kernel_Common.hpp,\
                                    Kernel_DumpPage.hpp,\
                                    KernelCommon/Kernel_FileIO.hpp,\
                                    KernelCommon/Kernel_IPage.hpp

Kernel_Dump.cpp                 inc=heo58.h,\
                                    Kernel_Dump.hpp

&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

