#
# RunTime Environment Descriptions
#
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#

* -except
#
# No exception handling code variant
#
*-noex -DSAPDB_COMPILE_WITHOUT_EXCEPTION_HANDLING
#
RTE_Types.h     inc=SAPDB_Types.h
RTE_Types.hpp   inc=RTE_Types.h
#
# Header for 'TheRTE interface'
RTE_IGlobal.hpp inc=RTE_Types.hpp
#
# TheRTE singleton with support for internal tasking and multithreading (i.e. kernel....)
RTE_Global*.cpp  inc=SAPDBMem_NewDestroy.hpp,RTE_IGlobal.hpp,SAPDBErr_Assertions.hpp,RTETask_IContext.hpp,RTEThread_IContext.hpp,RTE_MessageList.hpp
#
# TheRTE singleton without support for internal tasking, but support for multithreading
# Usefull for multi threaded processes without internal tasking only
RTE_GlobalMultiThread*.cpp  inc=SAPDBMem_NewDestroy.hpp,RTE_IGlobal.hpp,SAPDBErr_Assertions.hpp,RTEThread_IContext.hpp,RTE_MessageList.hpp
#
# TheRTE singleton without support for internal tasking, but support for multithreading
# Usefull for single threaded processes only
RTE_GlobalSimpleProcess*.cpp  inc=SAPDBMem_NewDestroy.hpp,RTE_IGlobal.hpp,SAPDBErr_Assertions.hpp,RTE_MessageList.hpp
#
# Header for 'TheRTE system functions interface'
RTE_ISystem.hpp inc=RTE_Types.hpp,RTESys_MemProtect.h
#
&if $OS = WIN32

RTE_SystemNT*.cpp   inc=SAPDBMem_NewDestroy.hpp,RTE_ISystem.hpp,SAPDBErr_Assertions.hpp,RTESys_Spinlock.h,RTESys_SystemInfo.h

&else

RTE_SystemUNIX*.cpp inc=SAPDBMem_NewDestroy.hpp,RTE_ISystem.hpp,SAPDBErr_Assertions.hpp,RTESys_Spinlock.h,RTESys_SystemInfo.h
&  if $MACH in [ PA11, PA20W ]
RTE_SystemPA.h inc=
&  endif

&endif
#
# Basic Locking Testprogram
RTE_LockTest*.cpp inc=RTE_ISystem.hpp
#
# Basic Locked Counter Testprogram
RTE_CounterTest*.cpp inc=RTE_IGlobal.hpp,RTE_ISystem.hpp,RTESync_InterlockedCounter.hpp
#
# RTE Kernel Initialization
#
RTE_KernelMain.h   inc=
RTE_KernelMain*.cpp inc=RTE_KernelMain.h,RTE_KGS.hpp
#
# RTE_StackBacktrace code
#
RTE_StackBacktrace.h inc=SAPDB_C_Cplusplus.h
RTE_StackBacktrace.c inc=RTE_StackBacktrace.h,SAPDB_Types.h
#
# RTE_Debugger calling code
#
RTE_CallDebugger.h           inc=SAPDB_Types.h,SAPDB_C_Cplusplus.h
RTE_CallDebugger.cpp         inc=RTE_CallDebugger.h,RTEMem_Allocator.hpp
#
# RTE_Message SAPDBErr_MessageList output in knldiag
#
RTE_Message.cpp              inc=RTE_Message.hpp,SAPDB_ToString.hpp,heo60_2.h
RTE_Message.hpp              inc=SAPDBErr_MessageList.hpp
#
# RTE_Crash   Abort() including SAPDBErr_MessageList output
#
RTE_Crash.cpp                inc=RTE_Crash.hpp,RTE_Message.hpp,geo007_1.h,geo60.h
RTE_NonKernelCrash.cpp       inc=RTE_Crash.hpp,RTE_Message.hpp
RTE_Crash.hpp                inc=SAPDBErr_MessageList.hpp
#
# RTE_ItemRegister Singleton template class to register items 
#
RTE_ItemRegister.hpp         inc=RTESync_Spinlock.hpp,RTE_Message.hpp,RTE_Messages.hpp,RTE_MessageList.hpp,SAPDBErr_MessageList.hpp,RTEMem_UnregisteredAllocator.hpp
#
RTE_EmergencyChannel.hpp     inc=SAPDBErr_Diagnostic.hpp
RTE_EmergencyChannel.cpp     inc=RTE_EmergencyChannel.hpp,SAPDBMem_NewDestroy.hpp
RTE_TestEmergencyChannel.cpp inc=SAPDBErr_Diagnostic.hpp,SAPDBErr_MessageList.hpp,RTE_ISystem.hpp
#
# RTE Messages
#
RTE_Messages.genmsg          ascii

RTE_Messages.hpp             inc=SAPDBErr_MessageList.hpp
RTE_AWE_Messages.hpp         inc=SAPDBErr_MessageList.hpp

RTE_Message.hpp              inc=SAPDBErr_MessageList.hpp

RTE_MessageList.hpp          inc=RTE_Messages.hpp
#
# RTE_KGS
#
RTE_KGS.hpp                  inc=SAPDB_Singleton.hpp,geo002.h,geo50_0.h
RTE_KGS.cpp                  inc=SAPDBMem_NewDestroy.hpp,RTE_KGS.hpp,RTE_IGlobal.hpp,RTE_ISystem.hpp,RTEMem_Allocator.hpp,RTEMem_PageAllocator.hpp

#
RTE_UniqueId.h               inc=SAPDB_C_Cplusplus.h,RTE_Types.h
RTE_UniqueId.c               inc=RTE_UniqueId.h,RTESys_Spinlock.h,SAPDB_C_Cplusplus.h

#
# RTE_Speed
#
RTE_Speed.cpp  			     inc=SAPDB_C_Cplusplus.h,RTE_Types.h 

#
# RTE_CurrentStack
#
RTE_CurrentStack.hpp         inc=RTE_Types.h
RTE_CurrentStack.cpp         inc=RTE_CurrentStack.hpp,geo50_0.h\
&if ($MACH = IA64) || ($MACH = HP_IA64) || ($MACHINE = IA64) # PTS 1128112 
                             ,RTE_IA64GetBsp.h
&endif

#
# RTE_Test
#
RTE_Test.hpp inc=ggg00
RTE_Test.cpp inc=RTE_Test.hpp,RTE_Message.hpp,SAPDB_ToString.hpp

#
# RTE_ConsoleCommon: Common Routines for XCons and Console Thread
#
RTE_ConsoleCommon.h          inc=RTE_UniqueId.h
RTE_ConsoleCommon.cpp        inc=hsp77.h,heo15.h,RTE_Types.h,RTE_ConsoleCommon.h\
&if $OSSPEC = WIN32
                             ,gos41.h
&else
                             ,gen41.h
&endif

#
# RTE_GetDBRootOfDB
#
RTE_GetDBRootOfDB.h			inc=SAPDB_Types.h
RTE_GetDBRootOfDB.c			inc=SAPDB_Types.h,RTE_Types.h,gos00.h,gsp00

&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

RTE_DBRegistration.cpp inc=:SAPDB/SAPDBCommon/SAPDB_Types.hpp,\
    :SAPDB/RunTime/RTE_Types.hpp,:SAPDB/RunTime/RTE_MessageList.hpp,\
    :SAPDB/RunTime/RTE_Message.hpp,:SAPDB/RunTime/RTE_Messages.hpp,\
    :SAPDB/RunTime/RTE_DBRegistration.hpp,\
    gsp09.h,gos00.h,heo05.h,gsp00,heo44.h,hen09.h,gos94.h,hsp77.h,gen500.h,gen950.h,gen41.h
RTE_DBRegistration.hpp inc=:SAPDB/RunTime/RTE_Types.h,\
    :SAPDB/RunTime/MemoryManagement/RTEMem_Allocator.hpp,\
    :SAPDB/Container/Container_List.hpp
RTE_DBRegistrationStartStop.cpp inc=:SAPDB/SAPDBCommon/SAPDB_Types.hpp,\
    :SAPDB/RunTime/RTE_Types.hpp,:SAPDB/RunTime/RTE_MessageList.hpp,\
    :SAPDB/RunTime/RTE_Message.hpp,:SAPDB/RunTime/RTE_Messages.hpp,\
    :SAPDB/RunTime/RTE_DBRegistration.hpp,\
    gsp09.h,gos00.h,heo05.h,gsp00,heo44.h,hen09.h,gos94.h,hsp77.h,gen500.h,gen950.h,gen41.h
RTE_DBRegistrationDBEnum.cpp inc=:SAPDB/SAPDBCommon/SAPDB_Types.hpp,\
    :SAPDB/RunTime/RTE_Types.hpp,:SAPDB/RunTime/RTE_MessageList.hpp,\
    :SAPDB/RunTime/RTE_Message.hpp,:SAPDB/RunTime/RTE_Messages.hpp,\
    :SAPDB/RunTime/RTE_DBRegistration.hpp,\
    gsp09.h,gos00.h,heo05.h,gsp00,heo44.h,hen09.h,gos94.h,hsp77.h,gen500.h,gen950.h,gen41.h
RTE_DBRegistrationDBRegister.cpp inc=:SAPDB/SAPDBCommon/SAPDB_Types.hpp,\
    :SAPDB/RunTime/RTE_Types.hpp,:SAPDB/RunTime/RTE_MessageList.hpp,\
    :SAPDB/RunTime/RTE_Message.hpp,:SAPDB/RunTime/RTE_Messages.hpp,\
    :SAPDB/RunTime/RTE_DBRegistration.hpp,\
    gsp09.h,gos00.h,heo05.h,gsp00,heo44.h,hen09.h,gos94.h,hsp77.h,gen500.h,gen950.h,gen41.h

&if $MACH in [ PA11, PA20W ]
RTE_Coroutine.h                     inc=SAPDB_Types.h,RTE_Types.h,RTE_CompilerFeatures.h,RTE_SystemPA.h,RTE_SystemLinux.h
&else
RTE_Coroutine.h                     inc=SAPDB_Types.h,RTE_Types.h,RTE_CompilerFeatures.h,RTE_SystemLinux.h
&endif
RTE_Coroutine.cpp                   inc=geo002.h,geo50_0.h,SAPDBMem_IRawAllocator.hpp,RTE_Coroutine.h,RTESys_AtomicOperation.hpp
