#
#	RunTime Threading
#
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#

*
#
# No exception handling code variant
#
*-noex -DSAPDB_COMPILE_WITHOUT_EXCEPTION_HANDLING
#
RTEThread_IContext.hpp                  inc=RTE_Types.hpp
RTEThread_Context.hpp                   inc=RTEThread_IContext.hpp,SAPDBErr_MessageList.hpp
RTEThread_Context*.cpp                  inc=RTE_IGlobal.hpp,RTEThread_Context.hpp,RTETask_IContext.hpp,SAPDBErr_Assertions.hpp,RTE_MessageList.hpp

# Console Thread Main
RTEThread_Console*.cpp                  inc=heo15.h,geo07.h,RTE_Types.h,SAPDB_Types.h,RTE_ConsoleCommon.h,RTE_UniqueId.h,RTEThread_ConsoleCommandQueue.hpp,RTEThread_ConsoleCommandWorker.h,RTEThread_ConsoleConnectionList.h,RTESys_Time.h\
&if $OSSPEC = WIN32
                                        ,gos41.h
&else
                                        ,gen41.h,gen81.h
&endif  

#
# Console Command Queue
RTEThread_ConsoleCommandQueue.hpp       inc=RTE_Types.h,RTEMem_Allocator.hpp,Container_List.hpp,RTEThread_ConsoleCommandWorker.h
RTEThread_ConsoleCommandQueue*.cpp      inc=RTESys_Spinlock.h,RTE_ConsoleCommon.h,RTEThread_ConsoleCommandQueue.hpp

#
# Console Command Worker
RTEThread_ConsoleCommandWorker.h        inc=geo07.h
RTEThread_ConsoleCommandWorker*.cpp     inc=heo07.h,RTE_Types.h,SAPDB_Types.h,SAPDB_C_Cplusplus.h,RTE_ConsoleCommon.h,RTEThread_ConsoleCommandWorker.h,RTEThread_ConsoleCommandQueue.hpp,RTEThread_ConsoleConnectionList.hpp

#
# Console Connection List
RTEThread_ConsoleConnectionList.h       inc=
RTEThread_ConsoleConnectionList.hpp     inc=RTEMem_Allocator.hpp,RTEThread_ConsoleReplyPort.hpp,RTESys_Spinlock.h
RTEThread_ConsoleConnectionList*.cpp    inc=SAPDB_C_Cplusplus.h,RTEThread_ConsoleConnectionList.hpp,SAPDBMem_NewDestroy.hpp,RTESys_Time.h

#
# Console Reply Port
RTEThread_ConsoleReplyPort.hpp          inc=geo003.h,RTE_ConsoleCommon.h,RTE_UniqueId.h
RTEThread_ConsoleReplyPort*.cpp         inc=SAPDB_C_Cplusplus.h,RTEThread_ConsoleReplyPort.hpp\
&if $OSSPEC = WIN32
                                        ,gos00k.h
&endif 

&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

