# ------------------------------------------------------------------------------
#
# SAPDB Common descriptions
#
# ------------------------------------------------------------------------------
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#


regex(.*\.cpp$)    -except


# -------------------------------------------------------------------------------------
# Errors, exceptions and messages:
# -------------------------------------------------------------------------------------
#
SAPDB_MessageFile.cpp               inc=SAPDB_Types.h,\
                                        heo07.h,\
                                        heo15.h,\
                                        geo007_2.h,\
                                        heo07.h
SAPDB_MessageFile.hpp               inc=gsp00,\
                                        geo00_0.h,\
                                        heo07.h

SAPDB_Messages.genmsg               ascii

SAPDB_String_Messages.hpp           inc=SAPDBErr_MessageList.hpp

SAPDB_UTF8String_Messages.hpp       inc=SAPDBErr_MessageList.hpp

SAPDB_Exception.hpp                 inc=SAPDBErr_MessageList.hpp

# -------------------------------------------------------------------------------------
# Global configuration:
# -------------------------------------------------------------------------------------
#
SAPDB_Config.hpp
# -------------------------------------------------------------------------------------
# Basis Types:
# -------------------------------------------------------------------------------------
#
SAPDB_Types.h                       inc=
SAPDB_Types.hpp                     inc=SAPDB_Types.h,SAPDB_Config.hpp
SAPDB_EnhancedTypes.hpp             inc=SAPDB_Types.hpp

# -------------------------------------------------------------------------------------
# Elementary operations:
# -------------------------------------------------------------------------------------
#
SAPDB_BitOperations.hpp             inc=SAPDB_Types.hpp
SAPDB_IntegerArithmetic.hpp         inc=SAPDBErr_Assertions.hpp
SAPDB_PersistentTypes.hpp           inc=SAPDB_Types.hpp,\
                                        SAPDBErr_Assertions.hpp

# -------------------------------------------------------------------------------------
# ToString classes:
# -------------------------------------------------------------------------------------
#
SAPDB_ToString.hpp                  inc=SAPDB_Types.hpp
SAPDB_ToString.cpp                  inc=SAPDB_ToString.hpp,RTEMem_Allocator.hpp,hsp77.h
SAPDB_ToStringTest.cpp              inc=SAPDB_ToString.hpp

# -------------------------------------------------------------------------------------
# String elements and string basis class:
# -------------------------------------------------------------------------------------
#
SAPDB_UTF8StringElement.hpp         inc=SAPDB_UTF8Basis.hpp,\
                                        SAPDBErr_Assertions.hpp

# -------------------------------------------------------------------------------------
# UTF-8 string classes:
# -------------------------------------------------------------------------------------
#
SAPDB_UTF8Basis.hpp                 inc=SAPDB_Types.hpp,\
                                        hsp81.h

SAPDB_UTF8Basis.cpp                 inc=SAPDB_UTF8Basis.hpp

# -------------------------------------------------------------------------------------
# Streams and stream test:
# -------------------------------------------------------------------------------------
#
SAPDB_OStream.hpp                   inc=SAPDB_Types.hpp,\
                                        SAPDB_ToString.hpp
SAPDB_OStream.cpp                   inc=SAPDB_OStream.hpp,\
                                        RTE_CompilerFeatures.h

SAPDB_StreamTest.cpp                inc=SAPDB_Types.hpp,\
                                        SAPDB_ToString.hpp,\
                                        SAPDB_OStream.hpp

# -------------------------------------------------------------------------------------
# Include file useful for C/C++ header files, that means header files that are
# used in both universes...
# -------------------------------------------------------------------------------------
#
SAPDB_C_Cplusplus.h                 inc=

# -------------------------------------------------------------------------------------
# AutoPtr classes:
# -------------------------------------------------------------------------------------
#
SAPDB_AutoPtr.hpp                   inc=SAPDBErr_Assertions.hpp,\
                                        SAPDBMem_IRawAllocator.hpp

SAPDB_AutoPtrTest.cpp               inc=SAPDB_AutoPtr.hpp,\
                                        SAPDBMem_NewDestroy.hpp,\
                                        SAPDBMem_DefaultRawAllocator.hpp,\
                                        Test_Program.hpp

# -------------------------------------------------------------------------------------
# Single base class:
# -------------------------------------------------------------------------------------
#
SAPDB_Singleton.hpp                 inc=

#
# As long as vsp77.c exists, this headerfile allows only to use new names, later it should be headerfile for the implementation...
#
SAPDB_sprintf.h inc=hsp77.h

&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

