# --------------------------------------------------------------------------
# description: Fields within SAPDB Kernel
#
# author:	stefan.baier@sap.com
# --------------------------------------------------------------------------
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#


# Compile all modules with exception handling enabled
regex(.*\.cpp$)    -except

#
#-------------------------------------------------------------------------------
# Common files of this component
#
SAPDBFields_Messages.genmsg         ascii

SAPDBFields_Resource_Messages.hpp       inc=SAPDBErr_MessageList.hpp

SAPDBFields_Exception.hpp               inc=SAPDBErr_MessageList.hpp

#
#-------------------------------------------------------------------------------
# Fields and field sequences
#
SAPDBFields_Field.hpp                   inc=SAPDB_Types.hpp,\
                                            SAPDBErr_Assertions.hpp
#SAPDBFields_FieldSequence.hpp           inc=SAPDB_Types.hpp,\
#                                            SAPDB_OStream.hpp,\
#                                            Container_Vector.hpp,\
#                                            SAPDBErr_Assertions.hpp,\
#                                            SAPDBMem_RawToTypedAllocator.hpp,\
#                                            SAPDBFields_Field.hpp,\
#                                            SAPDBFields_RAMBuffer.hpp
#SAPDBFields_FieldSequence.cpp           inc=SAPDBFields_FieldSequence.hpp


#
#-------------------------------------------------------------------------------
# Resources
#
SAPDBFields_IResource.hpp               inc=SAPDB_Types.hpp,\
                                            SAPDBFields_Exception.hpp,\
                                            SAPDB_ToString.hpp \
                                        dep=SAPDBFields_Resource_Messages.hpp
                                        
SAPDBFields_FieldResource.hpp           inc=SAPDBFields_IResource.hpp,\
                                            SAPDBErr_Assertions.hpp

SAPDBFields_StaticResource.hpp          inc=SAPDBFields_IResource.hpp,\
                                            SAPDBErr_Assertions.hpp

SAPDBFields_DynamicResource.hpp         inc=SAPDBFields_FieldResource.hpp,\
                                            SAPDB_IntegerArithmetic.hpp,\
                                            RTEMem_Allocator.hpp

#
#-------------------------------------------------------------------------------
# RAM Buffers
#

SAPDBFields_BasicRAMBuffer.hpp          inc=SAPDBFields_Field.hpp

SAPDBFields_FieldRAMBuffer.hpp          inc=SAPDBFields_BasicRAMBuffer.hpp,\
                                            SAPDBFields_FieldResource.hpp

SAPDBFields_RAMBuffer.hpp               inc=SAPDBFields_FieldRAMBuffer.hpp

SAPDBFields_StaticRAMBuffer.hpp         inc=SAPDBFields_BasicRAMBuffer.hpp,\
                                            SAPDBFields_StaticResource.hpp

SAPDBFields_DynamicRAMBuffer.hpp        inc=SAPDBFields_BasicRAMBuffer.hpp,\
                                            SAPDBFields_DynamicResource.hpp

#
#-------------------------------------------------------------------------------
# String Buffers
#
SAPDBFields_BasicStringBuffer.hpp       inc=SAPDBFields_Field.hpp

SAPDBFields_FieldStringBuffer.hpp       inc=SAPDBFields_BasicStringBuffer.hpp,\
                                            SAPDBFields_FieldResource.hpp

SAPDBFields_StringBuffer.hpp            inc=SAPDBFields_FieldStringBuffer.hpp

SAPDBFields_StaticStringBuffer.hpp      inc=SAPDBFields_BasicStringBuffer.hpp,\
                                            SAPDBFields_StaticResource.hpp

SAPDBFields_DynamicStringBuffer.hpp     inc=SAPDBFields_BasicStringBuffer.hpp,\
                                            SAPDBFields_DynamicResource.hpp


#
#-------------------------------------------------------------------------------
# Test program
#
#SAPDBFields_Test.cpp                    inc=Test_Program.hpp,\
#                                            SAPDBErr_Assertions.hpp,\
#                                            SAPDBFields_Field.hpp,\
#                                            SAPDBFields_FieldSequence.hpp,\
#                                            SAPDBMem_DefaultRawAllocator.hpp

                     

&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

