# ------------------------------------------------------------------------------
#
# System View Descriptions
#
# ------------------------------------------------------------------------------
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#


regex(.*\.cpp$)    -except

# inc=+hta99.h,hta01.h


# ------------------------------------------------------------------------------
# Global Defines
# ------------------------------------------------------------------------------
SysView_Defines.hpp				inc=SAPDBTrace_Topic.hpp,SAPDBTrace_Usage.hpp

# ------------------------------------------------------------------------------
# Interfaces
# ------------------------------------------------------------------------------
SysView_ISysView.hpp            inc=

SysView_ITableObj.hpp           inc=SAPDB_Types.hpp,SysView_Defines.hpp

SysView_ISessionObj.hpp         inc=SAPDB_Types.hpp

# ------------------------------------------------------------------------------
# Base Classes
# ------------------------------------------------------------------------------
SysView_SysViewBase.hpp			inc=SysView_ISysView.hpp,\
                                    SysView_ITableObj.hpp,SysView_ISessionObj.hpp,\
                                    SAPDBTrace_Usage.hpp

SysView_SysViewBase.cpp         inc=ggg00,vak001,gak40,\
                                    SAPDBMem_IRawAllocator.hpp,\
                                    SAPDBMem_NewDestroy.hpp,\
                                    SysView_SysViewBase.hpp,\
                                    SysView_ITableObj.hpp,SysView_ISessionObj.hpp,\
                                    SysView_PascalTableObj.hpp,\
                                    SysView_PascalSessionObj.hpp                                    

SysView_PascalSessionObj.hpp    inc=SAPDB_Types.hpp,\
                                    SysView_ISessionObj.hpp

SysView_PascalSessionObj.cpp    inc=ggg00,vak001,hak07.h,SAPDB_Types.hpp,\
                                    SAPDBMem_IRawAllocator.hpp,\
                                    SAPDBMem_NewDestroy.hpp,\
									SysView_Defines.hpp,SysView_PascalSessionObj.hpp

SysView_PascalTableObj.hpp      inc=ggg00,gak40,vak001,gkb05,\
                                    SysView_Defines.hpp,SAPDB_Types.hpp,\
                                    SAPDB_UTF8Basis.hpp,SysView_ITableObj.hpp

SysView_PascalTableObj.cpp      inc=ggg00,hgg01_3.h,ggg91.h,ggg92.h,hgg06.h,\
                                    hgg10.h,gak40,hak40.h,vak001,hak42.h,\
                                    hsp81.h,hak07.h,gkb05,SAPDB_UTF8Basis.hpp,\
                                    SAPDBMem_IRawAllocator.hpp,SAPDB_Types.hpp,\
                                    SAPDBMem_NewDestroy.hpp,\
									SysView_Defines.hpp,SysView_PascalTableObj.hpp

# ------------------------------------------------------------------------------
# Implementation Classes
# ------------------------------------------------------------------------------
SysView_ActiveConfiguration.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                      SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_ActiveConfiguration.cpp   inc=ggg00,\
                                      RTEConf_ParameterAccessKernelInterface.hpp,\
                                      SAPDB_Types.hpp,\
                                      SysView_Defines.hpp,\
                                      SysView_ActiveConfiguration.hpp

SysView_BackupInformation.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                    SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_BackupInformation.cpp   inc=ggg00,\
                                    SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                    SysView_BackupInformation.hpp

SysView_BackupThreads.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_BackupThreads.cpp   inc=ggg00,\
                                SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                SysView_BackupThreads.hpp

SysView_CacheStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                  SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_CacheStatistics.cpp   inc=ggg00,hak42.h,\
                                  SysView_Defines.hpp,\
                                  SysView_CacheStatistics.hpp

SysView_CacheStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                       SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_CacheStatisticsReset.cpp   inc=ggg00,\
                                       SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                       SysView_CacheStatisticsReset.hpp

SysView_ClassContainers.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                  SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_ClassContainers.cpp   inc=ggg00,\
                                  SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                  SysView_ClassContainers.hpp

SysView_ClassContainerStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                           SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_ClassContainerStatistics.cpp   inc=ggg00,\
                                           SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                           SysView_ClassContainerStatistics.hpp

SysView_ClassContainerStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                                SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_ClassContainerStatisticsReset.cpp   inc=ggg00,\
                                                SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                                SysView_ClassContainerStatisticsReset.hpp

SysView_DataCache.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                            SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_DataCache.cpp   inc=ggg00,\
                            SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                            SysView_DataCache.hpp

SysView_DataStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                 SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_DataStatistics.cpp   inc=ggg00,\
                                 SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                 SysView_DataStatistics.hpp

SysView_DataStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                      SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_DataStatisticsReset.cpp   inc=ggg00,\
                                      SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                      SysView_DataStatisticsReset.hpp

SysView_DataVolumes.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                              SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_DataVolumes.cpp   inc=ggg00,hgg01_3.h,\
                              IOMan_IDataVolumeInfo.hpp,\
                              SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                              SysView_DataVolumes.hpp

SysView_Events.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                         SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_Events.cpp   inc=ggg00,\
                         SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                         SysView_Events.hpp

SysView_Files.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                        SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_Files.cpp   inc=ggg00,\
                        SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                        SysView_Files.hpp

SysView_HistoryCleanupStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                           SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_HistoryCleanupStatistics.cpp   inc=ggg00,\
                                           SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                           SysView_HistoryCleanupStatistics.hpp

SysView_HistoryCleanupStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                                SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_HistoryCleanupStatisticsReset.cpp   inc=ggg00,\
                                                SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                                SysView_HistoryCleanupStatisticsReset.hpp

SysView_IndexSizeDetails.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                   SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_IndexSizeDetails.cpp   inc=ggg00,\
                                   SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                   SysView_IndexSizeDetails.hpp

SysView_IOThreadStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                     SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_IOThreadStatistics.cpp   inc=ggg00,\
                                     SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                     SysView_IOThreadStatistics.hpp

SysView_IOThreadStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                          SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_IOThreadStatisticsReset.cpp   inc=ggg00,\
                                          SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                          SysView_IOThreadStatisticsReset.hpp

SysView_Locks.hpp   inc=ggg00,\
                        SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                        SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_Locks.cpp   inc=ggg00,hak07.h,hgg10.h,hak01.h,hak06.h,hgg01_3.h,\
                        hak07.h,hak36.h,hak40.h,hak42.h,vkb521.hpp,\
                        SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                        SysView_Locks.hpp

SysView_LockStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                 SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_LockStatistics.cpp   inc=ggg00,\
                                 SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                 SysView_LockStatistics.hpp

SysView_LockStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                      SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_LockStatisticsReset.cpp   inc=ggg00,\
                                      SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                      SysView_LockStatisticsReset.hpp

SysView_LogStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_LogStatistics.cpp   inc=ggg00,\
                                SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                SysView_LogStatistics.hpp

SysView_LogStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                     SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_LogStatisticsReset.cpp   inc=ggg00,\
                                     SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                     SysView_LogStatisticsReset.hpp

SysView_LogVolumes.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                             SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_LogVolumes.cpp   inc=ggg00,\
                             IOMan_ILogVolumeInfo.hpp,hgg01_3.h,\
                             SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                             SysView_LogVolumes.hpp

SysView_MemoryAllocatorStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                            SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_MemoryAllocatorStatistics.cpp   inc=ggg00,\
                                            SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                            SysView_MemoryAllocatorStatistics.hpp,\
                                            RTEMem_AllocatorInfoReader.hpp

SysView_MemoryAllocatorStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                                 SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_MemoryAllocatorStatisticsReset.cpp   inc=ggg00,\
                                                 SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                                 SysView_MemoryAllocatorStatisticsReset.hpp

SysView_MemoryHolders.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_MemoryHolders.cpp   inc=ggg00,hsp77.h,hak40.h,\
                                LVCMem_Allocator.hpp,\
                                SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                SysView_MemoryHolders.hpp

SysView_Miscellaneous.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_Miscellaneous.cpp   inc=ggg00,\
                                SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                SysView_Miscellaneous.hpp

SysView_OMSLocks.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                           SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_OMSLocks.cpp   inc=ggg00,gsp00,vak001,\
                           LVC_LibOmsInterface.hpp,\
                           SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                           SysView_OMSLocks.hpp

SysView_OMSProcedureStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                         SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_OMSProcedureStatistics.cpp   inc=ggg00,\
                                         SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                         SysView_OMSProcedureStatistics.hpp

SysView_OMSProcedureStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                              SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_OMSProcedureStatisticsReset.cpp   inc=ggg00,\
                                              SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                              SysView_OMSProcedureStatisticsReset.hpp

SysView_OMSVersions.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                              SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_OMSVersions.cpp   inc=ggg00,\
                              SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                              SysView_OMSVersions.hpp

SysView_OptimizerInformation.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                       SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_OptimizerInformation.cpp   inc=vak001,hak47.h,\
                                       SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                       SysView_OptimizerInformation.hpp

SysView_PageLocks.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                            SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_PageLocks.cpp   inc=ggg00,\
                            SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                            SysView_PageLocks.hpp

SysView_RegionLocks.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                              SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_RegionLocks.cpp   inc=ggg00,\
                              SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                              SysView_RegionLocks.hpp

SysView_RegionStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                   SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_RegionStatistics.cpp   inc=ggg00,\
                                   SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                   SysView_RegionStatistics.hpp

SysView_RegionStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                        SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_RegionStatisticsReset.cpp   inc=ggg00,\
                                        SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                        SysView_RegionStatisticsReset.hpp

SysView_RestartInformation.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                     SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_RestartInformation.cpp   inc=ggg00,\
                                     SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                     SysView_RestartInformation.hpp

SysView_Schemas.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                          SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_Schemas.cpp   inc=ggg00,\
                          SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                          SysView_Schemas.hpp

SysView_Sessions.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                           SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_Sessions.cpp   inc=ggg00,\
                           SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                           SysView_Sessions.hpp

SysView_SpinLockStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                     SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_SpinLockStatistics.cpp   inc=ggg00,RTESync_SpinlockReader.hpp,\
                                     SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                     SysView_SpinLockStatistics.hpp

SysView_SpinLockStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                          SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_SpinLockStatisticsReset.cpp   inc=ggg00,\
                                          SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                          SysView_SpinLockStatisticsReset.hpp

SysView_TableSizeDetails.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                   SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_TableSizeDetails.cpp   inc=ggg00,\
                                   SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                   SysView_TableSizeDetails.hpp

SysView_TaskGroupStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                      SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_TaskGroupStatistics.cpp   inc=ggg00,\
                                      SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                      SysView_TaskGroupStatistics.hpp

SysView_TaskGroupStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                           SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_TaskGroupStatisticsReset.cpp   inc=ggg00,\
                                           SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                           SysView_TaskGroupStatisticsReset.hpp

SysView_TaskStatistics.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                 SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_TaskStatistics.cpp   inc=ggg00,\
                                 SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                 SysView_TaskStatistics.hpp

SysView_TaskStatisticsReset.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                      SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_TaskStatisticsReset.cpp   inc=ggg00,\
                                      SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                                      SysView_TaskStatisticsReset.hpp

SysView_Transactions.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                               SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_Transactions.cpp   inc=ggg00,hak07.h,hgg01.h,ggg91.h,\
                               ggg92.h,hgg06.h,vkb522.hpp,\
                               SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                               SysView_Transactions.hpp

SysView_Version.hpp   inc=SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                          SysView_Defines.hpp,SysView_SysViewBase.hpp

SysView_Version.cpp   inc=ggg00,gsp100.h,hsp100.h,\
                          SysView_Defines.hpp,SysView_ISessionObj.hpp,SysView_ITableObj.hpp,\
                          SysView_Version.hpp


&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

