#
#   Trace
#
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#

* -I$WRK/incl/SAPDB

regex(*\.hpp$)              inc=gsp00,ggg00,SAPDBCommon/SAPDB_Types.hpp

Trace_DevSpace.hpp          inc=-ggg00

Trace_DevSpace.cpp          inc=+gsp03,\
                                gsp03_3,\
                                heo54k.h,\
                                heo58.h,\
                                hgg01.h,\
                                hgg01_1.h,\
                                vsp002,\
                                Trace_DevSpace.hpp,\
                                Trace_InfoPage.hpp

Trace_Manager.hpp           inc=+RTESync_InterlockedCounter.hpp,\
                                 Kernel_WaitQueue.hpp,\
                                 Trace_DevSpace.hpp,\
                                 Trace_Types.hpp,\
                                 Trace_SlotPool.hpp

Trace_Manager.cpp           inc=+heo51.h,\
                                heo55k.h,\
                                heo56.h,\
                                hgg01.h,\
                                hgg01_3.h,\
                                hgg08.h,\
                                RTEMem_Allocator.hpp,\
                                SAPDBMem_NewDestroy.hpp,\
                                Trace_Manager.hpp,\
                                Trace_Writer.hpp

Trace_Page.hpp              inc=gsp00,\
                                ggg11,\
                                SAPDB_Types.hpp,\
                                Trace_Types.hpp

Trace_InfoPage.hpp          inc=gsp00

Trace_InfoPage.h            inc=gsp00

Trace_InfoPage.cpp -DKERNEL_LZU inc=geo50_0.h,\
                                geo002.h,\
                                Trace_InfoPage.h,\
                                Trace_InfoPage.hpp

Trace_Slot.hpp              inc=+RTESync_NamedSpinlock.hpp,\
                                RTESync_InterlockedCounter.hpp,\
                                Trace_DevSpace.hpp,\
                                Trace_Page.hpp,\
                                Trace_Types.hpp

Trace_Slot.cpp              inc=+ggg90.h,\
                                hgg01.h,\
                                hsp77.h,\
                                Trace_Slot.hpp,\
                                Trace_Entry.hpp,\
                                Trace_InfoPage.hpp

Trace_SlotPool.hpp          inc=gsp00,\
                                RTEMem_Allocator.hpp,\
                                SAPDBMem_NewDestroy.hpp,\
                                SAPDB_Types.hpp,\
                                Trace_Slot.hpp

#
# TraceSort tool (exception handling allowed...)
#
Trace_Sort.cpp -except      inc=Trace_Types.hpp,\
                                Trace_InfoPage.hpp,\
                                Trace_Page.hpp,\
                                Trace_Entry.hpp,\
                                geo54.h

Trace_Types.hpp         

Trace_Types.cpp             inc=+ggg11,\
                                Trace_Types.hpp,\
                                Trace_Entry.hpp

Trace_Wrapper.cpp           inc=+gsp00,\
                                ggg00,\
                                gsp03,\
                                hgg01_1.h,\
                                SAPDB_Types.hpp,\
                                Trace_Entry.hpp,\
                                Trace_Manager.hpp,\
                                Trace_MessBlockEntry.hpp,\
                                Trace_PacketEntry.hpp,\
                                Trace_Writer.hpp

Trace_Writer.hpp            inc=+Kernel_IPage.hpp

Trace_Writer.cpp            inc=+hkb35.h,\
                                 hkb38.h,\
                                 hkb52_1.h,\
                                 hkb57.h,\
                                 hbd20_7.h,\
                                 hbd77.h,\
                                 hkb90.h,\
                                 hbd90.h,\
                                 hbd91.h,\
                                 hgg01.h,\
                                 hgg02.h,\
                                 heo51.h,\
                                 heo56.h,\
                                 heo58.h,\
                                 Converter_IDump.hpp,\
                                 Pager_IDump.hpp,\
                                 FBM_Manager.hpp,\
                                 Kernel_Dump.hpp,\
                                 RTEMem_Allocator.hpp,\
                                 RTE_ISystem.hpp,\
                                 SAPDBMem_NewDestroy.hpp,\
                                 Trace_Manager.hpp,\
                                 Trace_Writer.hpp

############################################
## Modules containing trace entry layouts ##
############################################

Trace_DevSpaceIOEntry.hpp   inc=gsp00,\
                                ggg00,\
                                ggg11,\
                                vsp002,\
                                Data_Types.hpp,\
                                IOMan_BlockAddress.hpp,\
                                Log_Types.hpp,\
                                Trace_Entry.hpp

Trace_Entry.hpp             inc=+ggg11,\
                                Trace_Types.hpp

Trace_Entry.cpp             inc=+ggg90.h,\
                                ggg91.h,\
                                Trace_Entry.hpp,\
                                Trace_Manager.hpp

Trace_MessBlockEntry.hpp    inc=+Trace_Types.hpp,\
                                Trace_Entry.hpp

Trace_MessBlockEntry.cpp    inc=+Trace_MessBlockEntry.hpp,\
                                Trace_Manager.hpp

Trace_PacketEntry.hpp       inc=+Trace_Entry.hpp,\
                                Trace_Manager.hpp

Trace_PageNoEntry.hpp       inc=gsp00,\
                                ggg00,\
                                ggg11,\
                                Trace_Entry.hpp

&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

