#
# RunTime Environment / Memory Handling Descriptions
#
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#

LVCMem_Wrapper.hpp            inc=heo38.h,geo38.h,heo51.h,heo58.h,geo573.h,hak260.h

LVCMem_Allocator.hpp          inc=SAPDBMem_IRawAllocator.hpp,\
                               SAPDBMem_SynchronizedRawAllocator.hpp,\
							   LVCMem_Wrapper.hpp,\
							   SAPDBMem_CallDirectory.hpp,\
							   Container_Vector.hpp,\
							   heo670.h

LVCMem_BlockAllocator.hpp     inc=SAPDB_Types.hpp,\
                               SAPDBMem_IBlockAllocator.hpp,\
                               RTESync_NamedSpinlock.hpp
LVCMem_DefaultAllocator.hpp   inc=SAPDBMem_IRawAllocator.hpp


LVCMem_EmergencyAllocator.hpp inc=SAPDBMem_RawAllocator.hpp,\
                                  gsp00

LVCMem_Allocator.cpp -except      inc=LVCMem_Allocator.h,\
                                      LVCMem_Allocator.hpp,\
                                      LVCMem_BlockAllocator.hpp,\
							          LVCMem_EmergencyAllocator.hpp,\
									  LVC_LibOmsInterface.hpp,\
                                      SAPDBMem_NewDestroy.hpp,\
                                      SAPDBMem_Exceptions.hpp,\
							          RTESync_NamedSpinlock.hpp,\
                                      RTE_Crash.hpp,\
                                      Kernel_OpMsg.hpp,\
									  OMS_Types.hpp,\
									  geo573.h,\
                                      heo670.h,\
                                      hsp77.h,\
                                      hco31-k.h
									  
LVCMem_Allocator-t.cpp -except    -DOMSTST inc=LVCMem_Allocator.h,\
                                      LVCMem_Allocator.hpp,\
                                      LVCMem_BlockAllocator.hpp,\
							          LVCMem_EmergencyAllocator.hpp,\
									  LVC_LibOmsInterface.hpp,\
                                      SAPDBMem_NewDestroy.hpp,\
                                      SAPDBMem_Exceptions.hpp,\
							          RTESync_NamedSpinlock.hpp,\
                                      RTE_Crash.hpp,\
                                      Kernel_OpMsg.hpp,\
									  OMS_Types.hpp,\
									  geo573.h,\
                                      heo670.h,\
                                      hsp77.h,\
                                      hco31-k.h
									  

LVCMem_BlockAllocator.cpp -except inc=RTE_CompilerFeatures.h,\
                                      SAPDBMem_NewDestroy.hpp,\
                                      LVCMem_BlockAllocator.hpp,\
                                      RTEMem_BlockAllocator.hpp,\
									  RTEMem_AllocatorRegister.hpp,\
									  Kernel_OpMsg.hpp,\
                                      KernelCommon/Kernel_VTrace.hpp

LVCMem_DefaultAllocator.cpp -except inc=LVCMem_DefaultAllocator.hpp,\
                                         geo573.h

LVCMem_EmergencyAllocator.cpp     inc=LVCMem_EmergencyAllocator.hpp,\
                                      LVCMem_BlockAllocator.hpp,\
									  hgg08.h,\
									  heo51.h,\
									  heo55k.h



LVCMem_Allocator.exp inc= ascii


# User allocators (session-specific and global) for use in OMS applications:

LVCMem_UserAllocatorBase.hpp            inc=gco103.h
LVCMem_UserAllocatorBase.cpp            inc=LVCMem_UserAllocatorBase.hpp
LVCMem_UserAllocatorBase-sim.cpp        inc=LVCMem_UserAllocatorBase.hpp -DOMS_SIMULATOR

LVCMem_UserAllocator.hpp                inc=LVCMem_UserAllocatorBase.hpp,SAPDBMem_RawAllocator.hpp,OMS_CallbackInterface.hpp,gco103.h
LVCMem_UserAllocator.cpp                inc=LVCMem_UserAllocator.hpp,SAPDB_UTF8Basis.hpp,hsp77.h,hak34.h,hgg01_3.h,hgg01_1.h,gsp03_1
LVCMem_UserAllocator-sim.cpp            inc=LVCMem_UserAllocator.hpp,SAPDB_UTF8Basis.hpp,hsp77.h,hak34.h,hgg01_3.h,hgg01_1.h,gsp03_1 -DOMS_SIMULATOR

LVCMem_CheckedUserAllocator.hpp         inc=LVCMem_UserAllocator.hpp
LVCMem_CheckedUserAllocator.cpp         inc=LVCMem_CheckedUserAllocator.hpp,OMS_CallbackInterface.hpp
LVCMem_CheckedUserAllocator-sim.cpp     inc=LVCMem_CheckedUserAllocator.hpp,OMS_CallbackInterface.hpp -DOMS_SIMULATOR

LVCMem_GlobalUserAllocatorRegister.hpp	inc=LVCMem_UserAllocator.hpp
LVCMem_GlobalUserAllocatorRegister.cpp	inc=LVCMem_GlobalUserAllocatorRegister.hpp,\
                                        RTESync_Spinlock.hpp,SAPDBMem_NewDestroy.hpp
LVCMem_GlobalUserAllocatorRegister-sim.cpp	inc=LVCMem_GlobalUserAllocatorRegister.hpp,\
                                        RTESync_Spinlock.hpp,SAPDBMem_NewDestroy.hpp -DOMS_SIMULATOR

# end of user allocators


&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O2
&endif

