/*


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end


*/
#ifndef AUTOPTR_H
#define AUTOPTR_H

class AutoPtr
{
public:
    // default constructor
    AutoPtr() : ptr(NULL) { };
    // copy constructor
    AutoPtr( char *ptr ) : ptr(ptr) { };
    //destructor
    ~AutoPtr() { this->Delete(); };
    // assignment
    AutoPtr& operator=( char *newPtr ) { this->ptr = newPtr; return *this; };
    // conversion
    operator char*() const { return this->ptr; };
    
private:
    void Delete() { if (this->ptr != NULL) delete this->ptr; };
    char *ptr;
}; // class AutoPtr

#endif
