/*!***************************************************************************

  module      : File_Types.hpp
  responsible : UweH
  special area: File
  created     : 2000-11-20
  last changed: 2000-11-20 12:00
  copyright   : Copyright by SAP AG, 2000
  description : general types for component file.



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/

#ifndef File_Types_HPP
#define File_Types_HPP

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/
/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/
/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/
/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/
/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

/*! ---------------------------------------------------------------------------
declaration: File_Type
description: This describes some file types.
*/
typedef enum File_Type
{
    File_Unknown,
    File_Undo,
    File_Redo,
    File_History,
    File_HistoryDirectory,
    File_OpenTrans,
    File_Table,
    File_Index
} File_Type;
/*! enddeclaration: File_Type */

#endif // File_Types_HPP
