/*!**************************************************************************

  module      : IOMan_DataPages.hpp

  -------------------------------------------------------------------------

  responsible : TorstenS

  special area: I/O Management for data pages
  description : This module is used to define a variant of the template 
                class IOMan_KernelPage suitable for data pages.

  last changed: 2001-01-31  16:41
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin  GPL
  Copyright (C) 2001 SAP AG

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  ========== licence end

*****************************************************************************/


#ifndef IOMAN_DATAPAGES_HPP
#define IOMAN_DATAPAGES_HPP



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "DataAccess/Data_BasePage.hpp"
#include "IOManager/IOMan_KernelPages.hpp"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

 /*!----------------------------------------------------------------------
    declarations: Type definitions
 -----------------------------------------------------------------------*/

typedef IOMan_Pages<Data_BasePage>          IOMan_DataPages;
typedef IOMan_PagesIterator<Data_BasePage>  IOMan_DataPagesIterator;

 /*!----------------------------------------------------------------------
    enddeclarations: Type definitions
 -----------------------------------------------------------------------*/

#endif  /* IOMAN_DATAPAGES_HPP */
