/*!*****************************************************************************

  module:       Kernel_Common.hpp

  ------------------------------------------------------------------------------

  responsible:  JrgM

  special area: SAPDB Kernel

  description:  Kernel common header file

                Trys to collect common used header files at a central point.
                DO NOT ADD TOO MANY THINGS HERE....

  copyright:    (C) 2000 SAP AG

  ------------------------------------------------------------------------------

  ========== licence begin  GPL
  Copyright (C) 2000 SAP AG

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  ========== licence end

*******************************************************************************/


#ifndef KERNEL_COMMON_HPP
#define KERNEL_COMMON_HPP

// Common Type definitions
#include "SAPDBCommon/SAPDB_Types.hpp"

// Assertion Macros and Message List Defintions
#include "SAPDBCommon/ErrorsAndMessages/SAPDBErr_Assertions.hpp"

// Common Trace definitions
#include "SAPDBCommon/Tracing/SAPDBTrace_Usage.hpp"

#endif // KERNEL_COMMON_HPP
