/*!***************************************************************************

  module      : Log_Test
  responsible : UweH
  special area: DataAccess
  created     : 2000-11-22
  last changed: 2000-11-22 12:00
  copyright   : Copyright by SAP AG, 2000
  description : entrypoint for component tests



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*****************************************************************************/

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "ggg00.h" // tgg00_TransContext
#include "Logging/Log_Test.hpp"
#include "Logging/Log_Transaction.hpp"
#include "hkb560.h"
#include "hbd01.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/
/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/
/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/
/*===========================================================================*
 *  LOCAL FUNCTIONS                                                          *
 *===========================================================================*/
/*===========================================================================*
 *  EXTERNAL FUNCTIONS                                                       *
 *===========================================================================*/

/* --------------------------------------------------------------------------- */
externCpp void Log_Test ( tgg00_TransContext& Trans,
                          SAPDB_UInt          testno)
{
    switch ( testno )
    {
        case 3:
            // normal test
            break;
        case 10:
        {
            // suspend logwriter
            pasbool     result;
            tsp00_Uint4 iosequence;
            result = kb560SuspendAndGetLastWrittenIOSequence (Trans.trTaskId_gg00, iosequence);
            break;
        }
        case 11:
            // resume logwriter
            k560ResumeLogWriterByUser(Trans.trTaskId_gg00);
            break;
        case 12:
        case 13:
            kb560SetLogAutoOverwrite (Trans.trTaskId_gg00, b01downfilesystem, 12==testno);
            break;
        default:
            break;
    }
}
