/*!================================================================
 module:        OMS_OidArrayReader.hpp

 responsible:   PeterG
 
 special area:  OMS
 
 description:   OID handling
 
 see:           
 
 copyright:     SAP AG 2002 


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License; or (at your option) any later version.

    This library is distributed in the hope that it will be useful;
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not; write to the Free Software
    Foundation; Inc.; 59 Temple Place; Suite 330; Boston; MA  02111-1307  USA
    ========== licence end

 ===================================================================*/


#ifndef OMS_OIDARRAYREADER_HPP
#define OMS_OIDARRAYREADER_HPP


#include "gco00.h"
#include "gco10.h"


/*! 
  Class: OMS_OidArrayReader

  Description: From interface class OmsIOidReadIterator (--> gco10.h)
	             derived class for reading an array of OIDs

*/

class OMS_OidArrayReader : public OmsIOidReadIterator
{
public:
  OMS_OidArrayReader(OmsObjectId* pOids, int cntOids);
  void omsReset();
  const OmsObjectId& omsGet() const;
  void operator++ ();
  operator bool () const;
private:
  OmsObjectId* m_pOids;
  int m_cntOids;
  int m_cntr;
};


#endif

