/*!**************************************************************************

  module      : Pager_Dump.hpp

  -------------------------------------------------------------------------

  responsible : Henrik

  special area: pager
  description : Layout of pager dump structures

  last changed: 2002-03-11
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin  GPL
  Copyright (C) 2001 SAP AG

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  ========== licence end

*****************************************************************************/


#ifndef PAGER_DUMP_HPP
#define PAGER_DUMP_HPP



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "SAPDBCommon/SAPDB_Types.hpp"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

struct PagerDump 
{
    SAPDB_UInt4     dmpNumPagerWriter;
    SAPDB_UInt4     dmpRegisteredPagerWriter;
    SAPDB_UInt4     dmpSuspendPagerWriter;
    SAPDB_UInt4     dmpPagerOrder;
    SAPDB_Bool1     dmpSVPIsActive;
    SAPDB_Bool1     dmpPreparePagerWriter;
    SAPDB_Bool1     dmpPagerWriterDisabled;
};

#endif  /* PAGER_DUMP_HPP */
