/*!**************************************************************************

  module      : Pager_IRestart.hpp

  -------------------------------------------------------------------------

  responsible : Henrik

  special area: Pager
  description : Interface for Pager instantiation and Converter restart
  last changed: 2002-08-06
  see also    :

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2002

  ========== licence begin LGPL
  Copyright (C) 2002 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/


#ifndef PAGER_IRESTART_HPP
#define PAGER_IRESTART_HPP

class Pager_IRestart;

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

class Pager_IRestart {
public:
    // singleton

    /*!-------------------------------------------------------------------------
    function:     GetInstance
    description:  returns instance of Pager_IRestart/Pager_Controller. If
      no instance exists a new one will be created
    arguments:    none
    return value: (new) singleton instance of Pager_IRestart
    --------------------------------------------------------------------------*/
    static Pager_IRestart& GetInstance();

    /*!-------------------------------------------------------------------------
    function:     ReadConverter
    description:  Read converter from devices for restart

    arguments:    TaskID [in] own taskID 
    return value: none
    --------------------------------------------------------------------------*/
    virtual void ReadConverter (const tsp00_TaskId taskId) = 0;


};

#endif  /* PAGER_IRESTART_HPP */


