/*!***************************************************************************

  module      : RTEConf_BuildParamFileName.c

  -------------------------------------------------------------------------

  responsible : RobinW

  special area: 
  description : 


  last changed: 2002-05-08  00:00
  first created:2000-05-08  17:49

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2002



    ========== licence begin GPL
    Copyright (C) 2002 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/


#include "gsp01.h"  /* tsp01_RteError */
#include "gsp11.h"
#include "heo01.h"
#include "heo47.h"
#include "geo60.h"

#include "RunTime/Configuration/RTEConf_BuildParamFileName.h"


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

#define MOD__ "RTEConf_BuildParamFileName.c :"

/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  LOCAL CLASSES, STRUCTURES, TYPES, UNIONS ...                             *
 *===========================================================================*/


/*===========================================================================*
 *  METHODS                                                                  *
 *===========================================================================*/


externC SAPDB_Bool RTEConf_GetParamfileDir ( SAPDB_Char     *DBNameC,
                                             SAPDB_Char     *ParamDir, 
                                             SAPDB_Int      TerminateWithDelimiter,
                                             tsp01_RteError *RteError  )
{
    #undef  MF__
    #define MF__ MOD__"RTEConf_GetParamfileDir"

    SAPDB_Bool                Ok ;

    Ok = sqlGetIndependentConfigPath ( ParamDir, TerminateWithDelimiter, RteError) ;

    DBG3 ((MF__, "Ok = %d, ParamDir = %s", Ok, ParamDir));

    return (Ok) ;
}

/*---------------------------------------------------------------------------*/

externC SAPDB_Bool RTEConf_BuildParamFileNameWithPath ( SAPDB_Char     *DBNameC,
                                                        SAPDB_Int4     ParamVersion,
                                                        SAPDB_Char     *ParamFileNameWithPath,
                                                        tsp01_RteError *RteError)
{
    SAPDB_Bool     Ok ;

    Ok = RTEConf_GetParamfileDir ( DBNameC, ParamFileNameWithPath, TERM_WITH_DELIMITER_EO01, RteError ) ;
    if ( Ok )
    {
        strcat (ParamFileNameWithPath, DBNameC);

        if ( ParamVersion != XP_ACT_VERSION_SP11 )
        {
            SAPDB_Int4 ActFileNameLen = strlen(ParamFileNameWithPath) ;
            ParamFileNameWithPath[ActFileNameLen] = '.' ;
            ActFileNameLen++ ;
            if ( ParamVersion < 10 ) 
            {
                ParamFileNameWithPath[ActFileNameLen] = '0' ;
                ActFileNameLen++ ;
            }
            sql47_itoa( ParamVersion, ParamFileNameWithPath + ActFileNameLen, 
                sizeof(tsp00_Pathc) - ActFileNameLen );
        }
    }
    return ( Ok );
}

/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/
