/*!**************************************************************************

  module      : RTEHSS_PascalKernelInterface.h

  -------------------------------------------------------------------------

  responsible : RobinW

  special area: Kernel RunTime
  description : BuildParamFileName

  last changed: 2002-05-31  15:12
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2002

  ========== licence begin LGPL
  Copyright (C) 2002 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/

/*!
  Function:    RTEConf_GetParamfileDir
  Description: 

  Returns a pointer to own mapping info string. This string contains all
  information needed to allow establishing a mirror of all data devspaces.

  Mapping info is string build of Hexdigits only [0-9A-F].

  Arguments:    ownMappingInfoSize [out] number of hex digits returned
				ownMappingInfo [out] own mapping info string
  Return value: true if call suceeded, false if call failed
 */
externC SAPDB_Bool RTEConf_GetParamfileDir ( SAPDB_Char      *DBNameC,
                                             SAPDB_Char      *ParamDir, 
                                             SAPDB_Int       TerminateWithDelimiter,
                                             tsp01_RteError  *RteError  );



/*!
  Function:    RTEConf_BuildParamFileNameWithPath
  Description: 

  Returns a pointer to own mapping info string. This string contains all
  information needed to allow establishing a mirror of all data devspaces.

  Mapping info is string build of Hexdigits only [0-9A-F].

  Arguments:    ownMappingInfoSize [out] number of hex digits returned
				ownMappingInfo [out] own mapping info string
  Return value: true if call suceeded, false if call failed
 */
externC SAPDB_Bool RTEConf_BuildParamFileNameWithPath ( SAPDB_Char      *DBNameC,
                                                        SAPDB_Int4      ParamVersion,
                                                        SAPDB_Char      *ParamFileNameWithPath,
                                                        tsp01_RteError  *RteError);
