/*!**************************************************************************

  module      : RTEDiag_Appldiag.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: User Runtime
  description : Appldiag file routine

  last changed: 2001-12-18  22:32
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin LGPL
  Copyright (C) 2001 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/


#ifndef RTEDIAG_APPLDIAG_H
#define RTEDIAG_APPLDIAG_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/
#include "RunTime/RTE_Types.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/
externC SAPDB_Int4 RTEDiag_SpawnAppldiagLogger( 
	SAPDB_Char *argv[],	/* the original argv */
	SAPDB_Char *newTitle, /* the new argv[0] value */
    SAPDB_Int4 outputFd, /* copy of sql22_fd */
	SAPDB_Int4 useTimestamp, /* copy of sql22_time_stamp */
    RTE_FileOffset fileLimit); /* new parameter */

externC SAPDB_Int4 RTEDiag_XserverLogger( 
	SAPDB_Char *argv[], /* the original argv */
    SAPDB_Int4 outputFd, /* copy of sql22_fd */
    RTE_FileOffset fileLimit, /* protocol file size limit */
    SAPDB_Char const *protocolPipeName); /* optional named pipe or 0 */

/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/



#endif  /* RTEDIAG_APPLDIAG_H */
