/*!***************************************************************************

  module      : RTEIO_DevSpaceInfo.h

  -------------------------------------------------------------------------

  responsible : StefanP

  special area: InputOutput
  description : Updating physical device information for devspaces (C Interface)

  last changed: 2001-04-05  16:11
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin LGPL
  Copyright (C) 2001 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/


#ifndef RTEIO_DEVSPACEINFO_H
#define RTEIO_DEVSPACEINFO_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

/*===========================================================================*
 *  PROTOTYPS                                                                *
 *===========================================================================*/



/*!
  Function: RTEIO_UpdatePhysicalDevInfoForDevspace
  Description: Update information about physical devices of a specific devspace (UNIX only)

  Arguments: pDevspace [in/out]     Pointer to devspace

 */
externC void RTEIO_UpdatePhysicalDevInfoForDevspace (DEV_DESCR      *pDevspace);

#endif  /* RTEIO_DEVSPACEINFO_HPP */
