/*!***************************************************************************

  module      : RTE_KGS.cpp

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: Kernel
  description : RTE Kernel Global Section singleton


  last changed: 2001-04-24  14:43
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin LGPL
  Copyright (C) 2001 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "SAPDBCommon/MemoryManagement/SAPDBMem_NewDestroy.hpp"
#include "RunTime/RTE_KGS.hpp"
#include "RunTime/RTE_IGlobal.hpp"
#include "RunTime/RTE_ISystem.hpp"
#include "RunTime/MemoryManagement/RTEMem_Allocator.hpp"
#include "RunTime/MemoryManagement/RTEMem_PageAllocator.hpp"

/*===========================================================================*
 *  METHODS                                                                  *
 *===========================================================================*/
RTE_KGS * RTE_KGS::m_Instance = (RTE_KGS *)0;

RTE_KGS & RTE_KGS::Instance()
{
  SAPDBMEM_STATIC_RAW_ALLOCATE(Space, sizeof(RTE_KGS));
  
  if ( !RTE_KGS::m_Instance )
  {
    RTE_KGS::m_Instance = new (Space) RTE_KGS();
  }
  return *m_Instance;
}

RTE_KGS::RTE_KGS() :
    m_RTE_IGlobal(RTE_IGlobal::Instance()),
    m_RTE_ISystem(RTE_ISystem::Instance()),
    m_RTEMem_Allocator(RTEMem_Allocator::Instance()),
    m_RTEMem_PageAllocator(0)
{
}

/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/