/*!******************************************************************************

  module:		 SAPDBFields_RAMBuffer.hpp

  ------------------------------------------------------------------------------

  responsible:  TillL

  special area: SAPDBCommon/Fields

  description:  Class for field based random access buffers

                - This is a class for common usage.
                - The basis type of the buffer is SAPDB_Byte.

  see also:     

  ------------------------------------------------------------------------------

                         Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*******************************************************************************/


#ifndef SAPDBFIELDS_RAMBUFFER_HPP
#define SAPDBFIELDS_RAMBUFFER_HPP

#include "SAPDBCommon/Fields/SAPDBFields_FieldRAMBuffer.hpp"

/*!-------------------------------------------------------------------------
declaration : SAPDBFields_RAMBuffer
description:  Field based byte buffer
--------------------------------------------------------------------------*/
typedef SAPDBFields_FieldRAMBuffer < SAPDB_Byte >
                                        
        SAPDBFields_RAMBuffer;  

/*!-------------------------------------------------------------------------
enddeclaration : SAPDBFields_RAMBuffer
--------------------------------------------------------------------------*/




#endif // SAPDBFIELDS_RAMBUFFER_HPP
