/*!*********************************************************************

  module:       SAPDBTrace_FileTrace.hpp

  ----------------------------------------------------------------------

  responsible:  DanielD

  special area: SAPDB Tracing

  description:  writes trace output into file.

  ----------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

  *********************************************************************/

#ifndef SAPDBTRACE_FILETRACE_HPP
#define SAPDBTRACE_FILETRACE_HPP

class SAPDBTrace_Stream;
class SAPDBMem_IRawAllocator;

/*! function: SAPDBTrace_NewFileTrace
    description: creates a new file based <Class>SAPDBTrace_Stream</>

        The file is overwritten, not appended.

        This is usable only for test programs as there is currently
        no way to free the associated ressources.

    arguments:
        filename [in] the name of the trace file.
        allocator [in,out] the <Class>SAPDBMem_IRawAllocator</> used
            to allocate the instance.
 */
SAPDBTrace_Stream * SAPDBTrace_NewFileTrace (
    const char * filename,
    SAPDBMem_IRawAllocator * allocator_param);

#endif

