/*
    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end
*/

/*!**********************************************************************

  module: StudioWeb_HtmlFragments.h

  -----------------------------------------------------------------------

  responsible:  WolfgangA

  special area: WebSQL

  description:  HTML Fragments for websql HTML pages

************************************************************************/


#ifndef STUDIOWEB_HTMLFRAGMENTS_H
#define STUDIOWEB_HTMLFRAGMENTS_H



/*=======================================================================
 *  INCLUDES
 *=====================================================================*/



/*=======================================================================
 * HTML CODE
 *=====================================================================*/

/*----------------------------------------------------------------------------\
// FORMACTIONPOST
//----------------------------------------------------------------------------*/
#define  WQ_UTF8ENCODING "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n"

/*----------------------------------------------------------------------------\
// FORMACTIONPOST
//----------------------------------------------------------------------------*/
#define  WQ_FORMACTIONPOST	   "<form method=\"POST\" action=\""

/*----------------------------------------------------------------------------\
// WQ_BUTTONFORM2
//----------------------------------------------------------------------------*/
#define  WQ_BUTTONFORM2	   "<input type=\"submit\" value=\""

/*----------------------------------------------------------------------------\
// WQ_BUTTONFORM4
//----------------------------------------------------------------------------*/
#define  WQ_BUTTONFORM4	   "<input type=\"hidden\" name=\""

/*----------------------------------------------------------------------------\
// WQ_BUTTONFORM6
//----------------------------------------------------------------------------*/
#define  WQ_BUTTONFORM6	   "\n<td width=\"25%\">\n"

/*----------------------------------------------------------------------------\
// WQ_WIDTH100
//----------------------------------------------------------------------------*/
#define  WQ_WIDTH100	   " width=\"100%\" "							

/*----------------------------------------------------------------------------\
// WQ_BORDER
//----------------------------------------------------------------------------*/
#define  WQ_BORDER		" border="

/*----------------------------------------------------------------------------\
// WQ_NAME
//----------------------------------------------------------------------------*/
#define  WQ_NAME	" name=\""

/*----------------------------------------------------------------------------\
// WQ_VALUE
//----------------------------------------------------------------------------*/
#define  WQ_VALUE	   " value=\""

/*----------------------------------------------------------------------------\
// WQ_HTML_BEGIN
//----------------------------------------------------------------------------*/
#define   WQ_HTML_BEGIN "<html>\n"

/*----------------------------------------------------------------------------\
// WQ_HTML_END
//----------------------------------------------------------------------------*/
#define   WQ_HTML_END "</html>\n"

/*----------------------------------------------------------------------------\
// WQ_HTML_HEADER_BEGIN
//----------------------------------------------------------------------------*/
#define WQ_HTML_HEADER_BEGIN "<head>\n"

/*----------------------------------------------------------------------------\
// WQ_HTML_HEADER_END
//----------------------------------------------------------------------------*/
#define  WQ_HTML_HEADER_END "</head>\n"

/*----------------------------------------------------------------------------\
// WQ_TITLE_BEGIN
//----------------------------------------------------------------------------*/
#define  WQ_TITLE_BEGIN "<title>"

/*----------------------------------------------------------------------------\
// WQ_TITLE_END
//----------------------------------------------------------------------------*/
#define  WQ_TITLE_END "</title>\n"

/*----------------------------------------------------------------------------\
//  WQ_PARAMFORMNAME 
//----------------------------------------------------------------------------*/
#define  WQ_PARAMFORMNAME "frmParam"

/*----------------------------------------------------------------------------\
//  WQ_FUNCTION
//----------------------------------------------------------------------------*/
#define  WQ_FUNCTION " function "

/*----------------------------------------------------------------------------\
//  WQ_SCRIPTCONTINUE
//----------------------------------------------------------------------------*/
#define WQ_SCRIPTCONTINUE "() { document."

/*----------------------------------------------------------------------------\
//  WQ_SCRIPTCONTINUE2
//----------------------------------------------------------------------------*/
#define  WQ_SCRIPTCONTINUE2 ".submit();}"

/*----------------------------------------------------------------------------\
// WQ_SERVICEDLL
//----------------------------------------------------------------------------*/
#define  WQ_SERVICEDLL "websql"

/*----------------------------------------------------------------------------\
// WQ_MAINWINDOW_TAG
//----------------------------------------------------------------------------*/
#define  WQ_MAINWINDOW_TAG  "websql"

/*----------------------------------------------------------------------------\
// WQ_TREEWINDOW_TAG
//----------------------------------------------------------------------------*/
#define  WQ_TREEWINDOW_TAG  "tree"

/*----------------------------------------------------------------------------\
// WQ_DSQL_WINDOW
//----------------------------------------------------------------------------*/
#define  WQ_DSQL_WINDOW "dsql" 

/*----------------------------------------------------------------------------\
// WQ_CREATENEWFOLDER
//----------------------------------------------------------------------------*/
#define  WQ_CREATENEWFOLDER "createnewfolder" 

/*----------------------------------------------------------------------------\
// WQ_RENAMEITEM
//----------------------------------------------------------------------------*/
#define  WQ_RENAMEITEM  "renameitem"

/*----------------------------------------------------------------------------\
// WQ_NEWITEM
//----------------------------------------------------------------------------*/
#define  WQ_NEWITEM  "newitem"

/*----------------------------------------------------------------------------\
// WQ_MOVETOFOLDER
//----------------------------------------------------------------------------*/
#define  WQ_MOVETOFOLDER "movetofolder"

/*----------------------------------------------------------------------------\
// WQ_COPYTOFOLDER
//----------------------------------------------------------------------------*/
#define  WQ_COPYTOFOLDER "copytofolder"

/*----------------------------------------------------------------------------\
// WQ_ACTIONTOTAKE
//----------------------------------------------------------------------------*/
#define  WQ_ACTIONTOTAKE "actiontotake"

/*----------------------------------------------------------------------------\
// WQ_DELETEITEMFILE
//----------------------------------------------------------------------------*/
#define  WQ_DELETEITEMFILE "deleteitemfile"

/*----------------------------------------------------------------------------\
// WQ_DELETEITEMFOLDER
//----------------------------------------------------------------------------*/
#define  WQ_DELETEITEMFOLDER "deleteitemfolder"

/*----------------------------------------------------------------------------\
// WQ_LOGOFF_TAG
//----------------------------------------------------------------------------*/
#define  WQ_LOGOFF_TAG  "logoff"

/*----------------------------------------------------------------------------\
// WQ_CLEAR_TAG
//----------------------------------------------------------------------------*/
#define  WQ_CLEAR_TAG  "clear"

/*----------------------------------------------------------------------------\
// WQ_RESULTPAGE_TAG
//----------------------------------------------------------------------------*/
#define  WQ_RESULTPAGE_TAG  "result"

/*----------------------------------------------------------------------------\
// WQ_RESULTS_TAG
//----------------------------------------------------------------------------*/
#define  WQ_RESULTS_TAG  "results"

/*----------------------------------------------------------------------------\
// WQ_FRAME_TAG
//----------------------------------------------------------------------------*/
#define  WQ_FRAME_TAG "wqframe"

/*----------------------------------------------------------------------------\
// WQ_EXECUTE_TAG
//----------------------------------------------------------------------------*/
#define  WQ_DSQLEXECUTE_TAG  "dsqlexecute"

/*----------------------------------------------------------------------------\
// WQ_HEADERPAGE_TAG
//----------------------------------------------------------------------------*/
#define  WQ_HEADERPAGE_TAG  "wqheaderpage"

/*----------------------------------------------------------------------------\
// WQ_STOREDSTATMENTPATH_TAG
//----------------------------------------------------------------------------*/
#define  WQ_STOREDSTATEMENTPATH_TAG  "Path of Stored Statement: "

/*----------------------------------------------------------------------------\
// OBJ_STOREITEMTEXT1
//----------------------------------------------------------------------------*/
#define OBJ_STOREITEMTEXT1	    "Save in selected Folder"

/*----------------------------------------------------------------------------\
// OBJ_STOREITEMTEXT2
//----------------------------------------------------------------------------*/
#define OBJ_STOREITEMTEXT2	    "Save"

/*----------------------------------------------------------------------------\
// WQ_WQLOGONMAIN_TAG
//----------------------------------------------------------------------------*/
#define  WQ_WQLOGONMAIN_TAG  "wqlogonmain"

/*----------------------------------------------------------------------------\
// WQ_TREEBUTTON_PAGE
//----------------------------------------------------------------------------*/
#define WQ_TREEBUTTON_PAGE  "treebuttons"

/*----------------------------------------------------------------------------\
// WQ_JS_BEGIN
//----------------------------------------------------------------------------*/
#define  WQ_JS_BEGIN "<script language=\"JavaScript\">\n"

/*----------------------------------------------------------------------------\
// WQ_JS_BEGIN2
//----------------------------------------------------------------------------*/
#define  WQ_JS_BEGIN2 "<script>"

/*----------------------------------------------------------------------------\
// WQ_JS_BEGIN
//----------------------------------------------------------------------------*/
#define  WQ_JS_BEGIN3 "<script language=\"JavaScript\" src="

/*----------------------------------------------------------------------------\
// WQ_JS_END
//----------------------------------------------------------------------------*/
#define  WQ_JS_END "</script>"

/*----------------------------------------------------------------------------\
// WQ_BG_COLOR
//----------------------------------------------------------------------------*/
#define  WQ_BG_COLOR "bgcolor=\"#DEDEC8\" "

/*----------------------------------------------------------------------------\
// WQ_SHOWNAVIGATION
//----------------------------------------------------------------------------*/
#define  WQ_SHOWNAVIGATION "onLoad=\"parent.showNavigation(0);\""

/*----------------------------------------------------------------------------\
// WQ_MARKSELECTEDITEM
//----------------------------------------------------------------------------*/
#define  WQ_MARKSELECTEDITEM "parent.markSelectedItem(0,true);"

/*----------------------------------------------------------------------------\
// WQ_MARKSELECTEDITEM
//----------------------------------------------------------------------------*/
#define  WQ_HREFASFUNCTION "parent.hRefAsFunction(0,'parent.dsql.refreshDSQLStoredStatement');"

/*----------------------------------------------------------------------------\
// WQ_SQLQUERYTEXT
//----------------------------------------------------------------------------*/
#define  WQ_SQLQUERYTEXT  "dsqlquerytext"

/*----------------------------------------------------------------------------\
// WQ_PATHTOSTORE
//----------------------------------------------------------------------------*/
#define  WQ_PATHTOSTORE  "pathtostore"

/*----------------------------------------------------------------------------\
// WQ_OVERWRITE
//----------------------------------------------------------------------------*/
#define  WQ_OVERWRITE  "overwrite"

/*----------------------------------------------------------------------------\
// WQ_FIRSTBUTTON_TAG
//----------------------------------------------------------------------------*/
#define  WQ_FIRSTBUTTON_TAG  "top"

/*----------------------------------------------------------------------------\
// WQ_PREVBUTTON_TAG
//----------------------------------------------------------------------------*/
#define  WQ_PREVBUTTON_TAG  "prev"

/*----------------------------------------------------------------------------\
// WQ_NEXTBUTTON_TAG
//----------------------------------------------------------------------------*/
#define  WQ_NEXTBUTTON_TAG  "nextbutton"

/*----------------------------------------------------------------------------\
// WQ_LASTBUTTON_TAG
//----------------------------------------------------------------------------*/
#define  WQ_LASTBUTTON_TAG  "last"

/*----------------------------------------------------------------------------\
// WQ_LOGON_TAG
//----------------------------------------------------------------------------*/
#define  WQ_LOGON_TAG "logon"

/*----------------------------------------------------------------------------\
// WQ_CRYPT_TAG
//----------------------------------------------------------------------------*/
#define  WQ_CRYPT_TAG "CRYPT"

/*----------------------------------------------------------------------------\
// WQ_PREVSTATEMENT_TAG
//----------------------------------------------------------------------------*/
#define  WQ_PREVSTATEMENT_TAG "prevstatement"

/*----------------------------------------------------------------------------\
// WQ_NEXTSTATEMENT_TAG
//----------------------------------------------------------------------------*/
#define  WQ_NEXTSTATEMENT_TAG "nextstatement"

/*----------------------------------------------------------------------------\
// WQ_EVENT_TAG
//----------------------------------------------------------------------------*/
#define  WQ_EVENT_TAG "event"

/*----------------------------------------------------------------------------\
// WQ_DBTIMEOUT_TAG
//----------------------------------------------------------------------------*/
#define  WQ_DBTIMEOUT_TAG "connectionPoolTimeout"

/*----------------------------------------------------------------------------\
// WQ_ODBCDRIVER_TAG
//----------------------------------------------------------------------------*/
#define  WQ_ODBCDRIVER_TAG "odbcDriver"

/*----------------------------------------------------------------------------\
// WQ_NEXTPARAMBUTTON_TAG
//----------------------------------------------------------------------------*/
#define  WQ_NEXTPARAMBUTTON_TAG  "nextparambutton"
/*----------------------------------------------------------------------------\
// WQ_STOREDQUERY_TAG
//----------------------------------------------------------------------------*/
#define  WQ_STOREDQUERY_TAG "STOREDQUERY"

/*----------------------------------------------------------------------------\
// WQ_BODYCLOSE
//----------------------------------------------------------------------------*/
#define  WQ_BODYCLOSE "</body>\n"

/*----------------------------------------------------------------------------\
// WQ_JSROOT
//----------------------------------------------------------------------------*/
#define   WQ_JSROOT "parent.Navigations.items[0]."	

/*----------------------------------------------------------------------------\
// WQ_STOREDQUERY_FOLDER
//----------------------------------------------------------------------------*/
#define  WQ_STOREDQUERY_FOLDER "/"

/*----------------------------------------------------------------------------\
// WQ_DBNAME_TAG
//----------------------------------------------------------------------------*/
#define  WQ_DBNAME_TAG	 "wqDatabase"

/*----------------------------------------------------------------------------\
// WQ_DBSERVER_TAG
//----------------------------------------------------------------------------*/
#define  WQ_DBSERVER_TAG	 "wqServer"

/*----------------------------------------------------------------------------\
// WQ_PASSWORD_TAG
//----------------------------------------------------------------------------*/
#define  WQ_PASSWORD_TAG "wqPassword"

/*----------------------------------------------------------------------------\
// WQ_DBUSER_TAG
//----------------------------------------------------------------------------*/
#define  WQ_DBUSER_TAG "wqUser"

/*----------------------------------------------------------------------------\
// WQ_LASTBUTTONNAME
//----------------------------------------------------------------------------*/
#define  WQ_LASTBUTTONNAME  "Bottom"

/*----------------------------------------------------------------------------\
// WQ_FIRSTBUTTONNAME
//----------------------------------------------------------------------------*/
#define  WQ_FIRSTBUTTONNAME  "Top"

/*----------------------------------------------------------------------------\
// WQ_PREVBUTTONNAME
//----------------------------------------------------------------------------*/
#define  WQ_PREVBUTTONNAME  "Previous"

/*----------------------------------------------------------------------------\
// WQ_NEXTBUTTONNAME
//----------------------------------------------------------------------------*/
#define  WQ_NEXTBUTTONNAME  "Next"

/*----------------------------------------------------------------------------\
// WQ_USERNAME_TAG
//----------------------------------------------------------------------------*/
#define  WQ_NEXTPARAMBUTTONNAME  "Continue"

/*----------------------------------------------------------------------------\
// WQ_CLOSETAG
//----------------------------------------------------------------------------*/
#define WQ_CLOSETAG ">\n"

/*----------------------------------------------------------------------------\
// WQ_PARAGRAPHOPEN
//----------------------------------------------------------------------------*/
#define  WQ_PARAGRAPHOPEN "\n<p>"

/*----------------------------------------------------------------------------\
// WQ_PARAGRAPHCLOSE
//----------------------------------------------------------------------------*/
#define  WQ_PARAGRAPHCLOSE "</p>\n"

/*----------------------------------------------------------------------------\
// WQ_FORMCLOSE
//----------------------------------------------------------------------------*/
#define WQ_FORMCLOSE "</form>\n"

/*----------------------------------------------------------------------------\
// WQ_CLASS
//----------------------------------------------------------------------------*/
#define WQ_CLASS " class=\""

/*----------------------------------------------------------------------------\
// WQ_ALIGNCENTER
//----------------------------------------------------------------------------*/
#define WQ_ALIGNCENTER  " align=\"Center\""

/*----------------------------------------------------------------------------\
// WQ_LINEBREAK
//----------------------------------------------------------------------------*/
#define WQ_LINEBREAK "<br>"

/*----------------------------------------------------------------------------\
// WQ_BODYOPEN
//----------------------------------------------------------------------------*/
#define  WQ_BODYOPEN "\n<body "

/*----------------------------------------------------------------------------\
// WQ_BODYOPEN2
//----------------------------------------------------------------------------*/
#define  WQ_BODYOPEN2 "\n<body link=\"#0000FF\" vlink=\"#0000FF\" background=\"/WARoot/Images/tatami.gif\" topmargin=\"4\" leftmargin=\"4\""

// WQ_JS_ADDNAV
//----------------------------------------------------------------------------*/
#define  WQ_JS_ADDNAV "parent.Navigations.addNavigation(new parent.navigation(\""

/*----------------------------------------------------------------------------\
// WQ_JS_NAVONE
//----------------------------------------------------------------------------*/
#define  WQ_JS_NAVONE "parent.Navigations.justOneNavigation(new parent.navigation(\""

/*----------------------------------------------------------------------------\
// WQ_JS_CLEAR_TREE
//----------------------------------------------------------------------------*/
#define   WQ_JS_CLEAR_TREE "parent.Navigations = new parent.navigations();\n"

/*----------------------------------------------------------------------------\
// WQ_JS2
//----------------------------------------------------------------------------*/
#define  WQ_JS2 "nodes["

/*----------------------------------------------------------------------------\
// WQ_JS3
//----------------------------------------------------------------------------*/
#define  WQ_JS3 "addNode(new parent.node(\""

/*----------------------------------------------------------------------------\
// WQ_WSTEXT_ON
//----------------------------------------------------------------------------*/
#define  WQ_WSTEXT_ON " on "

/*----------------------------------------------------------------------------\
// WQ_NO
//----------------------------------------------------------------------------*/
#define  WQ_NO "no"

/*----------------------------------------------------------------------------\
// WQ_ON
//----------------------------------------------------------------------------*/
#define  WQ_ON "on"

/*----------------------------------------------------------------------------\
// WQ_OFF
//----------------------------------------------------------------------------*/
#define  WQ_OFF "off"

/*----------------------------------------------------------------------------\
// WQ_YES
//----------------------------------------------------------------------------*/
#define  WQ_YES "yes"

/*----------------------------------------------------------------------------\
// WQ_PARAMTEXT
//----------------------------------------------------------------------------*/
#define  WQ_PARAMTEXT "Complete query"

/*----------------------------------------------------------------------------\
// WQ_CREATEWEBSQLURL
//----------------------------------------------------------------------------*/
#define  WQ_CREATEWEBSQLURL "parent.CreateWebSQLURL(\""

/*----------------------------------------------------------------------------\
// WQ_REFRESHFRAMESCTIPT
//----------------------------------------------------------------------------*/
#define  WQ_REFRESHFRAMESCTIPT "<script language=\"JavaScript\">function refreshDSQLWindow() {parent.frames.dsql.location.href = parent.CreateWebSQLURL(\"dsql=refresh\");} </script>"

/*----------------------------------------------------------------------------\
// WQ_REFRESHDSQLWINDOW
//----------------------------------------------------------------------------*/
#define  WQ_REFRESHDSQLWINDOW "onLoad=\"refreshDSQLWindow()\""

/*----------------------------------------------------------------------------\
// WQ_STYLESHEET
//----------------------------------------------------------------------------*/
#define  WQ_STYLESHEET "<link rel=\"stylesheet\" href=\"/WARoot/Styles/sapdbweb.css\" type=\"text/css\">\n"

/*----------------------------------------------------------------------------\
// WQ_AUTOCOMMIT_TAG
//----------------------------------------------------------------------------*/
#define  WQ_AUTOCOMMIT_TAG	 "AutoCommit"

/*----------------------------------------------------------------------------\
// WQ_SQLMODE_TAG
//----------------------------------------------------------------------------*/
#define  WQ_SQLMODE_TAG	 "SQLMode"

/*----------------------------------------------------------------------------\
// WQ_ISOLATIONLEVEL_TAG
//----------------------------------------------------------------------------*/
#define  WQ_ISOLATIONLEVEL_TAG	 "IsolationLevel"

/*----------------------------------------------------------------------------\
// WQ_REFRESH_TAG
//----------------------------------------------------------------------------*/
#define  WQ_REFRESH_TAG	 "refresh"

/*----------------------------------------------------------------------------\
// WQ_ZOOM_ROW_TAG
//----------------------------------------------------------------------------*/
#define  WQ_ZOOM_ROW_TAG "zoomrow"

/*----------------------------------------------------------------------------\
// WQ_ZOOM_COL_TAG
//----------------------------------------------------------------------------*/
#define  WQ_ZOOM_COL_TAG "zoomcol"

/*----------------------------------------------------------------------------\
// WQ_HEXVIEW
//----------------------------------------------------------------------------*/
#define  WQ_HEXVIEW "Hexadecimal Zoom"

/*----------------------------------------------------------------------------\
// WQ_ZOOMWARN1
//----------------------------------------------------------------------------*/
#define  WQ_ZOOMWARN1 " ;Warning: Maximum size for data is "

/*----------------------------------------------------------------------------\
// WQ_ZOOMWARN2
//----------------------------------------------------------------------------*/
#define  WQ_ZOOMWARN2 " bytes, data is truncated !"

/*----------------------------------------------------------------------------\
// WQ_ZOOMBACK_TAG
//----------------------------------------------------------------------------*/
#define  WQ_ZOOMBACK_TAG "zoomback"

/*----------------------------------------------------------------------------\
// WQ_ZOOMBACKTEXT_TAG
//----------------------------------------------------------------------------*/
#define  WQ_ZOOMBACKTEXT_TAG "Back to result"

/*----------------------------------------------------------------------------\
// WQ_TARGETTOP
//----------------------------------------------------------------------------*/
#define  WQ_TARGETTOP  "_top"

/*----------------------------------------------------------------------------\
// WQ_TARGETSELF
//----------------------------------------------------------------------------*/
#define  WQ_TARGETSELF			"_self"

/*----------------------------------------------------------------------------\
// WQ_NPSP
//----------------------------------------------------------------------------*/
#define  WQ_NPSP "&nbsp;"



#endif
