/****************************************************************************

  module      : SysView_CacheStatisticsReset.cpp

  -------------------------------------------------------------------------

  responsible : UlrichJ

  special area: SystemViews
  description : This module implements the "CacheStatisticsReset" view class.

  last changed: 2002-08-14
  see also    :

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2002

  ========== licence begin LGPL
  Copyright  (C) 2002 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or  (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "ggg00.h"
#include "SystemViews/SysView_Defines.hpp"
#include "SystemViews/SysView_ISessionObj.hpp"
#include "SystemViews/SysView_ITableObj.hpp"
#include "SystemViews/SysView_CacheStatisticsReset.hpp"


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/



/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL CLASSES, STRUCTURES, TYPES, UNIONS ...                             *
 *===========================================================================*/



/*===========================================================================*
 *  STATIC/INLINE FUNCTIONS  (PROTOTYPES)                                     *
 *===========================================================================*/



/*===========================================================================*
 *  METHODS                                                                  *
 *===========================================================================*/

void SysView_CacheStatisticsReset::Create()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_CacheStatisticsReset::Create", SysView_Trace, 5);

	m_Table->AppendCol (ITOCT_CHAR ,SV_NAME, 4, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_ACCESSCOUNT, 11, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_SUCCESSFULACCESSCOUNT, 21, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_UNSUCCESSFULACCESSCOUNT, 23, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_HITRATE, 7, 3);

}

/*---------------------------------------------------------------------------*/

SAPDB_Int SysView_CacheStatisticsReset::GetColCount()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_CacheStatisticsReset::GetColCount", SysView_Trace, 5);

    return SV_CC_CACHESTATISTICSRESET;
}

/*---------------------------------------------------------------------------*/

SAPDB_Int SysView_CacheStatisticsReset::EstimateRows()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_CacheStatisticsReset::EstimateRows", SysView_Trace, 5);

    return SV_ER_CACHESTATISTICSRESET;
}

/*---------------------------------------------------------------------------*/

void SysView_CacheStatisticsReset::Execute()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_CacheStatisticsReset::Execute", SysView_Trace, 5);

    m_Session->ThrowError (e_not_implemented, 1);
}

/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/
