/****************************************************************************

  module      : SysView_DataCache.cpp

  -------------------------------------------------------------------------

  responsible : UlrichJ

  special area: SystemViews
  description : This module implements the "DataCache" view class.

  last changed: 2002-08-14
  see also    :

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2002

  ========== licence begin LGPL
  Copyright  (C) 2002 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or  (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "ggg00.h"
#include "SystemViews/SysView_Defines.hpp"
#include "SystemViews/SysView_ISessionObj.hpp"
#include "SystemViews/SysView_ITableObj.hpp"
#include "SystemViews/SysView_DataCache.hpp"


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/



/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL CLASSES, STRUCTURES, TYPES, UNIONS ...                             *
 *===========================================================================*/



/*===========================================================================*
 *  STATIC/INLINE FUNCTIONS  (PROTOTYPES)                                     *
 *===========================================================================*/



/*===========================================================================*
 *  METHODS                                                                  *
 *===========================================================================*/

void SysView_DataCache::Create()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_DataCache::Create", SysView_Trace, 5);

	m_Table->AppendCol (ITOCT_FIXED ,SV_USABLESIZE, 10, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_USEDSIZE, 8, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MAXUSEDSIZE, 11, 20);
	m_Table->AppendCol (ITOCT_CHAR ,SV_ENHANCEDMEMORYISUSED, 20, 3);
	m_Table->AppendCol (ITOCT_CHAR ,SV_ENHANCEDMEMORYTYPE, 18, 12);
	m_Table->AppendCol (ITOCT_FIXED ,SV_ENHANCEDMEMORYMAPSIZE, 21, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_ENHANCEDMEMORYUNMAPSIZE, 23, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_OMSDATASIZE, 11, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_OMSKEYDATASIZE, 14, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_HISTORYDATASIZE, 15, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_SQLDATASIZE, 11, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_CHANGEDDATASIZE, 15, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_PENDINGOPERATIONCOUNT, 21, 10);

}

/*---------------------------------------------------------------------------*/

SAPDB_Int SysView_DataCache::GetColCount()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_DataCache::GetColCount", SysView_Trace, 5);

    return SV_CC_DATACACHE;
}

/*---------------------------------------------------------------------------*/

SAPDB_Int SysView_DataCache::EstimateRows()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_DataCache::EstimateRows", SysView_Trace, 5);

    return SV_ER_DATACACHE;
}

/*---------------------------------------------------------------------------*/

void SysView_DataCache::Execute()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_DataCache::Execute", SysView_Trace, 5);

    m_Session->ThrowError (e_not_implemented, 1);
}

/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/
