/*!**************************************************************************

  module      : SysView_Defines.hpp

  -------------------------------------------------------------------------

  responsible : UlrichJ

  special area: SystemViews
  description : This file contains the defines for the system view table columns.

  last changed: 2002-08-08
  see also    :

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin LGPL
  Copyright (C) 2001 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/


#ifndef SYSVIEW_DEFINES_HPP
#define SYSVIEW_DEFINES_HPP


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "SAPDBCommon/Tracing/SAPDBTrace_Topic.hpp"
#include "SAPDBCommon/Tracing/SAPDBTrace_Usage.hpp"


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

extern SAPDBTrace_Topic SysView_Trace;

#define SV_ACCESSCOUNT                     	"ACCESSCOUNT"
#define SV_ACTIVE                          	"ACTIVE"
#define SV_ADDRESSINGMODE                  	"ADDRESSINGMODE"
#define SV_ALLOBJECTCOUNT                  	"ALLOBJECTCOUNT"
#define SV_ALLOCATECOUNT                   	"ALLOCATECOUNT"
#define SV_ALLOCATEDSIZE                   	"ALLOCATEDSIZE"
#define SV_ALLOCATEOBJECTCOUNT             	"ALLOCATEOBJECTCOUNT"
#define SV_ALLOCATORNAME                   	"ALLOCATORNAME"
#define SV_APPLICATIONNODE                 	"APPLICATIONNODE"
#define SV_APPLICATIONPROCESS              	"APPLICATIONPROCESS"
#define SV_APPLICATIONTYPE                 	"APPLICATIONTYPE"
#define SV_ARCHIVELOGENABLED               	"ARCHIVELOGENABLED"
#define SV_AVGLONGCOLUMNLENGTH             	"AVGLONGCOLUMNLENGTH"
#define SV_AVGMEMORYDELTA                  	"AVGMEMORYDELTA"
#define SV_AVGREADSTREAMBUFFERCOUNT        	"AVGREADSTREAMBUFFERCOUNT"
#define SV_AVGREADSTREAMROWCOUNT           	"AVGREADSTREAMROWCOUNT"
#define SV_AVGRELEASEMEMORYCHUNKSIZE       	"AVGRELEASEMEMORYCHUNKSIZE"
#define SV_AVGREQUESTMEMORYCHUNKSIZE       	"AVGREQUESTMEMORYCHUNKSIZE"
#define SV_AVGROWCOUNTPERLEAF              	"AVGROWCOUNTPERLEAF"
#define SV_AVGROWCOUNTPERSECONDARYKEY      	"AVGROWCOUNTPERSECONDARYKEY"
#define SV_AVGROWLENGTH                    	"AVGROWLENGTH"
#define SV_AVGSECONDARYKEYLENGTH           	"AVGSECONDARYKEYLENGTH"
#define SV_AVGSEPARATORLENGTH              	"AVGSEPARATORLENGTH"
#define SV_AVGUSEDENTRYCOUNT               	"AVGUSEDENTRYCOUNT"
#define SV_AVGUSEDENTRYCOUNTPERCENTAGE     	"AVGUSEDENTRYCOUNTPERCENTAGE"
#define SV_AVGUSEDSIZEPERCENTAGEINLEAVES   	"AVGUSEDSIZEPERCENTAGEINLEAVES"
#define SV_AVGVAROBJECTLENGTH              	"AVGVAROBJECTLENGTH"
#define SV_AVGWAITCOUNTPERPAGE             	"AVGWAITCOUNTPERPAGE"
#define SV_AVGWAITTIMEFORNEWCONSISTENTVIEW 	"AVGWAITTIMEFORNEWCONSISTENTVIEW"
#define SV_AVGWRITESTREAMBUFFERCOUNT       	"AVGWRITESTREAMBUFFERCOUNT"
#define SV_AVGWRITESTREAMROWCOUNT          	"AVGWRITESTREAMROWCOUNT"
#define SV_BADINDEXCOUNT                   	"BADINDEXCOUNT"
#define SV_BASEALLOCATECOUNT               	"BASEALLOCATECOUNT"
#define SV_BASEALLOCATORNAME               	"BASEALLOCATORNAME"
#define SV_BASEDEALLOCATECOUNT             	"BASEDEALLOCATECOUNT"
#define SV_BUILD                           	"BUILD"
#define SV_BYTESRECEIVED                   	"BYTESRECEIVED"
#define SV_BYTESREPLIED                    	"BYTESREPLIED"
#define SV_CALCULATEDSIZE                  	"CALCULATEDSIZE"
#define SV_CALLCOUNT                       	"CALLCOUNT"
#define SV_CALLSTACK                       	"CALLSTACK"
#define SV_CANCELFLAG                      	"CANCELFLAG"
#define SV_CATALOGCACHEUSEDSIZE            	"CATALOGCACHEUSEDSIZE"
#define SV_CHANGEDDATASIZE                 	"CHANGEDDATASIZE"
#define SV_CHUNKCOUNT                      	"CHUNKCOUNT"
#define SV_CHUNKSIZE                       	"CHUNKSIZE"
#define SV_CLASSGUID                       	"CLASSGUID"
#define SV_CLASSNAME                       	"CLASSNAME"
#define SV_CLEANUPCOUNT                    	"CLEANUPCOUNT"
#define SV_CMDEXECUTETIME                  	"CMDEXECUTETIME"
#define SV_CMDWAITABSOLUTETIME             	"CMDWAITABSOLUTETIME"
#define SV_CMDWAITRELATIVETIME             	"CMDWAITRELATIVETIME"
#define SV_COLLISIONCOUNT                  	"COLLISIONCOUNT"
#define SV_COLLISIONRATE                   	"COLLISIONRATE"
#define SV_COLUMNNAME                      	"COLUMNNAME"
#define SV_COMMENT                         	"COMMENT"
#define SV_COMMITSUBTRANSCOUNT             	"COMMITSUBTRANSCOUNT"
#define SV_COMMUNICATIONCOUNT              	"COMMUNICATIONCOUNT"
#define SV_CONFIGUREDSIZE                  	"CONFIGUREDSIZE"
#define SV_CONNECTSTATE                    	"CONNECTSTATE"
#define SV_CONSISTENTVIEWID                	"CONSISTENTVIEWID"
#define SV_CONTAINERNUMBER                 	"CONTAINERNUMBER"
#define SV_CONVERTERVERSION                	"CONVERTERVERSION"
#define SV_CORRECTIONLEVEL                 	"CORRECTIONLEVEL"
#define SV_CPPEXCEPTIONCOUNT               	"CPPEXCEPTIONCOUNT"
#define SV_CREATEDATE                      	"CREATEDATE"
#define SV_CREATEOBJECTCOUNT               	"CREATEOBJECTCOUNT"
#define SV_CYCLERELATEDENDOFFSET           	"CYCLERELATEDENDOFFSET"
#define SV_DATABASEIDENTIFIER              	"DATABASEIDENTIFIER"
#define SV_DATAFULL                        	"DATAFULL"
#define SV_DATEFORMAT                      	"DATEFORMAT"
#define SV_DEADLOCKCOUNT                   	"DEADLOCKCOUNT"
#define SV_DEALLOCATECOUNT                 	"DEALLOCATECOUNT"
#define SV_DEFINEDLONGCOLUMNCOUNT          	"DEFINEDLONGCOLUMNCOUNT"
#define SV_DELETECACHEDOBJECTCOUNT         	"DELETECACHEDOBJECTCOUNT"
#define SV_DELETEOBJECTCOUNT               	"DELETEOBJECTCOUNT"
#define SV_DESCRIPTION                     	"DESCRIPTION"
#define SV_DEVICESTATE                     	"DEVICESTATE"
#define SV_DIFFERENTIALBACKUPSIZE          	"DIFFERENTIALBACKUPSIZE"
#define SV_DISPATCHCOUNT                   	"DISPATCHCOUNT"
#define SV_DISTINCTVALUECOUNT              	"DISTINCTVALUECOUNT"
#define SV_DROPCONTAINERCOUNT              	"DROPCONTAINERCOUNT"
#define SV_EMERGENCYCLEANUPCOUNT           	"EMERGENCYCLEANUPCOUNT"
#define SV_ENHANCEDMEMORYISUSED            	"ENHANCEDMEMORYISUSED"
#define SV_ENHANCEDMEMORYMAPSIZE           	"ENHANCEDMEMORYMAPSIZE"
#define SV_ENHANCEDMEMORYTYPE              	"ENHANCEDMEMORYTYPE"
#define SV_ENHANCEDMEMORYUNMAPSIZE         	"ENHANCEDMEMORYUNMAPSIZE"
#define SV_ENTRYCOUNT                      	"ENTRYCOUNT"
#define SV_EXTENDEDTASKSTATE               	"EXTENDEDTASKSTATE"
#define SV_FAILEDALLOCATECOUNT             	"FAILEDALLOCATECOUNT"
#define SV_FILEDIRECTORYROOT               	"FILEDIRECTORYROOT"
#define SV_FILEID                          	"FILEID"
#define SV_FLUSHMODE                       	"FLUSHMODE"
#define SV_GROUPCOMMITCOUNT                	"GROUPCOMMITCOUNT"
#define SV_HISTORYDATASIZE                 	"HISTORYDATASIZE"
#define SV_HISTORYDIRECTORYROOT            	"HISTORYDIRECTORYROOT"
#define SV_HISTORYLAST                     	"HISTORYLAST"
#define SV_HISTORYPAGECOUNT                	"HISTORYPAGECOUNT"
#define SV_HISTORYROOT                     	"HISTORYROOT"
#define SV_HITRATE                         	"HITRATE"
#define SV_HOLDERCOUNT                     	"HOLDERCOUNT"
#define SV_HOLDERTASKID                    	"HOLDERTASKID"
#define SV_HOPCOUNT                        	"HOPCOUNT"
#define SV_ID                              	"ID"
#define SV_IDLECOUNT                       	"IDLECOUNT"
#define SV_IDLETIME                        	"IDLETIME"
#define SV_INDEXNAME                       	"INDEXNAME"
#define SV_INSTALLSERVERDBVERSION          	"INSTALLSERVERDBVERSION"
#define SV_IOCOUNT                         	"IOCOUNT"
#define SV_IODIRECTION                     	"IODIRECTION"
#define SV_IOPAGECOUNT                     	"IOPAGECOUNT"
#define SV_IOTIME                          	"IOTIME"
#define SV_IOWAITCOUNT                     	"IOWAITCOUNT"
#define SV_IOWAITTIME                      	"IOWAITTIME"
#define SV_ISOLATIONLEVEL                  	"ISOLATIONLEVEL"
#define SV_KERNELVARIANT                   	"KERNELVARIANT"
#define SV_KEYDEFINED                      	"KEYDEFINED"
#define SV_KEYPARTITIONCOUNT               	"KEYPARTITIONCOUNT"
#define SV_LASTDATABACKUPID                	"LASTDATABACKUPID"
#define SV_LASTDATABACKUPLOGSEQUENCE       	"LASTDATABACKUPLOGSEQUENCE"
#define SV_LASTDATABACKUPVERSION           	"LASTDATABACKUPVERSION"
#define SV_LASTEMERGENCYHISTORYCLEANUP     	"LASTEMERGENCYHISTORYCLEANUP"
#define SV_LASTFULLDATABACKUPSUCCESSFUL    	"LASTFULLDATABACKUPSUCCESSFUL"
#define SV_LASTFULLDATABACKUPVERSION       	"LASTFULLDATABACKUPVERSION"
#define SV_LASTHISTORYSEQUENCE             	"LASTHISTORYSEQUENCE"
#define SV_LASTKNOWNOFFSET                 	"LASTKNOWNOFFSET"
#define SV_LASTKNOWNSEQUENCE               	"LASTKNOWNSEQUENCE"
#define SV_LASTLOGBACKUPID                 	"LASTLOGBACKUPID"
#define SV_LASTOPENDATE                    	"LASTOPENDATE"
#define SV_LASTRESTARTDATE                 	"LASTRESTARTDATE"
#define SV_LASTSAVEPOINTDATE               	"LASTSAVEPOINTDATE"
#define SV_LASTSAVEPOINTID                 	"LASTSAVEPOINTID"
#define SV_LASTSAVEPOINTOFFSETINPAGE       	"LASTSAVEPOINTOFFSETINPAGE"
#define SV_LASTSAVEPOINTOFFSETONDEVICE     	"LASTSAVEPOINTOFFSETONDEVICE"
#define SV_LASTSAVEPOINTREASON             	"LASTSAVEPOINTREASON"
#define SV_LASTSAVEPOINTRELEASEVERSION     	"LASTSAVEPOINTRELEASEVERSION"
#define SV_LASTSAVEPOINTSEQUENCE           	"LASTSAVEPOINTSEQUENCE"
#define SV_LASTWRITE                       	"LASTWRITE"
#define SV_LOCKCOUNT                       	"LOCKCOUNT"
#define SV_LOCKESCALATIONCOUNT             	"LOCKESCALATIONCOUNT"
#define SV_LOCKESCALATIONVALUE             	"LOCKESCALATIONVALUE"
#define SV_LOCKMODE                        	"LOCKMODE"
#define SV_LOCKOBJECTCOUNT                 	"LOCKOBJECTCOUNT"
#define SV_LOCKREQUESTTIMEOUT              	"LOCKREQUESTTIMEOUT"
#define SV_LOCKSTATE                       	"LOCKSTATE"
#define SV_LOGFULL                         	"LOGFULL"
#define SV_LOGMODE                          "LOGMODE"
#define SV_LONGDIRECTORYROOT               	"LONGDIRECTORYROOT"
#define SV_MAJORRELEASE                    	"MAJORRELEASE"
#define SV_MAXDYNAMICDATAPAGENUMBER        	"MAXDYNAMICDATAPAGENUMBER"
#define SV_MAXLONGCOLUMNLENGTH             	"MAXLONGCOLUMNLENGTH"
#define SV_MAXMEMORYDELTA                  	"MAXMEMORYDELTA"
#define SV_MAXPENDINGIOCOUNT               	"MAXPENDINGIOCOUNT"
#define SV_MAXQUEUELENGTHMAXPENDINGIOCOUNT 	"MAXQUEUELENGTHMAXPENDINGIOCOUNT"
#define SV_MAXREADSTREAMBUFFERCOUNT        	"MAXREADSTREAMBUFFERCOUNT"
#define SV_MAXREADSTREAMROWCOUNT           	"MAXREADSTREAMROWCOUNT"
#define SV_MAXRELEASEMEMORYCHUNKSIZE       	"MAXRELEASEMEMORYCHUNKSIZE"
#define SV_MAXREQUESTMEMORYCHUNKSIZE       	"MAXREQUESTMEMORYCHUNKSIZE"
#define SV_MAXROWCOUNTPERLEAF              	"MAXROWCOUNTPERLEAF"
#define SV_MAXROWCOUNTPERSECONDARYKEY      	"MAXROWCOUNTPERSECONDARYKEY"
#define SV_MAXROWLENGTH                    	"MAXROWLENGTH"
#define SV_MAXSECONDARYKEYLENGTH           	"MAXSECONDARYKEYLENGTH"
#define SV_MAXSEPARATORLENGTH              	"MAXSEPARATORLENGTH"
#define SV_MAXSPINLOOPCOUNT                	"MAXSPINLOOPCOUNT"
#define SV_MAXSTATICDATAPAGENUMBER         	"MAXSTATICDATAPAGENUMBER"
#define SV_MAXUSEDENTRYCOUNT               	"MAXUSEDENTRYCOUNT"
#define SV_MAXUSEDENTRYCOUNTPERCENTAGE     	"MAXUSEDENTRYCOUNTPERCENTAGE"
#define SV_MAXUSEDPERMANENTSIZE            	"MAXUSEDPERMANENTSIZE"
#define SV_MAXUSEDRUNQUEUELENGTH           	"MAXUSEDRUNQUEUELENGTH"
#define SV_MAXUSEDSESSIONID                	"MAXUSEDSESSIONID"
#define SV_MAXUSEDSIZE                     	"MAXUSEDSIZE"
#define SV_MAXUSEDSIZEPERCENTAGEINLEAVES   	"MAXUSEDSIZEPERCENTAGEINLEAVES"
#define SV_MAXUSEDSTACK                    	"MAXUSEDSTACK"
#define SV_MAXUSEDTEMPORARYSIZE            	"MAXUSEDTEMPORARYSIZE"
#define SV_MAXUSEDTRANSACTIONNUMBER        	"MAXUSEDTRANSACTIONNUMBER"
#define SV_MAXWAITCOUNTPERPAGE             	"MAXWAITCOUNTPERPAGE"
#define SV_MAXWAITTIMEFORNEWCONSISTENTVIEW 	"MAXWAITTIMEFORNEWCONSISTENTVIEW"
#define SV_MAXWRITESTREAMBUFFERCOUNT       	"MAXWRITESTREAMBUFFERCOUNT"
#define SV_MAXWRITESTREAMROWCOUNT          	"MAXWRITESTREAMROWCOUNT"
#define SV_MAXYIELDLOOPCOUNT               	"MAXYIELDLOOPCOUNT"
#define SV_MINLONGCOLUMNLENGTH             	"MINLONGCOLUMNLENGTH"
#define SV_MINMEMORYDELTA                  	"MINMEMORYDELTA"
#define SV_MINORRELEASE                    	"MINORRELEASE"
#define SV_MINREADSTREAMBUFFERCOUNT        	"MINREADSTREAMBUFFERCOUNT"
#define SV_MINREADSTREAMROWCOUNT           	"MINREADSTREAMROWCOUNT"
#define SV_MINRELEASEMEMORYCHUNKSIZE       	"MINRELEASEMEMORYCHUNKSIZE"
#define SV_MINREQUESTMEMORYCHUNKSIZE       	"MINREQUESTMEMORYCHUNKSIZE"
#define SV_MINROWCOUNTPERLEAF              	"MINROWCOUNTPERLEAF"
#define SV_MINROWCOUNTPERSECONDARYKEY      	"MINROWCOUNTPERSECONDARYKEY"
#define SV_MINROWLENGTH                    	"MINROWLENGTH"
#define SV_MINSECONDARYKEYLENGTH           	"MINSECONDARYKEYLENGTH"
#define SV_MINSEPARATORLENGTH              	"MINSEPARATORLENGTH"
#define SV_MINUSEDSIZEPERCENTAGEINLEAVES   	"MINUSEDSIZEPERCENTAGEINLEAVES"
#define SV_MINWAITTIMEFORNEWCONSISTENTVIEW 	"MINWAITTIMEFORNEWCONSISTENTVIEW"
#define SV_MINWRITESTREAMBUFFERCOUNT       	"MINWRITESTREAMBUFFERCOUNT"
#define SV_MINWRITESTREAMROWCOUNT          	"MINWRITESTREAMROWCOUNT"
#define SV_MULTIPLE                        	"MULTIPLE"
#define SV_NAME                            	"NAME"
#define SV_NOTSAVEDPERCENTAGE              	"NOTSAVEDPERCENTAGE"
#define SV_NOTSAVEDSIZE                    	"NOTSAVEDSIZE"
#define SV_NUMERICVALUE                    	"NUMERICVALUE"
#define SV_OBJECTSIZE                      	"OBJECTSIZE"
#define SV_OLDESTNOTSAVEDLOGOFFSET         	"OLDESTNOTSAVEDLOGOFFSET"
#define SV_OLDESTNOTSAVEDLOGSEQUENCE       	"OLDESTNOTSAVEDLOGSEQUENCE"
#define SV_OMSCALLACTIVE                   	"OMSCALLACTIVE"
#define SV_OMSCALLBACKCOUNT                	"OMSCALLBACKCOUNT"
#define SV_OMSCALLBACKMETHOD               	"OMSCALLBACKMETHOD"
#define SV_OMSDATASIZE                     	"OMSDATASIZE"
#define SV_OMSHEAPUSEDSIZE                 	"OMSHEAPUSEDSIZE"
#define SV_OMSKEYDATASIZE                  	"OMSKEYDATASIZE"
#define SV_OMSLOCKCOLLISIONCOUNT           	"OMSLOCKCOLLISIONCOUNT"
#define SV_OMSLOCKMODE                     	"OMSLOCKMODE"
#define SV_OMSLOCKREQUESTTIMEOUT           	"OMSLOCKREQUESTTIMEOUT"
#define SV_OMSPROCEDURENAME                	"OMSPROCEDURENAME"
#define SV_OMSREQUESTTIMEOUTCOUNT          	"OMSREQUESTTIMEOUTCOUNT"
#define SV_OMSVERSIONID                    	"OMSVERSIONID"
#define SV_OPENTRANSCOUNT                  	"OPENTRANSCOUNT"
#define SV_OPENTRANSFILEROOT               	"OPENTRANSFILEROOT"
#define SV_OPENVERSION                     	"OPENVERSION"
#define SV_OPERATINGSYSTEM                 	"OPERATINGSYSTEM"
#define SV_OUTOFDATAEXCEPTIONCOUNT         	"OUTOFDATAEXCEPTIONCOUNT"
#define SV_OUTOFMEMORYEXCEPTIONCOUNT       	"OUTOFMEMORYEXCEPTIONCOUNT"
#define SV_OWN                             	"OWN"
#define SV_OWNER                           	"OWNER"
#define SV_PACKAGENAME                     	"PACKAGENAME"
#define SV_PAGE                            	"PAGE"
#define SV_PARAMETERCOUNT                  	"PARAMETERCOUNT"
#define SV_PARAMETERNAME                   	"PARAMETERNAME"
#define SV_PATH                            	"PATH"
#define SV_PEERPROCESSID                   	"PEERPROCESSID"
#define SV_PENDINGIOCOUNT                  	"PENDINGIOCOUNT"
#define SV_PENDINGOPERATIONCOUNT           	"PENDINGOPERATIONCOUNT"
#define SV_PERMANENT                       	"PERMANENT"
#define SV_PHYSICALWRITECOUNT              	"PHYSICALWRITECOUNT"
#define SV_PREVIOUSCONVERTERVERSION        	"PREVIOUSCONVERTERVERSION"
#define SV_PRIORITY                        	"PRIORITY"
#define SV_PROCEDURENAME                   	"PROCEDURENAME"
#define SV_PROCESSORTYPE                   	"PROCESSORTYPE"
#define SV_QUEUECOUNT                      	"QUEUECOUNT"
#define SV_QUEUEINSERTCOUNT                	"QUEUEINSERTCOUNT"
#define SV_QUEUEMAXUSED                    	"QUEUEMAXUSED"
#define SV_QUEUEOVERFLOWCOUNT              	"QUEUEOVERFLOWCOUNT"
#define SV_QUEUESIZE                       	"QUEUESIZE"
#define SV_READABSOLUTETIME                	"READABSOLUTETIME"
#define SV_READCACHEDOBJECTCOUNT           	"READCACHEDOBJECTCOUNT"
#define SV_READCACHEDOBJECTVIAKEYCOUNT     	"READCACHEDOBJECTVIAKEYCOUNT"
#define SV_READCOUNT                       	"READCOUNT"
#define SV_READOBJECTCOUNT                 	"READOBJECTCOUNT"
#define SV_READOBJECTHISTORYACCESSCOUNT    	"READOBJECTHISTORYACCESSCOUNT"
#define SV_READOBJECTVIAKEYCOUNT           	"READOBJECTVIAKEYCOUNT"
#define SV_READPAGECOUNT                   	"READPAGECOUNT"
#define SV_READRELATIVETIME                	"READRELATIVETIME"
#define SV_READTIME                        	"READTIME"
#define SV_READVAROBJECTCOUNT              	"READVAROBJECTCOUNT"
#define SV_REGIONACCESSCOUNT               	"REGIONACCESSCOUNT"
#define SV_REGIONID                        	"REGIONID"
#define SV_REGIONNAME                      	"REGIONNAME"
#define SV_RELEASECONTAINERPAGECOUNT       	"RELEASECONTAINERPAGECOUNT"
#define SV_RELEASEOBJECTPAGECOUNT          	"RELEASEOBJECTPAGECOUNT"
#define SV_REQUESTMODE                     	"REQUESTMODE"
#define SV_REQUESTORCOUNT                  	"REQUESTORCOUNT"
#define SV_REQUESTSTATE                    	"REQUESTSTATE"
#define SV_RESTARTENTRYDATE                	"RESTARTENTRYDATE"
#define SV_RESTARTENTRYTYPE                	"RESTARTENTRYTYPE"
#define SV_RESTARTIOSEQUENCE               	"RESTARTIOSEQUENCE"
#define SV_RESTARTOFFSETOFENTRYINPAGE      	"RESTARTOFFSETOFENTRYINPAGE"
#define SV_RESTARTOFFSETOFPAGEONDEVICE     	"RESTARTOFFSETOFPAGEONDEVICE"
#define SV_RESUMETASKCOUNT                 	"RESUMETASKCOUNT"
#define SV_ROLLBACKSUBTRANSCOUNT           	"ROLLBACKSUBTRANSCOUNT"
#define SV_ROLLEDOUT                       	"ROLLEDOUT"
#define SV_ROOT                            	"ROOT"
#define SV_ROWCOUNT                        	"ROWCOUNT"
#define SV_ROWID                           	"ROWID"
#define SV_ROWIDHEX                        	"ROWIDHEX"
#define SV_ROWIDLENGTH                     	"ROWIDLENGTH"
#define SV_ROWLOCKCOUNT                    	"ROWLOCKCOUNT"
#define SV_ROWREGIONCOUNT                  	"ROWREGIONCOUNT"
#define SV_RUNNABLE                        	"RUNNABLE"
#define SV_SAVEPOINTCOUNT                  	"SAVEPOINTCOUNT"
#define SV_SCANOBJECTCOUNT                 	"SCANOBJECTCOUNT"
#define SV_SCANOBJECTHISTORYACCESSCOUNT    	"SCANOBJECTHISTORYACCESSCOUNT"
#define SV_SCANOBJECTVIAKEYRANGECOUNT      	"SCANOBJECTVIAKEYRANGECOUNT"
#define SV_SCHEMANAME                      	"SCHEMANAME"
#define SV_SECONDARYKEYCOUNT               	"SECONDARYKEYCOUNT"
#define SV_SELFREADABSOLUTETIME            	"SELFREADABSOLUTETIME"
#define SV_SELFREADCOUNT                   	"SELFREADCOUNT"
#define SV_SELFREADPAGECOUNT               	"SELFREADPAGECOUNT"
#define SV_SELFWRITEABSOLUTETIME           	"SELFWRITEABSOLUTETIME"
#define SV_SELFWRITECOUNT                  	"SELFWRITECOUNT"
#define SV_SELFWRITEPAGECOUNT              	"SELFWRITEPAGECOUNT"
#define SV_SESSIONID                       	"SESSIONID"
#define SV_SLEEPABSOLUTETIME               	"SLEEPABSOLUTETIME"
#define SV_SLEEPCOUNT                      	"SLEEPCOUNT"
#define SV_SLEEPRELATIVETIME               	"SLEEPRELATIVETIME"
#define SV_SPINLOCKCOLLISIONCOUNT          	"SPINLOCKCOLLISIONCOUNT"
#define SV_SPINLOOPCOUNT                   	"SPINLOOPCOUNT"
#define SV_SQLDATASIZE                     	"SQLDATASIZE"
#define SV_SQLLOCKCOLLISIONCOUNT           	"SQLLOCKCOLLISIONCOUNT"
#define SV_SQLLOCKMODE                     	"SQLLOCKMODE"
#define SV_SQLLOCKREQUESTTIMEOUT           	"SQLLOCKREQUESTTIMEOUT"
#define SV_SQLMODE                         	"SQLMODE"
#define SV_SQLREQUESTTIMEOUTCOUNT          	"SQLREQUESTTIMEOUTCOUNT"
#define SV_STARTDATE                       	"STARTDATE"
#define SV_STATE                           	"STATE"
#define SV_SUBTRANSACTIONLEVEL             	"SUBTRANSACTIONLEVEL"
#define SV_SUCCESSFULACCESSCOUNT           	"SUCCESSFULACCESSCOUNT"
#define SV_SUSPENDABSOLUTETIME             	"SUSPENDABSOLUTETIME"
#define SV_SUSPENDCOUNT                    	"SUSPENDCOUNT"
#define SV_SUSPENDRELATIVETIME             	"SUSPENDRELATIVETIME"
#define SV_SWITCHABLE                      	"SWITCHABLE"
#define SV_TABLEID                         	"TABLEID"
#define SV_TABLELOCKCOUNT                  	"TABLELOCKCOUNT"
#define SV_TABLENAME                       	"TABLENAME"
#define SV_TABLEOWNER                      	"TABLEOWNER"
#define SV_TABLEREGIONCOUNT                	"TABLEREGIONCOUNT"
#define SV_TASKCLUSTER                     	"TASKCLUSTER"
#define SV_TASKCOUNT                       	"TASKCOUNT"
#define SV_TASKGROUPBLOCKED                	"TASKGROUPBLOCKED"
#define SV_TASKGROUPID                     	"TASKGROUPID"
#define SV_TASKID                          	"TASKID"
#define SV_TASKRESCEDULECOUNT              	"TASKRESCEDULECOUNT"
#define SV_TASKSTATE                       	"TASKSTATE"
#define SV_TASKTYPE                        	"TASKTYPE"
#define SV_TEMPSPACEUSEDSIZE               	"TEMPSPACEUSEDSIZE"
#define SV_TERMINATECOUNT                  	"TERMINATECOUNT"
#define SV_THREADID                        	"THREADID"
#define SV_THREADNAME                      	"THREADNAME"
#define SV_TIMEOUT                         	"TIMEOUT"
#define SV_TIMEOUTEXCEPTIONCOUNT           	"TIMEOUTEXCEPTIONCOUNT"
#define SV_TRACE                           	"TRACE"
#define SV_TRANSACTIONCOUNT                	"TRANSACTIONCOUNT"
#define SV_TRANSACTIONID                   	"TRANSACTIONID"
#define SV_TRANSACTIONREGIONCOUNT          	"TRANSACTIONREGIONCOUNT"
#define SV_TREELEVELCOUNT                  	"TREELEVELCOUNT"
#define SV_TYPE                            	"TYPE"
#define SV_UNSUCCESSFULACCESSCOUNT         	"UNSUCCESSFULACCESSCOUNT"
#define SV_UPDATECACHEDOBJECTCOUNT         	"UPDATECACHEDOBJECTCOUNT"
#define SV_UPDATEOBJECTCOUNT               	"UPDATEOBJECTCOUNT"
#define SV_UPDATEVAROBJECTCOUNT            	"UPDATEVAROBJECTCOUNT"
#define SV_USABLESIZE                      	"USABLESIZE"
#define SV_USABLESTACKSIZE                 	"USABLESTACKSIZE"
#define SV_USEDDATASIZE                    	"USEDDATASIZE"
#define SV_USEDENTRYCOUNT                  	"USEDENTRYCOUNT"
#define SV_USEDENTRYCOUNTPERCENTAGE        	"USEDENTRYCOUNTPERCENTAGE"
#define SV_USEDPERMANENTSIZE               	"USEDPERMANENTSIZE"
#define SV_USEDRUNQUEUELENGTH              	"USEDRUNQUEUELENGTH"
#define SV_USEDSIZE                        	"USEDSIZE"
#define SV_USEDSIZENOTONVOLUMES            	"USEDSIZENOTONVOLUMES"
#define SV_USEDSIZEONVOLUMES               	"USEDSIZEONVOLUMES"
#define SV_USEDSIZEPERCENTAGE              	"USEDSIZEPERCENTAGE"
#define SV_USEDSTACKSIZE                   	"USEDSTACKSIZE"
#define SV_USEDSYSTEMTIME                  	"USEDSYSTEMTIME"
#define SV_USEDTEMPORARYSIZE               	"USEDTEMPORARYSIZE"
#define SV_USEDUSERTIME                    	"USEDUSERTIME"
#define SV_USERNAME                        	"USERNAME"
#define SV_VALUE                           	"VALUE"
#define SV_VAROBJECTCONTAINER              	"VAROBJECTCONTAINER"
#define SV_WAITABSOLUTETIME                	"WAITABSOLUTETIME"
#define SV_WAITCOUNT                       	"WAITCOUNT"
#define SV_WAITINGFORPAGE                  	"WAITINGFORPAGE"
#define SV_WAITINGFORROOT                  	"WAITINGFORROOT"
#define SV_WAITINGFORTASK                  	"WAITINGFORTASK"
#define SV_WAITRELATIVETIME                	"WAITRELATIVETIME"
#define SV_WRITEABSOLUTETIME               	"WRITEABSOLUTETIME"
#define SV_WRITECOUNT                      	"WRITECOUNT"
#define SV_WRITEPAGECOUNT                  	"WRITEPAGECOUNT"
#define SV_WRITERELATIVETIME               	"WRITERELATIVETIME"
#define SV_WRITETIME                       	"WRITETIME"
#define SV_WRITETRANSACTIONCOUNT           	"WRITETRANSACTIONCOUNT"
#define SV_WRITETRANSACTIONID              	"WRITETRANSACTIONID"
#define SV_YIELDLOOPCOUNT                  	"YIELDLOOPCOUNT"

// 370 unique definitions found.

// Table column counts:

#define SV_CC_ACTIVECONFIGURATION            	2
#define SV_CC_BACKUPINFORMATION              	8
#define SV_CC_BACKUPTHREADS                  	9
#define SV_CC_CACHESTATISTICS                	5
#define SV_CC_CACHESTATISTICSRESET           	5
#define SV_CC_CLASSCONTAINERS                	11
#define SV_CC_CLASSCONTAINERSTATISTICS       	10
#define SV_CC_CLASSCONTAINERSTATISTICSRESET  	10
#define SV_CC_DATACACHE                      	13
#define SV_CC_DATASTATISTICS                 	16
#define SV_CC_DATASTATISTICSRESET            	6
#define SV_CC_DATAVOLUMES                    	6
#define SV_CC_DIAGNOSE                       	3
#define SV_CC_EVENTS                         	7
#define SV_CC_FILES                          	8
#define SV_CC_HISTORYCLEANUPSTATISTICS       	14
#define SV_CC_HISTORYCLEANUPSTATISTICSRESET  	13
#define SV_CC_INDEXSIZEDETAILS               	21
#define SV_CC_IOTHREADSTATISTICS             	11
#define SV_CC_IOTHREADSTATISTICSRESET        	9
#define SV_CC_LOCKS                          	12
#define SV_CC_LOCKSTATISTICS                 	21
#define SV_CC_LOCKSTATISTICSRESET            	19
#define SV_CC_LOGSTATISTICS                  	24
#define SV_CC_LOGSTATISTICSRESET             	12
#define SV_CC_LOGVOLUMES                     	4
#define SV_CC_MEMORYALLOCATORSTATISTICS      	9
#define SV_CC_MEMORYALLOCATORSTATISTICSRESET 	6
#define SV_CC_MEMORYHOLDERS                  	3
#define SV_CC_MISCELLANEOUS                  	5
#define SV_CC_OMSLOCKS                       	5
#define SV_CC_OMSPROCEDURESTATISTICS         	50
#define SV_CC_OMSPROCEDURESTATISTICSRESET    	50
#define SV_CC_OMSVERSIONS                    	8
#define SV_CC_OPTIMIZERINFORMATION           	6
#define SV_CC_PAGELOCKS                      	4
#define SV_CC_REGIONLOCKS                    	3
#define SV_CC_REGIONSTATISTICS               	9
#define SV_CC_REGIONSTATISTICSRESET          	6
#define SV_CC_RESTARTINFORMATION             	25
#define SV_CC_SCHEMAS                        	5
#define SV_CC_SESSIONS                       	18
#define SV_CC_SPINLOCKSTATISTICS             	7
#define SV_CC_SPINLOCKSTATISTICSRESET        	7
#define SV_CC_TABLESIZEDETAILS               	21
#define SV_CC_TASKGROUPSTATISTICS            	11
#define SV_CC_TASKGROUPSTATISTICSRESET       	8
#define SV_CC_TASKSTATISTICS                 	54
#define SV_CC_TASKSTATISTICSRESET            	36
#define SV_CC_TRANSACTIONS                   	15
#define SV_CC_VERSION                        	9

// Table estimated rows:

#define SV_ER_ACTIVECONFIGURATION				150
#define SV_ER_BACKUPINFORMATION					1
#define SV_ER_BACKUPTHREADS						10
#define SV_ER_CACHESTATISTICS					5
#define SV_ER_CACHESTATISTICSRESET				5
#define SV_ER_CLASSCONTAINERS					255
#define SV_ER_CLASSCONTAINERSTATISTICS			255
#define SV_ER_CLASSCONTAINERSTATISTICSRESET		255
#define SV_ER_DATACACHE							1
#define SV_ER_DATASTATISTICS					1
#define SV_ER_DATASTATISTICSRESET				1
#define SV_ER_DATAVOLUMES						10
#define SV_ER_DIAGNOSE							50
#define SV_ER_EVENTS							25
#define SV_ER_FILES								50000
#define SV_ER_HISTORYCLEANUPSTATISTICS			5
#define SV_ER_HISTORYCLEANUPSTATISTICSRESET		5
#define SV_ER_INDEXSIZEDETAILS					3000
#define SV_ER_IOTHREADSTATISTICS				10
#define SV_ER_IOTHREADSTATISTICSRESET			10
#define SV_ER_LOCKS								1000
#define SV_ER_LOCKSTATISTICS					1
#define SV_ER_LOCKSTATISTICSRESET				1
#define SV_ER_LOGSTATISTICS						1
#define SV_ER_LOGSTATISTICSRESET				1
#define SV_ER_LOGVOLUMES						2
#define SV_ER_MEMORYALLOCATORSTATISTICS			100
#define SV_ER_MEMORYALLOCATORSTATISTICSRESET	100
#define SV_ER_MEMORYHOLDERS						500
#define SV_ER_MISCELLANEOUS						10
#define SV_ER_OMSLOCKS							100
#define SV_ER_OMSPROCEDURESTATISTICS			100
#define SV_ER_OMSPROCEDURESTATISTICSRESET		100
#define SV_ER_OMSVERSIONS						100
#define SV_ER_OPTIMIZERINFORMATION				15000
#define SV_ER_PAGELOCKS							50
#define SV_ER_REGIONLOCKS						100
#define SV_ER_REGIONSTATISTICS					25
#define SV_ER_REGIONSTATISTICSRESET				25
#define SV_ER_RESTARTINFORMATION				1
#define SV_ER_SCHEMAS							20
#define SV_ER_SESSIONS							50
#define SV_ER_SPINLOCKSTATISTICS				20
#define SV_ER_SPINLOCKSTATISTICSRESET			20
#define SV_ER_TABLESIZEDETAILS					12000
#define SV_ER_TASKGROUPSTATISTICS				10
#define SV_ER_TASKGROUPSTATISTICSRESET			10
#define SV_ER_TASKSTATISTICS					50
#define SV_ER_TASKSTATISTICSRESET				50
#define SV_ER_TRANSACTIONS						50
#define SV_ER_VERSION							1

typedef enum
{
    ITOVT_NULL,
    ITOVT_INT2,
    ITOVT_INT4,
    ITOVT_UINT4,
    ITOVT_INT8,
    ITOVT_UINT8,
    ITOVT_CHARPTR,
    ITOVT_UTF8PTR,
    ITOVT_TRANSNO,
    ITOVT_LOCKREQMODE,
    ITOVT_LOCKREQSTATE,
    ITOVT_SURROGATE,
    ITOVT_LONGCOLREF,
    ITOVT_KNLIDENTIFIER,
    ITOVT_TRANSLOCKMODE
}
SysView_ITOVarType;

typedef enum
{
    ITOCT_CHAR,
    ITOCT_CHARBYTE,
    ITOCT_CHARUNICODE,
    ITOCT_FIXED,
    ITOCT_LONG,
    ITOCT_TIMESTAMP
}
SysView_ITOColType;

/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/



#endif  /* SYSVIEW_DEFINES_HPP */

