/****************************************************************************

  module      : SysView_OMSProcedureStatisticsReset.cpp

  -------------------------------------------------------------------------

  responsible : UlrichJ

  special area: SystemViews
  description : This module implements the "OMSProcedureStatisticsReset" view class.

  last changed: 2002-08-14
  see also    :

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2002

  ========== licence begin LGPL
  Copyright  (C) 2002 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or  (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "ggg00.h"
#include "SystemViews/SysView_Defines.hpp"
#include "SystemViews/SysView_ISessionObj.hpp"
#include "SystemViews/SysView_ITableObj.hpp"
#include "SystemViews/SysView_OMSProcedureStatisticsReset.hpp"


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/



/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL CLASSES, STRUCTURES, TYPES, UNIONS ...                             *
 *===========================================================================*/



/*===========================================================================*
 *  STATIC/INLINE FUNCTIONS  (PROTOTYPES)                                     *
 *===========================================================================*/



/*===========================================================================*
 *  METHODS                                                                  *
 *===========================================================================*/

void SysView_OMSProcedureStatisticsReset::Create()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_OMSProcedureStatisticsReset::Create", SysView_Trace, 5);

	m_Table->AppendCol (ITOCT_CHARUNICODE ,SV_PACKAGENAME, 11, 32);
	m_Table->AppendCol (ITOCT_CHAR ,SV_PROCEDURENAME, 13, 32);
	m_Table->AppendCol (ITOCT_FIXED ,SV_CALLCOUNT, 9, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_READCACHEDOBJECTCOUNT, 21, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_READOBJECTCOUNT, 15, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_READCACHEDOBJECTVIAKEYCOUNT, 27, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_READOBJECTVIAKEYCOUNT, 21, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_UPDATECACHEDOBJECTCOUNT, 23, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_UPDATEOBJECTCOUNT, 17, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_DELETECACHEDOBJECTCOUNT, 23, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_DELETEOBJECTCOUNT, 17, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_LOCKOBJECTCOUNT, 15, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_SCANOBJECTCOUNT, 15, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_READOBJECTHISTORYACCESSCOUNT, 28, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_SCANOBJECTHISTORYACCESSCOUNT, 28, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_CPPEXCEPTIONCOUNT, 17, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_OUTOFDATAEXCEPTIONCOUNT, 23, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_TIMEOUTEXCEPTIONCOUNT, 21, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_OUTOFMEMORYEXCEPTIONCOUNT, 25, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_TERMINATECOUNT, 14, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_ROLLBACKSUBTRANSCOUNT, 21, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_COMMITSUBTRANSCOUNT, 19, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_SUBTRANSACTIONLEVEL, 19, 5);
	m_Table->AppendCol (ITOCT_FIXED ,SV_READVAROBJECTCOUNT, 18, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_UPDATEVAROBJECTCOUNT, 20, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_AVGVAROBJECTLENGTH, 18, 5);
	m_Table->AppendCol (ITOCT_FIXED ,SV_AVGWAITTIMEFORNEWCONSISTENTVIEW, 31, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MINWAITTIMEFORNEWCONSISTENTVIEW, 31, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MAXWAITTIMEFORNEWCONSISTENTVIEW, 31, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_AVGREADSTREAMBUFFERCOUNT, 24, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MINREADSTREAMBUFFERCOUNT, 24, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MAXREADSTREAMBUFFERCOUNT, 24, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_AVGWRITESTREAMBUFFERCOUNT, 25, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MINWRITESTREAMBUFFERCOUNT, 25, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MAXWRITESTREAMBUFFERCOUNT, 25, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_AVGREADSTREAMROWCOUNT, 21, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MINREADSTREAMROWCOUNT, 21, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MAXREADSTREAMROWCOUNT, 21, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_AVGWRITESTREAMROWCOUNT, 22, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MINWRITESTREAMROWCOUNT, 22, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MAXWRITESTREAMROWCOUNT, 22, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_AVGREQUESTMEMORYCHUNKSIZE, 25, 10);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MINREQUESTMEMORYCHUNKSIZE, 25, 10);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MAXREQUESTMEMORYCHUNKSIZE, 25, 10);
	m_Table->AppendCol (ITOCT_FIXED ,SV_AVGRELEASEMEMORYCHUNKSIZE, 25, 10);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MINRELEASEMEMORYCHUNKSIZE, 25, 10);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MAXRELEASEMEMORYCHUNKSIZE, 25, 10);
	m_Table->AppendCol (ITOCT_FIXED ,SV_AVGMEMORYDELTA, 14, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MINMEMORYDELTA, 14, 20);
	m_Table->AppendCol (ITOCT_FIXED ,SV_MAXMEMORYDELTA, 14, 20);

}

/*---------------------------------------------------------------------------*/

SAPDB_Int SysView_OMSProcedureStatisticsReset::GetColCount()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_OMSProcedureStatisticsReset::GetColCount", SysView_Trace, 5);

    return SV_CC_OMSPROCEDURESTATISTICSRESET;
}

/*---------------------------------------------------------------------------*/

SAPDB_Int SysView_OMSProcedureStatisticsReset::EstimateRows()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_OMSProcedureStatisticsReset::EstimateRows", SysView_Trace, 5);

    return SV_ER_OMSPROCEDURESTATISTICSRESET;
}

/*---------------------------------------------------------------------------*/

void SysView_OMSProcedureStatisticsReset::Execute()
{
    SAPDBTRACE_METHOD_DEBUG ("SysView_OMSProcedureStatisticsReset::Execute", SysView_Trace, 5);

    m_Session->ThrowError (e_not_implemented, 1);
}

/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/
