/****************************************************************************

  module      : SysView_OptimizerInformation.cpp

  -------------------------------------------------------------------------

  responsible : UlrichJ

  special area: SystemViews
  description : This module implements the "OptimizerInformation" view class.

  last changed: 2002-08-14
  see also    :

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2002

  ========== licence begin LGPL
  Copyright  (C) 2002 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or  (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "vak001.h"
#include "hak47.h"
#include "SystemViews/SysView_Defines.hpp"
#include "SystemViews/SysView_ISessionObj.hpp"
#include "SystemViews/SysView_ITableObj.hpp"
#include "SystemViews/SysView_OptimizerInformation.hpp"


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/



/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL CLASSES, STRUCTURES, TYPES, UNIONS ...                             *
 *===========================================================================*/



/*===========================================================================*
 *  STATIC/INLINE FUNCTIONS  (PROTOTYPES)                                     *
 *===========================================================================*/



/*===========================================================================*
 *  METHODS                                                                  *
 *===========================================================================*/

void SysView_OptimizerInformation::Create(void)
{
	m_Table->AppendCol (ITOCT_CHARUNICODE, SV_OWNER, 5, 32);
	m_Table->AppendCol (ITOCT_CHARUNICODE, SV_TABLENAME, 9, 32);
	m_Table->AppendCol (ITOCT_CHARUNICODE, SV_COLUMNNAME, 10, 32);
	m_Table->AppendCol (ITOCT_CHARUNICODE, SV_INDEXNAME, 9, 32);
	m_Table->AppendCol (ITOCT_FIXED, SV_DISTINCTVALUECOUNT, 18, 10);
	m_Table->AppendCol (ITOCT_FIXED, SV_CALCULATEDSIZE, 14, 10);

}

/*---------------------------------------------------------------------------*/

SAPDB_Int SysView_OptimizerInformation::GetColCount(void)
{
	return SV_CC_OPTIMIZERINFORMATION;
}

/*---------------------------------------------------------------------------*/

SAPDB_Int SysView_OptimizerInformation::EstimateRows(void)
{
	return SV_ER_OPTIMIZERINFORMATION;
}

/*---------------------------------------------------------------------------*/

void SysView_OptimizerInformation::Execute(void)
{
    //a47optimize_statistics (m_ACV, a41v);
    a47show_table (*(m_Session->GetPascalObjPtr()), *(m_Table->GetPascalObjPtr()), cak_i_optimize);
}

/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/
