# *******************************************************************************
#
#  module:       Tools.com
#
#  ------------------------------------------------------------------------------
#
#  responsible:  Bernd Vorsprach (D025588 - mailto:Bernd.Vorsprach@sap.com)
#
#  special area: SAPDB Tools Extensions
#
#  description:  Compilation description for Tools
#
#  see also:     
#
#  ------------------------------------------------------------------------------
#
#                         Copyright by SAP AG, 1998
#
# *******************************************************************************
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#


&if $OS in [ WIN32 ]
* -FR    # MSDEV source browser
&endif
* -I$WRK/incl/SAPDB 

#
# include dependencies (do not edit)
#
ToolsCommon.com inc=
Tools_Array.hpp inc=
Tools_ConfigFile.cpp inc=:SAPDB/ToolsCommon/Tools_System.hpp,\
    :SAPDB/ToolsCommon/Tools_ConfigFile.hpp
Tools_ConfigFile.hpp inc=\
    :SAPDB/SAPDBCommon/ErrorsAndMessages/SAPDBErr_MessageList.hpp,\
    :SAPDB/ToolsCommon/Tools_DynamicUTF8String.hpp,\
    :SAPDB/ToolsCommon/Tools_Object.hpp
Tools_DynamicUTF8String.cpp inc=\
    :SAPDB/ToolsCommon/Tools_UnicodeCaseTable.hpp,\
    :SAPDB/ToolsCommon/Tools_DynamicUTF8String.hpp
Tools_DynamicUTF8String.hpp inc=\
    :SAPDB/ToolsCommon/Tools_DynamicUTF8StringBuffer.hpp
Tools_DynamicUTF8StringBuffer.hpp inc=\
    :SAPDB/ToolsCommon/Tools_UTF8StringElement.hpp
Tools_Expression.cpp inc=:SAPDB/ToolsCommon/Tools_Expression.hpp
Tools_Expression.hpp inc=:SAPDB/SAPDBCommon/SAPDB_Types.hpp,\
    :SAPDB/ToolsCommon/Tools_DynamicUTF8String.hpp,\
    :SAPDB/ToolsCommon/Tools_Array.hpp
Tools_Extest.cpp inc=:SAPDB/ToolsCommon/Tools_Expression.hpp
Tools_Vector.hpp inc=
Tools_Object.hpp inc=\
    :SAPDB/SAPDBCommon/ErrorsAndMessages/SAPDBErr_MessageList.hpp
Tools_Session.hpp inc=:SAPDB/SAPDBCommon/SAPDB_Types.hpp,\
    :SAPDB/ToolsCommon/Tools_DynamicUTF8String.hpp
Tools_System.cpp inc=:SAPDB/ToolsCommon/Tools_System.hpp
Tools_System.hpp inc=
Tools_Template.cpp inc=:SAPDB/ToolsCommon/Tools_Template.hpp
Tools_Template.hpp inc=hwd02waapi.h,:SAPDB/SAPDBCommon/SAPDB_Types.hpp,\
    :SAPDB/ToolsCommon/Tools_Vector.hpp,\
    :SAPDB/ToolsCommon/Tools_DynamicUTF8String.hpp
Tools_TemplateMsgBox.cpp inc=:SAPDB/ToolsCommon/Tools_TemplateMsgBox.hpp
Tools_TemplateMsgBox.hpp inc=:SAPDB/ToolsCommon/Tools_Template.hpp,\
    :SAPDB/SAPDBCommon/ErrorsAndMessages/SAPDBErr_MessageList.hpp
Tools_TemplateSimpleTable.cpp inc=\
    :SAPDB/ToolsCommon/Tools_TemplateSimpleTable.hpp
Tools_TemplateSimpleTable.hpp inc=:SAPDB/ToolsCommon/Tools_Template.hpp,\
    :SAPDB/ToolsCommon/Tools_Array.hpp
Tools_UTF8Basis.cpp inc=:SAPDB/ToolsCommon/Tools_UTF8Basis.hpp
Tools_UTF8Basis.hpp inc=hsp81.h,:SAPDB/SAPDBCommon/SAPDB_Types.hpp
Tools_UTF8StringElement.hpp inc=:SAPDB/ToolsCommon/Tools_UTF8Basis.hpp
Tools_UnicodeCaseTable.cpp inc=\
    :SAPDB/ToolsCommon/Tools_UnicodeCaseTable.hpp
Tools_UnicodeCaseTable.hpp inc=:SAPDB/SAPDBCommon/SAPDB_Types.hpp

&if $OSSPEC == LINUX && $MACH == IA64
regex(\w+\.cpp) -OPT=-O0
&endif

