/*!**********************************************************************

  module: WDVCAPI_Lock.h

  -----------------------------------------------------------------------

  responsible:  Markus Oezgen

  special area: WebDAV

  description:  Lock Handling

  see also:

  -----------------------------------------------------------------------

						copyright by SAP AG 2001


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

************************************************************************/

#ifndef WDVCAPI_LOCK_H
#define WDVCAPI_LOCK_H

/***********************************************************************

	Includes

 ***********************************************************************/

#include <WDVCAPI_Definition.h>

#include "SAPDB/WebDAV/CAPI/WDVCAPI_Resource.h"

/***********************************************************************

	Defines

 ***********************************************************************/

/***********************************************************************

	Types

 ***********************************************************************/

/***********************************************************************

	Prototypes

 ***********************************************************************/

WDV_Bool WDVCAPI_LockCreateHandle( WDVCAPI_WDV          wdv,
                                   WDVCAPI_LockHandle  *hLock );

WDV_Bool WDVCAPI_LockDestroyHandle( WDVCAPI_WDV         wdv,
                                    WDVCAPI_LockHandle  hLock );

WDV_Bool Lock_DestroyFreeList( WDVCAPI_LockHandle hLock );

WDV_Bool Lock_InitHandle( WDVCAPI_WDV           wdv,
                          WDVCAPI_LockHandle    hLock );

WDV_Bool Lock_ResetHandle( WDVCAPI_WDV           wdv,
                           WDVCAPI_LockHandle    hLock );

WDV_Bool Lock_GetLockDescription( WDVCAPI_WDV          wdv,
                                  WDVCAPI_Resource     lockResource,
                                  WDVCAPI_LockHandle   hLock );

WDV_Bool Lock_GetDescriptionByLockId( WDVCAPI_WDV          wdv,
                                      WDVCAPI_LockIdString lockIdString,
                                      WDVCAPI_LockHandle   hLock );

WDV_Bool Lock_IsLockIdInList( WDVCAPI_WDV           wdv,
                              WDVCAPI_LockIdList    lockIdList,
                              WDVCAPI_URI           lockUri,
                              WDVCAPI_LockId        lockId );

/***********************************************************************

	End

 ***********************************************************************/

#endif
