#ifndef XMLQSLIB_INTERFACE_H
#define XMLQSLIB_INTERFACE_H
/****************************************************************************

  module      : XMLQSLib_Interface.h

  -------------------------------------------------------------------------

  responsible : Daniel Kirmse

  special area: 
  description : 


  last changed: 2001-06-20  15:53
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin  GPL
  Copyright (C) 2001 SAP AG

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  ========== licence end

*****************************************************************************/

	/*------------------------------------------------------------------------
		Defines
	--------------------------------------------------------------------------*/
	/*------------------------------------------------------------------------
		Includes
	--------------------------------------------------------------------------*/
	#include "SAPDB/XML/QueryServerLib/XMLQSLib_Common_Include.h"
	#include "SAPDB/XML/QueryServerLib/XMLQSLib_Common_TextConstants.h"
	#include "SAPDB/XML/QueryServerLib/XMLQSLib_Connection.h"

	typedef void (*XMLQSLib_DestroyUserData)( void *userData);

	typedef SAPDB_Bool (*RetrieveDocuments)( SQLHDBC                      hDBCDocStore,
										     SQLHENV                      hEnvDocStore,
										     XMLQSLib_WhereClause         hWhereClause,
										     void                       **userData,
										     XMLQSLib_DestroyUserData    *funcDestroyUserData,
										     XMLError_Error               hError );

	typedef SAPDB_Bool (*GetRetrievedDocument)( SQLHDBC          hDBCDocStore,
											SQLHENV          hEnvDocStore,
											void            *userData,
											char            *docURI,
											SAPDB_UInt       docURILen,
											XMLError_Error   hError );

#endif	
