
/*******************************************************************************

  module:       hak07.h

  ------------------------------------------------------------------------------

  responsible:  ElkeZ

  purpose:      AK_error_handling

  lastChanged:  2002-12-10

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999


    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
********************************************************************************/

#ifndef HAK07_H
#define HAK07_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\277\023\247\225\265dA\012\223kl!\025\215\226\300'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "vak001.h"
#include "vsp008.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void a07ClientLayoutParam (
    tak_all_command_glob  &  acv,
    integer                  param_no,
    tsp_moveobj_ptr          param_addr,
    integer                  param_len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_const_b_put_error (
    tak_all_command_glob  &  acv,
    tgg_basis_error          b_err,
    tsp_int4                 err_code,
    tsp_moveobj_ptr          param_addr,
    integer                  const_len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_error (
    tak_all_command_glob  &  acv,
    tgg_basis_error          err,
    tsp_int2              &  nod1,
    tsp_int2              &  nod2);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_b_put_error (
    tak_all_command_glob  &  acv,
    tgg_basis_error          b_err,
    tsp_int4                 err_code);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_kw_put_error (
    tak_all_command_glob  &  acv,
    tgg_basis_error          b_err,
    tsp_int4                 err_code,
    integer                  kw);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_nb_put_error (
    tak_all_command_glob  &  acv,
    tgg_basis_error          b_err,
    tsp_int4                 err_code,
    tsp_knl_identifier    &  n);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_sb_put_error (
    tak_all_command_glob  &  acv,
    tgg_basis_error          b_err,
    tsp_int4                 err_code,
    tgg_err               &  err);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_tb_put_error (
    tak_all_command_glob  &  acv,
    tgg_basis_error          b_err,
    tsp_int4                 err_code,
    tgg_surrogate         &  tab_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp_int2 a07_return_code (
    tgg_basis_error          b_err,
    tsp_sqlmode_Param        sqlmode);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_intern_error_put (
    tak_all_command_glob  &  acv);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07ak_system_error (
    tak_all_command_glob  &  acv,
    integer                  modul_no,
    integer                  id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07const_param (
    tak_all_command_glob  &  acv,
    integer                  param_no,
    tsp_moveobj_ptr          param_addr,
    integer                  param_len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_sysmsg_get (
    tak_all_command_glob  &  acv,
    tgg_message2_type_Param     direct_or_next,
    tsp_int2                 msgno,
    tsp_c3                &  language,
    pasbool               &  found);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07msg_kernelsink_get (
    tak_all_command_glob  &  acv,
    tsp_int2                 msgno,
    tak_order_errortext   &  err_text,
    integer               &  msglen);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_uni_error (
    tak_all_command_glob  &  acv,
    tsp8_uni_error_Param     uni_err,
    tsp_int4                 err_code);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07_hex_uni_error (
    tak_all_command_glob  &  acv,
    tsp8_uni_error_Param     uni_err,
    tsp_int4                 err_code,
    pasbool                  to_unicode,
    tsp_moveobj_ptr          bytestr,
    tsp_int4                 len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07parm3_put_error (
    tak_all_command_glob  &  acv,
    tgg_basis_error          b_err,
    tsp_int4                 err_code,
    tsp_knl_identifier    &  param1,
    tsp_knl_identifier    &  param2,
    tsp_knl_identifier    &  param3);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void a07put_error_pos (
    tak_all_command_glob  &  acv,
    tsp_int4                 err_pos);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

