
/*******************************************************************************

  module:       hbd02.h.h

  ------------------------------------------------------------------------------

  responsible:  JuergenP

  purpose:      filesysteminterface_2

  lastChanged:  2002-05-13

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999


    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
********************************************************************************/

#ifndef HBD02_H
#define HBD02_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\012\242\263"k\224;\236$\'\261\031E\235\311\230'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void b02add_record (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    const tgg00_Rec       &  b);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02calculate_page_count (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_Lkey            &  startkey,
    tgg00_Lkey            &  stopkey,
    tsp00_Int4            &  page_count);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02col_next_stringcol (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    integer                  string_col_cnt,
    tgg00_Lkey            &  rk,
    integer               &  string_col_no,
    tgg00_FileId          &  col_id,
    tgg00_FilePos         &  file_pos);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02del_record (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    const tgg00_Lkey      &  rk);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02eval_page_count (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_Lkey            &  startkey,
    tgg00_Lkey            &  stopkey,
    pasbool                  count_records,
    tsp00_Int4            &  page_count,
    tsp00_Int4            &  all_page_cnt,
    tsp00_Int4            &  record_cnt);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02exists_record (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_Lkey            &  rk);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02file_outcopy (
    tgg00_MessBlock       &  mbuf);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02find_leaf (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_Lkey            &  key);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02finish_load (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_PageNo             rightmost_leaf);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02get_lock_record (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  b);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02get_record (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    const tgg00_Lkey      &  rk,
    tgg00_Rec             &  b);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02init_load (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    pasbool                  set_read_only,
    tsp00_PageNo          &  rightmost_leaf);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02kb_del_rec (
    tgg00_MessBlock       &  m,
    tsp00_Addr               pDeleteCmd,
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  old_recbuf,
    tgg00_LockReqMode_Param     granted_lock);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02kb_ins_record (
    tgg00_MessBlock       &  m,
    tsp00_Addr               pInsertCmd,
    tgg00_Rec             &  b,
    tgg00_LockReqMode_Param     granted_lock);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02kb_select_rec (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_KeyPtr             RecKey,
    tsp00_Int2            &  RecKeyLen,
    tsp00_KeyPtr             StopKey,
    tsp00_Int4               StopKeyLen,
    tsp00_Int4               recbuf_size,
    tsp00_MoveObjPtr         recbuf_ptr,
    pasbool                  ignore_vwait,
    tgg00_SelectFieldsParam  &  sel,
    tgg00_StackDesc       &  stack_desc,
    pasbool               &  unqualified,
    tgg00_LockReqMode     &  granted_lock);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02kb_upd_rec (
    tgg00_MessBlock       &  m,
    tsp00_Addr               pUpdateCmd,
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  old_recbuf,
    tgg00_Rec             &  new_recbuf,
    tgg00_LockReqMode_Param     granted_lock);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02load_table (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  tree_id,
    tsp00_PageNo          &  rightmost_leaf,
    tsp00_PageNo          &  check_leaf,
    tsp00_Int4               load_buf_len,
    tsp00_MoveObj         &  load_buf);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02next_record (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_Lkey            &  rk,
    pasbool                  inclusive,
    tgg00_Rec             &  b);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02prefetch (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_PageNo             pno);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02prev_record (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_Lkey            &  rk,
    pasbool                  inclusive,
    tgg00_Rec             &  b);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02range_exi_rec (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_Int4            &  left___pages,
    tsp00_Int4            &  middle_pages,
    tsp00_Int4            &  right__pages,
    tgg00_Lkey            &  rk_the_one,
    tgg00_Lkey            &  rk_another);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02reorg_treeindex (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_Lkey            &  rk);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02repl_record (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    const tgg00_Rec       &  b);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02select_record (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_Key             &  RecKey,
    tsp00_Int2            &  RecKeyLen,
    tsp00_Key             &  StopKey,
    tsp00_Int4               StopKeyLen,
    tsp00_Int4               recbuf_size,
    tsp00_MoveObjPtr         recbuf_ptr,
    tgg00_SelectFieldsParam  &  sel,
    tgg00_StackDesc       &  stack_desc,
    pasbool               &  unqualified);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02u_init_unload (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b02unload_table (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  tree_id,
    tsp00_PageNo          &  pno,
    tsp00_PageNo          &  pno_x,
    tsp00_Int4               ret_buf_size,
    tsp00_MoveObj         &  ret_buf,
    tsp00_Int4            &  ret_buf_len);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

