/*!******************************************************************************

  @file         hbd30.h

  ------------------------------------------------------------------------------

  @author       JuergenP

  @brief        treehandling

\if EMIT_LICENCE  

    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HBD30_H
#define HBD30_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\x86\xff\x0d\xc8\xe5\x0e\x6e\xe4\x90\x63\x2c\xbe\xa1\xf4\xe0\xe1'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void b30add_to_tree (
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  b,
    integer                  page_fill_limit,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30add_filestate (
    tbd_current_tree      &  current,
    tbd_file_state_set    &  new_filestate);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30append_to_tree (
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  b,
    tgg00_FilePos         &  tree_pos,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30bad_file (
    tbd_current_tree      &  current,
    pasbool                  incl_root_upd,
    pasbool                  use_lock,
    tbd_file_state_set    &  new_state);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30check_tree (
    tbd_current_tree      &  current,
    tsp00_Int2               long_col_cnt,
    tsp00_Int2               new_long_col_cnt,
    pasbool                  bWithExtendedCheck,
    pasbool                  check_long_existence);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30cget_result_leaf (
    tgg00_Lkey            &  rk,
    pasbool                  get_next,
    pasbool                  prepare_for_upd,
    tgg00_FilePos         &  tree_pos,
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30cnext_from_tree (
    tgg00_Lkey            &  rk,
    tgg00_BdSetResultRecord  &  set_result,
    tgg00_FilePos         &  tree_pos,
    void                  *  b,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30col_next_stringcol (
    tgg00_Lkey            &  rk,
    integer                  string_col_cnt,
    integer               &  string_col_no,
    tgg00_FileId          &  col_id,
    tgg00_FilePos         &  tree_pos,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30cprev_from_tree (
    tgg00_Lkey            &  rk,
    tgg00_BdSetResultRecord  &  set_result,
    tgg00_FilePos         &  tree_pos,
    void                  *  b,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30current (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_MessType_Param     m_type,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30database_verify (
    tgg00_TransContext    &  t,
    tsp00_Int4            &  bad_index_cnt,
    tsp00_Int4            &  total_bad_cnt,
    tgg00_BasisError      &  verify_error,
    pasbool                  bWithUpdate,
    pasbool                  bWithIndexes,
    pasbool                  bWithExtendedCheck,
    integer                  max_server);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30del_from_tree (
    tgg00_Lkey            &  rk,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30exists_rec (
    tgg00_Lkey            &  rk,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30fdir_to_treeid (
    tbd_fileinfo          &  fi,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30find_leaf (
    tgg00_Lkey            &  key,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30get_from_tree (
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  b,
    tbd_current_tree      &  current,
    tgg00_LockReqMode_Param     wanted_mode);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30init_load (
    tsp00_PageNo          &  rightmost_leaf,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30load_table (
    tbd_node_ptrs         &  lnptr,
    tbd_node_ptrs         &  nptr,
    pasbool                  only_left,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30new_tree (
    tbd_fileinfo          &  fi,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30next_from_tree (
    tgg00_Lkey            &  rk,
    pasbool                  inclusive,
    tgg00_FilePos         &  tree_pos,
    tgg00_Rec             &  b,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30prev_from_tree (
    tgg00_Lkey            &  rk,
    pasbool                  inclusive,
    tgg00_FilePos         &  tree_pos,
    tgg00_Rec             &  b,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30range_exi_rec (
    tgg00_Lkey            &  rk_the_one,
    tgg00_Lkey            &  rk_another,
    tsp00_Int4            &  left___pages,
    tsp00_Int4            &  middle_pages,
    tsp00_Int4            &  right__pages,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30release_tree (
    tbd_current_tree      &  current,
    integer                  stringcol_cnt,
    pasbool                  only_empty);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30repl_in_tree (
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  b,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30reset_bad_file (
    tbd_current_tree      &  current,
    pasbool                  incl_root_upd,
    tbd_file_state_set    &  sub_state);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30save_quick (
    tsp00_PageNo          &  pno,
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30search_record (
    tsp00_KeyPtr             RecKey,
    tsp00_Int4               RecKeyLen,
    tbd_treelock_Param       lock_type,
    tbd_node_request_Param     node_req,
    tsp00_Int4            &  left_estimation,
    tsp00_Int4            &  rightestimation,
    tbd_node_ptrs         &  nptr,
    integer               &  index,
    tbd_neighbors         &  neighbs,
    tbd_searchresult      &  result,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30set_fileversion (
    tbd_current_tree      &  current,
    tgg91_FileVersion        new_fileversion);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30set_read_only (
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30treeleafnodes (
    tbd_current_tree      &  current,
    tbd_node_request_Param     node_req,
    tsp00_Int4            &  old_leafnodes);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30sub_filestate (
    tbd_current_tree      &  current,
    tbd_file_state_set    &  filestate);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30tadd_temp_primary (
    pasbool                  bCountDuplicates,
    tgg00_Rec             &  Rec,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b30verify_tree (
    tbd_current_tree      &  current,
    pasbool                  conv_update,
    pasbool                  bWithExtendedCheck,
    tsp00_Int4            &  NumPages);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd30CreateBeforeImageForDelete (
    tgg00_MessBlock       &  m,
    tsp00_Addr               pDeleteCmd,
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  old_recbuf,
    tgg00_LockReqMode_Param     granted_lock,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd30CreateBeforeImageForInsert (
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  b,
    tgg00_MessBlock       &  m,
    tsp00_Addr               pInsertCmd,
    tgg00_LockReqMode_Param     granted_lock,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd30CreateBeforeImageForUpdate (
    tgg00_MessBlock       &  m,
    tsp00_Addr               pUpdateCmd,
    tgg00_Lkey            &  rk,
    tgg00_Rec             &  old_recbuf,
    tgg00_Rec             &  new_recbuf,
    tgg00_LockReqMode_Param     granted_lock,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd30CreateCoordinator (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  FileId,
    tgg00_MessType_Param     MessType);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd30OmsReadAheadCoordinator (
    tgg00_TransContext    &  t,
    integer                  ReadAheadServer);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

