/*!******************************************************************************

  @file         hbd50.h

  ------------------------------------------------------------------------------

  @author       JuergenP

  @brief        indexhandling

\if EMIT_LICENCE  

    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HBD50_H
#define HBD50_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\x3d\x0f\x33\x3b\x4f\x54\xee\x6f\xf3\xf6\xc6\x15\xba\xd4\xde\x34'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void b50bfind_branchnode (
    tsp00_KeyPtr             sepkey,
    tsp00_Int4               KeyLen,
    tsp00_Int2               lno,
    tbd_node_request_Param     node_req,
    tbd_node_ptrs         &  nptr,
    tbd_neighbors         &  neighbs,
    pasbool               &  found,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50calculate_pagecount (
    tbd_current_tree      &  current,
    pasbool               &  is_tree_requested,
    tgg00_Lkey            &  start_sep,
    tgg00_Lkey            &  stop_sep,
    tsp00_Int4            &  page_count);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50change_treeroot (
    tsp00_PageNo             subroot,
    tsp00_PageNo             new_root,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50check_subtree (
    tsp00_PageNo             root,
    tsp00_PageNo             right,
    tsp00_Int2               long_col_cnt,
    tsp00_Int2               new_long_col_cnt,
    pasbool               &  dump_parent,
    pasbool               &  bad_long,
    tbd_current_tree      &  current,
    tgg00_Lkey            &  checkKey,
    pasbool                  bWithExtendedCheck,
    pasbool                  check_long_existence);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50cross_subtree_boundary (
    tbd_current_tree      &  current,
    tsp00_PageNo             source_leaf,
    tsp00_PageNo             dest_leaf);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50eval_pagecount (
    tgg00_Lkey            &  start_key,
    tgg00_Lkey            &  stop_key,
    pasbool                  count_records,
    tsp00_Int4            &  page_count,
    tsp00_Int4            &  all_page_cnt,
    tsp00_Int4            &  record_cnt,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50find_leaf (
    tsp00_KeyPtr             sepkey,
    tsp00_Int4               KeyLen,
    tbd_treelock_Param       lock_type,
    tbd_node_request_Param     node_req,
    tbd_subtree_info      &  subtree_info,
    tsp00_Int4            &  left_estimate,
    tsp00_Int4            &  rightestimate,
    tsp00_PageNo          &  index_pno,
    tbd_node_ptrs         &  nptr,
    tbd_neighbors         &  neighbs,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50first_leaf (
    tsp00_PageNo          &  firstleaf,
    tbd_treelock_Param       lock_type,
    pasbool               &  single,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50get_left_subtree (
    tbd_node_ptrs         &  nptr,
    integer               &  index,
    tsp00_PageNo             left_neighbor,
    tsp00_PageNo          &  left_subroot,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50position_leaf (
    tsp00_Int4               leafpos,
    tsp00_Int4               leafnodes,
    tsp00_Int4            &  left_estimate,
    tsp00_Int4            &  rightestimate,
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50release_subtree (
    tsp00_PageNo             subroot,
    integer                  stringcol_cnt,
    pasbool                  only_empty,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50reorg_treeindex (
    tgg00_Lkey            &  rk,
    integer                  stringcol_cnt,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b50verify_subtree (
    tsp00_PageNo             root,
    tsp00_PageNo             right,
    pasbool                  conv_update,
    pasbool                  bWithExtendedCheck,
    pasbool               &  dump_parent,
    tgg00_Lkey            &  checkKey,
    tbd_current_tree      &  current,
    tsp00_Int4            &  NumPages);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd50DetermineKeyRangeForServer (
    tbd_current_tree      &  PrimCurrent,
    tsp00_KeyPtr             StartPrimKey,
    tsp00_Int4            &  StartPrimKeyLen,
    tsp00_KeyPtr             StopPrimKey,
    tsp00_Int4            &  StopPrimKeyLen,
    tsp00_Int4            &  NumLeavesToScan,
    tsp00_Int4            &  AvgRecordsPerLeaf,
    pasbool               &  bFinish);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd50DetermineLeafNode (
    tbd_current_tree      &  current,
    tsp00_KeyAddr            pSepKey,
    tsp00_Int4               keyLen,
    tbd_nodeptr              nptr,
    tsp00_Int4            &  recIndex,
    tsp00_PageNo          &  leaf);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tgg00_RecPtr bd50GetRecPtr (
    tbd_current_tree      &  Current,
    tbd_node_ptrs         &  Nptr,
    tsp00_Int4               RecIndex);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd50ExtractForeignKey (
    tgg00_MessBlock       &  m,
    tbd_current_tree      &  current,
    tbd_current_tree      &  temp_current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd50FindLeaf (
    tsp00_Key             &  sepKey,
    tsp00_Int4               keyLen,
    tbd_node_ptrs         &  nptrs,
    tbd_neighbors         &  neighbs,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool bd50IndexNodeIsSaveForDelete (
    tbd_current_tree      &  current,
    tsp00_Int4               recIndex);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool bd50IndexNodeIsSaveForInsert (
    tbd_current_tree      &  current,
    tsp00_Int4               recIndex);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

