/* @lastChanged: "1998-10-20  14:18"
* @filename:    gco04.h
* @purpose:     "DBProcedure: allgemeine Routinen (OMS+SQL Klasse)"
* @release:     7.1.0.0
* @see:         ""
*
* @copyright:   "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*/

#ifdef LC_DBPROC_PROTO
#ifndef GCO04_H_PROTO
#define GCO04_H_PROTO

#define PROGIDPFX  "LiveCache" 
#include "livecache.h"			/* no check *    persistent object definitions */ 
#include "livecachesql.h"		/* no check *    C++ SQL Interface             */
#include "livecachetypes.h" /* no check */
#define CONNECT_E_CANNOTCONNECT 0x80040202

#if defined(WIN32) && defined(SQL_STD_STRING_SUPPORTED)
#define INIT_STRING_HANDLING  static_cast<SqlHandle*>(this)->m_str_assign = &str_assign; \
        static_cast<SqlHandle*>(this)->m_str_append = &str_append;
#else
#define INIT_STRING_HANDLING  ;
#endif


DEFINE_GUID(IID_IliveCacheSpec, 
            0x0D4BFA71,0x5A99,0x11d1,0xA9,0x43,0x00,0xA0,0xC9,0x43,0x11,0xA5);

DECLSPEC_IMPORT void co90CheckVersion (IUnknown**     pIKernelSink, 
                                       const char*    pISinkVersion, 
                                       const char*    pTypesVersion,
                                       const char*    pOMSVersion, 
                                       const char*    pSQLVersion );
DECLSPEC_IMPORT void co90SysRequest (void*, void*, int*, unsigned char* ); 
/*EXTERN_C DECLSPEC_IMPORT void STDAPICALLTYPE Init_PsODll();*/

extern DECLSPEC_IMPORT HRESULT co90AttachSqlSession(void* sql_handle);

extern DECLSPEC_IMPORT HRESULT co90AttachDefaultContext(void* oms_handle);

extern DECLSPEC_IMPORT HRESULT co90RegisterComObject (char *progIDPfx,
                                                      char *project, 
                                                      char *version,
                                                      const GUID &ClsID,
                                                      char *moduleName);

extern DECLSPEC_IMPORT HRESULT co90ReleaseSqlSession(void* sql_handle);

extern DECLSPEC_IMPORT HRESULT co90ReleaseDefaultContext(void* oms_handle);

extern DECLSPEC_IMPORT HRESULT co90UnregisterComObject (char *progIDPfx,
                                                        char *project, 
                                                        char *version,
                                                        const GUID &ClsID,
                                                        char *moduleName);
/* PTS 1111008
extern DECLSPEC_IMPORT void co90MonitorInit   (void*  oms_handle,
                                               void*  sql_handle,
                                               void** lpMonitor,
                                               long   numEntries);

extern DECLSPEC_IMPORT void co90MonitorInit   (void*  oms_handle,
                                               void*  sql_handle,
                                               CLSID* lpClsId,
                                               void** lpMonitor,
                                               long   numEntries);
*/
/* PTS 1111008 */
extern DECLSPEC_IMPORT void co90MonitorInit   (void*  oms_handle,
                                               void*  sql_handle,
                                               const  IID*   IId,
                                               void** lpMonitor,
                                               long   numEntries);

extern DECLSPEC_IMPORT void co90MonitorProlog (void* lpMonitor,
                                               void* oms_handle,
                                               int dispId,
                                               unsigned char* lpmethodName);

/* PTS 1120804 */
extern DECLSPEC_EXPORT void co90SqlMonitorProlog(void* sql_handle, 
                                                 unsigned char* lpmethodName);

extern DECLSPEC_IMPORT void co90MonitorEpilog (void* lpMonitor,
                                               void* oms_handle, 
                                               void* sql_handle,     /* PTS 1120804 */
                                               int   dispId,
                                               int   runTime);

extern DECLSPEC_IMPORT void co90MonitorDelete (void* lpMonitor); 

extern DECLSPEC_IMPORT void co90Vtrace (IUnknown* psession, 
                                        long buflen, 
                                        unsigned char *lpv);

extern DECLSPEC_IMPORT int co90IsDebugEnvironment (IUnknown* psession);

DECLSPEC_IMPORT LONG STDAPICALLTYPE co90InterlockedIncrement( LPLONG lpAddend );
DECLSPEC_IMPORT LONG STDAPICALLTYPE co90InterlockedDecrement( LPLONG lpAddend );

extern "C" DECLSPEC_IMPORT unsigned int dbpStrLen( const DbpTypeUnicode *s );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrCat( DbpTypeUnicode *dest, const DbpTypeUnicode *src );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrnCat( DbpTypeUnicode *dest, const DbpTypeUnicode *src, unsigned int maxlen );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrChr( const DbpTypeUnicode *s, const DbpTypeUnicode c );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrnChr( const DbpTypeUnicode *s, const DbpTypeUnicode c, unsigned int maxlen );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrCmp( DbpTypeUnicode *dest, const DbpTypeUnicode *src );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrnCmp( DbpTypeUnicode *dest, const DbpTypeUnicode *src, unsigned int maxlen );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrCpy( DbpTypeUnicode *dest, const DbpTypeUnicode *src );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrnCpy( DbpTypeUnicode *dest, const DbpTypeUnicode *src, unsigned int maxlen );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrrChr( const DbpTypeUnicode *s, const DbpTypeUnicode c );
extern "C" DECLSPEC_IMPORT DbpTypeUnicode * dbpStrnrChr( const DbpTypeUnicode *s, const DbpTypeUnicode c, unsigned int maxlen );

#if defined(SQL_INCLUDED)
#if defined (WIN32) && defined(SQL_STD_STRING_SUPPORTED)
#if defined(INITGUID)
VOID STDMETHODCALLTYPE str_assign ( char* va, const char* buf, long cl ) 
  { ((std::string&)*va).assign(buf, cl); };
VOID STDMETHODCALLTYPE str_append ( char* va, const char* buf, long cl ) 
  { ((std::string&)*va).append(buf, cl); };
#else
VOID STDMETHODCALLTYPE str_assign ( char* va, const char* buf, long cl );
VOID STDMETHODCALLTYPE str_append ( char* va, const char* buf, long cl );
#endif
#endif
#endif

/*PTS 1105154 FF*/
extern DECLSPEC_IMPORT HRESULT co90CleanUp (void*, void* ); 

/*PTS 1103516 FF*/
extern "C" VOID STDMETHODCALLTYPE Co_IntrospectObject (LPCLSID      *lpClsId,
                                                    LPIID          *lpIId,
                                                    unsigned short *lpNum,
                                                    long           *lpVersion );

#define GLOBAL_DLL_DATA

#endif  /* GCO04_H_PROTO */
#undef LC_DBPROC_PROTO

#else  /* ! LC_DBPROC_PROTO */

#ifndef GCO04_H
#define GCO04_H

/*===========================================================================*
*  INCLUDES                                                                 *
*===========================================================================*/


/*===========================================================================*
*  DEFINES                                                                  *
*===========================================================================*/


/*===========================================================================*
*  MACROS                                                                   *
*===========================================================================*/

/*===========================================================================*
*  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
*===========================================================================*/

class CMonitor {
public :
  void* m_pMon;
  CMonitor () {
    m_pMon = NULL; 
  }
  ~CMonitor() {
#if defined (OMS_INCLUDED)
   co90MonitorDelete (m_pMon);
#endif
  }
};

CMonitor dbpMonitor;

/*===========================================================================*
*  FUNCTION PROTOTYPES                                                      *
*===========================================================================*/
void  dbpDebugBreak() {
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpDebugBreak();
};

/*--------------------------------------------------------------------------*/

void  dbpDropMessageFile(const char* fn) {
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpDropMessageFile(fn);
};

/*--------------------------------------------------------------------------*/

void  dbpExistsFile(const char* fn, bool& doesExist, bool& IsDirectory) {
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpExistsFile(fn, doesExist, IsDirectory);
};

/*--------------------------------------------------------------------------*/

void  dbpFreeLibrary (DbpHandle hd) {
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpFreeLibrary(hd);
};

/*--------------------------------------------------------------------------*/

void  dbpGetDbrootSapPath(char* path, int bufSize) {
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpGetDbrootSapPath(path, bufSize);
};

/*--------------------------------------------------------------------------*/

DbpPROC dbpGetProcAddress(DbpHandle hd, const char *pProcName) {
  DbpBase   dbpBase(this->m_pIUnknown);
  return dbpBase.dbpGetProcAddress(hd, pProcName);
};

/*--------------------------------------------------------------------------*/

void  dbpGetWorkingDirectory(char* path, int bufSize) {
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpGetWorkingDirectory(path, bufSize);
};

/*--------------------------------------------------------------------------*/

DbpHandle   dbpLoadLibrary(const char* path, bool loadGlobal) {
  DbpBase   dbpBase(this->m_pIUnknown);
  return dbpBase.dbpLoadLibrary(path, loadGlobal);
};

/*--------------------------------------------------------------------------*/

void  dbpOpError  ( const char*fmt, ... ) {
  va_list args;
  va_start (args, fmt);
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpOpErrorVarg(fmt, args);
  va_end (args);
};

/*--------------------------------------------------------------------------*/

void  dbpOpMsg  ( const char*fmt, ... ) {
  va_list args;
  va_start (args, fmt);
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpOpMsgVarg(fmt, args);
  va_end (args);
};

/*--------------------------------------------------------------------------*/

void  dbpTrace  ( const char*fmt, ... ) {
  va_list args;
  va_start (args, fmt);
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpTraceVarg(fmt, args);
  va_end (args);
};

/*--------------------------------------------------------------------------*/

OmsTypeInt4  dbpOpenMessageFile (const char* fn, unsigned long fileSize, bool doAppend) {
  DbpBase   dbpBase(this->m_pIUnknown);
  return dbpBase.dbpOpenMessageFile(fn, fileSize, doAppend);
};

/*--------------------------------------------------------------------------*/

void  dbpWriteMessageFile(OmsTypeInt4 fileHandle,  const char*fmt, ... ) {
  va_list args;
  va_start (args, fmt);
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpWriteMessageFileVarg(fileHandle, fmt, args );
  va_end (args);
};

/*--------------------------------------------------------------------------*/

void  dbpCloseMessageFile(OmsTypeInt4 fileHandle) {
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpCloseMessageFile(fileHandle);
};

/*--------------------------------------------------------------------------*/

void  dbpSyncMessageFile (OmsTypeInt4 fileHandle) {
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpSyncMessageFile(fileHandle);
};

/*--------------------------------------------------------------------------*/

void  dbpSyncMessageFile (const char* fn) {
  DbpBase   dbpBase(this->m_pIUnknown);
  dbpBase.dbpSyncMessageFile(fn);
};

/*--------------------------------------------------------------------------*/

STDMETHOD ( sysRequest) ( int __RPC_FAR *lpbuflen, unsigned char __RPC_FAR *lpv )
#if defined (SQL_INCLUDED)
#if defined (OMS_INCLUDED)
{ co90SysRequest( STATIC_CAST(OmsHandle*,this), STATIC_CAST(SqlHandle*, this), lpbuflen, lpv ); return S_OK; };
#else
{ co90SysRequest( NULL, STATIC_CAST(SqlHandle*, this), lpbuflen, lpv ); return S_OK; };
#endif
#else
#if defined (OMS_INCLUDED)
{ co90SysRequest( STATIC_CAST(OmsHandle*, this), NULL, lpbuflen, lpv ); return S_OK; };
#else
{ co90SysRequest( NULL, NULL, lpbuflen, lpv ); return S_OK; };
#endif
#endif
STDMETHOD ( sysSqlSupport ) ( BOOLEAN __RPC_FAR *sql_support)     
#if defined (SQL_INCLUDED)
{ *sql_support = true; return S_OK; };
#else
{ *sql_support = false; return S_OK; };
#endif

/*--------------------------------------------------------------------------*/

STDMETHOD ( sysMonitorInit ) (void)
{
#if defined (OMS_INCLUDED)
  LPCLSID         lpClsId;
  LPIID           lpIId;
  unsigned short  num;
  long            version;

  Co_IntrospectObject (&lpClsId, &lpIId, &num, &version );
  co90MonitorInit( STATIC_CAST(OmsHandle*, this), NULL, 
    /*lpIId 1111008*/&COM_INTERFACE_IID, 
    &dbpMonitor.m_pMon, num+3 );
#endif
  return S_OK; 
};

/*--------------------------------------------------------------------------*/

STDMETHOD ( sysMonitorProlog ) ( int dispId, unsigned char __RPC_FAR *lpMethodName ) {
  if (dbpMonitor.m_pMon) {
#   if defined (OMS_INCLUDED)    
      co90MonitorProlog (dbpMonitor.m_pMon, STATIC_CAST(OmsHandle*,this), dispId, lpMethodName);
      /* PTS 1120804 */
#     if defined (SQL_INCLUDED)   
        co90SqlMonitorProlog( STATIC_CAST(SqlHandle*,this), lpMethodName );
#     endif
#   endif
  }
  return S_OK;
}

/*--------------------------------------------------------------------------*/

STDMETHOD ( sysMonitorEpilog ) ( int dispId, int runTime ) {
  if (dbpMonitor.m_pMon) {
#   if defined (OMS_INCLUDED)   
      /* PTS 1120804 */
      void* pSH = NULL;
#     if defined (SQL_INCLUDED)   
        pSH = STATIC_CAST(SqlHandle*,this);
#     endif  
      co90MonitorEpilog( dbpMonitor.m_pMon, STATIC_CAST(OmsHandle*,this), 
                         pSH, dispId, runTime );
#   endif
  }
  return S_OK;
}

/*--------------------------------------------------------------------------*/

STDMETHODIMP QueryInterface(const struct _GUID & rclsid,void **ppv )
{
  *ppv=NULL;
  if (IID_IUnknown==rclsid || COM_INTERFACE_IID == rclsid)
    *ppv=STATIC_CAST(COM_INTERFACE*,(this));
  if (IID_IliveCacheSpec == rclsid )
    *ppv=STATIC_CAST(IliveCacheSpec*,(this));
  if ( *ppv == NULL ) return ResultFromScode(E_NOINTERFACE);   
  ((LPUNKNOWN)*ppv)->AddRef();
  return NOERROR;
};	

/*--------------------------------------------------------------------------*/

STDMETHODIMP_(unsigned long) AddRef(void)
{
  return co90InterlockedIncrement(&m_cRef);
};

/*--------------------------------------------------------------------------*/

STDMETHODIMP_(unsigned long) Release(void)
{
	unsigned long refCnt = co90InterlockedDecrement(&m_cRef);
	if (0 == refCnt) {
      delete this;
      return 0;
    }
    return refCnt;
}

/*--------------------------------------------------------------------------*/

STDMETHODIMP Advise(LPUNKNOWN pUnkSink)
{
  IUnknown       *pSink;
  HRESULT        hr = NOERROR;
  
  /* Verify that the sink has the interface it's supposed to.*/
  if (FAILED(pUnkSink->QueryInterface(IID_IliveCacheSink, (void**)&pSink)))
    return ResultFromScode(CONNECT_E_CANNOTCONNECT);
  m_pIUnknown=pSink;
#if defined (SQL_INCLUDED)
  hr = co90AttachSqlSession(STATIC_CAST(SqlHandle*, this));
  if ( FAILED(hr) ) return hr;
#endif
#if defined (OMS_INCLUDED)
  hr = co90AttachDefaultContext(STATIC_CAST(OmsHandle*, this));
#endif
  return hr;
};

/*--------------------------------------------------------------------------*/

STDMETHODIMP Unadvise()
{
  HRESULT hr = NOERROR;
  if ( m_pIUnknown != NULL ) {
#if defined (SQL_INCLUDED)
    hr = co90ReleaseSqlSession(STATIC_CAST(SqlHandle*, this));
#endif
#if defined (OMS_INCLUDED)
    hr = co90ReleaseDefaultContext(STATIC_CAST(OmsHandle*, this));
#endif
    m_pIUnknown->Release();
  }
  m_pIUnknown = NULL;
  return hr;
};

/*------------------------- PTS 1105154 ------------------------------------*/

STDMETHOD ( sysCleanUp )( void )
{
  HRESULT hr = S_OK;
#if defined (SQL_INCLUDED)
#if defined (OMS_INCLUDED)
   hr = co90CleanUp( STATIC_CAST(OmsHandle*,this), STATIC_CAST(SqlHandle*, this) );
#else
   hr = co90CleanUp( NULL, STATIC_CAST(SqlHandle*, this) );
#endif
#else
#if defined (OMS_INCLUDED)
   hr = co90CleanUp( STATIC_CAST(OmsHandle*,this), NULL );
#else
   hr = co90CleanUp( NULL, NULL );
#endif
#endif
  return hr;
};
#endif  /* GCO04_H */
#endif  /* LC_DBPROC_PROTO */




