/* @lastChanged: "1998-09-18  9:36"

  * @filename:   hco002.h
  * @purpose:    "ABAP Packed Interface"
  * @release:    7.1.0.0
  * @see:        "http://www.bea.sap-ag.de/doku/rel-7.1/gco10.html"
  *
  * @copyright:  "Copyright by   SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*/

#if !defined (__GCO14_H)
#define __GCO14_H

#include "livecachetypes.h" /* no check */

#if defined(WIN32)
#define EXPORT_CLASS __declspec(dllexport)
#else
#define EXPORT_CLASS
#endif

#define SAPDB_HIGH(X) (X >> 4)
#define SAPDB_LOW(X) (X & 0x0F)

#define MAX_CURRENCY_VAL 9223372036854775807I64

#define  BCDPLUS           0xc
#define  BCDMINUS          0xd

class EXPORT_CLASS OmsPacked {
public :
  OmsTypeInt64 toInt64_16();
  void   toPacked(OmsTypeInt64, int);
private :
  /* PTS 1107752 */
  int digit15() { return SAPDB_HIGH(m_packed[0]); }
  int digit14() { return SAPDB_LOW (m_packed[0]); }
  int digit13() { return SAPDB_HIGH(m_packed[1]); }
  int digit12() { return SAPDB_LOW (m_packed[1]); }
  int digit11() { return SAPDB_HIGH(m_packed[2]); }
  int digit10() { return SAPDB_LOW (m_packed[2]); }
  int digit9 () { return SAPDB_HIGH(m_packed[3]); }
  int digit8 () { return SAPDB_LOW (m_packed[3]); }
  int digit7 () { return SAPDB_HIGH(m_packed[4]); }
  int digit6 () { return SAPDB_LOW (m_packed[4]); }
  int digit5 () { return SAPDB_HIGH(m_packed[5]); }
  int digit4 () { return SAPDB_LOW (m_packed[5]); }
  int digit3 () { return SAPDB_HIGH(m_packed[6]); }
  int digit2 () { return SAPDB_LOW (m_packed[6]); }
  int digit1 () { return SAPDB_HIGH(m_packed[7]); }
  int sign   () { return SAPDB_LOW (m_packed[7]); }
  unsigned char m_packed[8];     
};

#undef EXPORT_CLASS

#endif






