/*!***************************************************************************

  module      : SQL.h

  -------------------------------------------------------------------------

  responsible : FerdiF

  special area: C++ SQL-Class   
  description : SQL - Application Interface for an SQL-Statement 
				
  
  last changed: 2000-03-08  11:22
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/

#ifndef GCO501SQL_H
#define GCO501SQL_H

#ifndef __vco03_h__
#include "livecachetypes.h" /* no check*/
#endif

class SqlCol;
class co521CSqlStmt;

/*----------------------------------------------------------------------*/
/* class SQL                                                            */
/*----------------------------------------------------------------------*/
class SqlHandle;

class AFX_EXT_CLASS SQL {
  friend class SqlHandle;
  friend class co51CSqlSessionContext;
private:
  co521CSqlStmt*  m_sqlstatement;
  boolean         m_dummy1;

  SQL(SqlHandle* hd, const char* stmt);
  SQL(SqlHandle* hd, const DbpTypeUnicode* stmt);
public:

#if defined (EXT_CLIENT_SQL)
  int		connect (const char* hostname, const char* dbname, 
    const char* user, const char* pwd, const char* isolevel);
#endif

  SQL();
  ~SQL ();
  SQL(const SQL& sql);
  short   sqlNumCols () const;            // returns number of input and output parameters
  short   sqlNumOutCols () const;         // returns number of output parameters
  int     sqlExecute ();                  // executes a statement
  int     sqlPrepare ();                  // prepares a statement and returns the number
  int     operator() ();                  // like execute ()
#if defined( SUN )
  SQL	    &operator<< (const SqlCol);     // assignes a column
#else
  SQL	    &operator<< (const SqlCol&);    // assignes a column
#endif
  SqlCol  &operator[] (int);              // select a column by index
  const SQL & operator= (const SQL& right);
  void*   operator new( size_t sz );
  void    operator delete (void* p);
  void*   operator new[] (size_t sz);
  void    operator delete[] (void* p);
};

/*----------------------------------------------------------------------*/


#endif


