/*!***************************************************************************

  module      : gco512CParseSQLReply.h 

  -------------------------------------------------------------------------

  responsible : FerdiF

  special area: C++ SQL-Class   
  description : co512CParseSQLReply - Parse SQL Reply Parser 
				
  
  last changed: 2000-03-08  11:22
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000 



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/

#ifndef GCO512CPARSESQLREPLY_H
#define GCO512CPARSESQLREPLY_H

#ifndef HIN204_H
#include "hin204.h"
#endif

class co51CSqlSessionContext;
class co521CSqlStmt;

class co512CParseSQLReply : public  cin204_ReplyParser
{
  co51CSqlSessionContext& m_sessCtxt;
  co521CSqlStmt&          m_stmt;
public:
  co512CParseSQLReply( co51CSqlSessionContext& sessionContext,
    co521CSqlStmt& stmt );
  virtual int        ParseReplyData ( tsp1_packet* m_reply_packet);
  virtual AcceptKind HandleErrortext ( int argCount, int len, const char * data);
  virtual AcceptKind HandleData ( int argCount, int dataLen, const teo00_Byte * dataPtr);
  virtual AcceptKind HandleLongdata ( int argCount, int dataLen, const tsp00_Byte * dataPtr);
  virtual AcceptKind HandleParsid ( int argCount, int len, const tin02_ParseId * data);
  virtual AcceptKind HandleParsidOfSelect ( int argCount, int len, const tin02_ParseId * data);
  virtual AcceptKind HandleResultcount ( int argCount, int len, long data );
  virtual AcceptKind HandleResulttablename ( int argCount, int len, const char * data);
  virtual AcceptKind HandleShortinfo ( int argCount, int len, const tsp1_param_info * data);
};

#endif
