/*!***************************************************************************

  module      : gco522CColumnDesc.h 

  -------------------------------------------------------------------------

  responsible : FerdiF

  special area: C++ SQL-Class   
  description : SqlCol  - SQL Statement Parameter Description 
				
  
  last changed: 2000-03-08  11:22
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/

#ifndef GCO522CCOLUMNDESC_H
#define GCO522CCOLUMNDESC_H

#ifndef VSP001_H
#include "vsp001.h"
#endif

//#define     MIN_REPLY_SIZE_CO522    1024

class cin201_Part;
class co51CSqlSessionContext;
class co521CSqlStmt;

class co522CColumnDesc {
public:
  tsp1_param_info   sfi; 
  struct sql_var_info {
    long            ind;
    long            vlen;
    void*           vaddr;
    unsigned char   vfrac;
    unsigned char   vtype;
  }                 vfi;
  short             long_idx;
  co522CColumnDesc();
  const co522CColumnDesc & operator= (const co522CColumnDesc& right);
  int   addParmToBuffer( cin201_Part * part, co51CSqlSessionContext& sess,
    co521CSqlStmt& stmt, int idx );
  int   addOpenLongDataToBuffer( cin201_Part * part, co51CSqlSessionContext& sess,
    co521CSqlStmt& stmt, int idx );
  int   addOpenLongDescriptor( cin201_Part * part, co51CSqlSessionContext& sess,
    co521CSqlStmt& stmt, int idx );
  int   getParmFromBuffer( const teo00_Byte * dataPtr, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
  int   getParmLongDescFromBuffer( const tsp00_Byte * dataPtr, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
  int   getOpenLongDataFromBuffer( const tsp00_Byte * dataPtr, co51CSqlSessionContext& sess,
    co521CSqlStmt& stmt, int idx );
  void  assignVar( const co522CColumnDesc& right );  
  void* operator new( size_t sz );
  void  operator delete (void* p);
protected:
  int addParmVBool( cin201_Part * part, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
  int addParmVChar( cin201_Part * part, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
  int addParmVNum( cin201_Part * part, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
  int addParmVSTDString( cin201_Part * part, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
  int getParmVBool( const teo00_Byte * dataPtr, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
  int getParmVChar( const teo00_Byte * dataPtr, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
  int getParmVNum( const teo00_Byte * dataPtr, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
  int getParmVSTDString( const teo00_Byte * dataPtr, co51CSqlSessionContext& sess, 
    co521CSqlStmt& stmt, int idx );
};
#endif
