/*!================================================================
 module:        hco54.h

 responsible:   DanielD

 special area:  Interfaces | SQL Class

 description:   Client Session

 copyright:     SAP AG 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 ===================================================================*/

#ifndef SQLCPPCLASS_H
#define SQLCPPCLASS_H

#if !defined EXT_CLIENT_SQL
#define EXT_CLIENT_SQL
#endif
#include <livecachesql.h>

class SqlConnection;

class AFX_EXT_CLASS SqlSession : public SqlHandle
{
public:
  typedef enum { ISO_LEVEL_0, ISO_LEVEL_1, ISO_LEVEL_15, ISO_LEVEL_2, ISO_LEVEL_3} IsoLevel;

  SqlSession ();
  SqlSession (const char * user, const char * pwd,
    const char * dbname, const char * host = "", 
    const IsoLevel = ISO_LEVEL_1, const char * version = LIVECACHESQL_VERSION);
  ~SqlSession ();
  bool connect (const char * user, const char * pwd,
    const char * dbname, const char * host = "", 
    const IsoLevel = ISO_LEVEL_1, const char * version = LIVECACHESQL_VERSION);

private:
    void * dummy;
};

AFX_EXT_CLASS void SqlInit();
AFX_EXT_CLASS void SqlFinish();

#endif

