/*!***************************************************************************

  module      : hco11OmsLockObj.h

  -------------------------------------------------------------------------

  responsible : ThomasA

  special area: OMS

  description : defines OmsLockObject

  last changed: 2000-07-26  18:24
  
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*****************************************************************************/

#ifndef OmsLockObject_h
#define OmsLockObject_h

#include "gco00.h"
#include "livecachetypes.h" // nocheck

class  OmsHandle;
class  OmsSession_co12;
struct OmsLockHandle;
class  SessionLockObject;

typedef SessionLockObject* SessionLockObjectPtr;

class AFX_EXT_CLASS OmsLockObject {
  friend class OmsHandle;
  friend class OmsSession_co12;
  friend class SessionLockObjects;
public :
   OmsLockObject(OmsHandle&);
   ~OmsLockObject();                       
   void omsEnable ();
   void omsEnable (const OmsLockHandle&);
   const OmsLockHandle& omsGetLockHandle() const;
   void  omsLockShare();
   void  omsLockExclusive();
   void  omsUnlock();
   bool  omsIsLocked() const;
   bool  omsShareLocked() const;
   bool  omsExclusiveLocked() const;
   void  Invalidate();
private :
  OmsHandle*           m_omsHandle;
  OmsLockHandle        m_lockHandle;
  SessionLockObjectPtr m_pLock;
};

#endif