/****************************************************************************

  module      : gen32.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: dump packets
  description : Get Socket Addresses

  last changed: 1999-02-04  14:13
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEN32_H
#define GEN32_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "geo00.h"
#include "gen00.h"
#include "gen003.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC int     sql32_open_kernel_fifo ( char         *dbname ,
										 int          *fdp ,
										 uid_t        *uidp ,
										 char        **errm );

externC  int     sql32_open_reply_fifo ( char         *dbname ,
										 pid_t         pid ,
										 tsp00_Int4    ref ,
										 char         *file ,
										 int          *fdp ,
										 char        **errm );

externC int     sql32_attach_comseg ( connection_info *cip );

externC void    sql32_lock_comseg ( connection_info   *cip ,
									char              *msg );

externC void    sql32_unlock_comseg ( connection_info *cip );

#endif  /* GEN32_H */
