/****************************************************************************

  module      : gen33.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: Remote communication
  description : Communation functions

  last changed: 1999-02-19  11:01
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEN33_H
#define GEN33_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "geo00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC int sql33_connect ( connection_info  *cip ,
							char            **errm ,
							connection_info   conn_info [ ],
							int               count);

externC int sql33_release ( connection_info  *cip ,
			                char            **errm ,
						    connection_info   conn_info [ ],
						    int               count);

externC int sql33_request ( connection_info  *cip ,
							char            **errm );

externC int sql33_replyavailable ( connection_info  *cip ,
								   char            **errm );

externC int sql33_receive ( connection_info  *cip ,
							char            **errm );

externC int en33CheckedReceive ( int (*checkCallback)(void *),
                                   void *arg,
                                   connection_info  *cip ,
							       char            **errm );

externC int sql33_cancel ( connection_info  *cip ,
						   char            **errm );

externC int sql33_dump   ( connection_info  *cip ,
						   char            **errm );

externC int sql33_clear ( connection_info  *cip ,
						  char            **errm ,
						  connection_info   conn_info [ ],
						  int               count);

externC void sql33_cleanup ( connection_info     *cip );

externC teo00_Longuint 
en33Request ( connection_info                *pConnInfo, 
              teo00_Longuint                  ulDataLen,
              tsp00_ErrTextc  VAR_ARRAY_REF   szErrText ) ;

externC teo00_Longuint 
en33Receive ( connection_info                *pConnInfo, 
              teo003_CommPacketRecord       **ppResultPacket,
              teo00_Longuint                 *pulResultLen,
              tsp00_ErrTextc  VAR_ARRAY_REF   szErrText );

#endif  /* GEN33_H */
