/****************************************************************************

  module      : gen60.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: vopmsg

  description : Message Output


  last changed: 1999-11-19  16:28
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEN60_H
#define GEN60_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "geo00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC void sql60kc_msg ( tsp00_Uint1 prio ,
						   const char *text,
						   int   msg_type );

externC void sql60_write_to_util_diag ( const char     *text ,
                                        int      len );

externC void sql60_write_to_event_file ( const char     *text ,
                                         int      len );

externC void e60_deliver_msg (char *msg, 
							  int lgt );

externC int  en60InitializeMessageOutput( /* void */ );

externC int en60_UseDiagFifo( /* void */ );

externC void sqldbgwrite ( const char *text ,
                           ... );

externC void sqlerrwrite ( const char *text ,
                           ... );

externC void sqlwngwrite ( const char *text ,
                           ... );

externC int  en60OpenEventFile ( tsp00_VFilenamec VAR_ARRAY_REF Filename, tsp00_Int4 MaxSize );

#endif  /* GEN60_H */
