/****************************************************************************

  module      : gen75.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: communication kernel
  description : Communication Functions for Kernel

  last changed: 1999-02-04  14:14
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEN75_H
#define GEN75_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "geo00.h"
#include "geo002.h"
#include "geo70k.h"
#include "gen00.h"
#include "gen003.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC int e75_wake_peer ( connection_info *cip );

externC void e75_release_all_ukp_tasks ( );

externC void e75_release_connection ( int reason ,
                                      int waitflag );

externC int e75_has_com ( struct TASK_TYPE *tcb );

externC int e75_is_connected ( struct TASK_TYPE *tcb );

externC int e75_connect_request ( struct DOUBLY_LINKED  *lquu );

externC void e75_release_request ( struct DOUBLY_LINKED *lquu );

/* PTS 1113008 */
/*!
  Function: en75FinalReleaseConnections
  Description: Release client connections from Watchdog thread after _exit of kernel
  Arguments: kernelExitCode [in] final kernl exit code != 0 on crash, == 0 on normal shutdown
 */
externC void en75FinalReleaseConnections( int kernelExitCode );

#endif  /* GEN75_H */
