/****************************************************************************

  module      : hen43.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: socket_address_resolution
  description : Get Socket Addresses

  last changed: 1998-09-01  12:32
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef HEN43_H
#define HEN43_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "gsp01.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC  void sqlhostname ( tsp00_NodeId   host ,
							tsp00_ErrText  errtext ,
							tsp01_CommErr *returncode );

externC  void sqlnodename ( tsp00_NodeId   host ,
							tsp00_NodeId   node ,
							tsp00_ErrText  errtext ,
							tsp01_CommErr *returncode );

#endif  /* HEN43_H */
