/****************************************************************************

  module      : hen53.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: communication
  description : vcmd_wait_time, vconnect, vconnect2, vreceive, vreply

  last changed: 1999-09-21  10:53
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef HEN53_H
#define HEN53_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "gsp01.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC tsp00_Int4 vcmd_wait_time ( tsp00_TaskId pid );

externC void    vconnect2 ( tsp00_TaskId                pid ,
							tsp00_Int4    VAR_VALUE_REF max_data_len ,
							tsp00_Bool    VAR_VALUE_REF webuser ,
						   	tsp01_CommErr VAR_VALUE_REF returncode );

externC void    vconnect  ( tsp00_TaskId                pid ,
						    tsp00_Int4    VAR_VALUE_REF max_data_len ,
						    tsp01_CommErr VAR_VALUE_REF returncode );

externC void    vreceive (  tsp00_TaskId                pid ,
							tsp00_Int4                  timeout ,
							void                      **rcv_packet_ptr ,
							tsp00_Int4    VAR_VALUE_REF rcv_length ,
							void                      **reply_packet_ptr ,
							tsp00_Int4    VAR_VALUE_REF reply_size ,
							tsp01_CommErr VAR_VALUE_REF returncode );

externC void    vreply (    tsp00_TaskId                pid ,
							void                       *reply_packet_ptr ,
							tsp00_Int4                  reply_length ,
							tsp01_CommErr VAR_VALUE_REF returncode );

externC	void	vrelease ( tsp00_TaskId	pid );

externC void	vgetapplpid( tsp00_TaskId               pid ,
                             tsp00_NodeId VAR_ARRAY_REF appl_node ,
                             tsp00_Int4   VAR_VALUE_REF appl_pid ,
                             tsp00_Bool   VAR_VALUE_REF ok );

#endif  /* HEN53_H */
