/****************************************************************************

  module      : hen71.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: dispatcher
  description : Dispatcher and Queue Management


  last changed: 1998-09-01  15:07
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef HEN71_H
#define HEN71_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC void v2prio ( tsp00_Int4 task_id ,
					  tsp00_Uint1 prio ,
					  tsp00_Bool  set_prio ,
					  int root ,
					  int leaf,
					  int locktype );

externC void vprio ( tsp00_Int4  task_id,
					 tsp00_Uint1 prio,
					 tsp00_Bool  set_prio );

externC void vdelay_commit ( tsp00_TaskId pid );

externC void vdelay_lw ( tsp00_TaskId pid );

#endif  /* HEN71_H */

