/*!**************************************************************************

  module      : ven15.c

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: Client RunTime
  description : Miscellaneous Functions


  last changed: 2001-09-21  12:17
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin LGPL
  Copyright (C) 2001 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/
#define MOD__ "ven15.c:"

void                            sqlgeteuid ();
void                            sqlfileexists ();

#include "gen00.h"
#include "heo46.h"

/*
 * ===================================================================
 */
#undef MF__
#define MF__ MOD__"sqlgeteuid"
void                           sqlgeteuid ( 
tsp_int4                       *euid )
{
DBGIN;
    *euid = (tsp_int4) geteuid ();
DBGOUT;
} 

/*
 * ===================================================================
 */
#undef MF__
#define MF__ MOD__"sqlfileexists"
void                           sqlfileexists ( 
tsp_vfilename                  filename ,
tsp00_Bool                        * exists )
{

tsp00_VFilenamec               tempn ;
tsp_int4                       fildes ;

DBGIN;

fildes = sizeof ( tsp_vfilename );
eo46PtoC ( tempn , filename , fildes );
fildes = open ( (char *)tempn , O_RDONLY , 0 );
if ( fildes >= 0 )
    {
    * exists  = TRUE ;
    close ( (int) fildes );
    }
else
    {
    * exists  = FALSE ;
    }

DBGOUT;
}
