/****************************************************************************

  module      : geo66.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: virtual file LZU Kernel
  description : LZU Internal Virtual File Interface


  last changed: 1999-03-11  9:22
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEO66_H
#define GEO66_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC void sql66kc_open( char                          *filename ,
                           tsp00_Bool                    no_magic_record,
						   tsp_int4                      *hostfileno ,
						   tsp_vf_return VAR_VALUE_REF   error ,
						   tsp_errtext   VAR_ARRAY_REF   errtext );

externC void sql66kc_append_open(  char            *filename ,
								   tsp_int4        *hostfileno ,
								   tsp_vf_return VAR_VALUE_REF  error ,
								   tsp_errtext   VAR_ARRAY_REF  errtext );

externC void sql66kc_close ( tsp_int4        hostfileno ,
							 tsp_vf_return  VAR_VALUE_REF error ,
							 tsp_errtext    VAR_ARRAY_REF errtext );

externC void sql66kc_write ( tsp_int4        hostfileno ,
							 char           *block ,
							 tsp_int4        block_len ,
							 tsp_vf_return  VAR_VALUE_REF error ,
							 tsp_errtext    VAR_ARRAY_REF errtext );

/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/

#endif  /* GEO66_H */
