/****************************************************************************

  module      : geo67.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: logging ...
  description : description ...


  last changed: 1999-11-22  13:28
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEO67_H
#define GEO67_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "vsp0031.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC bool  eo67ConnectEventTask( tsp00_TaskId pid );

externC bool  eo67ReleaseEventTask( tsp00_TaskId pid );

externC tsp00_Int4 eo67SpaceNeeded( tsp00_Int4 maxNumberOfEventTasks,
                                    tsp00_Int4 maxNumberOfEvents );

externC bool  eo67Initialize( tsp00_Int4 maxNumberOfEventTasks,
                              tsp00_Int4 maxNumberOfEvents );

externC void  eo67InitializeEventInfo( );

externC void  eo67InsertKeepAlive();

/* PTS 1004575 */
externC void  eo67InsertSessionEvent(bool isConnect, const tsp00_Int4 TaskIndex);

/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/



#endif  /* GEO67_H */
