/****************************************************************************

  module      : geo900.h

  -------------------------------------------------------------------------

  responsible : RaymondR

  special area: Process checking
  description : Process checking


  last changed: 2000-06-05  11:56
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEO900_H
#define GEO900_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include  "geo00.h"
#include  "geo001.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

typedef enum   
{ 
  UnknownOrInvalid = 1,
  Alive,
  Died 
} RTEProc_State;

typedef struct 
{
# if defined (_WIN32)
   HANDLE             m_ProcHandle;
# endif
  teo001_Pid          m_Pid;
} RTEProc_Handle;

/*===========================================================================*
 *  PROTOTYPES                                                               *
 *===========================================================================*/


bool            RTEProc_Open    ( teo001_Pid     Pid,
                                  RTEProc_Handle *pHandle );

bool            RTEProc_Close   ( RTEProc_Handle Handle );

RTEProc_State   RTEProc_GetState( RTEProc_Handle Handle );

#endif  /* GEO900_H */
