/****************************************************************************

  module      : geo906.h

  -------------------------------------------------------------------------

  responsible : RaymondR

  special area: DBMServer communication
  description : DBMServer communication


  last changed: 1999-12-09  18:08
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEO906_H
#define GEO906_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "geo001.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

#define DBM_TRANSFER_BUFFER_SIZE        16384
#define DBM_MIN_RESPONSE_PACKET_SIZE    100


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

typedef struct teo906_Connection 
{
#if defined (_WIN32)
    HANDLE                      CancelThread;
    BOOL                        ItsAShmConnection;
    struct tos906c_shmServer    *ShmComm;
#else
    teo001_Pid                  CancelProcess;
#endif

#if defined (DUMP_PACKET_DATA)
    char*                       pSendDataBuffer;
#endif

    void                        *pCommObj;
} teo906_Connection;

/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/



#endif  /* GEO906_H */
