/*!**************************************************************************

  module      : heo00x.h

  -------------------------------------------------------------------------

  responsible : FrankH

  special area: 
  description : RTE - XCONS  include module


  last changed: 2001-09-20  17:24
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin  GPL
  Copyright (C) 2001 SAP AG

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  ========== licence end

*****************************************************************************/

#ifndef HEO00X_H
#define HEO00X_H


#include "heo00.h"


/*
// +---------------------------------------------------------------+
// |  TASK STATE REASON                                            |
// +---------------------------------------------------------------+
*/
typedef char SHORT_REASON_STR[14+1] ;
typedef char LONG_REASON_STR [40+1] ;
 
typedef struct suspend_state_reason
  {
  SHORT_REASON_STR                      szShortReason ;
  LONG_REASON_STR                       szLongReason ;
  } SUSPEND_STATE_REASON;
 
static SUSPEND_STATE_REASON SuspendReasonText[MAX_SUSPEND_REASONS] =
  {
    {  "Vsuspend (000)" , " NICHT BENUTZEN                         " } ,
    {  "Eventing (001)" , "vwait_for_event: waiting for event      " } ,
    {  "DelFile  (002)" , "bd95_RemoveObjFile                      " } ,
    {  "NodeExcl      " , "bd13GetNode                             " } ,
    {  "NodeShare     " , "bd13GetNode                             " } ,
    {  "RootExcl      " , "bd13GetNode                             " } ,
    {  "RootShare     " , "bd13GetNode                             " } ,
    {  "sus-RLI  (007)" , "b50calculate_pagecount                  " } ,
    {  "sus-RLL  (008)" , "bd72multi_column_statistics             " } ,
    {  "sus-RLI  (009)" , "b50read_ahead_pnos                      " } ,
    {  "sus-DLT  (010)" , "B01change filetype                      " } ,
    {  "sus-DLT  (011)" , "b01fset_write_state                     " } ,
    {  "sus-DLT  (012)" , "b01prefix_destroyx                      " } ,
    {  "sus-DLT  (013)" , "b01reload_file                          " } ,
    {  "sus-RLT  (014)" , "b01get_inv_usage_cnt                    " } ,
    {  "sus-RLL  (015)" , "b30get_inv_usage_cnt                    " } ,
    {  "sus-DLT  (016)" , "b01set_fileversion                      " } ,
    {  "sus-RLT  (017)" , "b01treeleafnodes                        " } ,
    {  "sus-DLT  (018)" , "b01treeleafnodes                        " } ,
    {  "sus-RLT  (019)" , "b01sfile_statistic                      " } ,
    {  "sus-RLT  (020)" , "b01tnext_temp_stati                     " } ,
    {  "sus-DLT  (021)" , "b01treset_file                          " } ,
    {  "sus-DLT  (022)" , "b01file_unload                          " } ,
    {  "sus-DLT  (023)" , "b01empty_file                           " } ,
    {  "sus-RLI  (024)" , "b50calculate_pagecount                  " } ,
    {  "sus-RLT  (025)" , "b01pverify_participant                  " } ,
    {  "sus-DLT  (026)" , "b01destroy_file                         " } ,
    {  "sus-RLL  (027)" , "Data_ScanTreeAccess::ReplaceLeafPageLock" } ,
    {  "sus-RLL  (028)" , "Data_ScanTreeAccess::ReplaceLeafPageLock" } ,
    {  "sus-RLT  (029)" , "Data_SerializableScanTreeAccess:Continue" } ,
    {  "sus-WLT  (030)" , "b05trunc_bytestr                        " } ,
    {  "sus-WLT  (031)" , "b05copy_bytestr                         " } ,
    {  "sus-WLT  (032)" , "b05copy_bytestr                         " } ,
    {  "sus-WLT  (033)" , "b05expand_bytestr                       " } ,
    {  "sus-WLT  (034)" , "b05write_bytestr                        " } ,
    {  "sus-RLT  (035)" , "b06put_errtxt                           " } ,
    {  "sus-WLT  (036)" , "b06put_errtxt                           " } ,
    {  "Vsuspend (037)" , "                                        " } ,
    {  "sus-RLT  (038)" , "b06get_errtxt                           " } ,
    {  "Vsuspend (039)" , "                                        " } ,
    {  "Vsuspend (040)" , "                                        " } ,
    {  "IOWait(R)(041)" , "b13get_node: await read              :-(" } ,
    {  "IOWait(W)(042)" , "b13get_node                          :-(" } ,
    {  "DC OvFlow(043)" , "b13get_node: sysbuf_overflow (SVP)   :-(" } ,
    {  "IOWait(W)(044)" , "b13pfree_pno                         :-(" } ,
    {  "SVP-End  (045)" , "b13pfree_pno                         :-(" } ,
    {  "DC OvFlow(046)" , "bd13frame_for: sysbuf_overflow       :-(" } ,
    {  "Vsuspend (047)" , "                                        " } ,
    {  "Vsuspend (048)" , "                                        " } ,
    {  "No-Work  (049)" , "Trace_Manager::WaitForWork              " } ,
    {  "Vsuspend (050)" , "                                        " } ,
    {  "VTRACE IO(051)" , "Trace_Manager::PrepareAndWaitForFlush   " } ,
    {  "InitState(052)" , "                                        " } ,
    {  "No-Work  (053)" , "Pager_Writer::Run                       " } ,
    {  "Vsuspend (054)" , "Pager_Controller::WaitForDwReply        " } ,
    {  "sus-DLT  (055)" , "b17reset_read_only                      " } ,
    {  "FreeWait (056)" , "bd13frame_for_new_node                  " } ,
    {  "IOWait(R (057)" , "b13b_get_node_by_blockaddr           :-(" } ,
    {  "IOWait(W)(058)" , "b13b_get_node_by_blockaddr           :-(" } ,
    {  "DC OvFlow(059)" , "b13b_get_node: sysbuf_overflow (SVP) :-(" } ,
    {  "sus-RLT  (060)" , "b30current                              " } ,
    {  "sus-RLT  (061)" , "b30current                              " } ,
    {  "sus-RLT  (062)" , "b30current                              " } ,
    {  "sus-WLT  (063)" , "b30del_from_tree                        " } ,
    {  "sus-WLI  (064)" , "b30del_from_tree                        " } ,
    {  "Vsuspend (065)" , "                                        " } ,
    {  "Vsuspend (066)" , "                                        " } ,
    {  "Vsuspend (067)" , "                                        " } ,
    {  "Vsuspend (068)" , "                                        " } ,
    {  "Vsuspend (069)" , "                                        " } ,
    {  "Vsuspend (070)" , "                                        " } ,
    {  "sus-WLT  (071)" , "b30repl_in_tree                         " } ,
    {  "sus-WLI  (072)" , "b30repl_in_tree                         " } ,
    {  "sus-WLT  (073)" , "b30add_to_tree                          " } ,
    {  "sus-WLI  (074)" , "b30add_to_tree                          " } ,
    {  "sus-RLI  (075)" , "Data_RandomTreeAccess::SetToRoot        " } ,
    {  "sus-LLL  (076)" , "Data_RandomTreeAccess::SetToRoot        " } ,
    {  "Vsuspend (077)" , "                                        " } ,
    {  "sus-RLI  (078)" , "b50determine_keyrange_for_server        " } ,
    {  "sus-RLL  (079)" , "b50read_ahead_pnos                      " } ,
    {  "sus-DLT  (080)" , "bd37init_target                         " } ,
    {  "sus-WLT  (081)" , "b09trunc_logfile                        " } ,
    {  "sus-WLT  (082)" , "b09append_logentry                      " } ,
    {  "sus-WLT  (083)" , "b30set_read_only                        " } ,
    {  "sus-RLL  (084)" , "b30treeleafnodes                        " } ,
    {  "sus-RLI  (085)" , "b30treeleafnodes                        " } ,
    {  "sus-RLL  (086)" , "b31next_search                          " } ,
    {  "sus-RLI  (087)" , "b31prev_search                          " } ,
    {  "sus-RLL  (088)" , "b31prev_search                          " } ,
    {  "sus-RLL  (089)" , "b31t_prev_temp_search                   " } ,
    {  "sus-RLL  (090)" , "b36nqual_from_tree                      " } ,
    {  "sus-RLT  (091)" , "b01verify_database                      " } ,
    {  "sus-RLT  (092)" , "b01verify_database                      " } ,
    {  "sus-DLT  (093)" , "b17add_fdir                             " } ,
    {  "sus-DLT  (094)" , "b17del_fdir                             " } ,
    {  "sus-DLT  (095)" , "b17fadd_file_state                      " } ,
    {  "sus-DLT  (096)" , "b17fsub_file_state                      " } ,
    {  "sus-RLT  (097)" , "b17get_fdir                             " } ,
    {  "sus-DLT  (098)" , "b17next_del_fdir                        " } ,
    {  "sus-DLT  (099)" , "b17repl_fdir                            " } ,
    {  "sus-DLT  (100)" , "b17reset_read_only                      " } ,
    {  "sus-DLT  (101)" , "b17reset_read_only                      " } ,
    {  "sus-DLT  (102)" , "b17set_filestate                        " } ,
    {  "sus-RLT  (103)" , "b17state_fdir                           " } ,
    {  "sus-RLT  (104)" , "b17succ_fdir                            " } ,
    {  "sus-RLT  (105)" , "b17tnext_temp_fdir                      " } ,
    {  "sus-DLT  (106)" , "b17unload_fdir                          " } ,
    {  "Vsuspend (107)" , "                                        " } ,
    {  "Vsuspend (108)" , "                                        " } ,
    {  "Vsuspend (109)" , "                                        " } ,
    {  "Vsuspend (110)" , "                                        " } ,
    {  "Vsuspend (111)" , "                                        " } ,
    {  "sus-RLL  (112)" , "b72column_statistic                     " } ,
    {  "Vsuspend (113)" , "                                        " } ,
    {  "Vsuspend (114)" , "                                        " } ,
    {  "Vsuspend (115)" , "                                        " } ,
    {  "Vsuspend (116)" , "                                        " } ,
    {  "Vsuspend (117)" , "                                        " } ,
    {  "Vsuspend (118)" , "                                        " } ,
    {  "sus-RLL  (119)" , "bd72mult_column_stat                    " } ,
    {  "sus-RLL  (120)" , "bd72sample_next                         " } ,
    {  "Vsuspend (121)" , "                                        " } ,
    {  "Vsuspend (122)" , "                                        " } ,
    {  "sus-RLI  (123)" , "b50bfind_branch                         " } ,
    {  "sus-RLI  (124)" , "b50bfind_branch                         " } ,
    {  "sus-RLI  (125)" , "b50cross_subtree                        " } ,
    {  "sus-RLI  (126)" , "b50eval_pagecount                       " } ,
    {  "sus-RLI  (127)" , "b50eval_pagecount                       " } ,
    {  "sus-RLI  (128)" , "b50eval_pagecount                       " } ,
    {  "sus-RLI  (129)" , "b50eval_pagecount                       " } ,
    {  "sus-RLI  (130)" , "b50eval_pagecount                       " } ,
    {  "sus-RLI  (131)" , "b50eval_pagecount                       " } ,
    {  "HistRootExcl  " , "bd13GetNode                             " } ,
    {  "sus-RLI  (133)" , "b50find_leaf                            " } ,
    {  "sus-WLL  (134)" , "b50find_leaf                            " } ,
    {  "sus-RLL  (135)" , "b50find_leaf                            " } ,
    {  "sus-RLI  (136)" , "b50find_leaf                            " } ,
    {  "sus-WLL  (137)" , "b50find_leaf                            " } ,
    {  "sus-RLL  (138)" , "b50find_leaf                            " } ,
    {  "sus-RLI  (139)" , "b50first_leaf                           " } ,
    {  "sus-WLL  (140)" , "b50first_leaf                           " } ,
    {  "sus-RLL  (141)" , "b50first_leaf                           " } ,
    {  "sus-RLI  (142)" , "b50first_leaf                           " } ,
    {  "sus-WLL  (143)" , "b50first_leaf                           " } ,
    {  "sus-RLL  (144)" , "b50first_leaf                           " } ,
    {  "sus-RLI  (145)" , "b50position_leaf                        " } ,
    {  "sus-RLL  (146)" , "b50position_leaf                        " } ,
    {  "sus-RLI  (147)" , "b50position_leaf                        " } ,
    {  "sus-RLL  (148)" , "b50position_leaf                        " } ,
    {  "sus-SLT  (149)" , "b30verify_tree                          " } ,
    {  "sus-RLT  (150)" , "b02add_record                           " } ,
    {  "sus-RLT  (151)" , "b02append_record                        " } ,
    {  "sus-DLT  (152)" , "b02copy_file_content                    " } ,
    {  "sus-RLT  (153)" , "b02del_record                           " } ,
    {  "sus-RLT  (154)" , "b02exist_record                         " } ,
    {  "sus-RLT  (155)" , "b02get_lock_record                      " } ,
    {  "sus-RLT  (156)" , "b02get_record                           " } ,
    {  "sus-DLT  (157)" , "b02init_load                            " } ,
    {  "sus-DLT  (158)" , "b02init_load                            " } ,
    {  "sus-RLT  (159)" , "b02kb_del_rec                           " } ,
    {  "sus-DLT  (160)" , "b30reset_bad_file                       " } ,
    {  "Vsuspend (161)" , "b02kb_ins_rec                           " } ,
    {  "sus-DLT  (162)" , "b30bad_file                             " } ,
    {  "sus-SLT  (163)" , "b30check_tree                           " } ,
    {  "sus-RLT  (164)" , "b02kb_upd_rec                           " } ,
    {  "sus-RLT  (165)" , "bd01CountRecords                        " } ,
    {  "sus-DLT  (166)" , "b02leaves_copy_with_                    " } ,
    {  "sus-DLT  (167)" , "b02leaves_copy_with_                    " } ,
    {  "sus-DLT  (168)" , "b02load_table                           " } ,
    {  "sus-RLT  (169)" , "b02logadd_record                        " } ,
    {  "sus-RLT  (170)" , "b02next_record                          " } ,
    {  "sus-RLT  (171)" , "b02prev_record                          " } ,
    {  "sus-DLT  (172)" , "b02range_delete                         " } ,
    {  "sus-DLT  (173)" , "b02range_delete                         " } ,
    {  "sus-RLT  (174)" , "b02range_exi_rec                        " } ,
    {  "sus-RLT  (175)" , "b02repl_record                          " } ,
    {  "sus-RLT  (176)" , "b02kb_select_rec                        " } ,
    {  "HistRootShare " , "bd13GetNode                             " } ,
    {  "HistNodeExcl  " , "bd13GetNode                             " } ,
    {  "Prep-End (179)" , "b75ilwrite_lock_index                   " } ,
    {  "Prep-End (180)" , "b75tldelete_lock_tree                   " } ,
    {  "Prep-End (181)" , "b75tlwrite_lock_tree                    " } ,
    {  "HistNodeShare " , "bd13GetNode                             " } ,
    {  "UndoRootExcl  " , "bd13GetNode                             " } ,
    {  "UndoRootShare " , "bd13GetNode                             " } ,
    {  "sus-RLL  (185)" , "bd50p_count_primkeys                    " } ,
    {  "sus-RLL  (186)" , "bd50p_count_primkeys                    " } ,
    {  "sus-RLI  (187)" , "bd50count_records                       " } ,
    {  "UndoNodeExcl  " , "bd13GetNode                             " } ,
    {  "sus-RLT  (189)" , "b36nqual_from_tree                      " } ,
    {  "sus-RLL  (190)" , "b72column_statistic                     " } ,
    {  "UndoNodeShare " , "bd13GetNode                             " } ,
    {  "sus-RLL  (192)" , "bd72sample_next                         " } ,
    {  "sus-RLL  (193)" , "b31next_search                          " } ,
    {  "sus-RLL  (194)" , "bd50count_records                       " } ,
    {  "sus-RLT  (195)" , "b50determine_keyrange_for_server        " } ,
    {  "sus-RLL  (196)" , "b50determine_keyrange_for_server        " } ,
    {  "db-full  (197)" , "Conv_HandleDBFull                       " } ,
    {  "Vsuspend (198)" , "                                        " } ,
    {  "sus-RLI  (199)" , "Data_RandomTreeAccess::DetermineLeaf    " } ,
    {  "sus-RLL  (200)" , "Data_RandomTreeAccess::DetermineLeaf    " } ,
    {  "Vsuspend (201)" , "k28force_checkp                         " } ,
    {  "Vsuspend (202)" , "k38e_autosave_end                       " } ,
    {  "Vsuspend (203)" , "kb39read_wait                           " } ,
    {  "Vsuspend (204)" , "kb39write_wait                          " } ,
    {  "sus-RLI  (205)" , "Data_TraverseTreeAccess::GetLeftMostNode" } ,
    {  "sus-RLL  (206)" , "Data_TraverseTreeAccess::GetLeftMostNode" } ,
    {  "Vsuspend (207)" , "kb55logwriter                           " } ,
    {  "sus-RLI  (208)" , "Data_TraverseTreeAccess::ReplaceFirstInd" } ,
    {  "Vsuspend (209)" , "k90receiver_process                     " } ,
    {  "Vsuspend (210)" , "k90sender_process                       " } ,
    {  "Vsuspend (211)" , "k90sreceiver_server                     " } ,
    {  "Vsuspend (212)" , "kb90parent_wait                         " } ,
    {  "Vsuspend (213)" , "k91integrate_prot                       " } ,
    {  "Vsuspend (214)" , "k96client_wait                          " } ,
    {  "sus-RLL  (215)" , "Data_TraverseTreeAccess::ReplaceLeafPage" } ,
    {  "Vsuspend (216)" , "k38st_autosave_start (new tape required)" } ,
    {  "Vsuspend (217)" , "kb51new_trans (all trans entries used)  " } ,
    {  "sus-RLI  (218)" , "Data_TraverseTreeAccess::GetRootNode    " } ,
    {  "sus-RLL  (219)" , "Data_TraverseTreeAccess::GetRootNode    " } ,
    {  "sus-RLL  (220)" , "Data_TraverseTreeAccess::ReplaceLeafPage" } ,
    {  "Vsuspend (221)" , "k562restore_entry_to_data (reserve used)" } ,
    {  "Vsuspend (222)" , "k562cp_log_of_trans (part rollb wait)   " } ,
    {  "Vsuspend (223)" , "k562get_next_redo_trans                 " } ,
    {  "Vsuspend (224)" , "kb39wait_for_redo                       " } ,
    {  "Vsuspend (225)" , "kb57wait_for_stamp_flush                " } ,
    {  "Vsuspend (226)" , "kb39io_remote                           " } ,
    {  "Vsuspend (227)" , "                                        " } ,
    {  "No-Work  (228)" , "bd91ObjGarbageCollector                 " } ,
    {  "Vsuspend (229)" , "bd91StopAllGarbageCollectors            " } ,
    {  "Prep-End (230)" , "bd13GetNode                             " } ,
    {  "NoRedoJob(231)" , "Log_RedoTrafficControl::ExecuteJobs()   " } ,
    {  "SyncRedo (232)" , "Log_RedoTrafficControl::WaitForIoSeq()  " } ,
    {  "LogQ FULL(233)" , "Log_Queue::ReserveSpace              :-(" } ,
    {  "LogIOwait(234)" , "Log_Queue::UserTaskEOTReady             " } ,
    {  "No-Work  (235)" , "Log_Writer                              " } ,
    {  "Vsuspend (236)" , "Conv_FreePageNoWaitDuringSavepoint      " } ,
    {  "Vsuspend (237)" , "Conv_ExpandWaitDuringSavepoint          " } ,
    {  "Vsuspend (238)" , "Conv_WaitForConvPageIOToGetSpecPageNo   " } ,
    {  "ObjRootExcl   " , "bd13GetNode                             " } ,
    {  "DC OvFlow(240)" , "b13pfree: sysbuf_overflow (SVP)      :-(" } ,
    {  "LOG FULL (241)" , "Log_Writer                              " } ,
    {  "InitState(242)" , "Log_Writer                              " } ,
    {  "SVP-wait (243)" , "Log_Savepoint::StartSavepointAndWait    " } ,
    {  "SVP-wait (244)" , "Log_Savepoint::TriggerAndWait (DBM-OP)  " } ,
    {  "SHUTDOWN (245)" , "k51WaitForLastOpenTransaction           " } ,
    {  "LOG FULL (246)" , "Log_Queue::ReserveSpace              :-(" } ,
    {  "Vsuspend (247)" , "Log_Writer::Suspend (wait for suspend)  " } ,
    {  "USR HOLD (248)" , "Log_Writer suspended by user            " } ,
    {  "ObjRootShare  " , "bd13GetNode                             " } ,
    {  "ObjNodeExcl   " , "bd13GetNode                             " } ,
    {  "ObjNodeShare  " , "bd13GetNode                             " } ,
    {  "InvRootExcl   " , "bd13GetNode                             " } ,
    {  "InvRootShare  " , "bd13GetNode                             " } ,
    {  "InvNodeExcl   " , "bd13GetNode                             " } ,
    {  "InvNodeShare  " , "bd13GetNode                             " }
  } ;
 

#endif  /* HEO00X_H */
