/* @lastChanged: "1998-05-19  16:25"
 * @filename:    heo02.h
 * @filename:   heo02.h
 * @purpose:    "Interface for RTE functions, used by c++ modules"
 * @release:    7.1.0.0
 * @see:        "http://www.bea.sap-ag.de/doku/rel-7.1/eo/heo02.html"
 *
 * @copyright:  "Copyright by   SAP AG, 1997"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */


#ifndef HEO02
#define HEO02


/******************************************
 *            I N C L U D E S             *
 ******************************************/

#if !defined(__cplusplus)
#ERROR This header file is used by C++ modules only. Use heo102.h instead
#endif

#include "gsp00.h"
#include "vsp004.h"
#include "geo572.h" /* sqlfree(), sqlallocat() */

/******************************************
 *        D E K L A R A T I O N S         * 
 ******************************************/

externC void sqlfinish (
	char					terminate);



externC void sqlabort ();

 
 
/*------------------------------*/ 
 
/* deleted by Bernd Vorsprach - prototype now in geo572.h
externC void sqlallocat (
	tsp_int4				length,
	tsp_objaddr*			p,
	tsp00_Bool*  		    ok); */

 
/*------------------------------*/ 
 

/* deleted by Bernd Vorsprach - prototype now in geo572.h
externC void sqlfree (
	tsp_bufaddr				p); */

 
/*------------------------------*/ 
 

externC void sqlargl (
	tsp_line&				args);				/* tsp00_Array<char, mxsp_c132> */

 
/*------------------------------*/ 
 

externC void sqlarg3 (
	tsp4_xuser_record*		user_params,
	tsp_pw&					password,			/* tsp00_Array<char, mxsp_c18> */
	tsp4_args_options*		options,
	tsp4_xuserset&			xusertype,			/* tsp00_Set<tsp4_xuser_Enum, ...> */
	tsp_errtext&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlcharsetname (
	tsp_knl_identifier&		charsetname);		/* tsp00_Array<char, mxsp_c64> */

 
/*------------------------------*/ 
 

externC void sqlclearuser ();

 
/*------------------------------*/ 
 

externC void sqlclock (
	tsp_int4*				sec,
	tsp_int4*				microsec);

 
/*------------------------------*/ 
 

externC void sqlconcat (
	tsp_vfilename&			first_part,			/* tsp00_Array<char, mxsp_c64> */
	tsp_vfilename&			second_part,		/* tsp00_Array<char, mxsp_c64> */
	tsp_vfilename&			resconcat,			/* tsp00_Array<char, mxsp_c64> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqldattime (
	tsp_date&				d,					/* tsp00_Array<char, mxsp_c8> */
	tsp_time&				t);					/* tsp00_Array<char, mxsp_c8> */

 
/*------------------------------*/ 
 

externC void SqlDevSize (
	const char             *dev_name,			/* tsp00_Array<char, mxsp_c64> */
	tsp00_Int4*				devcapacity,
	tsp00_ErrTextc&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlexec (
	tsp_execline&			command,			/* tsp00_Array<char, mxsp_c512> */
	tsp00_ExecMode_Enum		mode,				
	tsp_exec_return*		error,				/* tsp00_Enum<tsp_exec_return_Enum, ...> */
	tsp_errtext&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp_int2*				commandresult);

 
/*------------------------------*/ 
 

externC void sqlgetpid (
	tsp_int4*				pid);

 
/*------------------------------*/ 
 

externC void sqlgetuser (
	tsp4_xuser_record*		user_params,
	tsp_errtext&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlindexuser (
	tsp_int2				user_index,
	tsp4_xuser_record*		user_params,
	tsp_errtext&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlinit (
	tsp_compname&			component,			/* tsp00_Array<char, mxsp_c64> */
	tsp00_Bool*             ok);

 
/*------------------------------*/ 
 

externC void sqlos (
	tsp_os*					os);				/* tsp00_Enum<tsp_os_Enum, ...> */

 
/*------------------------------*/ 
 

externC void sqlpoff (
	char					print,
	tsp_errtext&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlpon (
	tsp_prtname&			printer,			/* tsp00_Array<char, mxsp_c64> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlprint (
	tsp_prtline&			line,				/* tsp00_Array<char, mxsp_c256> */
	tsp_int2				length,
	tsp00_VpLinefeeds_Enum	lfeeds,
	tsp_errtext&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlputuser (
	tsp4_xuser_record*		user_params,
	tsp_errtext&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlread (
	tsp_line&				text,				/* tsp00_Array<char, mxsp_c132> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 
/* deleted by Bernd Vorsprach - prototype now in geo572.h
externC void sqlreallocat (
	tsp_int4				length,
	tsp_objaddr*			p,
	tsp00_Bool*				ok); */

 
/*------------------------------*/ 
 

externC void sqlresult (
	tsp_int1				result);

 
/*------------------------------*/ 
 

externC void sqlsleep (
	tsp_int2				duration);

 
/*------------------------------*/ 
 

externC void sqltermid (
	tsp_termid&				terminalid);		/* tsp00_Array<char, mxsp_c18> */			

 
/*------------------------------*/ 
 

externC void sqltermvar (
	tsp_c18&				term_type);			/* tsp00_Array<char, mxsp_c18> */

 
/*------------------------------*/ 
 

externC void sqlthold (
	tsp_int4				term_ref,
	char					manual_input);

 
/*------------------------------*/ 
 

externC void sqltio (
	tsp_int4				term_ref,
	tsp_screenbufaddr*		screen_buf,
	tsp_screenbufaddr*		attribute_buf,
	char					refresh,
	tsp_int2*				cursorline,
	tsp_int2*				cursorcolumn,
	tsp_hif_parms*			hif,
	tsp_vt_options*			options,
	tsp_vt_result*			result,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqltoff (
	tsp_int4				term_ref,
	tsp_screenbufaddr*		screen_buf,
	tsp_screenbufaddr*		attribute_buf,
	tsp_vtmsg&				msg);				/* tsp00_Array<char, mxsp_c80> */

 
/*------------------------------*/ 
 

externC void sqlton (
	char					multi_task,
	tsp_int4*				term_ref,
	tsp_terminal_description*	desc,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqltrelease (
	tsp_int4				term_ref);

 
/*------------------------------*/ 
 

externC void sqlttable (
	tsp_int2				i,
	tsp_vt_attrib&			attrib,				/* tsp00_Set<tsp_vt_mode_Enum, ...> */
	tsp_vt_color&			foreground,			/* tsp00_Set<tsp_vt_color_Enum, ...> */
	tsp_vt_color&			background);		/* tsp00_Set<tsp_vt_color_Enum, ...> */

 
/*------------------------------*/ 
 

externC void sqlversion (
	tsp_c40&				rte_version);		/* tsp00_Array<char, mxsp_c40> */

 
/*------------------------------*/ 
 

externC void sqluid (
	tsp_process_id*			uid);

 
/*------------------------------*/ 
 

externC void sqlwdgclear (
	tsp_int2				box_id);

 
/*------------------------------*/ 
 

externC void sqlwdgget (
	tsp_int2				box_id,
	tsp_int2				item_id,
	tsp_c256&				text,				/* tsp00_Array<char, mxsp_c256> */
	tsp_int2*				text_len,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlwdgset (
	tsp_int2				box_id,
	tsp_int2				item_id,
	tsp_c256&				text,				/* tsp00_Array<char, mxsp_c256> */
	tsp_int2				text_len,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlwdgswitch (
	tsp_int2				box_id,
	tsp_vt_keys&			trigger,			/* tsp00_Set<tsp_vt_key_Enum, ...> */
	tsp00_VtKey_Enum		return_key,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlwindow (
	tsp_int4				parent_ref,
	tsp_rectangle*			position,
	tsp_terminal_description*	desc,
	tsp_int4*				term_ref,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlwoff (
	tsp_int4				term_ref,
	tsp_screenbufaddr*		screen_buf,
	tsp_screenbufaddr*		attribute_buf);

 
/*------------------------------*/ 
 

externC void sqlwrite (
	tsp_line&				text);				/* tsp00_Array<char, mxsp_c132> */

 
/*------------------------------*/ 
 

externC void sqlwscbar (
	tsp_int4				term_ref,
	tsp_int2				screen_nr,
	tsp00_VtScroll_Enum		t,
	tsp_int2				range_beg,
	tsp_int2				range_end,
	tsp_int2				pos,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlwscroll (
	tsp_int4				term_ref,
	tsp_rectangle*			rect,
	tsp_int2				displ_x,
	tsp_int2				displ_y,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlwsplit (
	tsp_int4				term_ref,
	tsp_int2				nr_screens,
	tsp_terminal_description*	desc,
	tsp_int2*				offset,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlwtitle (
	tsp_int4				term_ref,
	tsp_int2				screen_nr,
	tsp_c256&				text,				/* tsp00_Array<char, mxsp_c256> */
	tsp_int2				text_len,
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlxucloseuser (
	tsp_errtext&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp00_Bool*				ok);

 
/*------------------------------*/ 
 

externC void sqlxuopenuser (
	tsp_errtext&			errtext,			/* tsp00_Array<char, mxsp_c40> */
	tsp00_Bool*				ok);


/*------------------------------*/ 

externC void sqlget_config_path (  
   tsp_c256&       configpath  ); /* tsp00_Array<char, mxsp_c256> */

/*------------------------------*/ 

externC void sqlget_wrk_path (  
   tsp_c256&       wrkpath  );    /* tsp00_Array<char, mxsp_c256> */

#endif /*HEO02*/	
