/****************************************************************************

  module      : heo50.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: Mathematical function
  description : Mathematical function wrapper, used to prevent from exceptions

  last changed: 1999-01-26  9:39
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef HEO50_H
#define HEO50_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

#if defined(__cplusplus)
extern "C" {
#endif

    tsp00_Longreal vasin ( tsp00_Longreal  value, 
					   tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vsin ( tsp00_Longreal  value, 
							 tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vsinh ( tsp00_Longreal  value, 
        tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vacos ( tsp00_Longreal  value, 
        tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vcos ( tsp00_Longreal  value, 
							 tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vcosh ( tsp00_Longreal  value, 
        tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vatan ( tsp00_Longreal  value, 
        tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vatan2 ( tsp00_Longreal  y, 
        tsp00_Longreal  x, 
        tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vtan ( tsp00_Longreal  value, 
							 tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vtanh ( tsp00_Longreal  value, 
        tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vexp ( tsp00_Longreal  value, 
							 tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vlog10 ( tsp00_Longreal  value, 
        tsp00_NumError VAR_VALUE_REF error );
    
    tsp00_Longreal vln ( tsp00_Longreal  value, 
        tsp00_NumError VAR_VALUE_REF error );
    
#if defined(__cplusplus)
}
#endif

#endif  /* HEO50_H */
