/* @lastChanged: "1998-02-27 10:15"

  * @filename:   heo55k.h
  * @purpose:    "mutual exclusive"
  * @release:    7.1.0.0
  * @see:        "-.-"
  *
  * @copyright:  "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*/

#ifndef HEO55K_H
#define HEO55K_H

#include "gsp00.h"

/* --- VOS55KC / VEN55C ------------------------------------------------------ */

#if defined(__cplusplus)
extern "C" {
#endif

void                   vsemaphid         ( tsp00_Region    semaname,
										   tsp00_RegionId *sid );

tsp00_Bool             visexcl           ( tsp00_TaskId    pid,
										   tsp00_RegionId  sid );

/*
 * The following two lines replace the prototype definition
 * void       vbegexcl          ( tsp00_TaskId    pid,
 *												  tsp00_RegionId  sid );
 */

/************/
#ifdef WIN32
/************/

void                   vbegexcl          ( tsp00_TaskId    pid,
					 					   tsp00_RegionId  sid );

/************/
#else
/************/

#define vbegexcl (*vbegexcl_func_ptr)
extern void (*vbegexcl_func_ptr) ( tsp00_TaskId pid, tsp00_RegionId sid );

/************/
#endif
/************/

void                   vendexcl          ( tsp00_TaskId    pid,
					 					   tsp00_RegionId  sid );

#if defined(__cplusplus)
}
#endif

#endif
