/*!***************************************************************************

  module      : heo60_1.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: Wrapper for sprintf
  description : Wrapper for ANSI C 'sprintf' function

  last changed: 1999-09-17  18:39

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef HEO60_1_H
#define HEO60_1_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

/*!
  Function:     vksprintf
  description:  Wrapper for ANSI C function 'sprintf'

    In multi threaded environment direct use of 'sprintf' is forbidden. This wrapper
    is used instead. The ANSI specification of 'sprintf' should be used.
    NOTE: Message buffer MUST contain enough space or system may get corrupted.
          There is no way to check size of buffer...

  arguments:
    pszBuffer [out] pointer to the message buffer
    pszFormat [in] pointer to the message format string
    ... [in] variable number of arguments depending on format

  return value: none
 */
externC void 
vksprintf(       tsp00_Char * pszBuffer,
		   const tsp00_Char * pszFormat,
		                      ...);
/* implementation found in vos60c and ven60c */

#endif  /* HEO60_1_H */
