/****************************************************************************

  module      : heo79.h

  -------------------------------------------------------------------------

  responsible : FrankH

  special area: LZU / Kernel
  description : kernel xparam access routines


  last changed: 2001-01-04  13:58
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef HEO79_H
#define HEO79_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "heo11.h"

#include "heo79_1.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

/* --- VEO79.C ------------------------------------------------------------- */


externC void    vxparam_open            (   XP_PHFILE           plXParamFd,
                                            tsp_errtext         errtext,
                                            tsp_xp_return_code *pucXParamReturnCode );

externC void    vxparam_close           (   XP_HFILE            lXParamFd,
                                            tsp_errtext         errtext,
                                            tsp_xp_return_code *pucXParamReturnCode );

externC void    vxparam_open_binary      ( tsp00_DbName       ServerDB,
                                           BOOLEAN            ReadOnly,
                                           XP_PHFILE          xp_fd ,
                                           tsp00_ErrText      errtext ,
                                           tsp_xp_return_code *xp_ret ) ;

externC void    vxparam_read_binary      ( XP_HFILE            xp_fd ,
                                           char               *buf ,
                                           tsp_int4            bytes_to_read ,
                                           tsp_int4           *bytes_read ,
                                           tsp_errtext         errtext ,
                                           tsp_xp_return_code *xp_ret );

externC void    vxparam_write_binary     ( XP_HFILE            xp_fd ,
                                           char               *buf ,
                                           tsp_int4            bytes_to_write ,
                                           tsp_int4           *bytes_written ,
                                           tsp_errtext         errtext ,
                                           tsp_xp_return_code *xp_ret );

externC void    vxparam_get_filesize    ( tsp_int4           *xp_fsize ,
                                          tsp_errtext         errtext ,
                                          tsp_xp_return_code *xp_ret );

#endif  /* HEO79_H */
