/****************************************************************************

  module      : heo79_1.h

  -------------------------------------------------------------------------

  responsible : FrankH

  special area: LZU / Kernel
  description : kernel xparam access routines


  last changed: 2001-01-04  13:58
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef HEO79_1_H
#define HEO79_1_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

/* --- VEO79.C ------------------------------------------------------------- */


externC void    vxparam_save_good_config (
    tsp00_Bool                          is_restart,
    tsp00_ErrText      VAR_ARRAY_REF    errtext,
    tsp00_XpReturnCode VAR_VALUE_REF    pucXParamReturnCode ) ;

externC tsp00_Bool  vxparam_delete_sysdev (
    tsp00_ErrText      VAR_ARRAY_REF     errtext );


#endif  /* HEO79_1_H */
