/*@lastChanged: "1999-04-21  15:03"
* @filename:    veo38.cpp
* @purpose:     "COM_Interface" 
* @release:     7.2.0.0
* @see:         ""
*
* @copyright:   "Copyright by SAP AG, 1999"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*/

/*===========================================================================*
*  INCLUDES                                                                 *
*===========================================================================*/
#if defined(NMP)
#define RWSTD_NO_NAMESPACE  1
#include <sys/user.h>
#endif

#include "SAPDBCommon/MemoryManagement/SAPDBMem_NewDestroy.hpp"
#include "gsp00.h"
#include "ggg00.h"
#include "ggg92.h"
#include "heo01.h"
#include "heo52.h"
#include "heo58.h" //vGetAcvPtrFromCurrentTask
#include "heo15.h"
#include "hgg01_3.h" // g01unicode PTS 1127607 FF 2004-FEB-10
#include "RunTime/System/RTESys_IO.h"
#if defined (_WIN32)

#define DCOM_EXCLUSIVE  &kgs.DCOM_MEM.lExclusive
#define DCOM_HEAD       kgs.DCOM_MEM.lphead
#define DCOM_FREE       kgs.DCOM_MEM.lpfree
#include "heo00.h" /* nocheck */
#include "gos00.h" /* nocheck */
/* gos00.h defines try as '__try' and catch as '__except' */ 
#undef try
#undef catch 
#include "gos00k.h"           /* nocheck */
#include "ilivecachesink.h"   /* no check */
#include "hos38.h"            /* nocheck */
#else

#define DCOM_EXCLUSIVE  kgs->DCOM_MEM.lExclusive
#define DCOM_HEAD       kgs->DCOM_MEM.lphead
#define DCOM_FREE       kgs->DCOM_MEM.lpfree
#include "heo00.h" /* nocheck */
#include "gco00.h" /* nocheck */
#include "ilivecachesink.h"  /* no check */
#include "vsp002c.h" /* nocheck */
#include "heo46.h" /* nocheck */
#include "geo60.h" /* nocheck */
#include "heo60.h" /* nocheck */
#include "gen50.h" /* nocheck */
#include "hen38.h" /* nocheck */
#endif

#include "geo007_1.h" 


#include "hgg08.h"   // semaphore definition
#include "heo51.h"   // vgetpid
#include "heo55k.h"  // vbegexcl, vendexcl
#include "heo56.h"   // vsleep
#include "geo60.h" 

#include "geo00d.h"
#include "geo39.h"
#include "hak07.h"
#include "hak34.h"
#include "hak341.h"
#include "geo38.h"
#include "heo38.h"
#include "heo922.h"  // vGetRteInfoTaskDetails
#include "hsp77.h"
#include "Oms/OMS_Types.hpp"
#include "SAPDBCommon/MemoryManagement/SAPDBMem_RawAllocator.hpp"


#include "geo36.h"
#include "heo02x.h"
#define  KERNEL        1        /* PTS 1115295 FF 2002-04-19 FF */
#include "hco31-k.h"
#include "ggg251.h"

#include "geo50_0.h"   /* PTS 1106969 */
#include "hgg01.h"     /* PTS 1110818 */

#undef _CDECL       // PTS 1112369
#include "geo573.h" // PTS 1112369
#include "gco103.h"

// we need a copy here, since normally it's declared only in liboms
#include "Oms/OMS_CallbackInterface.hpp"
#include "liveCache/MemoryManagement/LVCMem_Allocator.hpp"
#include "liveCache/MemoryManagement/LVCMem_CheckedUserAllocator.hpp"

externC void vabort(tsp00_Bool dumpCore);

/*===========================================================================*
*  DEFINES                                                                  *
*===========================================================================*/

#ifdef NO_INLINES
# define _INLINE
#else
# define _INLINE  inline
#endif

#if defined (BIT64)
#define   MIN_PARAMETER_SIZE  8
#else
#define   MIN_PARAMETER_SIZE  4
#endif

#if defined (_WIN32)
#define   TRY                               __try 
#define   CATCH_ALL                         __except (EXCEPTION_EXECUTE_HANDLER, eo38_Dump_Exception(GetExceptionInformation())) 
#else    
#define   TRY                               try
#define   CATCH_ALL                         catch (DbpError)   
#endif

//#define   DEBUG_FACTORY                   -1
#define   DEBUG_INTERFACE_LOCAL             -2
#define   DEBUG_INTERFACE_REMOTE            -3
#define   DEBUG_SESSION_ID                   1

#define   RC_DISPADDR_FAILED                -1;
#define   RC_DISPADDR_INVALIDATE_FAILED     -2;
#define   RC_DISPADDR_OK                     0;
#define   RC_DISPADDR_FACTORY_FOUND          1;
#define   RC_DISPADDR_INVALID_FOUND          2;
#define   RC_DISPADDR_INUSE                  3;

#define   C_SYS_DISPID                       5;

/* +++  PTS 1106969  x_cons information extended                        */
#define ENTER_SINK_METHOD(_idx)  this->CallbackIsActive = true;\
  if ( this->lpTaskContext != NULL ) { \
    TASK_STATE(REINTERPRET_CAST(TASK_CTRL,this->lpTaskContext)) = TSK_RUNNING;\
    REINTERPRET_CAST(TASK_CTRL,this->lpTaskContext)->TaskOMSStat.CallbackCount++;\
    REINTERPRET_CAST(TASK_CTRL,this->lpTaskContext)->TaskOMSStat.OMSCallActive = 1;\
    REINTERPRET_CAST(TASK_CTRL,this->lpTaskContext)->TaskOMSStat.MethodIdx = _idx;\
  }

#define LEAVE_SINK_METHOD(_rc)  this->CallbackIsActive = false;\
  if ( this->lpTaskContext != NULL ) {\
    TASK_STATE(REINTERPRET_CAST(TASK_CTRL,lpTaskContext)) = TSK_DCOM_OBJ_CALLED;\
    REINTERPRET_CAST(TASK_CTRL,this->lpTaskContext)->TaskOMSStat.OMSCallActive = 0;\
  };\
  return _rc
/* ---  PTS 1106969  x_cons information extended                        */

/* +++ new CWaitUntilAlone PTS 1109279 +++                              */
class CWaitUntilAlone {
public:
  CWaitUntilAlone() {
    WAIT_UNTIL_ALONE (DCOM_EXCLUSIVE);
    inRegion = 1;
  };
  
  ~CWaitUntilAlone() {
    if ( inRegion )
      CLEARLOCK (DCOM_EXCLUSIVE);
    inRegion = 0;
  };

  void Enter() {
    if ( !inRegion ) 
      WAIT_UNTIL_ALONE (DCOM_EXCLUSIVE);
    inRegion = 1;
  };

  void Leave() {
    if ( inRegion ) 
      CLEARLOCK (DCOM_EXCLUSIVE);
    inRegion = 0;
  };
  int       inRegion;
};
/* --- new CWaitUntilAlone PTS 1109279 ---                              */

/*===========================================================================*
*  MACROS                                                                   *
*===========================================================================*/

/*===========================================================================*
*  LOCAL CLASSES, STRUCTURES, TYPES, UNIONS ...                             *
*===========================================================================*/

#if defined(_IBMR2)

#if defined(BIT64)
/* 
 *  with xlC Compiler on AIX an interface pointer points to the following      
 *  structure:
 *
 *
 *
 *  Interface - pointer  
 *   
 *  | 
 *  |
 *  v
 *   ----------   0  -----------      
 *  |virt.Meth.|--->! Method 1  !    Method 1 is a 'normal' Function- 
 *   ----------   8  -----------     pointer ( see AIX 32 BIT )
 *                  ! Method 2  !    
 *               16  -----------                       
 *                  !     .     !                    
 *                        .                             
 *                  !     .     !                        
 *              n*8  -----------
 *                  ! Method n  !    
 *                   -----------     
 *                  !  0xdead   !    
 *                   -----------     
 *                  !  0xdead   !     
 *                   -----------     
 *                                          
 *                                   
 *                                           
 */
typedef long *t_lpptr;
#else  /* AIX 32 BIT */
/* 
 *  with xlC Compiler on AIX an interface pointer points to the following      
 *  structure:
 *
 *
 *
 *  Interface - pointer  
 *   
 *  | 
 *  |
 *  v
 *   ----------   0  -----------     each Method-Pointer is made up of 
 *  |virt.Meth.|--->!     0     !    2 words:
 *   ----------      -----------        
 *                  !     0     !      1-word: address (Method-Desc)
 *                8  -----------       2-word: pInterface + 2-word = 
 *                  ! Method 1  !              this-pointer of C++ Class
 *                   -         -               of the member function
 *                  ! pointer   !              
 *               16  -----------
 *                  ! Method 2  !    Method-Desc-i -> 0  -----------
 *                   -         -                        ! method i  !
 *                  ! pointer   !                     4  -----------
 *               24  -----------                        !   TOC     ! r2
 *                  !     .     !                     8  -----------
 *                        .                             !environment! r11
 *                  !     .     !                        ----------
 *              n*8  -----------
 *                  ! Method n  !    the Method-Desc-i has the 'normal'
 *                   -         -     structure for a function pointer
 *                  ! pointer   !    parameter
 *                   -----------     1. word: address of the entry point of
 *                  !  0xdead   !             the procedure
 *                   -         -     2. word: address of TOC of module in which 
 *                  !  0xbeaf   !             the procedure is bound
 *                   -----------     3. word: environment-pointer for languages 
 *                                            as Pascal. If used by C++ ????
*/
typedef struct t_tabentry
{
  void*     addr;
  long      this_displ;
} t_tabentry;
typedef t_tabentry *t_lpptr;
#endif /* AIX 32 BIT */

#elif defined(NMP)  /* Reliant Unix  -  32 & 64 Bit */

/* 
 *  with CC Compiler on NMP an interface pointer points to the following      
 *  structure:
 *
 *
 *
 *  Interface - pointer  
 *   
 *  | 
 *  |
 *  v
 *   ----------   0  -----------     each Method-Entry made up of 
 *  |virt.Meth.|--->!   RTTI    !    2 short fields +
 *   ----------      --       --     1 pointer (4 Byte aligned 32 Bit/
 *                  !   Entry   !               8 Byte aligned 64 Bit )
 *                i  -----------       1.st short: is the delta value added 
 *                  ! Method 1  !                  to the this pointer  
 *                   -         -       2.nd short: isn't used (cfront compatability)
 *                  !  Entry    !      3 pointer:  point to the virtual function
 *               2*i -----------
 *                  ! Method 2  !                                            
 *                   -         -                                       
 *                  !  Entry    !                                    
 *               3*i -----------                                          
 *                  !     .     !    i = sizeof(short)*2 + alignment + sizeof(pointer);
 *                        .                                               
 *                  !     .     !        32 Bit ==> alignment = 0; 
 *              n*i  -----------         64 Bit ==> alignment = 4;
 *                  ! Method n  !                                      
 *                   -         -                                      
 *                  !  Entry    !               
 *                   -----------                                            
 *                                                         
 *                                                                              
*/
typedef struct t_tabentry
{
  short     this_displ;
  short     not_used;
#if defined(BIT64)
  int       filler;
#endif
  void*     addr;
} t_tabentry;

typedef t_tabentry *t_lpptr;

//#end Reliant Unix NMP */
#elif defined(SUN)
#if (__SUNPRO_CC < 0x0500)     /* PTS 1105381 */
/* 
 *
 *  the SUN C++ Compiler interface pointer points to the following      
 *  structure:
 *
 *  pInterface -> 0  ----------        0  -----------  each Method-Pointer is  
 *                  |virt.Meth.|-------->!     0     !   made up of 2 words:
 *                   ----------           -----------        
 *                  |          |         !     0     ! 1-word:  
 *                                      8  -----------  1. half-word: pInterface +       
 *                                       ! Method 1  !     half-word = this-pointer 
 *                                        -         -                  of Class
 *                                       ! pointer   !  2. half-word: not used      
 *                                    16  -----------       
 *                                       ! Method 2  ! 2-word: address of method
 *                                        -         -         
 *                                       ! pointer   !        
 *                                    24  -----------         
 *                                       !     .     !        
 *                        .              
 *                                       !     .     !        
 *                                   n*8  -----------
 *                                       ! Method n  !    
 *                                        -         -     
 *                                       ! pointer   !    
 *                                        -----------
*/
typedef struct t_tabentry
{
  short     this_displ;
  short     filler;
  void*     addr;
} t_tabentry;

typedef t_tabentry *t_lpptr;
#else
/* 
 *
 *  pInterface -> 0  -----------        0  ------------
 *                  ! virt.Meth ! ------->|      0     |
 *                   -----------           ------------
 *                  !     :     !         |      0     |
 *                                      8  ------------
 *                                        | Method 1   |
 *                                     16  ------------
 *                                        | Method 2   |
 *                                         ------------
 *                                        |      :     |
 *                                               :
 *                                        |      :     |
 *                                         ------------
 *                                (n+1)*4 | Method n   |
 *                                         ------------
 *                                        
*/
typedef long *t_lpptr;
#endif
#elif defined(PA11) || defined(PA20W)
/* 
 *  the HP 32Bit aCC Compiler interface pointer points to the following      
 *  structure:
 *
 *  pInterface -> 0  -----------        0  ------------
 *                  ! virt.Meth ! ------->|      0     |
 *                   -----------           ------------
 *                  !     :     !         |      0     |
 *                                         ------------
 *                                        |      x     |
 *                                         ------------
 *                                        |      0     |
 *                                      16 ------------
 *                                        | Method 1   |
 *                                         ------------
 *                                        | Method 2   |
 *                                         ------------
 *                                        |      :     |
 *                                               :
 *                                        |      :     |
 *                                         ------------
 *                                        | Method n   |
 *                                         ------------
 *                                        
*/
typedef long *t_lpptr;
#elif defined(ALPHA)
/* 
 *  the ALPHA 64Bit cxx Compiler interface pointer points to the following      
 *  structure:
 *
 *  pInterface -> 0  -----------        0  ------------
 *                  ! virt.Meth ! ------->| Method 1   |
 *                   -----------           ------------
 *                  !     :     !       8 | Method 2   |
 *                                         ------------
 *                                        |      :     |
 *                                               :
 *                                        |      :     |
 *                                         ------------
 *                               (n-1)*8  | Method n   |
 *                                         ------------
 *                                        
 * on the ALPHA machine the C++ type 'long' and pointers are 64-bit long.
*/
typedef long *t_lpptr;
#elif defined(LINUX)
/* 
 *  gcc 2.95/2.96 Compiler interface pointer points to the following      
 *  structure:
 *
 *  pInterface -> 0  -----------        0  ------------
 *                  ! virt.Meth ! ------->|      0     |
 *                   -----------           ------------
 *                  !     :     !       4 | Type-Info  |
 *                                         ------------
 *                                      8 | Method 1   |
 *                                         ------------
 *                                        |      :     |
 *                                               :
 *                                        |      :     |
 *                                         ------------
 *                           8 + (n-1)*4  | Method n   |
 *                                         ------------
 *
 *
 *  gcc 3.2 for i386 interface pointer points to the following      
 *  structure:
 *
 *  pInterface -> 0  -----------        0  ------------
 *                  ! virt.Meth ! ------->| Method 1   |
 *                   -----------           ------------
 *                  !     :     !       4 | Method 2   |
 *                                         ------------
 *                                      8 | Method 3   |
 *                                         ------------
 *                                        |      :     |
 *                                               :
 *                                        |      :     |
 *                                         ------------
 *                              (n-1) * 4 | Method n   |
 *                                         ------------
 *
 *
 *  gcc 3.1 on ia64 uses new c++ abi (without runtime type info):
 *
 *  pInterface -> 0  -----------        0  -----------------------
 *                  ! virt.Meth ! ------->| gp0        | Method 0 |
 *                   -----------          |------------|          |
 *                  !     :     !       8 | offset0    |          |
 *                                         ------------+----------|
 *                                     16 | gp1        | Method 1 |
 *                                         ------------|          |
 *                                     24 | offset1    |          |
 *                                         ------------+----------|
 *                                        |      :     |    :     |
 *                                               :       
 *                                        |      :     |    :     |
 *                                         ------------+----------|
 *                             16*(n-1)+0 | gp n       | Method n |
 *                                         ------------|          |
 *                             16*(n-1)+8 | offset n   |          |
 *                                         ------------+----------
 */
typedef long *t_lpptr;
#elif defined(_WIN32)

#if defined(_WIN64)
/* 
 *  MS VC++ Compiler interface pointer points to the following      
 *  structure:
 *
 *  pInterface -> 0  -----------        0  ------------
 *                  ! virt.Meth ! ------->| Method 1   |
 *                   -----------           ------------
 *                  !     :     !       8 | Method 2   |
 *                                         ------------
 *                                        |      :     |
 *                                               :
 *                                        |      :     |
 *                                         ------------
 *                               (n-1)*8  | Method n   |
 *                                         ------------
*/
typedef tsp00_Longint *t_lpptr;
#else
/* 
 *  MS VC++ Compiler interface pointer points to the following      
 *  structure:
 *
 *  pInterface -> 0  -----------        0  ------------
 *                  ! virt.Meth ! ------->| Method 1   |
 *                   -----------           ------------
 *                  !     :     !       4 | Method 2   |
 *                                         ------------
 *                                        |      :     |
 *                                               :
 *                                        |      :     |
 *                                         ------------
 *                               (n-1)*4  | Method n   |
 *                                         ------------
*/
typedef long *t_lpptr;
#endif

#else
typedef long *t_lpptr;
#endif

typedef struct
{
  union
  {
    char i1;
    short i2;
    long i4;
    int intVal;
    FLOAT flt;
    FLOAT dbl;              
    PVOID ptr;
  } t;
} t_Parm;

typedef struct
{
  t_Parm p[256];
} t_Parms;

typedef HRESULT (__stdcall * t_lpIFunc) (LPVOID lpIID, const t_Parms p);

class CDefaultAllocator_eo38 {
public :
  void*  allocate(size_t sz) { 
    void* p = malloc(sz);
    if ( !p ) throw DbpError(DbpError::RTE_ERROR, e_new_failed);
    return p; 
  };
  
  void   deallocate(void* p) { 
    free(p); 
  };
};

class CLoadedLibDirEntry_eo38
{
private:
  HANDLE m_hd;
  short  m_usedCount;
  char*  m_namePtr;
  bool   m_global;
public:
  CLoadedLibDirEntry_eo38(HANDLE hd, const char* p, bool g) : m_hd(hd), m_usedCount(1), m_global(g) {
    m_namePtr = (char *)malloc(strlen(p)+1);
    if ( !m_namePtr ) throw DbpError(DbpError::RTE_ERROR, e_new_failed);
    strcpy(m_namePtr,p);
  };

  ~CLoadedLibDirEntry_eo38() {
    free(m_namePtr);
  }

  void  incrementUsedCount() { 
    m_usedCount++; 
  };
  short  decrementUsedCount() {
    if (m_usedCount > 0) {
      m_usedCount--;
    }
    return m_usedCount; 
  };

  const char * const getNamePtr() const {
    return m_namePtr;
  };

  HANDLE getHandle() const {
    return m_hd;
  };

  bool getGlobalFlg() const {
    return m_global;
  };

  void* operator new( size_t sz )                  /* PTS 1110403 */
  {                                                /* PTS 1110403 */
    return malloc( sz );                           /* PTS 1110403 */
  };                                               /* PTS 1110403 */
  
  void operator delete(void* p)                    /* PTS 1110403 */
  {                                                /* PTS 1110403 */
    free( p );                                     /* PTS 1110403 */
  };                                               /* PTS 1110403 */

};

class CIliveCacheSink::AllocPool {
public:
  AllocPool(SAPDBMem_RawAllocator *a, AllocPool *n) : m_allocator(a), m_next(n) {}

  SAPDBMem_RawAllocator *m_allocator;
  AllocPool             *m_next;
};

/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
*===========================================================================*/

/*===========================================================================*
*  GLOBAL VARIABLES                                                         *
*===========================================================================*/

static tsp00_Int4                                                    DummyBadAllocCountDown = -1;
static CDefaultAllocator_eo38                                        DefaultAllocator;
static cgg251DCList<CLoadedLibDirEntry_eo38*,CDefaultAllocator_eo38> LoadedLibDir(&DefaultAllocator);

RTESync_Spinlock            CIliveCacheSink::m_allocatorPoolLock;
CIliveCacheSink::AllocPool  *CIliveCacheSink::m_allocatorPool = NULL;
CIliveCacheSink::AllocPool  *CIliveCacheSink::m_allocatorPoolFreelist = NULL;

/*===========================================================================*
*  LOCAL VARIABLES                                                          *
*===========================================================================*/



/*===========================================================================*
*  LOCAL FUNCTIONS (PROTOTYPES)                                             *
*===========================================================================*/

static HRESULT eo38_ComCache (GUID * lpGuid, 
                              void *lpInterface, 
                              tsp00_Uint4 session,
                              bool  remoteDbgFlag,
                              teo38_HashEntryType hType);
static BOOLEAN eo38_Initialize (void);
static void eo38_Invalidate(tsp_dcom_co_create_instance_parms *lpParms,
                            GUID *lpGuid, 
                            tsp00_Uint4 session);
static void eo38_ReleaseInstance ( CHashEntryPtr    currEntry, tsp00_Addr SessionContext );
static HRESULT eo38_UnadviseInstance ( CHashEntryPtr    currEntry );
static void eo38DisposeInstances( tsp_dcom_dispatch_parms * parms );

static tsp00_Uint4 eo38ThreadIndex( TASK_CTRL p ); /* PTS 1112617 */

/*===========================================================================*
*  GLOBAL FUNCTIONS (CODE)                                                  *
*===========================================================================*/

/*===========================================================================*
*  CHashEntry                                                               *
*===========================================================================*/
CHashEntry::CHashEntry (){
  m_lpnext            = NULL;
  m_session           = 0;
  m_iid               = GUID_NULL;
  m_IUnknown          = NULL;
  m_type              = Free_eeo38;
  m_is_committed      = false;
  m_idebug_used_flag  = false;
  m_is_remote_debug   = false;
};

/*===========================================================================*
*  CSessionHashEntry                                                        *
*===========================================================================*/

void CHashEntry::init(tsp00_Uint4 session, 
                      LPGUID      lpGuid, 
                      LPUNKNOWN   lpInterface, 
                      bool        remoteDbgFlag,
                      teo38_HashEntryType hType )
{
  m_lpnext            = NULL;
  m_session           = session;
  m_iid               = *lpGuid;
  m_IUnknown          = lpInterface;
  m_type              = hType;
  m_is_committed      = false;
  m_idebug_used_flag  = false;
  m_is_remote_debug   = remoteDbgFlag;
};

/*---------------------------------------------------------------------------*/
void* CHashEntry::operator new( size_t sz )                    /* PTS 1110403 */
{                                                              /* PTS 1110403 */
  return malloc( sz );                                         /* PTS 1110403 */
};                                                             /* PTS 1110403 */

/*---------------------------------------------------------------------------*/
void CHashEntry::operator delete(void* p)                      /* PTS 1110403 */
{                                                              /* PTS 1110403 */
  free( p );                                                   /* PTS 1110403 */
};                                                             /* PTS 1110403 */
   
/*---------------------------------------------------------------------------*/
CCoClassHash::CCoClassHash ()
{
  m_HashHdrSize   = 0;
  m_HashHdrPtr    = NULL;
  m_HashFreePtr   = NULL;
  m_HashCurrPtr   = NULL;
  m_HashCurrIdx   = 0;
  m_session       = 0;
  m_searchType    = SearchEQ_eeo38;
};
  


/*---------------------------------------------------------------------------*/
tsp00_Uint4 CCoClassHash::HashInit (const tsp00_Uint4 lcSessionHashHdrSize )
{
  tsp00_Uint4    ix;
  
  /* m_HashHdrPtr    = new CHashEntryPtr [ lcSessionHashHdrSize ];        PTS 1110403 */ 
  m_HashHdrPtr = (CHashEntryPtr*) malloc( sizeof( CHashEntryPtr )      /* PTS 1110403 */
    * lcSessionHashHdrSize );                                          /* PTS 1110403 */
  if ( NULL == m_HashHdrPtr )
  {
    return ERROR_NOT_ENOUGH_MEMORY;
  }
#if defined(DEBUG_MEM_ALLOC)
    MSGD(( 11999, INFO_TYPE, "new   ", "veo38.cpp:HashInit - 0x%lx, sizeInBytes %ld",
                  m_HashHdrPtr, sizeof(CHashEntryPtr) * lcSessionHashHdrSize ));
#endif /* DEBUG_MEM_ALLOC */
  
  m_HashHdrSize = lcSessionHashHdrSize;
  for ( ix = 0; ix < lcSessionHashHdrSize; ix++ )
    m_HashHdrPtr[ix] = NULL;
  
  return S_OK;
};
 
/*---------------------------------------------------------------------------*/
void CCoClassHash::chainEntry(CHashEntryPtr p){
  tsp00_Uint4    ix;
  ix = SessionHashIdx(p->getSession());
  p->setNextEntry( m_HashHdrPtr[ix] );
  m_HashHdrPtr[ix] = p;
}


/*---------------------------------------------------------------------------*/
void CCoClassHash::ResetEntrySearch( tsp00_Uint4 session, 
                                    teo38_HashSearchType searchType ){
  m_session              = session;
  m_HashCurrPtr   = NULL;
  m_HashCurrIdx   = 0;
  m_searchType           = searchType;
};

/*---------------------------------------------------------------------------*/
CHashEntryPtr CCoClassHash::getFreeEntry(){
  CHashEntryPtr p;
  p = m_HashFreePtr;
  if ( NULL == p ) {
    p = new (CHashEntry);
#if defined(DEBUG_MEM_ALLOC)
    MSGD(( 11999, INFO_TYPE, "new   ", "veo38.cpp:getFreeEntry() - 0x%lx, sizeInBytes %ld",
                  p, sizeof(CHashEntry) ));
#endif /* DEBUG_MEM_ALLOC */
  }
  else {
    m_HashFreePtr = p->getNextEntry();
  }
  return p;
};

/*---------------------------------------------------------------------------*/
CHashEntryPtr CCoClassHash::NextEntry( void ){
  
  if ( SearchEQ_eeo38 == m_searchType ) {
    if ( NULL == m_HashCurrPtr ) 
      m_HashCurrPtr = m_HashHdrPtr[SessionHashIdx( m_session )];
    else
      m_HashCurrPtr = m_HashCurrPtr->getNextEntry();
    while ( NULL != m_HashCurrPtr ) {
      if ( m_HashCurrPtr->sessionEQ( m_session )) 
        return m_HashCurrPtr;
      m_HashCurrPtr = m_HashCurrPtr->getNextEntry();
    }
  }
  else {
    for ( ; m_HashCurrIdx < m_HashHdrSize; m_HashCurrIdx++ ){
      bool  found;
     
      if ( NULL == m_HashCurrPtr ) 
        m_HashCurrPtr = m_HashHdrPtr[m_HashCurrIdx];
      else
        m_HashCurrPtr = m_HashCurrPtr->getNextEntry();
      while ( NULL != m_HashCurrPtr ) {
        switch ( m_searchType )
        {
        case SearchALL_eeo38:
          found = true;
          break;
        case SearchNE_eeo38:
          found = m_HashCurrPtr->sessionNE( m_session );
          break;
        default:
          found = false;
        }
        if ( found )
        {
          return m_HashCurrPtr;
        }
        m_HashCurrPtr = m_HashCurrPtr->getNextEntry();
      }
    }
  }
  m_HashCurrPtr   = NULL;
  m_HashCurrIdx   = 0;
  return NULL;    
}

/*---------------------------------------------------------------------------*/
CHashEntryPtr CCoClassHash::GetRechainFirstEntry( 
                              teo38_HashEntryType *lpEntryType ){
  tsp00_Uint4           ix;
  bool                  found;
  CHashEntryPtr  prev = NULL;
  CHashEntryPtr  curr = NULL;
  
  for ( ix = 0; ix < m_HashHdrSize; ix++) {
    if ( NULL == curr ) 
      curr = m_HashHdrPtr[ix];
    else {
      prev = curr;
      curr = curr->getNextEntry();
    }
    
    while ( NULL != curr ) {
      switch ( m_searchType )
      {
      case SearchALL_eeo38:
        found = true;
        break;
      case SearchEQ_eeo38:
        found = curr->sessionEQ( m_session );
        break;
      case SearchNE_eeo38:
        found = curr->sessionNE( m_session );
        break;
      default:
        found = false;
      }
      if ( found && ( NULL != lpEntryType ))
      {
        if ( curr->getType() != *lpEntryType )
          found = false;
      }
      if ( found )
      {
        if ( NULL == prev )
          m_HashHdrPtr[ix] = curr->getNextEntry();
        else
          prev->setNextEntry(curr->getNextEntry());
        /* chain into FreeChain */
        curr->setNextEntry(m_HashFreePtr);
        m_HashFreePtr = curr;
        return curr;
      }
      prev = curr;
      curr = curr->getNextEntry();
    }
    prev = NULL;
  }
  return NULL;    
}
  
/*---------------------------------------------------------------------------*/
void CCoClassHash::chainFreeEntry(CHashEntryPtr p) {
  p->setNextEntry(m_HashFreePtr);
  m_HashFreePtr = p;
};
  
/*---------------------------------------------------------------------------*/
CHashEntryPtr CCoClassHash::FindHashEntry( GUID *lpGuid, tsp00_Uint4 session ) {
  CHashEntryPtr  curr;
  
  curr = m_HashHdrPtr[ SessionHashIdx(session) ];
  while ( NULL != curr ) {
    if ( curr->sessionEQ( session ) && curr->GuidEQ( lpGuid ) )
      return curr;
    curr = curr->getNextEntry();
  }
  return NULL;
}

/*---------------------------------------------------------------------------*/
void* CCoClassHash::operator new( size_t sz )                  /* PTS 1110403 */
{                                                              /* PTS 1110403 */
  return malloc( sz );                                         /* PTS 1110403 */
};                                                             /* PTS 1110403 */

/*---------------------------------------------------------------------------*/
void CCoClassHash::operator delete(void* p)                    /* PTS 1110403 */
{                                                              /* PTS 1110403 */
  free( p );                                                   /* PTS 1110403 */
};                                                             /* PTS 1110403 */

/*===========================================================================*
*                                                                            *
*===========================================================================*/

externC void eo38CoGetClassObject ( tsp_dcom_co_create_instance_parms * parms )
{
  
  /* Create a ClassFactory                              */
  /* ClassFactories are globally used within liveCache  */
  /* They are only released on *SHUTDOWN* within        */
  /* vdcom_releaseall ( eo38VDcomReleaseAll )           */
  /* exception: debugger related factories aren't       */
  /*            preserved.                              */
  
  LPCLASSFACTORY lpIClassFactory;
  tsp00_Uint4    session;
  GUID           CoClsId;
  
  memcpy (&session, &parms->session[0], sizeof (session));
  parms->idispatch = 0;
  memcpy(&CoClsId, &parms->coclsid[0], sizeof(CoClsId));
  parms->ret = sql38CoGetClassObject (&CoClsId,
    IID_IClassFactory,
    (void**)&parms->ifactory);
  lpIClassFactory = (IClassFactory *) parms->ifactory;
  if (!parms->ret)
  {
    if (!parms->ret) parms->ret = lpIClassFactory->LockServer (TRUE);
    if (parms->ret) 
    {
      MSGD ((ERR_DCOM_HRESULT, "LockServer", parms->ret ));
      MSGD ((ERR_DCOM_GUID, "COCLSID",
        CoClsId.Data1, CoClsId.Data2, CoClsId.Data3,
        CoClsId.Data4[0], CoClsId.Data4[1], CoClsId.Data4[2],
        CoClsId.Data4[3], CoClsId.Data4[4], CoClsId.Data4[5],
        CoClsId.Data4[6], CoClsId.Data4[7] ));
    }
    parms->ret = eo38_ComCache(&CoClsId, parms->ifactory, 0, false, CLSID_eeo38);
  }
  else
  {
    char cClsContext[80];    
    memset(cClsContext,'\0',sizeof(cClsContext));
    strcpy(cClsContext, "INPROC");
    MSGD ((ERR_DCOM_COCREATE, "CoGetClassObject", parms->ret, cClsContext ));
    MSGD ((ERR_DCOM_GUID, "COCLSID",
      CoClsId.Data1, CoClsId.Data2, CoClsId.Data3,
      CoClsId.Data4[0], CoClsId.Data4[1], CoClsId.Data4[2],
      CoClsId.Data4[3], CoClsId.Data4[4], CoClsId.Data4[5],
      CoClsId.Data4[6], CoClsId.Data4[7] ));
  }
}

/*---------------------------------------------------------------------------*/
/* PTS 1109279 Procedure created to allow caller to use                      */
/*             C++ Objects. SEH and C++ Destructor won't work                */
BOOLEAN eo38_InitializeCPP () {
  BOOLEAN b_ret;
  TRY {                                 
    b_ret = eo38_Initialize ();        
  }                                    
  CATCH_ALL { 
    b_ret = 0;
  };                        
  return b_ret;
};

/*---------------------------------------------------------------------------*/

externC BOOLEAN eo38CoInitialize ( void )
{  
  CWaitUntilAlone cs;                   
  return eo38_InitializeCPP();	    		
}

/*---------------------------------------------------------------------------*/

externC void eo38IIdILiveCacheSpec ( tsp_c16 * iid )
{
  memcpy (iid, &IID_IliveCacheSpec, sizeof (IID_IliveCacheSpec));
}

/*---------------------------------------------------------------------------*/

externC void eo38InitializeDebugServer (tsp_dcom_co_create_instance_parms * parms)
{
  tsp00_Uint4 session;
  LPCLASSFACTORY lpIClassFactory;
  IID guid_iid;

  /* RC_DISPADDR_INUSE */
  if ( parms->ret == 3 ) return;
  
  /* this procedure is only used to ensured the initialization    */
  /* of the LCDebug Server                                        */
  
  parms->idispatch = 0;
  parms->ifactory = 0;
  memcpy (&session, &parms->session[0], sizeof (session));
  memcpy (&guid_iid, &IID_IliveCacheDbg, sizeof (IID));
  
  eo38CoGetClassObject (parms);
  
  lpIClassFactory = (IClassFactory *) parms->ifactory;
  if (!parms->ret)
  {
    parms->ret =
      lpIClassFactory->CreateInstance (NULL,
      IID_IliveCacheDbg,
      (void**)&parms->idispatch);
    if (SUCCEEDED (parms->ret))
    {
        parms->ret = eo38_ComCache (&guid_iid,
        (IUnknown*)parms->idispatch,
        session,
        false,
        DbgInterface_eeo38);
    }
    lpIClassFactory->Release();
  }
  else {
    MSGD ((ERR_DCOM_HRESULT, "eo38InitializeDebugServer: Start of liveCacheProxy/liveCacheRMT failed", 
      parms->ret ));
  }
};

/*---------------------------------------------------------------------------*/

/* PTS 1109279 Procedure created to allow eo38DisposeInstances to use        */
/*             C++ Objects. SEH and C++ Destructor won't work                */
static HRESULT SysCleanUp (tsp_dcom_dispatch_parms * parms
                           ,IliveCacheSpec         * pILC ) {
  HRESULT hr;
  TRY {
    hr = pILC->sysCleanUp ();
  }
#if defined(WIN32)
  __except (eo38_Eval_Exception (parms, GetExceptionInformation ())) {
    hr = parms->hresult;
  };
#else
  catch (RTE_DBProcError e) {
    hr = GEO00D_DCOM_EXCEPTION_RAISED;
  }
  catch (DbpError e) { 
    en38_Eval_Exception( parms );
    hr = GEO00D_DCOM_DBPROC_CRASHED; 
  }
#endif
  return hr;
};

/*---------------------------------------------------------------------------*/

/* method is used to cleanup after a DB-Procedure crashed */
static void eo38DisposeInstances( tsp_dcom_dispatch_parms * parms ) {
  int                       j;
  bool                      EntryFound = true;
  CCoClassHashPtr           HashPtr;
  CHashEntryPtr             currEntry;
  unsigned int              session;
  CIliveCacheSink*          pIliveCacheSink;
  tsp1_packet*              SQLBuffer_ptr;
  IUnknown                  *lpIUnknown;
  HRESULT                   hr;
  IliveCacheSpec            *pILC;
  
  MSGD ((ERR_DCOM_DUMP_INFO, "Drop all component objects active on session"));

  ak341GetDebugContext (REINTERPRET_CAST(tak_all_command_glob*, parms->session_context),
    *REINTERPRET_CAST(tgg91_SessionNo*, &session),
    *REINTERPRET_CAST(tsp00_Addr*, &pIliveCacheSink),
    SQLBuffer_ptr );

  HashPtr = REINTERPRET_CAST(CCoClassHash*,DCOM_HEAD);
  if ( NULL == HashPtr ) {
    MSGD ((ERR_DCOM_DUMP_INFO, "eo38DisposeInstances DCOM_HEAD == NULL"));
    vabort(false);   
  };
  
  j = 0;
  while (EntryFound)
  {
    EntryFound = false;
    {                                       
      CWaitUntilAlone cs;                   
      HashPtr->ResetEntrySearch( session, SearchEQ_eeo38 );
      currEntry = HashPtr->NextEntry();
    };                                      

    if (NULL != currEntry)
    {
      EntryFound = true;
      
      lpIUnknown = currEntry->getIUnknown();
      if (currEntry->getType() != DbgInterface_eeo38)
      {
        hr = lpIUnknown->QueryInterface ( IID_IliveCacheSpec, (void **) &pILC);
        if (SUCCEEDED (hr))
        {
          hr = SysCleanUp( parms, pILC );   /* PTS 1109279 */
          if ( FAILED(hr)) {  
            IID loc_iid;
            char    msgBuffer[132];
       
            MSGD ((ERR_DCOM_HRESULT, "eo38DisposeInstances:sysCleanUp", hr ));
            memcpy (&loc_iid.Data1, currEntry->getGuid(), sizeof (loc_iid));
            sprintf(&msgBuffer[0],"IID:{%8.8X-%4.4X-%4.4X-%2.2X%2.2X-%2.2X%2.2X%2.2X%2.2X%2.2X%2.2X} hr:%d",
              loc_iid.Data1, loc_iid.Data2, loc_iid.Data3,
              loc_iid.Data4[0], loc_iid.Data4[1], loc_iid.Data4[2],
              loc_iid.Data4[3], loc_iid.Data4[4], loc_iid.Data4[5],
              loc_iid.Data4[6], loc_iid.Data4[7], hr);
            MSGD ((ERR_DCOM_DUMP_INFO, &msgBuffer[0]));
          }
          pILC->Release ();
        }
        else
          MSGD ((ERR_DCOM_HRESULT, "eo38DisposeInstances:QILC", hr ));
      }

      CHashEntry    localEntry = *currEntry;                        // PTS 1116802 
      // eo38_ReleaseInstance( currEntry, parms->session_context );    PTS 1116802
      CWaitUntilAlone cs;                   
      HashPtr->ResetEntrySearch( session, SearchEQ_eeo38 );
      currEntry = HashPtr->GetRechainFirstEntry(NULL);
      cs.Leave();                                                   // PTS 1116802
      eo38_ReleaseInstance( &localEntry, parms->session_context );  // PTS 1116802
    }
  }
  MSGD ((ERR_DCOM_DUMP_INFO, "Drop of component objects done"));
};

/*---------------------------------------------------------------------------*/
/* PTS 1109279 CPP variant created to allow object-creation within routine   */
/*             needed for CWaitUntilAlone                                    */
static void eo38ReleaseInstanceCPP ( tsp_dcom_release_instance_parms * parms )
{
  int                       j;
  tsp00_Uint4               session;
  bool                      EntryFound = true;
  CCoClassHashPtr           HashPtr;
  CHashEntryPtr             currEntry;
  
  HashPtr = REINTERPRET_CAST(CCoClassHash*,DCOM_HEAD);
  if ( NULL == HashPtr ) return;
  
  j = 0;
  while (EntryFound)
  {
    EntryFound = false;
    {                                       
      CWaitUntilAlone cs;                   
      memcpy (&session, &parms->session[0], sizeof (session));
      HashPtr->ResetEntrySearch( session, SearchEQ_eeo38 );
      currEntry = HashPtr->NextEntry();
    };                                     
    
    if (NULL != currEntry)
    {
      EntryFound = true;
      CHashEntry    localEntry = *currEntry;                        // PTS 1116802 
      // eo38_ReleaseInstance( currEntry, parms->session_context );    PTS 1116802
      CWaitUntilAlone cs;                  
      HashPtr->ResetEntrySearch( session, SearchEQ_eeo38 );
      currEntry = HashPtr->GetRechainFirstEntry(NULL);
      cs.Leave();                                                   // PTS 1116802
      eo38_ReleaseInstance( &localEntry, parms->session_context );  // PTS 1116802
    }
  }
};

/*---------------------------------------------------------------------------*/

externC void eo38ReleaseInstance ( tsp_dcom_release_instance_parms * parms )
{
  eo38ReleaseInstanceCPP( parms );         /* PTS 1109279 */
  REINTERPRET_CAST(CIliveCacheSink*, 
      &REINTERPRET_CAST(tak_all_command_glob*, parms->session_context)->a_kernel_sink)->Destruct();
}

/*---------------------------------------------------------------------------*/

/* PTS 1109279 Procedure created to caller to use                            */
/*             C++ Objects. SEH and C++ Destructor won't work                */
static void Release( IUnknown *lpIUnknown, const char* s ) {
  TRY { lpIUnknown->Release (); }
  CATCH_ALL { 
    MSGD ((ERR_DCOM_DUMP_INFO, s));
  };
};

/*---------------------------------------------------------------------------*/

/* PTS 1109279 CPP variant created to allow object-creation within routine   */
/*             needed for CWaitUntilAlone                                    */
static void eo38ReleaseProxiesCPP ()
{
  /* Routine only called during exception handling (vco50kc) */
  /* Routine should clear up all Debug Processes, to avoid   */
  /* Debugger Processes to stay alive after liveCache Crash  */
  
  IUnknown                *lpIUnknown;
  CCoClassHash            *HashPtr;
  CHashEntryPtr           currEntry;
  
  HashPtr = REINTERPRET_CAST(CCoClassHash*, (DCOM_HEAD));
  if ( NULL == HashPtr ) return;
    
  /* hopefully we didn't crash within critical region !!     */
  /* ELSE: liveCache busy-loop forever    *CHANGE*           */
  /* NOW a crash doesn't matter, because of the cs object    */
  /* created on stack                      PTS 1109279       */
  CWaitUntilAlone cs;                   
  
  /* Release session related debugger                        */
  HashPtr->ResetEntrySearch( 0, SearchALL_eeo38 );
  currEntry = HashPtr->NextEntry();  
  while ( NULL != currEntry)
  {
    if (currEntry->getType()  == DbgInterface_eeo38)
    {
      lpIUnknown = currEntry->getIUnknown();
      Release( lpIUnknown, "eo38ReleaseProxies:Release of debugger failed" ); /* PTS 1109279 */
    }
    currEntry = HashPtr->NextEntry();  
  }
}

/*---------------------------------------------------------------------------*/

externC void eo38ReleaseProxies ()
{
  eo38ReleaseProxiesCPP();              /* PTS 1109279      */
};

/*---------------------------------------------------------------------------*/

/* PTS 1109279 CPP variant created to allow object-creation within routine   */
/*             needed for CWaitUntilAlone                                    */
static void eo38RemoveProxyCPP ( tsp00_Uint4 session )
{
  /* Routine is called on DB-Session-Release     */
  /* If there is a Debugger related to this      */
  /* session -> release it.                      */
  /*                                             */
  
  IUnknown              *lpIUnknown;
  CCoClassHash          *HashPtr;
  CHashEntryPtr         currEntry;
  teo38_HashEntryType  entryType = DbgInterface_eeo38;
  HashPtr = REINTERPRET_CAST(CCoClassHash*,(DCOM_HEAD));
  if ( NULL == HashPtr ) return;
  
  CWaitUntilAlone cs;                   
  HashPtr->ResetEntrySearch( session, SearchALL_eeo38 );
  currEntry = HashPtr->GetRechainFirstEntry(&entryType);  
  while ( NULL != currEntry)
  {
    lpIUnknown = currEntry->getIUnknown();
    cs.Leave();                         
    Release( lpIUnknown, "eo38RemoveProxy:Release of debugger failed" );
    cs.Enter();                         
    HashPtr->ResetEntrySearch( 0, SearchALL_eeo38 );
    currEntry = HashPtr->GetRechainFirstEntry(&entryType);  
  };
};

/*---------------------------------------------------------------------------*/

externC void eo38RemoveProxy ( tsp00_Uint4 session ) {
  eo38RemoveProxyCPP(session);          /* PTS 1109279 */
};

/*------------- +++++ PTS 1106505 FF +++++++++++++++ ------------------------*/

externC void eo38CTraceBack( tsp00_Addr hd )
{
#if defined (WIN32)
  WAIT_UNTIL_ALONE (DCOM_EXCLUSIVE);   /* PTS 1110787 */
  __try                                /* PTS 1110787 */
  {                                    /* PTS 1110787 */
   eo38_Dump_Exception ( REINTERPRET_CAST(LPEXCEPTION_POINTERS, hd) );
  }
  __except (EXCEPTION_EXECUTE_HANDLER) /* PTS 1110787 */
  {                                    /* PTS 1110787 */
  }                                    /* PTS 1110787 */
  CLEARLOCK (DCOM_EXCLUSIVE);          /* PTS 1110787 */
#endif
};

/* --- PTS 1106505 FF ---------------  */

/*---------------------------------------------------------------------------*/

externC void eo38UnInitialize ( void )
{
  return;
}

/*--------------------         PTS 1112369    -------------------------------*/
static HRESULT eo38RegisterSyncExcp( IliveCacheSpec *pILC ) {
  HRESULT hr;
  try {
    hr = pILC->Register ();
  }
  catch ( BAD_ALLOC_GEO573 ) {                    
    hr = GEO00D_DCOM_BAD_ALLOC;                   
  }                                               
  catch ( RTE_DBProcError) {
    hr = -1;
  }
  catch ( DbpError &e) { 
    char    msgBuffer[132];
    sprintf(&msgBuffer[0],"eo38aVDcomCall: DbpError:%d", e.dbpError() );
    MSGD ((ERR_DCOM_DUMP_INFO,msgBuffer));
    hr = ERR_DCOM_COMETHOD_CRASHED;
  }
  return hr;
}

static HRESULT eo38Register( IliveCacheSpec *pILC, tsp_dcom_dispatch_parms *disp_parms ) {
  HRESULT hr;
#if defined(WIN32)
  __try { 
#endif
    hr = eo38RegisterSyncExcp( pILC );
#if defined(WIN32)
  }
  __except (eo38_Eval_Exception (disp_parms, GetExceptionInformation ())) {
    hr = disp_parms->hresult;
  }
#endif
  return hr;
}

/*---------------------------------------------------------------------------*/

externC void eo38VDcomCreateInstance ( tsp_dcom_co_create_instance_parms * parms )
{
  LPCLASSFACTORY lpIClassFactory;
  IUnknown *lpIUnknown;
  IliveCacheSpec *pILC;
  tsp00_Uint4 session;
  IID   IId;
  
  memcpy(&IId, &parms->iid[0], sizeof(IId));   /* PTS 1109371 */
  memcpy (&session, &parms->session[0], sizeof (session));
  lpIClassFactory = (IClassFactory *) parms->ifactory;
  
  try {
    parms->ret = lpIClassFactory->CreateInstance ( NULL,
      IId,
      (void **)&(parms->idispatch));
    if ( parms->ret == E_OUTOFMEMORY )
      parms->ret = GEO00D_DCOM_BAD_ALLOC;
  }                                               
  catch ( BAD_ALLOC_GEO573 ) {                    
    parms->ret = GEO00D_DCOM_BAD_ALLOC;                   
    MSGD ((ERR_DCOM_HRESULT, "eo38VDcomCreateInstance:CI", parms->ret ));
  } 
  
  if (SUCCEEDED (parms->ret))
  {
    lpIUnknown = (IUnknown *) parms->idispatch;
    parms->ret = lpIUnknown->QueryInterface ( IID_IliveCacheSpec,(void **) &pILC );
    if (! SUCCEEDED (parms->ret)) {
      MSGD ((ERR_DCOM_HRESULT, "eo38VDcomCreateInstance:QI(ILCSpec)", parms->ret ));
    }
    else {
      tsp_dcom_dispatch_parms disp_parms;
      disp_parms.idispatch = parms->idispatch;
      disp_parms.ifactory = parms->ifactory;
      disp_parms.dispid = -2;
      disp_parms.session_context = (char*)((CIliveCacheSink*)parms->ikernel_sink)->lpSessionContext;
      ((CIliveCacheSink*)parms->ikernel_sink)->CallbackIsActive = false;
      
      try  {
        parms->ret = pILC->Advise ( (IUnknown *) parms->ikernel_sink);
        parms->ret = pILC->sysMonitorInit (); /* +++ Change Request 1000139 +++ */
      }
      catch ( BAD_ALLOC_GEO573 ) {  
        pILC->Release();						/* destroy instance */
        pILC->Release();
        parms->ret = GEO00D_DCOM_BAD_ALLOC;                   
        MSGD ((ERR_DCOM_HRESULT, "eo38VDcomCreateInstance:Advise", parms->ret ));
      }                                               
      
      if (!parms->ret) {
		  
		  /* memcpy (&session, &parms->session[0], sizeof (session));  PTS 1109371 */
		  parms->ret = eo38_ComCache (REINTERPRET_CAST(IID *, & (parms->iid)),
			  parms->idispatch,
			  session,
			  false,
			  IID_eeo38);
		  if ( parms->ret ) {
			  MSGD ((ERR_DCOM_HRESULT, "CreateInstance:eo38_ComCache", parms->ret ));
			  /* +++      PTS 1109371      +++ */
			  CHashEntry        currEntry;
			  
			  currEntry.init( 0
				  , REINTERPRET_CAST(IID *, & (parms->iid))
				  , (LPUNKNOWN)parms->idispatch
				  , false
				  , IID_eeo38 );
			  eo38_ReleaseInstance ( &currEntry, (char*)&parms->session[0] );
			  /* ---      PTS 1109371      --- */
		  } 
		  else {
			  if (memcmp (&parms->iid[0], &IID_IliveCacheSpec, sizeof (parms->iid)))
				  parms->ret = eo38Register( pILC, &disp_parms ); 
			  if ( parms->ret ) {
				  MSGD ((ERR_DCOM_HRESULT, "CreateInstance:Register", parms->ret ));
			  }
		  }
		  if ( parms->ret ) {
        eo38DisposeInstances( &disp_parms );
      }
      IID     loc_iid;                                          /* PTS 1112617 */
      TASK_CTRL pTaskCtrl = CURR_TASK;                          /* PTS 1112617 */
      memcpy (&loc_iid.Data1, &(parms->iid), sizeof (loc_iid)); /* PTS 1112617 */
      MSGCD ((INFO_DCOM_CREATE_INSTANCE,                        /* PTS 1112617 */
        loc_iid.Data1, loc_iid.Data2, loc_iid.Data3,            /* PTS 1112617 */
        loc_iid.Data4[0], loc_iid.Data4[1], loc_iid.Data4[2],   /* PTS 1112617 */
        loc_iid.Data4[3], loc_iid.Data4[4], loc_iid.Data4[5],   /* PTS 1112617 */
        loc_iid.Data4[6], loc_iid.Data4[7],                     /* PTS 1112617 */ 
        eo38ThreadIndex(pTaskCtrl)));                           /* PTS 1112617 */ 
      pILC->Release ();
      }
    }
  }
}

/*---------------------------------------------------------------------------*/

static void eo38VDcomDispatch ( tsp_dcom_dispatch_parms * parms )
{
  IliveCacheSpec  *pILC;
  tsp00_Int4      start_time_sec; 
  tsp00_Int4      start_time_msec;
  tsp00_Int4      stop_time_sec; 
  tsp00_Int4      stop_time_msec;
  tsp00_Int4      diff_time_sec; 
  tsp00_Int4      diff_time_msec;
  
  tsp00_Uint4     param_stack_size;
  
#if defined(LINUX) 
  //    vdebug_break(10001);
#endif

  tsp00_Uint param_num; 
  tak_dbproc_stack_param_debug *pDebugStack;
  IUnknown										 *lpIUnknown;
  IUnknown										 *lpClassPtr;
  t_lpIFunc											lp_IFunc;
  t_lpptr												lpVTable;

  // PTASK_CTRL_REC pTaskCtrl = THIS_UKT_CTRL->pCTask; PTS 1106969 
  TASK_CTRL pTaskCtrl = CURR_TASK;                  // PTS 1106969
  // pTaskCtrl->TaskState = TSK_DCOM_OBJ_CALLED;       PTS 1106969 
  TASK_STATE(pTaskCtrl) = TSK_DCOM_OBJ_CALLED;      // PTS 1106969 
  /* +++ initialize statistic record                   PTS 1106969  */
  int nlen = sizeof(parms->method_name);
  if ( g01unicode )     /* g01unicode PTS 1127607 FF 2004-FEB-10 */
  {
      if ( ( nlen/2 ) > pTaskCtrl->TaskOMSStat.ProcedurName.size()) 
        nlen = pTaskCtrl->TaskOMSStat.ProcedurName.size() * 2;
      int ix;
      for ( ix = 0; ix < (nlen/2); ix++ )
          pTaskCtrl->TaskOMSStat.ProcedurName[ix] = parms->method_name[ix * 2 + 1];
      pTaskCtrl->TaskOMSStat.ProcedurName[ix] = '\0';
  }
  else
  {
      if ( nlen > pTaskCtrl->TaskOMSStat.ProcedurName.size()) 
        nlen = pTaskCtrl->TaskOMSStat.ProcedurName.size();
      memcpy(pTaskCtrl->TaskOMSStat.ProcedurName, parms->method_name, nlen);
      pTaskCtrl->TaskOMSStat.ProcedurName[nlen] = '\0';
  }
  pTaskCtrl->TaskOMSStat.CallbackCount  = 0;        
  pTaskCtrl->TaskOMSStat.MethodIdx      = -1;       
  pTaskCtrl->TaskOMSStat.OMSCallActive  = 0;        
  /* --- initialize statistic record                   PTS 1106969  */
  /* +++ initialize CIliveCacheSink                    PTS 1106969  */
  tsp00_C4          session;
  CIliveCacheSink*  pIliveCacheSink;
  tsp1_packet*      SQLBuffer_ptr;
  
  ak341GetDebugContext (REINTERPRET_CAST(tak_all_command_glob*, parms->session_context),
    *REINTERPRET_CAST(tgg91_SessionNo*, &session),
    *REINTERPRET_CAST(tsp00_Addr*, &pIliveCacheSink),
    SQLBuffer_ptr );
  pIliveCacheSink->lpTaskContext = pTaskCtrl;
  tsp92_RteTaskDetailsInfo taskInfo;
  vGetRteInfoTaskDetails (pIliveCacheSink->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00, &taskInfo);
  pIliveCacheSink->lpCallTaskInfo = &taskInfo;
  /* --- initialize CIliveCacheSink                    PTS 1106969  */
  lpIUnknown = (IUnknown *) parms->idispatch;
  lpClassPtr = lpIUnknown;

  if (g01is_livecache()) {
    if (!pIliveCacheSink->InitAllocator()) {
      // error initializing allocators, destroy sink and set return code
      pIliveCacheSink->lpSessionContext->a_transinf.
        tri_trans.trError_gg00 = e_no_more_memory;
      parms->hresult = GEO00D_DCOM_EXCEPTION_RAISED;
      return;
    }
  }

  lpVTable = (t_lpptr) * (tsp00_Longint *) lpIUnknown;

  param_num = parms->param_stack_len / sizeof(tak_dbproc_stack_param_debug);
  pDebugStack = REINTERPRET_CAST(tak_dbproc_stack_param_debug*,parms->param_stack);

#if defined(_IBMR2) || defined(SUN) || defined(PA11) || defined(PA20W) || defined(ALPHA) || defined(NMP)
  /* calculate entry address of method to call      */
#if defined(PA11) || defined(PA20W)
  lp_IFunc    = (t_lpIFunc) lpVTable[parms->dispid+4];
#elif defined(ALPHA) || ( defined(_IBMR2) && defined(BIT64) )
  lp_IFunc    = (t_lpIFunc) lpVTable[parms->dispid];
#elif defined(SUN) && (__SUNPRO_CC >= 0x0500)
  /* PTS 1105381 *//* 15-Nov-2000 FF chg == to >= */ 
  lp_IFunc    = (t_lpIFunc) lpVTable[parms->dispid+2];
#else
  lp_IFunc    = (t_lpIFunc) lpVTable[parms->dispid+1].addr;
  /* calculate this pointer of COM-Object           */
  lpClassPtr = (IUnknown*)((long)lpIUnknown + lpVTable[parms->dispid+1].this_displ);
#endif
  param_stack_size = sizeof(void *);      /* size for this pointer */
  while ( param_num > 0 )
  {
    if ( '\00' == pDebugStack->dbg_is_ptr )
    {
      /* C++ pushes 1&2 Bytes Types as words   */
      if ( pDebugStack->dbg_length <= MIN_PARAMETER_SIZE ) {
        param_stack_size = param_stack_size + MIN_PARAMETER_SIZE;
      }
      else  
      {
#if defined(PA11) || defined(BIT64)
	/* align to double word */
        param_stack_size = ( param_stack_size + 7 ) & 0xFFFFFFF8;
#endif
#if defined(NMP)
        /* double is passed as 2 Fullwords 8 Byte aligend on NMP */
        if ( pDebugStack->dbg_vt == csp1_vt_r8 ) {
          param_stack_size = (param_stack_size + 7) & 0xFFFFFFF8;
          param_stack_size = param_stack_size + 8;
        }
        else
#endif
          param_stack_size = param_stack_size + pDebugStack->dbg_length;
      }
    }
    else {
#if defined(BIT64)
      param_stack_size = (param_stack_size + 7) & 0xFFFFFFF8;
#endif
      param_stack_size = param_stack_size + sizeof(void *);
    }
    param_num--;
    pDebugStack++;
  }
#elif defined(LINUX) || defined(_WIN32)
#if defined(LINUX) && (__GNUC__ < 3)
  /* gcc 2.95/2.96 on i386 and ia64 */
  lp_IFunc = (t_lpIFunc) lpVTable[parms->dispid+2];
#elif defined(LINUX) && defined(I386) && __GNUC__ == 3 && __GNUC_MINOR__ >= 2
  /* gcc 3.2 on i386 */
  lp_IFunc = (t_lpIFunc) lpVTable[parms->dispid];
#elif defined(LINUX) && defined(IA64) && __GNUC__ == 3 && __GNUC_MINOR__ >= 1
  /* new ia64-c++-abi with '-fno-rtti', default with gcc 3.1 */
  lp_IFunc = (t_lpIFunc) &lpVTable[2 * parms->dispid];
#elif defined(_WIN32) 
  lp_IFunc = (t_lpIFunc) lpVTable[parms->dispid];
#endif
  param_stack_size = parms->param_stack_len;
#if defined	(_WIN64)
  //Define verwenden
  tak_dbproc_stack_param	param_stack[cak260max_params];

  //Define verwenden
  tak_dbproc_stack_param	fparam_stack[cak260max_fparams];

  tsp00_Uint				len = 0;
  tsp00_Uint				flen = 0;

  while (param_num > 0)
  {
    /*
     * The first 8 floating point parameters go into the floating point
     * parameter stack.  This allows the assembly code to easily determine
     * which parameters are passed in floating point registers.
     */
    if ( pDebugStack->dbg_vt == csp1_vt_r8 ) 
    {
      if (flen < cak260max_fparams)
      {
        /*
         * double precision floats are copied onto the floating point
	 * parameter stack in their memory format.
         */
          fparam_stack[flen].r8() = pDebugStack->dbg_value.r8();
          flen++;
      }
      else
      {
        MSGD ((ERR_DCOM_MAX_FPARAM, cak260max_fparams));
        ABORT ();
      }
    } /* end if double */
    else if ( pDebugStack->dbg_vt == csp1_vt_r4 ) 
    {
      if (flen < cak260max_fparams)
      {
        /*
         * Single precision floats are converted to double-precision floats 
         * before placing them on the floating point parameter stack because 
         * the assembly code can't tell the difference between single and 
         * double precision.  This does not affect the target function.  The 
         * target function receives the parameter either as a floating point 
         * register or on the general parameter stack, where it is left 
         * in single precision memory format.
         */
        fparam_stack[flen].r8() = pDebugStack->dbg_value.r4();
        flen++;
      }
      else
      {
        MSGD ((ERR_DCOM_MAX_FPARAM, cak260max_fparams));
        ABORT ();
      }
    } /* end else-if single */

    /*
     * All parameters (including floating point parameters) are placed
     * in order onto the general parameter stack.
     */
    if (len < cak260max_params)
    {
      param_stack[len].ptr() = pDebugStack->dbg_value.ptr();
      len++;
      param_num--;
      pDebugStack++;
    }
    else
    {
      MSGD ((ERR_DCOM_MAX_PARAM, cak260max_params));
      ABORT ();
    }
  } /* end for */

  /*
   * Convert len and flen to bytes.
   */
  len <<= 3;
  flen <<= 3;
#endif

#else
  lp_IFunc = (t_lpIFunc) &lpVTable[ 2 * parms->dispid];
//BLOEDSINN??  
  param_stack_size = parms->param_stack_len;
#endif
  
  /*--* +++ FF Change Request 1000139  +++ *---------------------------------*/
  if ( parms->monitoring )
  {
    TRY 
    {
      pILC = NULL;                  /* PTS 1116425 */
      parms->hresult =
      lpIUnknown->QueryInterface (IID_IliveCacheSpec, (void **)&pILC);
      if (FAILED(parms->hresult))
      {
        MSGD ((ERR_DCOM_HRESULT, "eo38VDcomDispatch:IID_IliveCacheSpec", parms->hresult));
        return;
      }
      pILC->sysMonitorProlog(parms->monitor_slot_id, 
        REINTERPRET_CAST(unsigned char*,&parms->method_name) );
      vclock (&start_time_sec, &start_time_msec);
    }
    CATCH_ALL 
    {
      MSGD ((ERR_DCOM_DUMP_INFO,"eo38VDcomDispatch:sysMonitorProlog : unhandled exception")); /* PTS 1107168 */
    }
#ifndef WIN32
    // on Dec, sysMonitorProlog might throw bad_alloc as well.
    catch (...) {
      MSGD ((ERR_DCOM_DUMP_INFO,"eo38VDcomDispatch:sysMonitorProlog : unhandled unknown exception"));
    }
#endif
  }
  /*--* --- FF Change Request 1000139  --- *---------------------------------*/
  TRY             
  {
   /*
     * following has been coded in Assembler
     * to push the exact length of needed Parms
     */
#if defined (_WIN64)
    sql38aVdcomCall (
      lpClassPtr,	 /* class this pointer */ 
      (PROC)lp_IFunc,    /* entry-point */
      param_stack,       /* call-stack */ 
      len,               /* call-stack length */
      fparam_stack,      /* call-stack (floats) */ 
      flen,              /* call-stack length (floats) */
      param_stack_size); /* param-stack size, is not needed in this case */
#else
#if defined(SUN) && defined(BIT64)
    /* PTS 1109493 */ /* round up to multiple of 16 bytes */
    param_stack_size = ( param_stack_size + 15 ) & (~15);
#endif
    sql38aVdcomCall(lpClassPtr,  /* class this pointer*/ 
      (PROC)lp_IFunc,            /* entry-point       */
      parms->param_stack,        /* call-stack        */ 
      parms->param_stack_len,    /* call-stack length */
      param_stack_size);         /* param-stack size  */
#endif
    parms->hresult = 0;
  }
#if defined(_WIN32)
  __except (eo38_Eval_Exception (parms, GetExceptionInformation ()))
  {
    if ( parms->hresult != GEO00D_DCOM_EXCEPTION_RAISED ) {
      MSGD ((ERR_DCOM_HRESULT, "eo38VDcomDispatch", parms->hresult ));
    }
  }
#else
  catch (RTE_DBProcError e) {
    if (e_terminate == e.error_number) { /* 1107692 */
      parms->hresult = GEO00D_DCOM_TERMINATED;
    }
    else {
      parms->hresult = GEO00D_DCOM_EXCEPTION_RAISED;
    }
  }
  catch (DbpError e) { 
    char    msgBuffer[132];
    sprintf(&msgBuffer[0],"eo38aVDcomCall: DbpError:%d", e.dbpError() );
    MSGD ((ERR_DCOM_DUMP_INFO,msgBuffer));
    en38_Eval_Exception( parms );
    parms->hresult = GEO00D_DCOM_DBPROC_CRASHED; }
  catch ( BAD_ALLOC_GEO573 ) {                    
    MSGD ((ERR_DCOM_DUMP_INFO,"eo38aVDcomCall: STD::BAD_ALLOC caught"));
    parms->hresult = GEO00D_DCOM_DBPROC_CRASHED;                   
  }                                               
#endif
  
  if (pIliveCacheSink->m_pCOMRoutineUserAllocator) {
    pIliveCacheSink->m_pCOMRoutineUserAllocator->omsCheckAllocatorEmpty();
  }

  /*--* +++ FF Change Request 1000139  +++ *---------------------------------*/
  if ( parms->monitoring && ( 0 == parms->hresult ))
  {
    TRY
    {
      vclock (&stop_time_sec, &stop_time_msec);
      diff_time_sec  = stop_time_sec - start_time_sec;
      diff_time_msec = stop_time_msec - start_time_msec;
      if (stop_time_msec < start_time_msec)
      {
        diff_time_sec  = diff_time_sec - 1;
        diff_time_msec = diff_time_msec + 1000000 ;
      }
      pILC->sysMonitorEpilog(parms->monitor_slot_id, diff_time_sec * 1000 + diff_time_msec / 1000);
      pILC->Release();
    }
    // BEGIN PTS 1117692
#if defined(_WIN32)
    __except (eo38_Eval_Exception (parms, GetExceptionInformation ()))
    {
      if ( parms->hresult != GEO00D_DCOM_EXCEPTION_RAISED ) {
        MSGD ((ERR_DCOM_HRESULT, "eo38VDcomDispatch", parms->hresult ));
      }
    }
#else
    catch (RTE_DBProcError e) {
      if (e_terminate == e.error_number) { /* 1107692 */
        parms->hresult = GEO00D_DCOM_TERMINATED;
      }
      else {
        parms->hresult = GEO00D_DCOM_EXCEPTION_RAISED;
      }
    }
    catch (DbpError e) { 
      char    msgBuffer[132];
      sprintf(&msgBuffer[0],"eo38aVDcomCall: DbpError:%d", e.dbpError() );
      MSGD ((ERR_DCOM_DUMP_INFO,msgBuffer));
      en38_Eval_Exception( parms );
      parms->hresult = GEO00D_DCOM_DBPROC_CRASHED; }
#endif  
    if (parms->hresult != 0 && pILC){
      pILC->Release();
    }
    // END PTS 1117692
  }
  else 
  {
    /*
     * PTS 1116425
     * in case of hresult (GEO00D_DCOM_TERMINATED,...),
     * where sysMonitorEpilog isn't executed,
     * correct COM instance reference counting,
     * to make sure instance will be deleted by eo38DisposeInstances()
     */
    if (parms->monitoring && pILC)
      pILC->Release();
  }

  /*--* --- FF Change Request 1000139  --- *---------------------------------*/
/*#ifdef WIN32 PTS 1106969 */
  //pTaskCtrl->TaskState = TSK_RUNNING;   PTS 1106969
  TASK_STATE(pTaskCtrl) = TSK_RUNNING; // PTS 1106969
/*#endif PTS 1106969 */
  /* +++ re-initialize statistic record           PTS 1106969  */
  pTaskCtrl->TaskOMSStat.ProcedurName[0] = '\0';
  pTaskCtrl->TaskOMSStat.CallbackCount  = 0;        
  pTaskCtrl->TaskOMSStat.MethodIdx      = -1;       
  pTaskCtrl->TaskOMSStat.OMSCallActive  = 0;        
  /* --- re-initialize statistic record           PTS 1106969  */
  pIliveCacheSink->lpCallTaskInfo = 0;
  return;
}

/*---------------------------------------------------------------------------*/

externC void eo38VDcomDBProc ( tsp_dcom_dispatch_parms * parms )
{
  tsp00_C4          session;
  CIliveCacheSink*  pIliveCacheSink;
  tsp1_packet*      SQLBuffer_ptr;
  
  ak341GetDebugContext (REINTERPRET_CAST(tak_all_command_glob*, parms->session_context),
    *REINTERPRET_CAST(tgg91_SessionNo*, &session),
    *REINTERPRET_CAST(tsp00_Addr*, &pIliveCacheSink),
    SQLBuffer_ptr );
  pIliveCacheSink->CallbackIsActive = false;
  pIliveCacheSink->sqlErrorFlag     = false;   /* PTS 1110814 FF */
  
  
  eo38VDcomDispatch (parms);
  // PTS 1116199: here comes call for allocator callback - check for emptyness in COM routine allocator
  pIliveCacheSink->UserAllocatorCtl(OmsCallbackInterface::BlockCOMRoutine, NULL);
  if (( GEO00D_DCOM_DBPROC_CRASHED == parms->hresult ) || ( GEO00D_DCOM_TERMINATED == parms->hresult )) {
    eo38DisposeInstances( parms );
    pIliveCacheSink->lpDefaultContext = NULL;
    /* PTS 1120804 */
    if (NULL != pIliveCacheSink->lpSqlSessionContext) {
      MSGD ((ERR_DCOM_DUMP_INFO,"eo38VDcomDBProc: lpSqlSessionContext <> NULL"));
      pIliveCacheSink->lpSqlSessionContext = NULL;
    }
  }
  else 
  {
    if ( pIliveCacheSink->sqlErrorFlag ) parms->hresult = -1;   /* PTS 1110814 FF  */
  }
}

/*---------------------------------------------------------------------------*/

externC void eo38VDcomGetDispAddr ( tsp_dcom_co_create_instance_parms * parms )
{
  GUID                    guid_coclsid;
  IID                     guid_iid;
  tsp00_Uint4             session;
  CCoClassHashPtr         HashPtr;
  CHashEntryPtr           currPtr;
  
  memcpy (&guid_coclsid, &parms->coclsid[0], sizeof (parms->coclsid));
  memcpy (&guid_iid, &parms->iid[0], sizeof (parms->iid));
  memcpy (&session, &parms->session[0], sizeof (session));
  parms->ret = RC_DISPADDR_FAILED;
  parms->idispatch = 0;
  parms->ifactory = 0;
  
  HashPtr = REINTERPRET_CAST(CCoClassHashPtr, (DCOM_HEAD));
  if (NULL == HashPtr) return;
  
  CWaitUntilAlone cs;                   
  
  currPtr = HashPtr->FindHashEntry( &guid_iid, session );
  if (NULL != currPtr)
  {
    /* the ILiveCacheDbg Interface is used within LOCAL and REMOTE Servers */
    if (currPtr->getType() == DbgInterface_eeo38) 
    {
      parms->idispatch = REINTERPRET_CAST(char *,(currPtr->getIUnknown())); 
      currPtr->setDebugFlag(true);
      parms->ret = RC_DISPADDR_OK;
      return;
    }
    else
    {
      parms->idispatch = REINTERPRET_CAST(char *,(currPtr->getIUnknown())); 
      if ( currPtr->getType() == Invalid_IID_eeo38 )
        eo38_Invalidate( parms, &guid_iid, session );
      else
        parms->ret = RC_DISPADDR_OK;
      return;
    }
  }
  
  /* check if CLSID in cache ( DBPROC Factory-Pointer)   */
  currPtr = HashPtr->FindHashEntry( &guid_coclsid, 0 );
  if ( NULL != currPtr )
  {
    parms->ifactory = REINTERPRET_CAST(char *,(currPtr->getIUnknown()));
    if ( currPtr->getType() == Invalid_CLSID_eeo38 )
    {
      parms->ret = RC_DISPADDR_INVALID_FOUND;
    }
    else
    {
      parms->ret = RC_DISPADDR_FACTORY_FOUND;
    }
  }
  return;
}

/*---------------------------------------------------------------------------*/

externC void eo38VDcomInitSink ( tsp_dcom_init_sink_parms * parms )
{
  CIliveCacheSink *lpCliveCacheSink;
  
  if (sizeof (CIliveCacheSink) > parms->sink_size)
  {
    MSGD ((ERR_DCOM_DUMP_INFO, "eo38VDcomInitSink: sizeof(CIliveCacheSink) > reserved space for Object"));
    vabort(false);   
  }
  else
  {
    lpCliveCacheSink  = new ( parms->sink_addr ) CIliveCacheSink;
    lpCliveCacheSink->lpSessionContext = 
      REINTERPRET_CAST(tak_all_command_glob*,(parms->acv_addr));
  }
  return;
}

/*--* +++ FF Change Request 1000139  +++ *-----------------------------------*/
/* PTS 1109279 Procedure created to caller to use                            */
/*             C++ Objects. SEH and C++ Destructor won't work                */
static HRESULT QuerySpecInterface( IUnknown *lpIUnknown
                                  ,IUnknown **lplpIUnknown
                                  ,const char* s ) {
  HRESULT hr;
  TRY { 
    hr = lpIUnknown->QueryInterface(IID_IliveCacheSpec, 
      REINTERPRET_CAST(void **,lplpIUnknown) );
  }
  CATCH_ALL { 
	hr = GEO00D_DCOM_EXCEPTION_RAISED;
    MSGD ((ERR_DCOM_DUMP_INFO, s));
  };
  return hr;
};

externC void eo38VDcomMonOpen ( tsp_dcom_monitor_parms * parms )
{
  CCoClassHashPtr         HashPtr;
  CHashEntryPtr           currSessEntry, newSessEntry;
  IUnknown*               lpIUnknown;
  HRESULT                 hr;
  tsp00_TaskId            taskid;

  vgetpid(taskid);
  vbegexcl(taskid, g08ComponentEnd );
  
  parms->session_handle   = NULL;
  parms->retcode          = -1;
  parms->idispatch        = NULL;
  
  CWaitUntilAlone cs;                   
  HashPtr = REINTERPRET_CAST(CCoClassHashPtr, (DCOM_HEAD));
  if (NULL != HashPtr) 
  {
    HashPtr->ResetEntrySearch( 0, SearchALL_eeo38 );
    currSessEntry = HashPtr->NextEntry();
    while ( currSessEntry )
    {
      /* only Interfaces, no Factories, no IDebug, no IID_IliveCacheSpec Interface */
      if ((IID_eeo38 == currSessEntry->getType()) &&
        (IID_IliveCacheSpec != *(currSessEntry->getGuid())))
      {
        /* get IUnknown for IID_IliveCacheSpec Interface */
        /* PTS 1109279 new call */
        hr = QuerySpecInterface( currSessEntry->getIUnknown()
          , &lpIUnknown
          , "eo38VDcomMonOpen:QueryInterface : unhandled exception" ); 
        if (SUCCEEDED(hr))
        {
          newSessEntry = HashPtr->getFreeEntry();
          newSessEntry->init( currSessEntry->getSession(), 
            currSessEntry->getGuid(), 
            lpIUnknown, 
            currSessEntry->getRemoteDbgFlag(), 
            currSessEntry->getType());
          newSessEntry->setNextEntry((CHashEntryPtr)parms->session_handle);
          parms->session_handle = (tsp00_Addr)newSessEntry;
        }
      }
      currSessEntry = HashPtr->NextEntry();
    }
  }
  cs.Leave();                                     
  if ( NULL == parms->session_handle )
  {
    parms->idispatch  = NULL;
    parms->retcode    = -1;
    vgetpid(taskid);
    vendexcl(taskid, g08ComponentEnd );
  }
  else
  {
    tsp00_Uint4  session = newSessEntry->getSession();
    newSessEntry = REINTERPRET_CAST(CHashEntryPtr,parms->session_handle);
    parms->idispatch = REINTERPRET_CAST(char *, newSessEntry->getIUnknown());
    memcpy (&parms->iid[0], newSessEntry->getGuid(), sizeof (parms->iid));
    memcpy(&parms->session[0], &session, sizeof(parms->session)); 
    parms->retcode = S_OK;
  }
}

/*---------------------------------------------------------------------------*/

externC void eo38VDcomMonNext ( tsp_dcom_monitor_parms * parms )
{
  CHashEntryPtr           currSessEntry, newSessEntry;
  CCoClassHashPtr         HashPtr;
  tsp00_TaskId            taskid;

  parms->retcode = S_OK;

  if ( NULL == parms->session_handle )
  {
    parms->idispatch  = NULL;
    parms->retcode    = -1;
    return;
  }

  currSessEntry = REINTERPRET_CAST(CHashEntryPtr,parms->session_handle);
  if (parms->idispatch == REINTERPRET_CAST(char *, currSessEntry->getIUnknown()))
  {
    Release( REINTERPRET_CAST(IUnknown *, parms->idispatch)
      , "eo38VDcomMonNext:Release : unhandled exception" );
    
    newSessEntry  = currSessEntry->getNextEntry();
    
    /* re-chain to free chain */
    CWaitUntilAlone cs;                   
    HashPtr = REINTERPRET_CAST(CCoClassHashPtr, (DCOM_HEAD));
    HashPtr->chainFreeEntry(currSessEntry);
    cs.Leave();                           
    
    if ( newSessEntry != NULL )
    {
      parms->session_handle = (tsp00_Addr)newSessEntry;
      tsp00_Uint4  session = newSessEntry->getSession();
      newSessEntry = REINTERPRET_CAST(CHashEntryPtr,parms->session_handle);
      parms->idispatch = REINTERPRET_CAST(char *, newSessEntry->getIUnknown());
      memcpy (&parms->iid[0], newSessEntry->getGuid(), sizeof (parms->iid));
      memcpy(&parms->session[0], &session, sizeof(parms->session)); 
    }
    else
    {
      parms->session_handle = NULL;
      parms->idispatch  = NULL;
      parms->retcode    = -1;
      vgetpid(taskid);
      vendexcl(taskid, g08ComponentEnd );
      return;
    }
  }
  else
  {
    MSGD ((ERR_DCOM_DUMP_INFO,"eo38VDcomMonNext: parameter incorrect (heap not cleared)"));
    parms->retcode = -1;
  }
}

/*---------------------------------------------------------------------------*/

externC void eo38VDcomMonClose ( tsp_dcom_monitor_parms * parms )
{
  CHashEntryPtr           currSessEntry, newSessEntry;
  CCoClassHashPtr         HashPtr;
  parms->retcode = S_OK;
  tsp00_TaskId            taskid;
  
  if (NULL == parms->session_handle ) return;
  
  currSessEntry = REINTERPRET_CAST(CHashEntryPtr,parms->session_handle);
  while (parms->idispatch == REINTERPRET_CAST(char *, currSessEntry->getIUnknown()))
  {
    Release( REINTERPRET_CAST(IUnknown *, parms->idispatch)
      , "eo38VDcomMonClose:Release : unhandled exception" );
    
    newSessEntry  = currSessEntry->getNextEntry();
    
    /* re-chain to free chain */
    CWaitUntilAlone cs;                   
    HashPtr = REINTERPRET_CAST(CCoClassHashPtr, (DCOM_HEAD));
    HashPtr->chainFreeEntry(currSessEntry);
    cs.Leave();                           
    currSessEntry = newSessEntry;
  }
  parms->session_handle = NULL;
  parms->idispatch = 0; 

  vgetpid(taskid);
  vendexcl(taskid, g08ComponentEnd );
}

/*--* --- FF Change Request 1000139  --- *-----------------------------------*/

/*---------------------------------------------------------------------------*/

externC void eo38VDcomInvalidate ( tsp_dcom_co_create_instance_parms * parms )
{
  IID   actIId;
  CLSID actCoClsId;
  CHashEntryPtr  currEntry;
  CCoClassHash  *HashPtr = REINTERPRET_CAST(CCoClassHash*,(DCOM_HEAD));
  
  if ( NULL == HashPtr ) return;
  
  memcpy( &actIId, &parms->iid[0], sizeof(actIId)); 
  memcpy( &actCoClsId, &parms->coclsid[0], sizeof(actCoClsId)); 
  
  CWaitUntilAlone cs;                   
  HashPtr->ResetEntrySearch( 0, SearchALL_eeo38 );
  currEntry = HashPtr->NextEntry();  
  while ( NULL != currEntry)
  {
    if ((*(currEntry->getGuid())  == actIId) ||
      (*(currEntry->getGuid())  == actCoClsId))  
    {
      switch(currEntry->getType())
      {
      case CLSID_eeo38: 
        currEntry->setType(Invalid_CLSID_eeo38); 
        break;
      case IID_eeo38: 
        currEntry->setType(Invalid_IID_eeo38); 
        break;
      case DbgFactory_eeo38:
      case DbgInterface_eeo38:
      default:
        break;
      }
    }
    currEntry = HashPtr->NextEntry();  
  }
}

/*---------------------------------------------------------------------------*/

externC void eo38VDcomReleaseAll ( tsp00_Addr pI )
{
  LPCLASSFACTORY        lpIClassFactory;
  tsp00_Uint4           cnt;
  CHashEntryPtr         currEntry;
  CCoClassHash          *HashPtr;
  
  HashPtr = REINTERPRET_CAST(CCoClassHash*,(DCOM_HEAD));
  if ( NULL == HashPtr ) return;
  
  CWaitUntilAlone cs;                   
  HashPtr->ResetEntrySearch( 0, SearchALL_eeo38 );
  currEntry = HashPtr->GetRechainFirstEntry(NULL);  
  while ( NULL != currEntry)
  {
    if ( 0 == currEntry->getSession() )
    {
      lpIClassFactory = REINTERPRET_CAST(IClassFactory *,(currEntry->getIUnknown()));
      cnt = lpIClassFactory->Release ();
      cnt = lpIClassFactory->LockServer (FALSE);
    }
    currEntry = HashPtr->GetRechainFirstEntry(NULL);  
  }
}

/*---------------------------------------------------------------------------*/

externC void eo38VDcomTransEnd ( tsp_dcom_dispatch_parms * parms )
{
  const short      vt_ptr             = 26;
  bool             DebugSessionLocal  = false;
  bool             DebugSessionRemote = false;
  short            rc                 = 0;
  int                     i;
  tsp00_Uint4              session;
  short                   arrCnt = 0;
  IUnknown*               arrInterfaces[100];  
  CCoClassHashPtr         HashPtr;
  CHashEntryPtr           currEntry;
  teo39_Transend          *param_stack   = REINTERPRET_CAST(teo39_Transend*,parms->param_stack);
  tsp00_Int4              l_buflen;
  struct _aligned_buf
  {
    union 
    {
      teo39_TransendBuf       l_buf;
      integer                 align;
    } v;
  } aligned_buf;
#if defined(_IBMR2) || defined(SUN) || defined(PA11) || defined(PA20W) || defined(ALPHA) || defined(NMP) || defined(_WIN64) || (defined(LINUX) && defined(IA64))|| defined (HP_IA64)
  teo39_Transend_desc   l_param;
  l_param.lpbuflen.plVal       = &l_buflen;  
  l_param.lpbuflen.vt          = vt_ptr;  
  l_param.lpbuflen.io_flag     = 1;  
  l_param.lpbuflen.ptr_flag    = 1;  
  l_param.lpbuflen.len         = 4;  
  l_param.lpbuf.byref          = (void*)&aligned_buf.v.l_buf;
  l_param.lpbuf.vt             = vt_ptr;  
  l_param.lpbuf.io_flag        = 1;  
  l_param.lpbuf.ptr_flag       = 1;  
  l_param.lpbuf.len            = sizeof( teo39_TransendBufMsg );  
#else
  teo39_Transend        l_param;
  l_param.lpbuflen      = &l_buflen;  
  l_param.lpbuf         = &aligned_buf.v.l_buf;
#endif
  
  parms->hresult = 0;
  HashPtr = REINTERPRET_CAST(CCoClassHash*,(DCOM_HEAD));
  if ( NULL == HashPtr ) return;
  
  memcpy(&session, parms->session, sizeof(session));
  CWaitUntilAlone cs;                   
  HashPtr->ResetEntrySearch( session, SearchEQ_eeo38 );
  currEntry = HashPtr->NextEntry();
  
  while ( NULL != currEntry)
  {
    if ((currEntry->getType() == IID_eeo38) ||
      (currEntry->getType() == Invalid_IID_eeo38))  
    {
      /* Ignore special Interface, which is activated by DDL (CREATE DBPROC) */
      if ( IID_IliveCacheSpec != *(currEntry->getGuid()))
      {
        arrInterfaces[arrCnt] = currEntry->getIUnknown();
        arrCnt++;
      }
    }
    else
    {
      if (currEntry->getDebugFlag())
      {
        if (currEntry->getRemoteDbgFlag()) 
          DebugSessionRemote = true;
        else
          DebugSessionLocal  = true;
      }
    }
    currEntry = HashPtr->NextEntry();  
  }
  
  cs.Leave();                           
  
  HRESULT hr = 0;
  i = 0;                         
  if ( i < arrCnt )              
  {
    aligned_buf.v.l_buf.msg.mtype     = param_stack->lpbuf->msg.mtype;
    aligned_buf.v.l_buf.msg.mtype2    = param_stack->lpbuf->msg.mtype2;
    l_buflen            = sizeof( teo39_TransendBufMsg );
#if defined(_IBMR2) || defined(SUN) || defined(PA11) || defined(PA20W) || defined(ALPHA) || defined(NMP) || defined(_WIN64) || (defined(LINUX) && defined(IA64)|| defined (HP_IA64))
    parms->param_stack_len = 2 * sizeof(teo39_Variant);
#endif
    parms->param_stack  = REINTERPRET_CAST(tsp00_Void*,(&l_param));
    parms->hresult = arrInterfaces[i]->QueryInterface( IID_IliveCacheSpec, 
    REINTERPRET_CAST(void **,(&parms->idispatch)));
    if ( SUCCEEDED(parms->hresult))
    {
      eo38VDcomDispatch (parms);
      rc = aligned_buf.v.l_buf.err; 
      if ((0 != rc) || FAILED(parms->hresult))
      {
        char dmp_buf[132];
        MSGD ((ERR_DCOM_HRESULT, "eo38VDcomTransEnd: Error calling sysRequest", rc ));
        sprintf(dmp_buf,"mtype: %X  mtype2: %X ",
	(int)(param_stack->lpbuf->msg.mtype),
	(int)(param_stack->lpbuf->msg.mtype2));
        MSGD ((ERR_DCOM_DUMP_INFO,dmp_buf));
        hr = GEO00D_DCOM_TRANSEND_FAILED;       /* pts 1105922 FF 10-Mar-2000 */
        /*if ( !hr ) hr = parms->hresult;          pts 1105922                */
      }
      arrInterfaces[i]->Release();
     }
     else
     {
       MSGD ((ERR_DCOM_HRESULT, "eo38VDcomTransEnd:QI(ILCSpec)", parms->hresult ));
       hr = GEO00D_DCOM_TRANSEND_FAILED;       /* pts 1105922 FF 10-Mar-2000 */
     }
  }
  
  parms->param_stack  = REINTERPRET_CAST(tsp00_Void*,param_stack);
#if defined(_IBMR2) || defined(SUN) || defined(PA11) || defined(PA20W) || defined(ALPHA) || defined(NMP) || defined(_WIN64) || (defined(LINUX) && defined(IA64))|| defined (HP_IA64)
  parms->param_stack_len = sizeof( teo39_TransendBufMsg );
#endif

   /*  if (( 0 != rc ) || FAILED(hr))  pts 1105922 */
  if ( 0 != hr )     /* pts 1105922 FF 10-Mar-2000 */
  {
    eo38DisposeInstances( parms );
    parms->hresult = GEO00D_DCOM_TRANSEND_FAILED; 
  }
}

/*---------------------------------------------------------------------------*/


void eo38LoadLibraryEx(const char *path, 
                       bool      loadGlobal,
                       HANDLE    *hd,
                       char      *errtext,
                       int       errtext_size) 
{
  CWaitUntilAlone cs;                   /* PTS 1109279 */
  /*WAIT_UNTIL_ALONE (DCOM_EXCLUSIVE);     PTS 1109279 */

  bool found = false;
  CLoadedLibDirEntry_eo38 *curr;
  for ( cgg251dclIterator<CLoadedLibDirEntry_eo38*,CDefaultAllocator_eo38> iter = LoadedLibDir.begin(); iter; ++iter) {
    curr = *iter();
    if ( !strcmp(curr->getNamePtr(), path) ) {
      found = true;
      break;
    }
  }
  cs.Leave();                               /* PTS 1109279 */
  /*CLEARLOCK (DCOM_EXCLUSIVE); // PTS 1108905 PTS 1109279 */

  if ( found ) {
    curr->incrementUsedCount();
    *hd = curr->getHandle();
  }
  else {
    *hd = sqlLoadLibraryEx(CONST_CAST(char*,path), (loadGlobal) ? RTLD_GLOBAL_EO02 : RTLD_LOCAL_EO02, errtext, errtext_size);
    if ( *hd ) {
      try {
        curr = new CLoadedLibDirEntry_eo38(*hd, path, loadGlobal);
        cs.Enter();                                     
        LoadedLibDir.push_front(curr);
        cs.Leave();                                     
      }
      catch (DbpError&) {
        sqlFreeLibrary(*hd, errtext, errtext_size);
        *hd = NULL;
      }
    }
    else  {
      char buf[256];                                  
      sprintf(&buf[0],"eo38LoadLibraryEx - File: %.100s  err: %.64s", path, errtext );
      MSGD ((ERR_DCOM_DUMP_INFO, &buf[0] ));
    }
  }
};

/*---------------------------------------------------------------------------*/

void eo38FreeLibrary(HANDLE      hd,
                     bool        *ok,
                     char        *errtext,
                     int         errtext_size)
{
  CWaitUntilAlone cs;                   /* PTS 1109279 */
  /*WAIT_UNTIL_ALONE (DCOM_EXCLUSIVE);     PTS 1109279 */

  bool found = false;
  *ok = false;
  CLoadedLibDirEntry_eo38 *curr;
  for ( cgg251dclIterator<CLoadedLibDirEntry_eo38*,CDefaultAllocator_eo38> iter = LoadedLibDir.begin(); iter; ++iter) {
    curr = *iter();
    if ( curr->getHandle() == hd ) {
      short useCnt = curr->decrementUsedCount();
#if 0 /* PTS 1108386 */
      if ( false /* PTS 1107191, 0 == useCnt */) {
        LoadedLibDir.remove(iter);
        delete curr;
        if ( sqlFreeLibrary(hd, errtext, errtext_size)) 
          *ok = true;
        else
          *ok = false;
      }
      else
#endif
        *ok = true;
      break;
    }
  }

  /*CLEARLOCK (DCOM_EXCLUSIVE);       PTS 1109279 */
};

/*---------------------------------------------------------------------------*/

CIliveCacheSink::CIliveCacheSink() 
  : lpDefaultContext(NULL)
  , lpTaskContext(NULL)
  , lpCallTaskInfo(NULL)
  , lpSqlSessionContext(NULL)     /* PTS 1120804 */
  , lpOmsSessionAllocator(NULL)
  , lpSqlClsAllocator(NULL)
  , sqlErrorFlag(false)
  , CallbackIsActive(false)
  , m_pSessionUserAllocator(NULL)
  , m_pTransactionUserAllocator(NULL)
  , m_pCOMRoutineUserAllocator(NULL)
  , m_pSessionRawAllocator(NULL)
{
  for (int ix = 0; ix < OMS_SYS_REGION; ++ix)
  {
    m_inRegion[ix] = false;
  }
}

/*---------------------------------------------------------------------------*/

bool CIliveCacheSink::InitAllocator()
{
  try {
    // make sure allocators are instantiated
    OmsAllocatorInterface *dummy;
    GetCOMRoutineUserAllocator(dummy);
    GetSessionUserAllocator(dummy);
    GetTransactionUserAllocator(dummy);
    return true;
  } catch (...) {
    return false;
  }
}

/*---------------------------------------------------------------------------*/

void CIliveCacheSink::Destruct()
{
    if (m_pCOMRoutineUserAllocator)
    {
        destroy(m_pCOMRoutineUserAllocator, LVCMem_Allocator::Instance());
    }
    if (m_pTransactionUserAllocator)
    {
        destroy(m_pTransactionUserAllocator, LVCMem_Allocator::Instance());
    }
    if (m_pSessionUserAllocator)
    {
        destroy(m_pSessionUserAllocator, LVCMem_Allocator::Instance());
    }
    if (m_pSessionRawAllocator) 
    {
        // return to the pool
        RTESync_LockedScope lck(m_allocatorPoolLock);
        if (m_allocatorPoolFreelist) {
          AllocPool *p = m_allocatorPoolFreelist;
          m_allocatorPoolFreelist = p->m_next;
          p->m_allocator = m_pSessionRawAllocator;
          p->m_next = m_allocatorPool;
          m_allocatorPool = p;
        } else {
          m_allocatorPool = new(LVCMem_Allocator::Instance())
            AllocPool(m_pSessionRawAllocator, m_allocatorPool);
        }
    }

    if (lpOmsSessionAllocator)
    {
        destroy (lpOmsSessionAllocator, LVCMem_Allocator::Instance());
    }
    if (lpSqlClsAllocator)
    {
         destroy (lpSqlClsAllocator, LVCMem_Allocator::Instance());
    }
}

/*---------------------------------------------------------------------------*/

void *CIliveCacheSink::operator new( size_t stAllocateBlock, void *addr )
{
  return addr;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::QueryInterface ( REFIID iid, PVOID *ppv)
{
  if (memcmp (&iid, &IID_IUnknown, sizeof (IID)) == 0)
    *ppv = (void *) this;
  else if (memcmp (&iid, &IID_IliveCacheSink, sizeof (IID)) == 0)
    *ppv = (void *) this;
  else
  {
    *ppv = 0;
    return E_NOINTERFACE;
  }
  this->AddRef();
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP_(ULONG) CIliveCacheSink::AddRef(void)
{
  return S_OK;
}

/*---------------------------------------------------------------------------*/

CIliveCacheSink* CIliveCacheSink::GetSessionSink()
{
  tak_all_command_glob* pAcv = REINTERPRET_CAST(tak_all_command_glob*, vGetAcvPtrFromCurrentTask());
	if (0 != pAcv)
	{
		return REINTERPRET_CAST(CIliveCacheSink*, &pAcv->a_kernel_sink);
	}
	return 0;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP_(ULONG) CIliveCacheSink::Release(void)
{
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetDefaultContext (void** p, pasbool** pCancelByte, tsp00_TaskId& taskId)
{
  *p           = lpDefaultContext;
  *pCancelByte = &this->lpSessionContext->a_transinf.tri_trans.trRteCommPtr_gg00->to_cancel;
  taskId = this->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00; // PTS 1110315
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SetDefaultContext (void* p)
{
  lpDefaultContext = p;
  return S_OK;
}

/*----- PTS 1120804 ---------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetSqlSessionContext (void** p)
{
  *p           = lpSqlSessionContext;
  return S_OK;
}

/*----- PTS 1120804 ---------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SetSqlSessionContext (void* p)
{
  lpSqlSessionContext = p;
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetObj (
                                      tgg91_TransNo&                 consistentView,
                                      tgg00_ContainerId&             containerId, 
                                      const tgg00_OmsVersionContext* pVersionContext,
                                      const OmsTypeOid&              oid,
                                      bool                           doLock,
                                      tgg91_PageRef&                 objSeq,
                                      tsp00_Int4                     bodySize,
                                      unsigned char*                 pBody,
                                      tsp00_Int4&                    bodyLen,
                                      tsp00_Int4&                    histLogCount,
                                      tgg00_BasisError&              e)
{
  ENTER_SINK_METHOD(GetObj_method_idx);
  ak341GetObj (this->lpSessionContext,
    consistentView,
    containerId,
    pVersionContext,
    *REINTERPRET_CAST(const tgg92_KernelOid*, &oid),
    doLock,
    bodySize,
    REINTERPRET_CAST(tgg00_Rec*, pBody),
    bodyLen, 
    objSeq,
    histLogCount,
    e);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::UpdateObj(
                                        unsigned char  * lpConsistentView,
                                        unsigned char  * lpContainerId,
                                        unsigned char  * lpVersionContext,
                                        unsigned char  * lpoid,
                                        unsigned char  * lpobjseq,
                                        tsp00_Int4 bodysize,
                                        unsigned char  * lpbody,
                                        unsigned char  * lpcoldesc,
                                        short  * b_error)
{
  ENTER_SINK_METHOD(UpdateObj_method_idx);
  ak341UpdateObj (this->lpSessionContext,
     (tgg91_TransNo *)          lpConsistentView,
    (tgg00_ContainerId *)       lpContainerId,
    (tgg00_OmsVersionContext*)  lpVersionContext,
    REINTERPRET_CAST(tgg92_KernelOid *,         lpoid),
    (tgg91_PageRef *)           lpobjseq,
    bodysize,
    (tgg00_Rec *) lpbody,
    (tgg00_ObjColDesc *) lpcoldesc,
    b_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::NewObj(
                                     unsigned char   * lpConsistentView,
                                     unsigned char   * lpContainerId,
                                     unsigned char   * lpVersionContext,
                                     tsp00_Int4                       KeyPos,
                                     tsp00_Int4                       KeyColSize,
                                     unsigned char   * KeyColumn, 
                                     OmsTypeOid      * lpoid,
                                     unsigned char   * lpobjseq,
                                     short           * b_error)
{
  ENTER_SINK_METHOD(NewObj_method_idx);
  ak341NewObj (this->lpSessionContext,
    (tgg91_TransNo *)           lpConsistentView,
    (tgg00_ContainerId *)       lpContainerId,
    (tgg00_OmsVersionContext*)  lpVersionContext,
    KeyPos, 
    KeyColSize,
    (tsp00_MoveObj*)    KeyColumn,
    REINTERPRET_CAST(tgg92_KernelOid *, lpoid),
    (tgg91_PageRef *)   lpobjseq,
    b_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::RegisterClass(
                                            tsp00_Int4          SchemaId,
                                            GUID                *lpGUID,
                                            tsp00_KnlIdentifier *lpClassName,
                                            tsp00_Int4           size,
                                            OmsContainerNo       ContainerNo,
                                            unsigned char       *lpcoldesc,
                                            unsigned char       *lpContainerId,
                                            short               *b_error)
{
  ENTER_SINK_METHOD(RegisterClass_method_idx);
  a34RegisterClass (*this->lpSessionContext,
    SchemaId,
    *REINTERPRET_CAST(tsp00_C16*, lpGUID),
    *REINTERPRET_CAST(tsp00_KnlIdentifier*, lpClassName),
    size,
    ContainerNo,
    *REINTERPRET_CAST(tgg00_ObjColDesc*, lpcoldesc),
    *REINTERPRET_CAST(tgg00_ContainerId*, lpContainerId),
    *b_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::DeleteAllObj(
                                           tgg91_TransNo&   consistentView,                     
                                           unsigned char  * lpContainerId,
                                           unsigned char  * lpVersionContext,
                                           int            & lpDeleted,                    
                                           short          & b_error,
                                           OmsTypeOid     & errorOid)
{
    ENTER_SINK_METHOD(DeleteAllObj_method_idx);
    ak341DeleteAllObj (this->lpSessionContext,
        consistentView,
        (tgg00_ContainerId*) lpContainerId,
        (tgg00_OmsVersionContext*) lpVersionContext,
        lpDeleted,
        b_error,
        *REINTERPRET_CAST(tgg92_KernelOid*, &errorOid));
    LEAVE_SINK_METHOD(S_OK);
}
        
/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::DeleteObj(
                                        unsigned char  * lpConsistentView,
                                        unsigned char  * lpContainerId,
                                        unsigned char  * lpVersionContext,
                                        unsigned char  * lpoid,
                                        unsigned char  * lpobjseq,
                                        unsigned char  * lpcoldesc,
                                        short  * b_error)
{
  ENTER_SINK_METHOD(DeleteObj_method_idx);
  ak341DeleteObj (this->lpSessionContext,
    (tgg91_TransNo *)            lpConsistentView,
    (tgg00_ContainerId *)        lpContainerId,
    (tgg00_OmsVersionContext*)   lpVersionContext,
    (tgg92_KernelOid *)          lpoid,
    (tgg91_PageRef *)            lpobjseq,
    (tgg00_ObjColDesc *)         lpcoldesc,
    b_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::CloseVersion(
                      OmsVersionId    *lpVersionId,
                      tsp00_Int4             lastKey,
                      short  *b_error)
{
  ENTER_SINK_METHOD(CloseVersion_method_idx);
  ak341CloseVersion (this->lpSessionContext, 
    (tak_oms_version_id*) lpVersionId,
    lastKey,
    b_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::CreateOpenVersion(
                      unsigned char  *lpConsistentView,
                      OmsVersionId   *lpVersionId,
                      boolean         createVersion,
                      unsigned char  *lpVersionContext,
                      short          *b_error)
{
  ENTER_SINK_METHOD(CreateOpenVersion_method_idx);
  ak341CreateOpenVersion (this->lpSessionContext,
    (tgg91_TransNo *)           lpConsistentView,
    (tak_oms_version_id*)       lpVersionId,
                                createVersion,
    (tgg00_OmsVersionContext*)  lpVersionContext,
    b_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::CreateKeyRangeIterator(
           tgg91_TransNo&          consistentView,
           tgg00_OmsVersionContext *lpVersionContext,
           tgg00_FileId&           objFile,
           tsp00_Int4              keyLen,
           const void*             pStartKey,
           const void*             pStopKey,
           void**                  pKeyRangeIterator,
           short&                  e) 
{
  ENTER_SINK_METHOD(CreateKeyIterator_method_idx);
  ak341CreateKeyRangeIterator (*this->lpSessionContext,
    consistentView, 
    lpVersionContext,
    objFile,
    keyLen,
    pStartKey,
    pStopKey,
    pKeyRangeIterator,
    e);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::DestroyKeyRangeIterator
(
 void* pKeyRangeIterator
 ) 
{
  ENTER_SINK_METHOD(DestroyKeyIterator_method_idx);
  ak341DestroyKeyRangeIterator(*this->lpSessionContext, pKeyRangeIterator);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::NewConsistentView(
                      unsigned char  *lpConsistentView,
                      short          *b_error) 
{
  ENTER_SINK_METHOD(NewConsistentView_method_idx);
  ak341NewConsistentView (this->lpSessionContext, 
    (tgg91_TransNo *)           lpConsistentView,
    b_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::EndConsistentView(
                      unsigned char  *lpConsistentView,
                      short          *b_error) 
{
  ENTER_SINK_METHOD(EndConsistentView_method_idx);
  ak341EndConsistentView (this->lpSessionContext, 
    (tgg91_TransNo *)           lpConsistentView,
    b_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::EnterCriticalSection(short regionId) 
{
  ENTER_SINK_METHOD(EnterCriticalSection_method_idx);  
  ak341EnterCriticalSection (this->lpSessionContext, regionId);
  if (regionId < OMS_SYS_REGION)
  {
      m_inRegion[regionId] = true;
  }
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::LeaveCriticalSection(short regionId) 
{
  ENTER_SINK_METHOD(LeaveCriticalSection_method_idx);
  ak341LeaveCriticalSection (this->lpSessionContext, regionId);
  if (regionId < OMS_SYS_REGION)
  {
      m_inRegion[regionId] = false;
  }
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

/* PTS 1115134 */
STDMETHODIMP CIliveCacheSink::ResetVersion( 
                                           unsigned char *lpVersionContext,
                                           short  &error)
{
  ENTER_SINK_METHOD(ResetVersion_method_idx);
  ak341ResetVersion (*this->lpSessionContext,
    *REINTERPRET_CAST(tgg00_OmsVersionContext*, lpVersionContext), 
    error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::Rollback( 
                                       tsp00_Int4 buflen,
                                       unsigned char  * lpv,
                                       short  * lpb_error)
{
  ENTER_SINK_METHOD(Rollback_method_idx);
  a34Rollback (*this->lpSessionContext,
    *REINTERPRET_CAST(tsp00_MoveObj *, lpv),
    buflen,
    *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetObjWithKey (
                                             unsigned char  * lpConsistentView,
                                             unsigned char  * lptree,
                                             unsigned char  * lpVersionContext,
                                             tsp00_Int4                      keylen,
                                             unsigned char  * lpkey,
                                             boolean                   getConsistent,
                                             tsp00_Int4                      bodysize,
                                             unsigned char  * lpbody,
                                             OmsTypeOid     * lpoid,
                                             unsigned char  * lpobjseq,
                                             int            * hist_log_count, /* +++ Change Request 1000139 +++ */
                                             short          * lpb_error)
{
  ENTER_SINK_METHOD(GetObjWithKey_method_idx);
  ak341GetObjWithKey (this->lpSessionContext,
    (tgg91_TransNo *)          lpConsistentView,
    (tgg00_ContainerId *)      lptree,
    (tgg00_OmsVersionContext*) lpVersionContext,
    getConsistent,
    bodysize,
    lpbody,
    keylen,
    lpkey,
    (tgg91_PageRef *)   lpobjseq,
    REINTERPRET_CAST(tgg92_KernelOid *, lpoid),
    hist_log_count,
    lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SetError(short error,
                                       tsp00_Int4 buflen,
                                       const unsigned char  * lpv,
                                       tsp00_CodeType codeType)
{
  ENTER_SINK_METHOD(SetError_method_idx);
  a34SetError (*this->lpSessionContext,
    error,
    *REINTERPRET_CAST(tsp00_MoveObj*, CONST_CAST(unsigned char*, lpv)),
    buflen,
    codeType);
  this->CallbackIsActive = false;
  sqlErrorFlag = true;    /* PTS 1110814 */
  
#ifdef WIN32
  tsp00_Uint4 status;
  if (e_terminate == error) {
    status = STATUS_TERMINATE_EXCEPTION;
  }
  else {
    status = STATUS_SETERROR_EXCEPTION;
  }
  if ( g01is_livecache() )  /* 1110814 FF */   
    RaiseException (status,
    0,            /* continuable exception */
    0,            /* number of parms       */
    NULL);        /* &parms                */
#else
  if ( g01is_livecache() )  /* 1110814 FF */   
    throw RTE_DBProcError(error);
#endif        
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SubtransStart( 
                                            short  * lpb_error)
{
  ENTER_SINK_METHOD(SubtransStart_method_idx);
  a34SubtransStart (*this->lpSessionContext,
    *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SubtransCommit( 
                                             short  * lpb_error)
{
  ENTER_SINK_METHOD(SubtransCommit_method_idx);
  a34SubtransCommit (*this->lpSessionContext,
    *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SubtransRollback( 
                                               short  * lpb_error)
{
  ENTER_SINK_METHOD(SubtransRollback_method_idx);
  a34SubtransRollback (*this->lpSessionContext,
    *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::Vtrace( 
                                     tsp00_Int4 buflen,
                                     unsigned char  * lpv)
{
  ENTER_SINK_METHOD(Vtrace_method_idx);
  a34VTrace (*this->lpSessionContext,
    *REINTERPRET_CAST(tsp00_MoveObj*, lpv),
    buflen);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::LockObj(
                                      unsigned char  * lpConsistentView,
                                      unsigned char  * lpContainerId,
                                      OmsTypeOid     * lpoid,
                                      unsigned char  * lpobjseq,
                                      short          * lpb_error)
{
  ENTER_SINK_METHOD(LockObj_method_idx);
  ak341LockObj (this->lpSessionContext, 
    (tgg91_TransNo *)     lpConsistentView,
    (tgg00_ContainerId *) lpContainerId,
    REINTERPRET_CAST(tgg92_KernelOid *,   lpoid),
    (tgg91_PageRef *)     lpobjseq,
    lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::LockUpdObj(unsigned char  * lpConsistentView,
                                      unsigned char  * lpContainerId,
                                      OmsTypeOid     * lpoid,
                                      unsigned char  * lpobjseq,
                                      short          * lpb_error)
{
  ENTER_SINK_METHOD(LockUpdObj_method_idx);
  ak341LockUpdObj (this->lpSessionContext, 
    (tgg91_TransNo *)     lpConsistentView,
    (tgg00_ContainerId *) lpContainerId,
    REINTERPRET_CAST(tgg92_KernelOid *,   lpoid),
    (tgg91_PageRef *)     lpobjseq,
    lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::BasisError( 
                                         short basis_error)
{
  ENTER_SINK_METHOD(BasisError_method_idx);
  a34BasisError (*this->lpSessionContext,
    basis_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::HResultError( 
                                           HRESULT hresult_error)
{
  ENTER_SINK_METHOD(HResultError_method_idx);
  a34HResultError (*this->lpSessionContext,
    hresult_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::AllocPacket(unsigned char  ** lpv,
                                          tsp00_Int4 *sz)
{
  ENTER_SINK_METHOD(AllocPacket_method_idx);
  a34AllocPacket (*this->lpSessionContext, 
    *REINTERPRET_CAST(tsp1_packet_ptr *, lpv), 
    *sz);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SQLRequest(tsp00_Int4 buflen,
                                         unsigned char  * lpv,
                                         short *lperror)
{
  ENTER_SINK_METHOD(SQLRequest_method_idx);
  a34Request (*this->lpSessionContext,
    (tsp1_packet_ptr) lpv);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SQLReceive(unsigned char  ** lpv)
{
  ENTER_SINK_METHOD(SQLReceive_method_idx);
  a34Receive (*this->lpSessionContext,
    *REINTERPRET_CAST(tsp1_packet_ptr*, lpv));
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::NextObj(unsigned char  * lpConsistentView,
                                      unsigned char  * lpContainerId,
                                      unsigned char  * lpVersionContext,
                                      OmsTypeOid     * lpoid,
                                      unsigned char  * lpobjseq,
                                      tsp00_Int4 bodysize,
                                      unsigned char  * lpbody,
                                      tsp00_Int4&      objHistReadCount, // PTS 1107819 TA 13/09/2000
                                      short  * b_error)
{
  ENTER_SINK_METHOD(NextObj_method_idx);
  ak341NextObj (this->lpSessionContext,
    (tgg91_TransNo *)          lpConsistentView,
    (tgg00_ContainerId *)      lpContainerId,
    (tgg00_OmsVersionContext*) lpVersionContext,
    REINTERPRET_CAST(tgg92_KernelOid *,        lpoid),
    bodysize,
    lpbody,
    REINTERPRET_CAST(tgg91_PageRef *,(lpobjseq)),
    objHistReadCount, // PTS 1107819 TA 13/09/2000
    b_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::VersionNextKey(
                            tgg00_OmsVersionContext* VersionContext,
                            const tgg00_ContainerId& ObjFile,
                            void*                    pKey,
                            tsp00_Int4               KeyLen,
                            bool                     Inclusive,
                            const void*              pStopKey,
                            OmsTypeOid&              Oid,
                            tgg00_BasisError&        e) 
{
  ENTER_SINK_METHOD(NextObj_method_idx);
  ak341VersionNextKey (*this->lpSessionContext,
      VersionContext,
      ObjFile,
      pKey,
      KeyLen,
      Inclusive,
      CONST_CAST(void*, pStopKey),
      *REINTERPRET_CAST(tgg92_KernelOid *, &Oid), 
      e);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::NextObjFromKeyIterator (
                            void                    *pKeyIterator,
                            tgg00_OmsVersionContext *VersionContext,
                            tgg00_ContainerId       &ObjFile,
                            tsp00_Int4              ObjBodySize,
                            void                    *pObjBody,
                            OmsTypeOid              &ResultOId, 
                            tgg91_PageRef           &ResultObjVers,
                            tsp00_Int4              &LogReadAccesses,
                            tsp00_Int2              &e)
{
  ENTER_SINK_METHOD(NextObjFromKeyIter_method_idx);
  ak341NextObjFromKeyIterator (*this->lpSessionContext,
    pKeyIterator,
    ObjFile,
    VersionContext,
    ObjBodySize,
    pObjBody,
    *REINTERPRET_CAST(tgg92_KernelOid*, &ResultOId), 
    ResultObjVers,
    LogReadAccesses,
    e);
  LEAVE_SINK_METHOD(S_OK);
}
 
/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::ABAPRead( 
            /* [out][in] */ OmsTypeInt4   &tabHandle,
            /* [out]     */ OmsTypeInt4   &count,
            /* [out]     */ OmsTypeInt4   &bufSize,
            /* [out]     */ OmsTypeByte*  &buf,
            /* [out]     */ short         &error)
{
  ENTER_SINK_METHOD(ABAPRead_method_idx);
  tsp00_MoveObjPtr pBuf;
  a34AbapRead (*this->lpSessionContext,
    *REINTERPRET_CAST(tsp00_MoveObj*, &tabHandle),
    count,
    bufSize,
    pBuf,
    error);
  buf = REINTERPRET_CAST(OmsTypeByte*, pBuf);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::ABAPWrite( 
                                        OmsTypeInt4   * TabHandle,
                                        tsp00_Int4    row_size,
                                        tsp00_Int4    row_count,
                                        unsigned char * lpv,
                                        short         * lpb_error)
{
  ENTER_SINK_METHOD(ABAPWrite_method_idx);
  a34AbapWrite (*this->lpSessionContext,
    *REINTERPRET_CAST(tsp00_MoveObj*, TabHandle),
    row_size,
    row_count,
    *REINTERPRET_CAST(tsp00_MoveObj*, lpv),
    *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetErrorMsg(short errorno,
                                          tsp00_Int4 *lpbuflen,
                                          unsigned char  * lpv)
{
  ENTER_SINK_METHOD(GetErrorMsg_method_idx);
  tsp00_Int2 e = errorno;
  a34GetErrormsg (*this->lpSessionContext,
    e,
    *REINTERPRET_CAST(tsp00_MoveObj*, lpv),
    *REINTERPRET_CAST(int *,(lpbuflen)));
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::MultiPurpose (unsigned char MessType,
                                            unsigned char MessType2,
                                            tsp00_Int4           *lpbuflen,
                                            unsigned char  *lpv,
                                            short          *lpb_error)
{
  ENTER_SINK_METHOD(MultiPurpose_method_idx);
  tgg00_MessType  l_MessType;                            /* PTS 1106619 FF */
  tgg00_MessType2 l_MessType2;                           /* PTS 1106619 FF */
  l_MessType.becomes( (tgg00_MessType_Enum)MessType );   /* PTS 1106619 FF */
  l_MessType2.becomes( (tgg00_MessType2_Enum)MessType2 );/* PTS 1106619 FF */
  
  ak341MultiPurpose (this->lpSessionContext,
    /*  *REINTERPRET_CAST(tgg00_MessType*,  (&MessType)),  PTS 1106619 FF */
    /*  *REINTERPRET_CAST(tgg00_MessType2*, (&MessType2)), PTS 1106619 FF */
    l_MessType,           /* PTS 1106619 FF */ 
    l_MessType2,          /* PTS 1106619 FF */
    REINTERPRET_CAST(int*, (lpbuflen)),
    (tsp00_MoveObj *) lpv,
    lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::UnlockObj(unsigned char  * lpContainerId,
                                        OmsTypeOid     * lpoid,
                                        short          * lpb_error)
{
  ENTER_SINK_METHOD(UnlockObj_method_idx);
  ak341UnlockObj (this->lpSessionContext, 
    (tgg00_ContainerId *) lpContainerId,
    REINTERPRET_CAST(tgg92_KernelOid *, lpoid),
    lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::IsLocked(unsigned char  * lpContainerId,
                                       OmsTypeOid     * lpoid,
                                       short          * lpb_error)
{
  ENTER_SINK_METHOD(IsLocked_method_idx);
  ak341IsLocked (this->lpSessionContext, 
    (tgg00_ContainerId *) lpContainerId,
    REINTERPRET_CAST(tgg92_KernelOid *, lpoid),
    lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::IsDebugEnvironment( void)
{
  return 0;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::ConsoleMsg( 
                                         tsp00_Int4 buflen,
                                         unsigned char  * lpv)
{
  ENTER_SINK_METHOD(ConsoleMsg_method_idx);
  unsigned char dmp_buf[132];
  if ( buflen >= sizeof(dmp_buf)) buflen = sizeof(dmp_buf) - 1;
  memcpy(dmp_buf,lpv,buflen);
  dmp_buf[buflen] = '\0';
  MSGD ((ERR_DCOM_PROXY_MSG,dmp_buf));
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::DropFile(char  *lpFileName,
                                       short &error)
{
  ENTER_SINK_METHOD(DropFile_method_idx);
  tsp00_VfReturn_Param Error;
  eo15RemoveMessageFile(lpFileName, Error);
  if (vf_ok == Error) {
    error = e_ok;
  }
  else {
    char buf[132];                                  
    sprintf(&buf[0],"DropFile: %.100s  err: %d ", lpFileName, Error );
    MSGD ((ERR_DCOM_DUMP_INFO,buf));
    error = a07_return_code (e_hostfile_error, sqlm_adabas);
  }
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::ExistsFile(char  *lpFileName,
                                       bool     &doesExist,
                                       bool     &isDirectory,
                                       short    &error)
{
  ENTER_SINK_METHOD(ExistsFile_method_idx);
  tsp00_VfReturn_Param Error;
  eo15CheckExist(lpFileName, doesExist, isDirectory, Error);
  if (vf_ok == Error) {
    error = e_ok;
  }
  else {
    char buf[132];                                  
    sprintf(&buf[0],"ExistsFile: %.100s  err: %d ", lpFileName, Error );
    MSGD ((ERR_DCOM_DUMP_INFO,buf));
    error = a07_return_code (e_hostfile_error, sqlm_adabas);
  }
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetWorkingDirectory(tsp00_Pathc& path,
                                       short  &error)
{
  ENTER_SINK_METHOD(GetWorkingDirectory_method_idx);
  tsp00_VfReturn_Param Error;
  RTESys_IOGetWorkingDirectory(path, Error);
  if (vf_ok == Error) {
    error = e_ok;
  }
  else {
    char buf[132];                                  
    sprintf(&buf[0],"GetWorkingDirectory  err: %d ", Error );
    MSGD ((ERR_DCOM_DUMP_INFO,buf));
    error = a07_return_code (e_hostfile_error, sqlm_adabas);
  }
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetDbrootSapPath(tsp00_Pathc& path,
                                       short  &error)
{
  ENTER_SINK_METHOD(GetDbrootSapPath_method_idx);
  tsp01_RteError rteError;
  if (sqlGetDbrootSapPath (path, TERM_WITH_DELIMITER_EO01, &rteError)) {
    error = e_ok;
  }
  else {
    char buf[256];                                  
    memcpy (&path[0], &rteError.RteErrText[0], sizeof(rteError.RteErrText));
    path[sizeof(rteError.RteErrText)] = 0;
    sprintf(&buf[0],"GetDbrootSapPath  rteError: %d %.80s", rteError.RteErrCode, rteError.RteErrText );
    MSGD ((ERR_DCOM_DUMP_INFO,buf));
    sprintf(&buf[0],"GetDbrootSapPath  osError: %d %.80s", rteError.OsErrCode, rteError.OsErrText );
    MSGD ((ERR_DCOM_DUMP_INFO,buf));
    error = a07_return_code (e_hostfile_error, sqlm_adabas);
  }
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::OpenFile(char  *lpFileName,
                                       tsp00_Uint4 FileSize,
                                       boolean     doNotInit,
                                       tsp00_Int4  *FileHandle,
                                       short       *lpb_error)
{
  ENTER_SINK_METHOD(OpenFile_method_idx);
  tsp00_VfReturn_Param Error;
  *FileHandle = eo15OpenMessageFile(lpFileName, (teo15_Position)FileSize, (doNotInit!=0), Error);
  if (vf_ok == Error) {
    *lpb_error = e_ok;
  }
  else {
    char buf[256];
    sprintf(&buf[0],"OpenFile: %.200s filesize %d [%sforce init] err: %d ", lpFileName, FileSize, (doNotInit ? "no " : ""), Error );
    MSGD ((ERR_DCOM_DUMP_INFO,buf));
    *lpb_error = a07_return_code (e_hostfile_error, sqlm_adabas);
  }
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::WriteFile(tsp00_Int4 FileHandle,
                                        char   *msg,
                                        short  *lpb_error)
{
  ENTER_SINK_METHOD(WriteFile_method_idx);
  tsp00_VfReturn_Param Error;
  eo15WriteMessageFile(FileHandle, msg, Error);
  if (vf_ok == Error) {
    *lpb_error = e_ok;
  }
  else {
    char buf[132];                                  
    sprintf(&buf[0],"WriteFile hd: %d  err: %d ", FileHandle, Error );
    MSGD ((ERR_DCOM_DUMP_INFO,buf));
    *lpb_error = a07_return_code (e_hostfile_error, sqlm_adabas);
  }                                     
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::CloseFile(tsp00_Int4 FileHandle,
                                        short  *lpb_error)
{
  ENTER_SINK_METHOD(CloseFile_method_idx);
  tsp00_VfReturn_Param Error;
  eo15CloseMessageFile(FileHandle, Error);
  if (vf_ok == Error) {
    *lpb_error = e_ok;
  }
  else {
    char buf[132];                                  
    sprintf(&buf[0],"CloseFile: %d  err: %d ", FileHandle, Error );
    MSGD ((ERR_DCOM_DUMP_INFO,buf));
    *lpb_error = a07_return_code (e_hostfile_error, sqlm_adabas);
  }                                        
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SyncFile(char       *lpFileName,
                                       tsp00_Int4 FileHandle,
                                       short      *lpb_error) 
{
  ENTER_SINK_METHOD(SyncFile_method_idx);
  tsp00_VfReturn_Param Error;
  if (NULL != lpFileName) {
    eo15SyncNamedMessageFile(lpFileName, Error);
  }
  else {
    eo15SyncMessageFile(FileHandle, Error);
  }
  if (vf_ok == Error) {
    *lpb_error = e_ok;
  }
  else {
    char buf[132];                                  
    if (NULL != lpFileName) 
      sprintf(&buf[0],"SyncFile %.100s err: %d ", lpFileName, Error );
    else
      sprintf(&buf[0],"SyncFile hd: %d err: %d ", FileHandle, Error );
    MSGD ((ERR_DCOM_DUMP_INFO,buf));
    *lpb_error = a07_return_code (e_hostfile_error, sqlm_adabas);
  }                                 
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetDateTime(tsp00_Date* Date,
                                          tsp00_Time* Time) 
{
  ENTER_SINK_METHOD(GetDateTime_method_idx);
  vdattime(*Date, *Time);                       
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetClock(tsp00_Int4* Sec,
                                       tsp00_Int4* MSec) 
{
  ENTER_SINK_METHOD(GetClock_method_idx);
  vclock(Sec, MSec);                       
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::DropVersion(unsigned char *lpVersionContext,
                                          short         *lpb_error)
{
  ENTER_SINK_METHOD(DropVersion_method_idx);
  ak341DropVersion (*this->lpSessionContext,
    *REINTERPRET_CAST(tgg00_OmsVersionContext*, lpVersionContext),
    *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::CreateSchema(const OmsTypeWyde *SchemaName,
                                          tsp00_Int4         *SchemaId,
                                          short              *lpb_error)
{
  ENTER_SINK_METHOD(CreateSchema_method_idx);
  a34CreateSchema (*this->lpSessionContext, 
    *REINTERPRET_CAST(tak_WydeArray*, CONST_CAST(OmsTypeWyde*, SchemaName)), *SchemaId, *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::ExistsSchema(const OmsTypeWyde   *SchemaName,
                                          tsp00_Int4           *SchemaId,
                                          short                *lpb_error)
{
  ENTER_SINK_METHOD(ExistsSchema_method_idx);
  a34ExistsSchema (*this->lpSessionContext, 
    *REINTERPRET_CAST(tak_WydeArray*, CONST_CAST(OmsTypeWyde*, SchemaName)), *SchemaId, *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::DropContainer(OmsSchemaHandle schema,
                                         const GUID&        guid,
                                         OmsContainerNo     cno,
                                         tgg00_BasisError&  error)
{
  ENTER_SINK_METHOD(DropContainer_method_idx);
  a34DropContainer (*this->lpSessionContext, schema, *REINTERPRET_CAST(tsp_c16*, CONST_CAST(GUID*, &guid)), cno, error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::DropSchema(tsp00_Int4 SchemaId,
                                         short      *lpb_error)
{
  ENTER_SINK_METHOD(DropSchema_method_idx);
  a34DropSchema (*this->lpSessionContext, SchemaId, *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetSchemaName(tsp00_Int4 SchemaId,
                                         OmsTypeWyde   *SchemaName,
                                         short         *lpb_error)
{
  ENTER_SINK_METHOD(GetSchemaName_method_idx);
  a34GetSchemaName (*this->lpSessionContext, SchemaId, 
    *REINTERPRET_CAST(tak_WydeArray*, SchemaName), *lpb_error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::LoadLibraryEx(const char  *path, 
                                            bool        loadGlobal,
                                            HANDLE      *hd,
                                            tsp_errtext &errtext,
                                            int         errtext_size)
{
  ENTER_SINK_METHOD(LoadLibraryEx_method_idx);
  eo38LoadLibraryEx(path, loadGlobal, hd, errtext, errtext_size);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::Reschedule() /* PTS 1107849 */
{
  ENTER_SINK_METHOD(Reschedule_method_idx);
  vsleep(this->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00, 0);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::FreeLibrary(HANDLE      hd,
                                          bool        &ok,
                                          tsp_errtext &errtext,
                                          int         errtext_size)
{
  ENTER_SINK_METHOD(FreeLibrary_method_idx);
  eo38FreeLibrary(hd, &ok, errtext, errtext_size);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetContainerInfo(tsp00_Uint4 containerHandle,
            GUID&            guid,
            OmsSchemaHandle& schema,
            OmsContainerNo&  cno,
            short&           error)
{
  ENTER_SINK_METHOD(GetContainerInfo_method_idx);
  a34GetContainerInfo (*this->lpSessionContext,
    containerHandle,
    *REINTERPRET_CAST(tsp00_C16*, &guid),
    (tsp00_Int4&) schema, 
    (tsp00_Int4&) cno,
    error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::IsObjHistoryUsed( 
            tgg00_ContainerId& containerId, 
            const OmsTypeOid&  oid,
            bool&              isUsed,
            tgg00_BasisError&  e) 
{
  ENTER_SINK_METHOD(IsObjHistoryUsed_method_idx);
  a34IsObjHistoryUsed (*this->lpSessionContext,
    containerId,
    *REINTERPRET_CAST(const tgg92_KernelOid*, &oid),
    isUsed, 
    e);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::Signal(tsp00_TaskId taskId, tsp00_Bool ok) // PTS 1110315
{
  ENTER_SINK_METHOD(Signal_method_idx);
  vsignal(taskId, ok);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::Wait(tsp00_Bool& ok) // PTS 1110315
{
  ENTER_SINK_METHOD(Wait_method_idx);
  vwait(this->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00, ok);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::ExistsContainer(
            /* [in]  */ tsp00_Int4     SchemaId,
            /* [in]  */ const GUID&    Guid,
            /* [in]  */ OmsContainerNo ContainerNo,
            /* [out] */ short&         error)  // PTS 1110334
{
  ENTER_SINK_METHOD(ExistsContainer_method_idx);
  a34ExistsContainer(*this->lpSessionContext, SchemaId,
    *REINTERPRET_CAST(tsp00_C16*, CONST_CAST(GUID*, &Guid)), ContainerNo, error);
  LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetSessionHeapUsage(
            /* [out] */ tsp00_8ByteCounter& heapUsage) 
{
  heapUsage = this->lpSessionContext->a_allocatorInfo.ai_alloc_sys.ami_Allocated +
    this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_Allocated;
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SimCtlDumpToHtml(
	OmsHandle			&handle,
	const OmsObjectId	&obj, 
	class OmsSimDumpCollector	&str)
{
	// TODO
	return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SimCtlGetHTMLRef(
	class OmsHandle				&handle,
	const struct OmsObjectId	&obj,
	const char					**data,
	int                         flags)
{
	*data = "";
	return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SimCtlSetObjectName(
	OmsHandle			&handle,
	const OmsObjectId	&obj,
	const char			*name)
{
	return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SimCtlGetObjectName(
	OmsHandle			&handle,
	const OmsObjectId	&obj,
	const char			**name)
{
	*name = NULL;
	return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::SimCtlDestroyHandleCB(
	class OmsHandle				&handle,
	struct IliveCacheSink		**session)
{
	return S_OK;
}

/*---------------------------------------------------------------------------*/

class OmsGlobalAllocatorHash {
public:
  class Item {
  public:
    SAPDB_UTF8                m_name[40+1]; // allocator name
    LVCMem_UserAllocator  *m_alloc;     // allocator
    Item                      *m_next;      // next in hash bucket

    Item(LVCMem_UserAllocator *alloc, const SAPDB_UTF8 *name, Item *next)
      : m_alloc(alloc), m_next(next)
    {
      strncpy(reinterpret_cast<char*>(&m_name[0]), 
        reinterpret_cast<const char*>(name), 40);
      m_name[40] = 0;
    }
  };

  typedef Item *PItem;

  enum {
    BUCKET_CNT  = 127
  };
  
  OmsGlobalAllocatorHash()
  {
    for (int i = 0; i < BUCKET_CNT; ++i) {
      m_buckets[i] = NULL;
    }
  }

  size_t hash(const SAPDB_UTF8 *name)
  {
    size_t val = 0;
    while (*name) {
      val = (val << 1) ^ (val >> 31) ^ *(name++);
    }
    return val;
  }

  LVCMem_UserAllocator *get(const SAPDB_UTF8 *name, CIliveCacheSink *sink)
  {
    if (name == NULL) {
      name = (const SAPDB_UTF8*) "";
    }
    size_t bucket = hash(name) % BUCKET_CNT;

    RTESync_LockedScope lck(m_lock);

    Item *i = m_buckets[bucket];
    while (i) {
      if (strncmp(reinterpret_cast<const char*>(name),
        reinterpret_cast<const char*>(&i->m_name[0]), 40) == 0) {
        return i->m_alloc;
      }
      i = i->m_next;
    }

    // create new allocator
    if (*name == 0) {
      name = (const SAPDB_UTF8*) "Global User Alloc";
    }
    LVCMem_UserAllocator *alloc = ::new(LVCMem_Allocator::Instance()) 
      LVCMem_UserAllocator(name, LVCMem_Allocator::Instance(), 32 * 1024, 32 * 1024, 
      SAPDBMem_RawAllocator::FREE_RAW_EXTENDS);
    alloc->SetBadAllocHandler(SAPDBMem_RawAllocator::THROW_STD_BAD_ALLOC);

    m_buckets[bucket] = ::new(LVCMem_Allocator::Instance()) Item(alloc, name, m_buckets[bucket]);
    return alloc;
  }

private:
  RTESync_Spinlock  m_lock;
  PItem             m_buckets[BUCKET_CNT];
};

static OmsGlobalAllocatorHash GlobalAllocHash_eo38;


/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetSessionAllocator(SAPDBMem_RawAllocator* &allocator)
{
  if (!m_pSessionRawAllocator) {
    {
      RTESync_LockedScope lck(m_allocatorPoolLock);
      if (m_allocatorPool) {
        // use allocator from pool
        AllocPool *p = m_allocatorPool;
        m_pSessionRawAllocator = allocator = p->m_allocator;
        m_allocatorPool = p->m_next;
        p->m_next = m_allocatorPoolFreelist;
        m_allocatorPoolFreelist = p;
        return S_OK;
      }
    }
	m_pSessionRawAllocator = ::new (LVCMem_Allocator::Instance()) 
		LVCMem_UserAllocator(reinterpret_cast<const unsigned char*>("OMS Session"),
		LVCMem_Allocator::Instance(),
		32 * 1024, 32 * 1024, SAPDBMem_RawAllocator::FREE_RAW_EXTENDS);
    m_pSessionRawAllocator->SetBadAllocHandler(SAPDBMem_RawAllocator::THROW_STD_BAD_ALLOC);
  }
  allocator = m_pSessionRawAllocator;
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetOmsSessionAllocator(SAPDBMem_RawAllocator* &allocator)
{
    if (NULL == this->lpOmsSessionAllocator)
    {
        SAPDB_UTF8 identifier[40];
        sp77sprintf((char *)identifier, sizeof(identifier), "OmsSession  T%03d", 
            this->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00);
        lpOmsSessionAllocator = ::new (LVCMem_Allocator::Instance()) 
            SAPDBMem_RawAllocator(&identifier[0],
            *REINTERPRET_CAST(SAPDBMem_RawAllocator*, this->lpSessionContext->a_transinf.tri_trans.trAllocator_gg00),
            32 * 1024, 32 * 1024, SAPDBMem_RawAllocator::FREE_RAW_EXTENDS);
        lpOmsSessionAllocator->SetBadAllocHandler(SAPDBMem_RawAllocator::THROW_STD_BAD_ALLOC);
    }
    allocator = lpOmsSessionAllocator;
    return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetSqlClsAllocator(SAPDBMem_RawAllocator* &allocator)
{
    if (NULL == this->lpSqlClsAllocator)
    {
        SAPDB_UTF8 identifier[40];
        sp77sprintf((char *)identifier, sizeof(identifier), "SqlCls  T%03d", 
            this->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00);
        lpSqlClsAllocator = ::new (LVCMem_Allocator::Instance()) 
            SAPDBMem_RawAllocator(&identifier[0],
            LVCMem_Allocator::Instance(),
            32 * 1024, 32 * 1024, SAPDBMem_RawAllocator::FREE_RAW_EXTENDS);
        lpSqlClsAllocator->SetBadAllocHandler(SAPDBMem_RawAllocator::THROW_STD_BAD_ALLOC);
    }
    allocator = lpSqlClsAllocator;
    return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::IsInRegion(
                                         /* [in]  */ int   regionId,
                                         /* [out] */ bool& inRegion) 
{
    if (regionId < OMS_SYS_REGION)
    {
      inRegion = (m_inRegion[regionId] ? true : false);
    }
    else
    {
        inRegion = false;
        throw DbpError(DbpError::RTE_ERROR, e_not_implemented);
    }
    return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetGlobalUserAllocator(
        OmsAllocatorInterface* &allocator, const char *name)
{
  allocator = GlobalAllocHash_eo38.get(reinterpret_cast<const SAPDB_UTF8*>(name), this); 
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetSessionUserAllocator(
        OmsAllocatorInterface* &allocator)
{
  if (!m_pSessionUserAllocator) {
    SAPDBMem_RawAllocator *alloc;
    GetSessionAllocator(alloc);
    SAPDB_UTF8 identifier[40];
    sp77sprintf((char *)identifier, sizeof(identifier), "OmsSessionUser T%03d", 
            this->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00);
    m_pSessionUserAllocator = ::new(LVCMem_Allocator::Instance()) 
      LVCMem_CheckedUserAllocator(&identifier[0], alloc, OmsCallbackInterface::BlockSession);
    //m_pSessionUserAllocator->omsRegisterCallback(reinterpret_cast<OmsSession_co12*>(
    //  lpDefaultContext)->GetCallbackInterface());
  }
  allocator = m_pSessionUserAllocator;
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetTransactionUserAllocator(
        OmsAllocatorInterface* &allocator)
{
  if (!m_pTransactionUserAllocator) {
    SAPDBMem_RawAllocator *alloc;
    GetSessionAllocator(alloc);
    SAPDB_UTF8 identifier[40];
    sp77sprintf((char *)identifier, sizeof(identifier), "OmsSessionTrans T%03d", 
            this->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00);
    m_pTransactionUserAllocator = ::new(LVCMem_Allocator::Instance()) 
      LVCMem_CheckedUserAllocator(&identifier[0], alloc, OmsCallbackInterface::BlockTransaction);
    //m_pTransactionUserAllocator->omsRegisterCallback(reinterpret_cast<OmsSession_co12*>(
    //  lpDefaultContext)->GetCallbackInterface());
  }
  allocator = m_pTransactionUserAllocator;
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::GetCOMRoutineUserAllocator(
        OmsAllocatorInterface* &allocator)
{
  if (!m_pCOMRoutineUserAllocator) {
    SAPDBMem_RawAllocator *alloc;
    GetSessionAllocator(alloc);
    SAPDB_UTF8 identifier[40];
    sp77sprintf((char *)identifier, sizeof(identifier), "OmsSessionCall T%03d", 
            this->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00);
    m_pCOMRoutineUserAllocator = ::new(LVCMem_Allocator::Instance()) 
      LVCMem_CheckedUserAllocator(&identifier[0], alloc, OmsCallbackInterface::BlockCOMRoutine);
    //m_pCOMRoutineUserAllocator->omsRegisterCallback(reinterpret_cast<OmsSession_co12*>(
    //  lpDefaultContext)->GetCallbackInterface());
  }
  allocator = m_pCOMRoutineUserAllocator;
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::UserAllocatorCtl(
        int msg, void *param)
{
  switch (msg) {
  case OmsCallbackInterface::BlockSession:
    // check session allocator empty
    if (m_pSessionUserAllocator) {
      m_pSessionUserAllocator->omsCheckAllocatorEmpty();
    }
    // no break;
  case OmsCallbackInterface::BlockTransaction:
    // check transaction allocator empty
    if (m_pTransactionUserAllocator) {
      m_pTransactionUserAllocator->omsCheckAllocatorEmpty();
    }
    // no break;
  case OmsCallbackInterface::BlockCOMRoutine:
    // check COM routine allocator empty
    if (m_pCOMRoutineUserAllocator) {
      m_pCOMRoutineUserAllocator->omsCheckAllocatorEmpty();
    }
    break;
  case OmsCallbackInterface::BlockUnregister:
    // remove all callbacks
    if (m_pSessionUserAllocator) {
      m_pSessionUserAllocator->omsRegisterCallback(NULL);
    }
    if (m_pTransactionUserAllocator) {
      m_pTransactionUserAllocator->omsRegisterCallback(NULL);
    }
    if (m_pCOMRoutineUserAllocator) {
      m_pCOMRoutineUserAllocator->omsRegisterCallback(NULL);
    }
    break;
  }
  return S_OK;
}

/*---------------------------------------------------------------------------*/

STDMETHODIMP CIliveCacheSink::IsUnicodeInstance(bool& isUnicodeInstance, short& error)
{
    ENTER_SINK_METHOD(IsUnicodeInstance_idx);
    isUnicodeInstance = ((pasbool) 0 != a34IsUnicodeLivecacheUser(*this->lpSessionContext));
    error = e_ok;
    LEAVE_SINK_METHOD(S_OK);
}

/*---------------------------------------------------------------------------*/

inline void eo38_EvalTaskSelfIOInfo(const tsp92_RteTaskSelfIOInfo& currInfo, tsp92_RteTaskSelfIOInfo& resInfo)
{
  resInfo.Cnt         = currInfo.Cnt        - resInfo.Cnt;
  resInfo.Pages       = currInfo.Pages      - resInfo.Pages;
  resInfo.AvgAbsTime  = currInfo.AvgAbsTime - resInfo.AvgAbsTime;
  resInfo.TotAbsTime  = currInfo.TotAbsTime - resInfo.TotAbsTime;    
}

inline void eo38_EvalTaskDEVIOIOInfo(const tsp92_RteTaskDEVIOInfo& currInfo, tsp92_RteTaskDEVIOInfo& resInfo)
{
  resInfo.Cnt         = currInfo.Cnt - resInfo.Cnt;
  resInfo.Pages       = currInfo.Pages - resInfo.Pages;
  resInfo.AvgRelTime  = currInfo.AvgRelTime;   
  resInfo.TotRelTime  = currInfo.TotRelTime - resInfo.TotRelTime;   
  resInfo.AvgAbsTime  = currInfo.AvgAbsTime;       
  resInfo.TotAbsTime  = currInfo.TotAbsTime - resInfo.TotAbsTime;  
}

inline void eo38_EvalTaskStateInfo(const tsp92_RteTaskStateInfo& currInfo, tsp92_RteTaskStateInfo& resInfo)
{
  resInfo.Cnt         = currInfo.Cnt - resInfo.Cnt;
  resInfo.AvgRelTime  = currInfo.AvgRelTime;   
  resInfo.TotRelTime  = currInfo.TotRelTime - resInfo.TotRelTime;   
  resInfo.AvgAbsTime  = currInfo.AvgAbsTime;       
  resInfo.TotAbsTime  = currInfo.TotAbsTime - resInfo.TotAbsTime; 
}


VIRTUAL HRESULT STDMETHODCALLTYPE CIliveCacheSink::EvalCallStatistics(
            bool            AllocatorOnly,                                                              
            OmsMonitorData& MonitorData)
{
  if (NULL != lpCallTaskInfo)
  {
    if (!AllocatorOnly)
    {
      tsp92_RteTaskDetailsInfo taskInfo;
      vGetRteInfoTaskDetails ( this->lpSessionContext->a_transinf.tri_trans.trTaskId_gg00, &taskInfo);
      MonitorData.m_cntDispatcher   = (OmsTypeUInt4)(taskInfo.DispatcherCnt - lpCallTaskInfo->DispatcherCnt);
      MonitorData.m_cntSelfSuspends = (OmsTypeUInt4)(taskInfo.TaskSelfSuspCnt - lpCallTaskInfo->TaskSelfSuspCnt);
      MonitorData.m_OmsLVCBaseCalls = (OmsTypeInt8) (taskInfo.OMSCallbackCount - lpCallTaskInfo->OMSCallbackCount);
      /*-------------------------------------- io statistics ----------------------------------------*/
      eo38_EvalTaskSelfIOInfo ( taskInfo.SelfIORead, lpCallTaskInfo->SelfIORead );
      eo38_EvalTaskSelfIOInfo ( taskInfo.SelfIOWrite, lpCallTaskInfo->SelfIOWrite );
      eo38_EvalTaskDEVIOIOInfo( taskInfo.DEVIORead, lpCallTaskInfo->DEVIORead );
      eo38_EvalTaskDEVIOIOInfo( taskInfo.DEVIOWrite, lpCallTaskInfo->DEVIOWrite );
      MonitorData.m_cntIO           = (OmsTypeUInt4) (lpCallTaskInfo->SelfIORead.Cnt +
        lpCallTaskInfo->SelfIOWrite.Cnt +
        lpCallTaskInfo->DEVIORead.Cnt +
        lpCallTaskInfo->DEVIOWrite.Cnt);
      MonitorData.m_IORelTime       = (OmsTypeInt4)  (lpCallTaskInfo->SelfIORead.TotAbsTime +
        lpCallTaskInfo->SelfIOWrite.TotAbsTime +
        lpCallTaskInfo->DEVIORead.TotRelTime +
        lpCallTaskInfo->DEVIOWrite.TotRelTime);   
      MonitorData.m_IOAbsTime       = (OmsTypeInt4)  (lpCallTaskInfo->SelfIORead.TotAbsTime +
        lpCallTaskInfo->SelfIOWrite.TotAbsTime +
        lpCallTaskInfo->DEVIORead.TotAbsTime +
        lpCallTaskInfo->DEVIOWrite.TotAbsTime); 
      /*------------------------------ receive/reply statistics ------------------------------------*/
      eo38_EvalTaskStateInfo  ( taskInfo.ReplyReceive, lpCallTaskInfo->ReplyReceive );
      eo38_EvalTaskStateInfo  ( taskInfo.ReceiveReply, lpCallTaskInfo->ReceiveReply );
      MonitorData.m_cntReplyReceive     = (OmsTypeUInt4) lpCallTaskInfo->ReplyReceive.Cnt;
      MonitorData.m_ReplyReceiveRelTime = (OmsTypeInt4)  lpCallTaskInfo->ReplyReceive.TotRelTime;
      MonitorData.m_ReplyReceiveAbsTime = (OmsTypeInt4)  lpCallTaskInfo->ReplyReceive.TotAbsTime;
      MonitorData.m_cntReceiveReply     = (OmsTypeUInt4) lpCallTaskInfo->ReceiveReply.Cnt; 
      MonitorData.m_ReceiveReplyRelTime = (OmsTypeInt4)  lpCallTaskInfo->ReceiveReply.TotRelTime; 
      MonitorData.m_ReceiveReplyAbsTime = (OmsTypeInt4)  lpCallTaskInfo->ReceiveReply.TotAbsTime;
      eo38_EvalTaskStateInfo  ( taskInfo.Vsuspend, lpCallTaskInfo->Vsuspend );
      /*---------------------------------- vwait statistics ----------------------------------------*/
      eo38_EvalTaskStateInfo  ( taskInfo.Vwait, lpCallTaskInfo->Vwait );
      MonitorData.m_cntWaits            = (OmsTypeUInt4) lpCallTaskInfo->Vwait.Cnt;  
      MonitorData.m_WaitsRelTime        = (OmsTypeInt4) lpCallTaskInfo->Vwait.TotRelTime;  
      MonitorData.m_WaitsAbsTime        = (OmsTypeInt4) lpCallTaskInfo->Vwait.TotAbsTime;
      /*---------------------------------- vsleep statistics ---------------------------------------*/
      eo38_EvalTaskStateInfo  ( taskInfo.Vsleep, lpCallTaskInfo->Vsleep );
      MonitorData.m_cntSleep            = (OmsTypeUInt4) lpCallTaskInfo->Vsleep.Cnt;  
      MonitorData.m_SleepRelTime        = (OmsTypeInt4) lpCallTaskInfo->Vsleep.TotRelTime;  
      MonitorData.m_SleepAbsTime        = (OmsTypeInt4) lpCallTaskInfo->Vsleep.TotAbsTime;
    }
    /*-------------------------------- allocator statistics --------------------------------------*/
    MonitorData.m_cntOperatorNew    = (OmsTypeInt8) this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_MallocCnt;
    if (MonitorData.m_cntOperatorNew > 0)
    {
        MonitorData.m_maxChunkAllocated = (OmsTypeUInt4) this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_MallocMax;
        MonitorData.m_minChunkAllocated = (OmsTypeUInt4) this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_MallocMin;
        MonitorData.m_avgChunkAllocated = (OmsTypeUInt4) (this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_MallocSum /
            this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_MallocCnt);
    }
    else
    {
        MonitorData.m_maxChunkAllocated = 0;
        MonitorData.m_minChunkAllocated = 0;
        MonitorData.m_avgChunkAllocated = 0; 
    }
    MonitorData.m_cntOperatorDelete = (OmsTypeInt8) this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_FreeCnt;
    if (MonitorData.m_cntOperatorDelete > 0)
    {
        MonitorData.m_maxChunkDeleted   = (OmsTypeUInt4) this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_FreeMax;
        MonitorData.m_minChunkDeleted   = (OmsTypeUInt4) this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_FreeMin;
        MonitorData.m_avgChunkDeleted   = (OmsTypeUInt4) (this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_FreeSum /
            this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_FreeCnt);
    }
    else
    {
        MonitorData.m_maxChunkDeleted   = 0;
        MonitorData.m_minChunkDeleted   = 0;
        MonitorData.m_avgChunkDeleted   = 0;
    }
    MonitorData.m_memoryDelta = (OmsTypeInt64) (this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_MallocSum 
         + this->lpSessionContext->a_allocatorInfo.ai_alloc_sys.ami_MallocSum
         - this->lpSessionContext->a_allocatorInfo.ai_alloc_usr.ami_FreeSum
         - this->lpSessionContext->a_allocatorInfo.ai_alloc_sys.ami_FreeSum);
    MonitorData.m_cntOutOfMemory = this->lpSessionContext->a_allocatorInfo.ai_badAllocCount; // PTS 1126793
  }
  return S_OK;
}

/*===========================================================================*
*  LOCAL FUNCTIONS (CODE)                                                   *
*===========================================================================*/

static HRESULT eo38_ComCache ( GUID * lpGuid, 
                              void *lpInterface, 
                              tsp00_Uint4 session,
                              bool  remoteDbgFlag,
                              teo38_HashEntryType hType )
{
  CCoClassHashPtr         HashPtr;
  CHashEntryPtr           currSessPtr;
  
  CWaitUntilAlone cs;                   /* PTS 1109279 */
  /*WAIT_UNTIL_ALONE (DCOM_EXCLUSIVE);     PTS 1109279 */
  
  HashPtr = REINTERPRET_CAST(CCoClassHashPtr,(DCOM_HEAD));
  if ( NULL == HashPtr ) 
  {
    eo38_Initialize ();
    HashPtr = REINTERPRET_CAST(CCoClassHashPtr,(DCOM_HEAD));
    if ( NULL == HashPtr ) 
    {
      /*CLEARLOCK (DCOM_EXCLUSIVE);       PTS 1109279 */
      return -1;
    }
  }
  
  currSessPtr = HashPtr->getFreeEntry();
  if ( NULL == currSessPtr )

  {
    /*CLEARLOCK (DCOM_EXCLUSIVE);         PTS 1109279 */
    return -1;
  }
  
  currSessPtr->init( session, lpGuid, (LPUNKNOWN)lpInterface, remoteDbgFlag, hType );
  HashPtr->chainEntry(currSessPtr);
  /*CLEARLOCK (DCOM_EXCLUSIVE);           PTS 1109279 */
  return S_OK;
}
/*---------------------------------------------------------------------------*/

/* +++ *** PTS 1112617 *** +++ */
static tsp00_Uint4 eo38ThreadIndex( TASK_CTRL p ) {
#if defined(WIN32)                                              
  return (tsp00_Uint4) p->ulTaskIndex;
#else 
  return (tsp00_Uint4) THREAD_INDEX(p);
#endif
}
/* --- *** PTS 1112617 *** --- */

/*---------------------------------------------------------------------------*/

static BOOLEAN eo38_Initialize ( void )
{
  BOOLEAN rc = 1;
  tsp00_Uint4  lRC;
  CCoClassHashPtr pMem;
  
  if (DCOM_HEAD == 0)
  {
    pMem = new (CCoClassHash);
    if ( NULL == pMem )
    {
      MSGD ((ERR_DCOM_NOMEM, "eo38_Initialize" ));
      rc = 0;
    }
    else
    {
#if defined(DEBUG_MEM_ALLOC)
      MSGD(( 11999, INFO_TYPE, "new   ", "veo38.cpp:eo38_Initialize - 0x%lx, sizeInBytes %ld",
        pMem, sizeof(CCoClassHash) ));
#endif /* DEBUG_MEM_ALLOC */
      lRC = pMem->HashInit( C_HASH_SESS_HDR_SIZE );
      if ( 0 != lRC )
      {
        MSGD ((ERR_DCOM_NOMEM, "eo38_Initialize:HashInit" ));
        rc = 0;
      }
      else
      {
        DCOM_HEAD = pMem;
      }
    }
  }
  return (rc);
}

/*---------------------------------------------------------------------------*/

static void eo38_Invalidate(tsp_dcom_co_create_instance_parms *lpParms,
                            GUID *lpGuid, 
                            tsp00_Uint4 session)
{
#ifdef HUGO
  HRESULT hr;
  tsp_dcom_dispatch_parms disp_parms;
  tsp00_Uint4    idx, ui;
  IUnknown *lpIUnknown;
  
  tsp00_Int4 bufLen;
  
  struct _buffer
  {
    union 
    { 
      tgg00_MessType  MessType;
      tsp00_Int2      Rc;
    } v;
  } buffer;
  
  struct  _stack 
  {
    tsp00_Int4     *plong;
    tgg00_MessType *pMessType;
  } stack;
  
  parms->ret = RC_DISPADDR_INVALID_FOUND;
  memcpy(&act_IID_Dsc,lpIID_Dsc,sizeof(act_IID_Dsc));
  
  lpIID_Dsc->idispatch = NULL;
  lpIID_Dsc->session = 0;
  lpIID_Dsc->AdviseCookie = 0;
  lpIID_Dsc->type = Free_eeo38;
  /* chain to free - chain */
  if (lpIID_Dsc_prev == NULL)
    (*((t_Head *) DCOM_HEAD))[idx] = STATIC_CAST(t_IIDDsc *,(lpIID_Dsc->lpnext));
  else
    lpIID_Dsc_prev->lpnext = STATIC_CAST(t_IIDDsc *,(lpIID_Dsc->lpnext));
  lpIID_Dsc->lpnext = DCOM_FREE;
  DCOM_FREE = lpIID_Dsc;
  CLEARLOCK (DCOM_EXCLUSIVE);
  
  /*** VALIDATE REQUEST for OMS Layer !!! ***/
  
  disp_parms.idispatch = REINTERPRET_CAST(char *,(act_IID_Dsc.idispatch));
  disp_parms.ifactory = REINTERPRET_CAST(char *,(act_IID_Dsc.idispatch));
  disp_parms.session_context  = parms->session_context;
  disp_parms.dispid           = C_SYS_DISPID;
  disp_parms.hresult          = S_OK;
  disp_parms.param_stack      = (tsp00_MoveObjPtr)&stack;
  disp_parms.param_stack_len  = sizeof(stack);
  disp_parms.debug_mode       = 0;
  disp_parms.debug_location   = NULL;
  bufLen            = sizeof(buffer);
  stack.plong       = &bufLen;
  stack.pMessType   = &buffer.v.MessType;
  buffer.v.MessType.becomes(m_shutdown);
  
  lpIUnknown = (IUnknown *) disp_parms.idispatch;
  hr = lpIUnknown->QueryInterface( IID_IliveCacheSpec, 
    REINTERPRET_CAST(void **,(&disp_parms.idispatch)));
  if ( SUCCEEDED(hr) )
  {
    eo38VDcomDispatch (&disp_parms);
    hr = disp_parms.hresult;
    if ( FAILED(hr) )
      MSGD ((ERR_DCOM_HRESULT, "eo38VDcomDispAddr:Invalidate(ILCSpec)", hr ));
  }
  else
    MSGD ((ERR_DCOM_HRESULT, "eo38VDcomDispAddr:QI(ILCSpec)", hr ));
  if ( FAILED(hr) )  parms->ret = RC_DISPADDR_INVALIDATE_FAILED;
  if ( buffer.v.Rc != S_OK ) 
  {
    parms->ret = buffer.v.Rc;
    MSGD ((ERR_DCOM_HRESULT, "eo38VDcomDispAddr:Invalidate_RC:", buffer.v.Rc ));
    return;
  }
  
  disp_parms.dispid = 2;
  TRY 
  {
    lpIUnknown = (IUnknown *) parms->idispatch;
    hr = lpIUnknown->QueryInterface ( IID_IConnectionPointContainer,
      (void **) &pCPC);
    if (SUCCEEDED (hr))
      hr = pCPC->FindConnectionPoint (IID_IliveCacheSink, &pCP);
    else
      MSGD ((ERR_DCOM_HRESULT, "eo38VDComDispAddr:QI(ICPC)", hr ));
    if (SUCCEEDED (hr))
    {
      pCPC->Release ();
      hr = pCP->Unadvise (act_IID_Dsc.AdviseCookie);
      if ( FAILED(hr))  
        MSGD ((ERR_DCOM_HRESULT, "eo38VDComDispAddr:Unadvise", hr ));
      pCP->Release ();
    }
    else
      MSGD ((ERR_DCOM_HRESULT, "eo38VDComDispAddr:FCP", hr ));
    lpIUnknown->Release ();
  }
  CATCH_ALL
  {
    MSGD ((ERR_DCOM_HRESULT, "eo38VDComDispAddr:Release", disp_parms.hresult ));
  }       
      }
#endif
};

/*---------------------------------------------------------------------------*/

static void eo38_ReleaseInstance ( CHashEntryPtr  currEntry, tsp00_Addr SessionContext  )
{
  tsp_dcom_dispatch_parms   disp_parms;
  tsp00_Uint4               cnt;
  IUnknown                  *lpIUnknown;
  HRESULT                   hr;
  IliveCacheSpec            *pILC;
  tsp00_TaskId              taskid;
  
  disp_parms.idispatch  = REINTERPRET_CAST(char *,(currEntry->getIUnknown()));
  disp_parms.ifactory   = REINTERPRET_CAST(char *,(currEntry->getIUnknown()));
  disp_parms.dispid     = 2;
  disp_parms.session_context = SessionContext;
  TRY
  {
    IID     loc_iid;                                                  /* PTS 1112617 */
    TASK_CTRL pTaskCtrl = CURR_TASK;                                  /* PTS 1112617 */
    memcpy (&loc_iid.Data1, currEntry->getGuid(), sizeof (loc_iid));  /* PTS 1112617 */
    MSGCD ((INFO_DCOM_RELEASE_INSTANCE,                               /* PTS 1112617 */
      loc_iid.Data1, loc_iid.Data2, loc_iid.Data3,                    /* PTS 1112617 */
      loc_iid.Data4[0], loc_iid.Data4[1], loc_iid.Data4[2],           /* PTS 1112617 */
      loc_iid.Data4[3], loc_iid.Data4[4], loc_iid.Data4[5],           /* PTS 1112617 */
      loc_iid.Data4[6], loc_iid.Data4[7],                             /* PTS 1112617 */ 
      eo38ThreadIndex(pTaskCtrl)));                                   /* PTS 1112617 */ 
    lpIUnknown = currEntry->getIUnknown();
    hr = lpIUnknown->QueryInterface ( IID_IliveCacheSpec, (void **) &pILC);
    if (SUCCEEDED (hr))
    {
      hr = pILC->Unadvise ();
      if ( FAILED(hr))  
        MSGD ((ERR_DCOM_HRESULT, "eo38_ReleaseInstance:Unadvise", hr ));
      pILC->Release ();
    }
    else
      MSGD ((ERR_DCOM_HRESULT, "eo38_ReleaseInstance:QILC", hr ));
    /* enter g08ComponentEnd region to make sure, that no OMS Monitor Iterator */
    /* is using the instance.                                                  */
    /* reason: instances are destructed via reference counting (0=delete this) */
    /* During destruction memory is passed back to a session heap, which is    */
    /* destructed after leaving the actual running routine ! Therefore it      */
    /* must be made sure, that the following Release() provokes destruction    */
    /* of the instance                                                         */
    vgetpid(taskid);
    vbegexcl(taskid, g08ComponentEnd );
    cnt = lpIUnknown->Release ();
    vendexcl(taskid, g08ComponentEnd );
  }
#if defined(WIN32)
  __except (eo38_Eval_Exception (&disp_parms, GetExceptionInformation ()))
  {
     MSGD ((ERR_DCOM_HRESULT, "eo38_ReleaseInstance:Release", disp_parms.hresult ));
  }
#else
  catch (RTE_DBProcError e) {
     disp_parms.hresult = GEO00D_DCOM_EXCEPTION_RAISED;
     MSGD ((ERR_DCOM_HRESULT, "eo38_ReleaseInstance:Release", disp_parms.hresult ));
  }
  catch (DbpError e) { 
    char    msgBuffer[132];
    sprintf(&msgBuffer[0],"eo38_ReleaseInstance:Release: DbpError:%d", e.dbpError() );
    MSGD ((ERR_DCOM_DUMP_INFO,msgBuffer));
  }
#endif
}

/*---------------------------------------------------------------------------*/

static HRESULT eo38_UnadviseInstance ( CHashEntryPtr    currEntry )
{
  tsp_dcom_dispatch_parms   disp_parms;
  IUnknown                  *lpIUnknown;
  HRESULT                   hr;
  IliveCacheSpec            *pILC;
  
  disp_parms.idispatch  = REINTERPRET_CAST(char *,(currEntry->getIUnknown()));
  disp_parms.ifactory   = REINTERPRET_CAST(char *,(currEntry->getIUnknown()));
  disp_parms.dispid     = 2;
  disp_parms.session_context = 0;
  TRY
  {
    lpIUnknown = currEntry->getIUnknown();
    if (currEntry->getType() != DbgInterface_eeo38) 
    {
      hr = lpIUnknown->QueryInterface ( IID_IliveCacheSpec,(void **) &pILC);
      if (SUCCEEDED (hr))
      {
        hr = pILC->Unadvise ();
        if ( FAILED(hr))  
          MSGD ((ERR_DCOM_HRESULT, "eo38_UnadviseInstance:Unadvise", hr ));
        pILC->Release ();
      }
      else
        MSGD ((ERR_DCOM_HRESULT, "eo38_UnadviseInstance:QI(ICPC)", hr ));
    }
  }
  CATCH_ALL  
  {
    disp_parms.hresult = GEO00D_DCOM_DBPROC_CRASHED;
    MSGD ((ERR_DCOM_HRESULT, "eo38_UnadviseInstance:Release", disp_parms.hresult ));
    if ( SUCCEEDED(hr) ) hr = disp_parms.hresult;
  }
  return hr;
}

/*===========================================================================*
*  END OF CODE                                                              *
*===========================================================================*/
