/*!******************************************************************************

  @file         hgg04.h

  ------------------------------------------------------------------------------

  @author       ElkeZ

  @brief        Select_Help_Procedures

\if EMIT_LICENCE

    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HGG04_H
#define HGG04_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\xe7\xfd\x28\x87\xd5\xf2\xa1\x2a\x37\x70\xcd\x0a\x2a\x6c\x35\x56'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void g04between_keys (
    tgg_mess_block        &  mblock,
    tgg_lkey              &  startlistkey,
    tgg_lkey              &  stoplistkey,
    integer                  colstackpos,
    integer                  startpos,
    integer                  stoppos);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04build_temp_tree_id (
    tgg00_FileId          &  curr,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04check_if_top_level (
    tgg_stack_list_ptr    &  mb_st,
    integer                  stpos,
    integer                  maxstpos,
    pasbool               &  top_level);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04inbetween_change (
    tgg_mess_block        &  mblock,
    pasbool               &  finding_possible);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04incheck (
    tgg_mess_block        &  mblock,
    integer                  stpos);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04init_select_fields (
    tgg_select_fields_param  &  sel,
    tsp_moveobj_ptr          data_addr,
    tsp_int4                 data_size,
    tgg_stack_list_ptr       work_st_addr,
    tsp_int2                 work_st_max,
    tsp_moveobj_ptr          work_buf_addr,
    tsp_int4                 work_buf_size,
    tsp_sqlmode_Param        curr_sqlmode);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool g04inv_tfn (
    tgg00_Tfn_Param          tfn);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04join_expl_row_trace (
    tgg00_TransContext    &  t,
    tsp_c40               &  strat,
    tsp_knl_identifier    &  owner,
    tsp_knl_identifier    &  table,
    tsp_longreal             recs_found,
    tsp_longreal             multiplier,
    tsp_longreal             new_left_size,
    tsp_longreal             new_left_recs,
    tsp_longreal             costs);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04locate_col (
    const tgg_stack_entry  &  st,
    const tgg00_Rec*         rec_buf_ptr,
    tgg_varcol_pos_list   &  varcol_pos,
    integer               &  col_pos,
    integer               &  col_len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04LocateOldVarCol (
    tgg_stack_entry          st,
    tgg00_RecPtr             rec_buf_ptr,
    integer               &  col_pos,
    integer               &  col_len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp_int2 g04calc_optimize_info_len (
    tgg_mess_block        &  mblock);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04mblock_optimize_info (
    tgg_mess_block        &  mblock);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04onevalue (
    tgg_mess_block        &  mblock,
    tsp_int2                 valpos,
    pasbool                  last_field,
    pasbool                  descending,
    tsp_int2                 maxlen,
    tgg_lkey              &  key);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04subqvalue (
    tgg_rec_buf           &  subq_buf,
    pasbool                  last_field,
    pasbool                  descending,
    tsp_int2                 maxlen,
    tgg_lkey              &  key,
    tgg_basis_error       &  e);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04c30_to_trace (
    tgg00_TransContext    &  t,
    tsp_c30               &  c30);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04longreal_to_trace (
    tgg00_TransContext    &  t,
    tsp00_Name            &  name,
    tsp00_Longreal           realval);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04int4_to_trace (
    tgg00_TransContext    &  t,
    tsp_name              &  name,
    tsp_int4                 intval);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04name_to_trace (
    tgg00_TransContext    &  t,
    tsp_name              &  name);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04line_to_trace (
    tgg00_TransContext    &  t,
    tsp_line              &  line);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04explain_trace (
    tgg00_TransContext    &  t,
    void                  *  shinfo);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04statistic_trace (
    tgg00_TransContext    &  t,
    tgg_ref_info_index_Param     arr_index,
    tsp_int4                 int1,
    tsp_int4                 int2,
    tsp_int4                 int3,
    tsp_int4                 int4);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04spec_null_check (
    tgg_mess_block        &  mblock,
    tgg_basis_error       &  b_err);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04read_subquery (
    tgg_mess_block        &  mblock,
    tgg_rec_buf           &  result,
    tgg00_FileId          &  subqtree_id,
    tgg_lkey              &  m_key,
    tgg_basis_error       &  aux_error,
    pasbool               &  ok);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void g04index_tree_build (
    tgg00_FileId          &  file_id,
    tgg00_FileId          &  index_tree,
    tsp_int2                 index_no);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool gg04IsPermStaticTfn (
    tgg00_Tfn_Param          Tfn);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool gg04IsStaticPage (
    tgg00_PageType2_Param     PageType2);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

