/*!***************************************************************************

  module      : vgg942.cpp
  responsible : UweH
  special area: ComponentTests
  created     : 2000-11-24
  last changed: 2000-11-30  9:36
  copyright   : Copyright by SAP AG, 2000
  description : component tests



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*****************************************************************************/

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"

#if COMPILEMODE_MEO00 >= SLOW_MEO00 
#include "hta99.h" /* nocheck */
#endif

#include "hgg942.h" // check of PASCAL header vgg942
#include "hbd03.h"  // bd03TestTree

#include "DataAccess/Data_Test.hpp"
#include "KernelCommon/Kernel_Test.hpp"
#include "Logging/Log_Test.hpp"
#include "RunTime/RTE_Test.hpp"

/*===========================================================================*
 *  EXTERNAL FUNCTIONS                                                       *
 *===========================================================================*/

/*----------------------------------------------------------------------------*/

externPascal void gg942ComponentTests (tgg00_TransContext& Trans,
                                       tsp00_Int4          TestNo)
{
    ROUTINE_DBG_MSP00 ("gg942ComponentTests");

    switch (TestNo)
    {
    case 1:
        Data_Test (Trans);
        break;
    case 2: 
        Kernel_Test (Trans);
        break;
    case 3: 
        Log_Test (Trans, TestNo);
        break;
    case 4: 
        RTE_Test (Trans);
        break;
    case 10: // suspend logwriter
    case 11: // resume logwriter
    case 12: // set log auto overwrite on
    case 13: // set log auto overwrite off
        Log_Test (Trans, TestNo); 
        break;
    case 20:
        bd03TestTree(Trans);
        break;

	default:
        break;
    }
}

