#!/usr/bin/perl
#
# BuildPackage/Items.pm
#
# $Header: //sapdb/V74/c_03/cor/sys/src/install/perl/BuildPackage/LCPool/Items.pm#6 $
# $DateTime: 2003/11/24 11:54:47 $
# $Change: 57448 $
#

# Desc:	- define packages and profiles of SAP DB Packages
#		
#
#
#    ========== licence begin LGPL
#    Copyright (C) 2002 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#

		
#
# data struct items describes which files have to be copied to LCPool
# structure of %items: 	
#	<source_path> => {'items' => [<file 1>,<directory 1>,<file 2>,... ]
#					  'subdir' => <destination_subdir>  	
#					}	
#
#	destination directory = <LC_POOL directory>/<destination_subdir>
#
#



package BuildPackage::LCPool::Items;

use BuildPackage::Vars;
use Exporter;

@ISA = ('Exporter');

@EXPORT = ('%lcitems'); 

my @liboms = ($^O =~ /mswin/i) ? ('lib/liboms.lib','pgm/liboms.dll','bin/sqlwhat.exe') : ("$LIBPATH/liboms.$SOEXT");

@simulator_list = ('lib/libomssimul.lib','pgm/libomssimul.dll','pgm/test/liboms.dll','pgm/test/liboms.lib',
					  'pgm/omststknl.exe','Support/Mapfiles/kernel-omstst.map','Support/Mapfiles/liboms-omstst.map',
						'Support/Mapfiles/lctest.map',

&if $OS in [ WIN32 ] && $_MSC_VER != 13					
					 'symbols/kernel-omstst.dbg',
					'symbols/liboms-omstst.dbg',
					'symbols/liboms.dbg',
					'symbols/libomssimul.dbg'
&else					
					'symbols/kernel-omstst.pdb',
					'symbols/liboms-omstst.pdb',
					'symbols/liboms.pdb',
					'symbols/libomssimul.pdb'
&endif					

					);

@simulator_list = ("$LIBPATH/libomssimul.$SOEXT","$LIBPATH/test/liboms.$SOEXT") unless($^O =~ /mswin/i);


push @simulator_list,"pgm/omststknl$EXEEXT";



%lcitems = (
	"$OWN" => {'items' => ['test/jtest/alltestpkg.sar','changelist.log',
				'SAPDBCSDK.SAR','TESTSIMUL.SAR','make.id']
			  },
	
	"$OWN/usr/etc" => {'items' => ['VERSIONS']},

	"$OWN/usr" => { 'items' => ['incl',
								"pgm/regcomp$EXEEXT",
								"bin/xregcomp$EXEEXT",
								"pgm/idl2xml$EXEEXT",
								"pgm/xml2ispc$EXEEXT",
								"sap/niping$EXEEXT",
								@liboms,
								@simulator_list
							  ],
				    'subdir' => 'sys/src/lcsrc'
				  },
				  
	"$WRK" => { 'items' => ['lcsrc'],
				'subdir' => 'sys/src'
			  },

	"$WRK/fast/install" => {'items' => ['packages/apocom'],
							'subdir' => 'sys/src/lcsrc'
						   }			
);


if ($^O =~ /mswin/i){
	$lcitems{"$OWN/usr/pgm"} = {'items' => ['dbmcli.exe']};
}
else{
	$lcitems{"$OWN/usr/bin"} = {'items' => ['dbmcli']};
}

1;


