###############################################################
# PACKAGE INFORMATION
#
# Notes:
#
# - rpm documentation
#   See www.rpm.org.
#


name:		sapdb
version: 	RELEASE
release: 	1	
copyright:	(c) 2002 SAP AG, Germany
vendor: 	SAP AG, Germany
packager: 	sapdb-general@sap.com
summary: 	SAP DB Sofware
group: 		Applications/Databases
Buildroot:	BUILDROOT

%description

For more information please see www.sapdb.org.


#####################################################################
#
#	SAP DB release independent software
#
#
#


%package ind
summary: 	database remote communication server
group: 		Applications/Databases

%description ind
SAP DB Communication Server / Basis Tools 

-	remote communication server
-	command line tools for database administration
-	precompiler runtime (for applications built by SAP DB precompiler)

For more information please see www.sapdb.org.


%files ind
%attr(-, root, sapdb) /opt/sapdb/indep_prog
%attr(-, root, sapdb) /var/opt/sapdb
%pre ind
if [ "$1" = "1" ]; then
    # first installation only
    if [ -f /var/spool/sql/ini/SAP_DBTech.ini ]; then
	echo "- aborting installation:" >&2
	echo "  - file /var/spool/sql/ini/SAP_DBTech.ini exists" >&2
	echo "  - can not (yet) upgrade non-rpm installation" >&2
	exit 1
    fi
fi

groupadd sapdb >/dev/null 2>&1
useradd -c "SAPDB demo user" -g sapdb -m -p SARW90n3cnWxc sapdb >/dev/null 2>&1
usermod -g sapdb -p SARW90n3cnWxc sapdb >/dev/null 2>&1


if [ ! -L /usr/spool ]; then
	if [ -d /usr/spool ]; then
		echo "/usr/spool has to be a link to ../var/spool"
		exit 1
	fi 	
	if [ ! -d /var/spool ];then
		mkdir -p /var/spool > /dev/null 2>&1
	fi
	ln -s ../var/spool /usr/spool
fi


ports="
sql30   7200 tcp
sql6    7210 tcp
"
_i=0
for _arg in $ports
do
    if [ $_i -eq 0 ]; then
	_i=1; _servicename=$_arg; continue
    fi
    if [ $_i -eq 1 ]; then
	_i=2; _port=$_arg; continue
    fi
    _i=0
    _protocol=$_arg
    _serviceline=`awk '/^[ 	]*'$_servicename'[ 	]/ {print $1 "/" $2}' /etc/services 2>&1`
    if [ ! -z "$_serviceline" ]; then
	for _cl in $_serviceline
	do
	    if [ "$_cl" != "$_servicename/$_port/$_protocol" ]; then
		echo "inconsistent service entry database:" >&2
		echo "specified entry '$_servicename $_port/$_protocol' does not match retrieved entry:" >&2
		echo "$_serviceline" >&2
		exit 1
	    fi
	done
    fi
    if [ -z "$_serviceline" ]; then
	echo "$_servicename $_port/$_protocol" >> /etc/services
	if [ $? -ne 0 ]; then
	    echo "entry '$_servicename $_port/$_protocol' could not be added to /etc/services" >&2
	    echo "add the entry to /etc/services manually" >&2
	    exit 1
	fi
    fi
done
exit 0

%post ind

export DBROOT=/opt/sapdb/indep_prog

if [ "$1" != "1" ]; then
    
    _f=/var/spool/sql/ini/SAP_DBTech.ini
    if [ -f $_f ]; then
      _i=0
      while [ -f $_f.$_i ]
      do
          _i=`expr $_i + 1`
      done
      echo "- saving $_f as version $_i ..."
      cp $_f $_f.$_i
      [ $? -ne 0 ] && exit 1
    else
      echo "update error: no file $_f found!" >&2
      exit 1
    fi
    	
else
	for _i in \
    		/var/spool/sql \
    		/var/spool/sql/config \
    		/var/spool/sql/diag \
    		/var/spool/sql/ipc \
    		/var/spool/sql/fifo \
   		/var/spool/sql/spool \
    		/var/spool/sql/ini
	do
    		mkdir -p $_i
    		chmod 775 $_i
    		chgrp sapdb $_i
	done   
    
fi


_o=`$DBROOT/bin/dbmcli -s dbm_setpath IndepDataPath /var/opt/sapdb/indep_data`
_test=`echo $_o | grep OK`
if [ "$_test" = "" ]; then
    echo "- could not set inpedendent data path: $_o" >&2
    exit 1
fi
_o=`$DBROOT/bin/dbmcli -s dbm_setpath IndepProgPath /opt/sapdb/indep_prog`
_test=`echo $_o | grep OK`
if [ "$_test" = "" ]; then
    echo "- could not set independent program path: $_o" >&2
    exit 1
fi

#register precompiler runtime
#/opt/sapdb/indep_prog/bin/irconf -i -p /opt/sapdb/indep_prog/runtime/7300 >/dev/null 2>&1
#/opt/sapdb/indep_prog/bin/irconf -i -p /opt/sapdb/indep_prog/runtime/7250 >/dev/null 2>&1
#/opt/sapdb/indep_prog/bin/irconf -i -p /opt/sapdb/indep_prog/runtime/7240 >/dev/null 2>&1
/opt/sapdb/indep_prog/bin/irconf -i -p /opt/sapdb/indep_prog/runtime/7403 >/dev/null 2>&1
su - -c "/opt/sapdb/indep_prog/bin/x_server start" sapdb  >/dev/null 2>&1
exit 0

%preun ind
/opt/sapdb/indep_prog/bin/irconf -r -p /opt/sapdb/indep_prog/runtime/7403 >/dev/null 2>&1

if [ "$1" != "0" ]; then
    # do nothing in upgrade case
    exit 0
fi
export DBROOT=/opt/sapdb/indep_prog

/opt/sapdb/indep_prog/bin/x_server stop >/dev/null  2>&1 

_o=`fuser $DBROOT/bin/* $DBROOT/pgm/* 2>/dev/null`
if [ $? -eq 0 ]; then
    if [ `echo $_o | wc -l` -eq 1 -a `echo $_o | grep -c "^$DBROOT/pgm/vserver"` -eq 1 ]; then
	$DBROOT/bin/x_server stop >/dev/null 2>&1
    else
	echo "- aborting (software is in use)" >&2
	exit 1
    fi
fi


rm -f /var/opt/sapdb/indep_data/wrk/_OPTSAPD/*  >/dev/null 2>&1
rm -f /var/opt/sapdb/indep_data/config/_OPTSAPD* >/dev/null 2>&1
rm -f /var/opt/sapdb/indep_data/wrk/dbmsrv.prt >/dev/null 2>&1
rm -f /var/opt/sapdb/indep_data/wrk/NI_TRACEFILE  >/dev/null 2>&1
rm -f /var/opt/sapdb/indep_data/wrk/loader.prt  >/dev/null 2>&1
rm -f /var/opt/sapdb/indep_data/wrk/xserver.prt  >/dev/null 2>&1
rm -f /var/opt/sapdb/indep_data/wrk/niserver.prot  >/dev/null 2>&1
rmdir  /var/opt/sapdb/indep_data/wrk/_OPTSAPD >/dev/null 2>&1


rm -f \
    /var/opt/sapdb/indep_data/wrk/vserver.prot \
    /var/opt/sapdb/indep_data/wrk/root/* \
    /var/spool/sql/ini/SAP_DBTech.ini* \    
    > /dev/null 2>&1

rm -rf /var/opt/sapdb/indep_data/wrk/irtrace* /var/spool/sql/dbspeed /var/spool/sql/pid /var/spool/sql/ppid >/dev/null 2>&1 
rm -f /var/opt/sapdb/indep_data/config/Registry*.dcom >/dev/null 2>&1
rm -f /var/spool/sql/ini/Registry_dcom.ini >/dev/null 2>&1


rmdir \
    /var/opt/sapdb/indep_data/wrk/root \
    /var/spool/sql/config \
    /var/spool/sql/diag \
    /var/spool/sql/ipc \
    /var/spool/sql/fifo \
    /var/spool/sql/pipe \
	/var/spool/sql/spool \
    /var/spool/sql/ini \
    /var/spool/sql \
    > /dev/null 2>&1

ports="
sql30   7200 tcp
sql6    7210 tcp
"
_i=0
for _arg in $ports
do
    if [ $_i -eq 0 ]; then
	_i=1; _servicename=$_arg; continue
    fi
    if [ $_i -eq 1 ]; then
	_i=2; _port=$_arg; continue
    fi
    _i=0
    _protocol=$_arg
    grep -v '^[ 	]*'$_servicename'[ 	]' /etc/services > /tmp/.$$
    [ $? -eq 0 ] && cp -f /tmp/.$$ /etc/services
    rm -f /tmp/.$$
done
exit 0

%postun ind
if [ "$1" = "0" ]; then
    [ -d /var/spool/sql ] && echo "cannot remove /var/spool/sql - directory not empty"
fi
exit 0


########################################################
#
#	SAP DB  -  ODBC/JDBC Driver
#
#
#

%package callif
summary: 	Database Client Software
group: 		Applications/Databases
Buildroot:	BUILDROOT

%description callif
SAP DB ODBC and JDBC Interfaces

-	ODBC driver
-	JDBC driver

For more information please see www.sapdb.org.

%files callif
%attr(-, root, sapdb) /opt/sapdb/interfaces/odbc
%attr(-, root, sapdb) /opt/sapdb/interfaces/jdbc


%pre callif

groupadd sapdb >/dev/null 2>&1
ports="
sql30   7200 tcp
sql6    7210 tcp
"
_i=0
for _arg in $ports
do
    if [ $_i -eq 0 ]; then
	_i=1; _servicename=$_arg; continue
    fi
    if [ $_i -eq 1 ]; then
	_i=2; _port=$_arg; continue
    fi
    _i=0
    _protocol=$_arg
    _serviceline=`awk '/^[ 	]*'$_servicename'[ 	]/ {print $1 "/" $2}' /etc/services 2>&1`
    if [ ! -z "$_serviceline" ]; then
	for _cl in $_serviceline
	do
	    if [ "$_cl" != "$_servicename/$_port/$_protocol" ]; then
		echo "inconsistent service entry database:" >&2
		echo "specified entry '$_servicename $_port/$_protocol' does not match retrieved entry:" >&2
		echo "$_serviceline" >&2
		exit 1
	    fi
	done
    fi
    if [ -z "$_serviceline" ]; then
	echo "$_servicename $_port/$_protocol" >> /etc/services
	if [ $? -ne 0 ]; then
	    echo "entry '$_servicename $_port/$_protocol' could not be added to /etc/services" >&2
	    echo "add the entry to /etc/services manually" >&2
	    exit 1
	fi
    fi
done
exit 0

%post callif

exit 0

%preun callif

exit 0

##########################################################
#
#	dependent server software
#
#

%package srv74
summary: 	Database Server Software
group: 		Applications/Databases
PreReq:		sapdb-ind >= RELEASE
Requires:   sapdb-ind >= RELEASE

%description srv74
SAP DB Database Server 

-	database kernel
-	Database Manager Server
-	Replication Manager Server
-	SAP DB start script

For more information please see www.sapdb.org.


%files srv74
%attr(-, root, sapdb) /opt/sapdb/depend74
%attr(775, root, root) /etc/init.d/sapdb74

%pre srv74
groupadd sapdb >/dev/null 2>&1
exit 0

%post srv74

export DBROOT=/opt/sapdb/depend74

if [ "$1" != "1" ]; then
	if [ -x $DBROOT/bin/dbmcli ]; then 	
		$DBROOT/bin/dbmcli -s -R $DBROOT inst_unreg $DBROOT >/dev/null 2>&1
	fi
fi

_o=`su - sapdb -c "$DBROOT/bin/dbmcli -s -R $DBROOT inst_reg -k $DBROOT"`
_test=`echo $_o | grep OK`
if [ "$_test" = "" ]; then
    echo "- could not register the installation: $_o" >&2
    exit 1
fi


_dcom_link=$DBROOT/wrk/Registry.dcom 

if [ -e $_dcom_link ] && [ ! -L $_dcom_link ]; then
       rm $_dcom_link >/dev/null 2>&1
fi

_o=`$DBROOT/bin/xregcomp -c $DBROOT/lib/dbpinstall 2>&1`

_test=`echo $_o | grep "Registration done"`
if [ "$_test" = "" ]; then
    echo "- could not register dbpinstall: $_o" >&2
    exit 1
fi


if [ -L $_dcom_link ]; then
	_dcom_file=`ls -l $_dcom_link | sed -e 's/.*-> //'` 
	if [ -f $_dcom_file ]; then
		chmod 664 $_dcom_file >/dev/null 2>&1
		chown root:sapdb $_dcom_file >/dev/null 2>&1
	fi
fi

exit 0

%preun srv74
if [ "$1" != "0" ]; then
    # do nothing in upgrade case
    exit 0
fi
export DBROOT=/opt/sapdb/depend74

find $DBROOT/misc -type f -name '*.pyc' -exec rm {} \; >/dev/null 2>&1
find $DBROOT/env -type f -name '*.pyc' -exec rm {} \; >/dev/null 2>&1
find $DBROOT/lib/python1.5 -type f -name '*.pyc' -exec rm {} \; >/dev/null 2>&1

IND_PROG_DBROOT=`$DBROOT/bin/dbmcli dbm_getpath IndepProgPath 2>&1 | awk 'BEGIN {ok=0} NR==1 && $1="OK" {ok=1} NR==2 && ok!=0 {print $0}'`
[ -z "$IND_PROG_DBROOT" -a -f /var/spool/sql/ini/SAP_DBTech.ini ] && IND_PROG_DBROOT=`grep '^IndepPrograms=' /var/spool/sql/ini/SAP_DBTech.ini | sed 's:IndepPrograms=::g'`

[ ! -z "$IND_PROG_DBROOT" ] && su - -c "$IND_PROG_DBROOT/bin/x_server start" sapdb >/dev/null 2>&1

IND_DATA_DBROOT=`$DBROOT/bin/dbmcli dbm_getpath IndepDataPath 2>&1 | awk 'BEGIN {ok=0} NR==1 && $1="OK" {ok=1} NR==2 && ok!=0 {print $0}'`
[ -z "$IND_DATA_DBROOT" -a -f /var/spool/sql/ini/SAP_DBTech.ini ] && IND_DATA_DBROOT=`grep '^IndepData=' /var/spool/sql/ini/SAP_DBTech.ini | sed 's:IndepData=::g'`

$DBROOT/bin/dbmcli -s -R $DBROOT inst_unreg $DBROOT >/dev/null 2>&1

_o=`fuser $DBROOT/bin/* $DBROOT/pgm/* 2>/dev/null`
if [ $? -eq 0 ]; then
    if [ `echo $_o | wc -l` -eq 1 -a `echo $_o | grep -c "^$DBROOT/pgm/vserver"` -eq 1 ]; then
	$DBROOT/bin/x_server stop >/dev/null 2>&1
    else
	echo "- aborting (software is in use)" >&2
	exit 1
    fi
fi

rm -f $DBROOT/env/_OPTSAPD* $DBROOT/load.prot >/dev/null 2>&1

_dcom_link=$DBROOT/wrk/Registry.dcom 

if [ -L $_dcom_link ]; then
	_dcom_file=`ls -l $_dcom_link | sed -e 's/.*-> //'` 
	if [ -f $_dcom_file ]; then
		rm -f $_dcom_file >/dev/null 2>&1
	fi
fi
rm -f ${_dcom_link}*  >/dev/null 2>&1

rm -f /var/spool/sql/ini/Registry_dcom.ini >/dev/null 2>&1


if [ ! -z "$IND_DATA_DBROOT" ]; then
    rm -f \
	$IND_DATA_DBROOT/config/_OPTSAPD* \
	$IND_DATA_DBROOT/wrk/_OPTSAPD*/* \
	$IND_DATA_DBROOT/wrk/dbmsrv.prt \
	>/dev/null 2>&1
    rmdir \
	$IND_DATA_DBROOT/wrk/_OPTSAPD* \
	>/dev/null 2>&1
fi


exit 0


###############################################################
# 
#	SAP DB Precompiler
# 
#

%package	precompiler
summary: 	Database Clients Software
group: 	Applications/Databases
PreReq:	sapdb-ind >= RELEASE
Requires:   sapdb-ind >= RELEASE


%description precompiler
SAP DB Precompiler

-	precompiler 
-	includes
-	libs (incl. precompiler runtime)

For more information please see www.sapdb.org.

%files precompiler
%attr(-, root, sapdb) /opt/sapdb/interfaces/precompiler
%pre precompiler


ports="
sql30   7200 tcp
sql6    7210 tcp
"
_i=0
for _arg in $ports
do
    if [ $_i -eq 0 ]; then
	_i=1; _servicename=$_arg; continue
    fi
    if [ $_i -eq 1 ]; then
	_i=2; _port=$_arg; continue
    fi
    _i=0
    _protocol=$_arg
    _serviceline=`awk '/^[ 	]*'$_servicename'[ 	]/ {print $1 "/" $2}' /etc/services 2>&1`
    if [ ! -z "$_serviceline" ]; then
	for _cl in $_serviceline
	do
	    if [ "$_cl" != "$_servicename/$_port/$_protocol" ]; then
		echo "inconsistent service entry database:" >&2
		echo "specified entry '$_servicename $_port/$_protocol' does not match retrieved entry:" >&2
		echo "$_serviceline" >&2
		exit 1
	    fi
	done
    fi
    if [ -z "$_serviceline" ]; then
	echo "$_servicename $_port/$_protocol" >> /etc/services
	if [ $? -ne 0 ]; then
	    echo "entry '$_servicename $_port/$_protocol' could not be added to /etc/services" >&2
	    echo "add the entry to /etc/services manually" >&2
	    exit 1
	fi
    fi
done
exit 0

%post precompiler

for _i in \
    /var/spool/sql \
    /var/spool/sql/config \
    /var/spool/sql/diag \
    /var/spool/sql/ipc \
    /var/spool/sql/fifo \
    /var/spool/sql/spool \
    /var/spool/sql/ini
do
    if ! [ -d $_i ]
    then
      mkdir -p $_i
      chmod 775 $_i
      chgrp sapdb $_i
      chown sapdb $_i
    fi
done

export IND_PATH=/var/opt/sapdb/indep_data
export X_PATH=/opt/sapdb/indep_prog/bin

_o=`$X_PATH/dbmcli -s dbm_getpath IndepDataPath | grep 'OK'`
if [ "$_o" != "OK" ]; then
    if ! [ -d $IND_PATH ]
    then
      mkdir -p $IND_PATH
      chmod 775 $IND_PATH
      chgrp sapdb $IND_PATH
      chown sapdb $IND_PATH
    fi
    _o=`$X_PATH/dbmcli -s dbm_setpath IndepDataPath $IND_PATH | grep OK`
    if [ "$_o" != "OK" ]; then
        echo "- could not set independent data path" >&2
        exit 1
    fi
fi

su - sapdb -c "$X_PATH/irconf -i -p /opt/sapdb/interfaces/precompiler/runtime/7403" >/dev/null 2>&1
exit 0

%preun precompiler

export IND_PATH=/var/opt/sapdb/indep_data
export X_PATH=/opt/sapdb/indep_prog/bin

if [ -f $IND_PATH/wrk/irtrace.shm ]; then
    rm -f $_o/wrk/irtrace.shm
fi

su - sapdb -c "$X_PATH/irconf -r -p  /opt/sapdb/interfaces/precompiler/runtime/7403" >/dev/null 2>&1
exit 0

####################################################################
#
#		SAP DB Perl/Python interface
#
#
#

%package scriptif
summary: 	Database Client Software
group: 	Applications/Databases


%description scriptif
SAP DB Perl and Python Interfaces

-	Perl driver
-	Python driver

For more information please see www.sapdb.org.

%files scriptif
%attr(-, root, sapdb) /opt/sapdb/interfaces/perl
%attr(-, root, sapdb) /opt/sapdb/interfaces/python



%pre scriptif

groupadd sapdb >/dev/null 2>&1

ports="
sql30   7200 tcp
sql6    7210 tcp
"
_i=0
for _arg in $ports
do
    if [ $_i -eq 0 ]; then
	_i=1; _servicename=$_arg; continue
    fi
    if [ $_i -eq 1 ]; then
	_i=2; _port=$_arg; continue
    fi
    _i=0
    _protocol=$_arg
    _serviceline=`awk '/^[ 	]*'$_servicename'[ 	]/ {print $1 "/" $2}' /etc/services 2>&1`
    if [ ! -z "$_serviceline" ]; then
	for _cl in $_serviceline
	do
	    if [ "$_cl" != "$_servicename/$_port/$_protocol" ]; then
		echo "inconsistent service entry database:" >&2
		echo "specified entry '$_servicename $_port/$_protocol' does not match retrieved entry:" >&2
		echo "$_serviceline" >&2
		exit 1
	    fi
	done
    fi
    if [ -z "$_serviceline" ]; then
	echo "$_servicename $_port/$_protocol" >> /etc/services
	if [ $? -ne 0 ]; then
	    echo "entry '$_servicename $_port/$_protocol' could not be added to /etc/services" >&2
	    echo "add the entry to /etc/services manually" >&2
	    exit 1
	fi
    fi
done
exit 0

%post scriptif

exit 0

%preun scriptif

exit 0


#################################################################
#
#
#	SAP DB sample database
#
#

%package testdb74
summary: 	sample database
group: 	Applications/Databases
PreReq:	sapdb-srv74
Requires: sapdb-srv74

%description testdb74
SAP DB Sample Database

-	package creates and immediately starts database instance TST74 (having 20 MB data space and 8 MB log space)
	Please remember to shutdown database before system shutdown. 
-	sample database user: TEST, password TEST
-	DBM user: DBM, password DBM
-	database administrator: DBA, password DBA 

For more information please see www.sapdb.org.


%files testdb74
%attr(775, root, sapdb) /opt/sapdb/testdb74

%pre testdb74
groupadd sapdb >/dev/null 2>&1
exit 0

%post testdb74
if [ "$1" != "1" ]; then
    # do nothing in upgrade case
    exit 0
fi
export DBROOT=/opt/sapdb/depend74

IND_PROG_DBROOT=`$DBROOT/bin/dbmcli dbm_getpath IndepProgPath 2>&1 | awk 'BEGIN {ok=0} NR==1 && $1="OK" {ok=1} NR==2 && ok!=0 {print $0}'`
[ -z "$IND_PROG_DBROOT" -a -f /var/spool/sql/ini/SAP_DBTech.ini ] && IND_PROG_DBROOT=`grep '^IndepPrograms=' /var/spool/sql/ini/SAP_DBTech.ini | sed 's:IndepPrograms=::g'`

[ ! -z "$IND_PROG_DBROOT" ] && su - -c "$IND_PROG_DBROOT/bin/x_server start" sapdb >/dev/null 2>&1


su -s /bin/sh -c "sh /opt/sapdb/testdb74/create_demo_db.sh > create_demo_db.log 2>&1" - sapdb > /dev/null 2>&1

exit 0

%preun testdb74
if [ "$1" != "0" ]; then
    # do nothing in upgrade case
    exit 0
fi
export DBROOT=/opt/sapdb/depend74

IND_PROG_DBROOT=`$DBROOT/bin/dbmcli dbm_getpath IndepProgPath 2>&1 | awk 'BEGIN {ok=0} NR==1 && $1="OK" {ok=1} NR==2 && ok!=0 {print $0}'`
[ -z "$IND_PROG_DBROOT" -a -f /var/spool/sql/ini/SAP_DBTech.ini ] && IND_PROG_DBROOT=`grep '^IndepPrograms=' /var/spool/sql/ini/SAP_DBTech.ini | sed 's:IndepPrograms=::g'`

[ ! -z "$IND_PROG_DBROOT" ] && su - -c "$IND_PROG_DBROOT/bin/x_server start" sapdb >/dev/null 2>&1

IND_DATA_DBROOT=`$DBROOT/bin/dbmcli dbm_getpath IndepDataPath 2>&1 | awk 'BEGIN {ok=0} NR==1 && $1="OK" {ok=1} NR==2 && ok!=0 {print $0}'`
[ -z "$IND_DATA_DBROOT" -a -f /var/spool/sql/ini/SAP_DBTech.ini ] && IND_DATA_DBROOT=`grep '^IndepData=' /var/spool/sql/ini/SAP_DBTech.ini | sed 's:IndepData=::g'`

su -s /bin/sh -c "sh /opt/sapdb/testdb74/drop_demo_db.sh > drop_demo_db.log 2>&1" - sapdb > /dev/null 2>&1

[ ! -z "$IND_DATA_DBROOT" ] && rm -rf $IND_DATA_DBROOT/wrk/sapdb >/dev/null 2>&1

exit 0

###############################################################
# 
#
#	SAP DB Webtools
#
# 
# 
#

%package web
summary: 	Database Client Software
group: 		Applications/Databases
PreReq:		sapdb-callif >= RELEASE
Requires:   sapdb-callif >= RELEASE


%description web
SAP DB Web Tools

-	modules for Apache Web Server
-	http server for running SAP DB Web Tools without Apache
	(start script is /etc/init.d/sapdbweb)
-	WebSQL, the browser-based SAP DB access for executing SQL statements,
	(url: http://<host>:<port>/websql)
-	WebDBM, the browser-based SAP DB access for administrating remote and local databases,
	(url: http://<host>:<port>/webdbm)

For more information please see www.sapdb.org.


%files web
%attr(-, root, sapdb) /opt/sapdb/web
%attr(775, root, root) /etc/init.d/sapdbweb
%attr(775, root, sapdb) /var/log/sapdb
%attr(755, root, sapdb) %config /var/spool/sql/ini/WebAgent74.ini
%attr(755, root, sapdb) %config /var/spool/sql/ini/sapdbxie.ini


%pre web

groupadd sapdb > /dev/null 2>&1

if [ ! -L /usr/spool ]; then
        if [ -d /usr/spool ]; then
                echo "/usr/spool has to be a link to ../var/spool"
                exit 1
        fi      
        if [ ! -d /var/spool ];then
                mkdir -p /var/spool > /dev/null 2>&1
        fi
        ln -s ../var/spool /usr/spool
fi

ports="
sql30   7200 tcp
sql6    7210 tcp
"
_i=0
for _arg in $ports
do
    if [ $_i -eq 0 ]; then
	_i=1; _servicename=$_arg; continue
    fi
    if [ $_i -eq 1 ]; then
	_i=2; _port=$_arg; continue
    fi
    _i=0
    _protocol=$_arg
    _serviceline=`awk '/^[ 	]*'$_servicename'[ 	]/ {print $1 "/" $2}' /etc/services 2>&1`
    if [ ! -z "$_serviceline" ]; then
	for _cl in $_serviceline
	do
	    if [ "$_cl" != "$_servicename/$_port/$_protocol" ]; then
		echo "inconsistent service entry database:" >&2
		echo "specified entry '$_servicename $_port/$_protocol' does not match retrieved entry:" >&2
		echo "$_serviceline" >&2
		exit 1
	    fi
	done
    fi
    if [ -z "$_serviceline" ]; then
	echo "$_servicename $_port/$_protocol" >> /etc/services
	if [ $? -ne 0 ]; then
	    echo "entry '$_servicename $_port/$_protocol' could not be added to /etc/services" >&2
	    echo "add the entry to /etc/services manually" >&2
	    exit 1
	fi
    fi
done
exit 0

%post web

HOSTNAME=`uname -n 2>/dev/null`
XIE_INI=/var/spool/sql/ini/sapdbxie.ini

if [ -f $XIE_INI ]; then
	cat $XIE_INI | sed -e s/\$NODE/$HOSTNAME/ > $XIE_INI.tmp 2>/dev/null
	mv $XIE_INI.tmp $XIE_INI >/dev/null 2>&1
fi

exit 0

%preun web
find /var/log/sapdb -type f -name '*.log' -exec rm {} \; >/dev/null 2>&1
rm /opt/sapdb/web/pgm/wahttp.pid >/dev/null 2>&1


exit 0
