/*!******************************************************************************

  @file         hkb39.h

  ------------------------------------------------------------------------------

  @author       UweH

  @brief        KB_backup_tasks

\if EMIT_LICENCE  

    ========== licence begin  GPL
    Copyright (C) 2001 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HKB39_H
#define HKB39_H


/*===========================================================================*
 *     RefType: Both                                                         *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\x41\x11\x9b\x77\x67\x87\xd9\x4f\xd9\xd4\xe6\x4d\x25\x6d\x6f\xab'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gkb00.h"
#include "vsp0031.h"
#include "gkb03.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void k39config_restartrec_from_first_tape (
    tgg00_TransContext    VAR_VALUE_REF  t,
    tkb3_save_static_ptr                 glob,
    tgg00_MessType2_Param                 msg2type,
    tsp00_Int2                           tape_no);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39incopy (
    tgg00_TransContext    VAR_VALUE_REF  t,
    tsp00_VFilename       VAR_ARRAY_REF  tape_name,
    tsp00_Int2            VAR_VALUE_REF  tape_no,
    tsp00_Int4                           buf_size,
    tsp00_MoveObjPtr                     buffer);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39GetEvents (
    tsp31_short_event_desc  VAR_VALUE_REF  Events);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39InitEventBackupPages (
    pasbool                              reset);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39locate_logentries_in_page (
    tgg00_TransContext    VAR_VALUE_REF  t,
    tsp00_PageNo                         wanted_lpno,
    tkb00_PagePtr         VAR_VALUE_REF  logpage,
    tsp00_MoveObjPtr      VAR_VALUE_REF  logbody,
    tsp00_Int4            VAR_VALUE_REF  logbody_len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39outcopy (
    tgg00_TransContext    VAR_VALUE_REF  t,
    tsp00_VFilename       VAR_ARRAY_REF  tape_name,
    tsp00_Int2            VAR_VALUE_REF  tape_no,
    tsp00_Int4                           buf_size,
    tsp00_MoveObjPtr                     buffer,
    tsp00_Int4            VAR_VALUE_REF  buf_len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 k39pages_for_first_info (
    tsp00_Int4                           blocksize);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39read_label (
    tgg00_TransContext    VAR_VALUE_REF  t,
    tkb3_save_static_ptr                 glob,
    tsp00_Int2                           tape_no,
    tkb3_info_stuff       VAR_VALUE_REF  my_info);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39release_logpage (
    tgg00_TransContext    VAR_VALUE_REF  t,
    tkb00_PagePtr         VAR_VALUE_REF  logpage);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39restore_config (
    tgg00_TransContext    VAR_VALUE_REF  t,
    tkb3_save_static_ptr                 glob,
    tsp_dbname            VAR_ARRAY_REF  dbname);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39run_backup_task (
    tgg00_MessBlock       VAR_VALUE_REF  mblock,
    pasbool                              in_region);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39SendEventBackupPages (
    tkb3_save_static_ptr                 glob);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39SetEventBackupPages (
    tsp00_TaskId                         taskId,
    tsp00_Int4                           distance);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39wakeup_all (
    tkb3_save_static_ptr                 glob,
    tsp00_TaskId                         process_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k39write_extra_block (
    tgg00_TransContext    VAR_VALUE_REF  t,
    tkb3_save_static_ptr                 glob,
    integer                              tape_no,
    tgg00_PageType2_Param                 what_page,
    tkb3_info_stuff       VAR_VALUE_REF  info);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

