/*!******************************************************************************

  @file         hkb391.h

  ------------------------------------------------------------------------------

  @author       MartinB

  @brief        KB_LogSaveIterator

\if EMIT_LICENCE  

    ========== licence begin  GPL
    Copyright (C) 2001 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HKB391_H
#define HKB391_H


/*===========================================================================*
 *     RefType: Both                                                         *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\x50\x36\x32\x9f\x72\x3d\x55\xe6\x40\x2a\x85\x55\x60\x06\xad\x48'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gkb00.h"
#include "gkb03.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void kb391_InitLogSaveIterator (
    tgg00_TransContext    VAR_VALUE_REF  trans,
    tsp00_Int2                           maxToBeRead,
    pasbool                              dbIsCold,
    pasbool                              forAutosave,
    pasbool                              completeLog,
    Log_SaveIterator*&                   iterator);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_ReadNextLogpages (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tkb3_block_ptr                       queue_buffer,
    tsp00_Int2            VAR_VALUE_REF  num_read);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_PrepareFreeLogForPipe (
    Log_SaveIterator*                    iterator,
    tgg00_BasisError      VAR_VALUE_REF  trError);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_DeleteIterator (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator**                   iterator);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetStartTime (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tsp00_Int4            VAR_VALUE_REF  startTime,
    tsp00_Int4            VAR_VALUE_REF  startDate);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetEndTime (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tsp00_Int4            VAR_VALUE_REF  endTime,
    tsp00_Int4            VAR_VALUE_REF  endDate);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetStartIOSeq (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tsp00_PageNo          VAR_VALUE_REF  startIOSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetEndIOSeq (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tsp00_PageNo          VAR_VALUE_REF  endIOSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetStartPageOffset (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tsp00_Uint4           VAR_VALUE_REF  startIOSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetEndPageOffset (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tsp00_Uint4           VAR_VALUE_REF  endIOSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetFirstNotSavedIOSeq (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tsp00_PageNo          VAR_VALUE_REF  endIOSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetFirstNotSavedPageOffset (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tsp00_Uint4           VAR_VALUE_REF  endOffset);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetNumOfPagesLeftForSegment (
    Log_SaveIterator*                    iterator,
    tsp00_Uint4           VAR_VALUE_REF  numOfUnsavedPages);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetNumOfPagesLeftForLogDev (
    Log_SaveIterator*                    iterator,
    tsp00_Uint4           VAR_VALUE_REF  numOfUnsavedPages);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391_GetBackupCount (
    tgg00_TransContext    VAR_VALUE_REF  t,
    Log_SaveIterator*                    iterator,
    tsp00_Uint4           VAR_VALUE_REF  backupCount);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_PageNo kb391_ReadFirstWriterIOSequenceNo (
    tkb00_Page            VAR_VALUE_REF  page);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_PageNo kb391_ReadLastWriterIOSequenceNo (
    tkb00_Page            VAR_VALUE_REF  page);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb391_IsCompleteSegment (
    Log_SaveIterator*                    iterator);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391Create_RTEConf_ParameterAccess (
    tgg00_TransContext    VAR_VALUE_REF  trans,
    tsp00_Addr            VAR_VALUE_REF  params);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391AppendTo_RTEConf_ParameterAccess (
    RTEConf_Parameter&                   params,
    tkb3_xparam_page      VAR_VALUE_REF  xpPage);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tgg00_BasisError kb391CheckParameterForRestore (
    RTEConf_Parameter&                   params);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb391Destroy_RTEConf_ParameterAccess (
    tgg00_TransContext    VAR_VALUE_REF  trans,
    tsp00_Addr            VAR_VALUE_REF  params);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

