/*!******************************************************************************

  @file         hkb560.h

  ------------------------------------------------------------------------------

  @author       UweH

  @brief        KB_Logging

\if EMIT_LICENCE

    ========== licence begin  GPL
    Copyright (C) 2001 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HKB560_H
#define HKB560_H


/*===========================================================================*
 *     RefType: Both                                                         *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\x95\x58\x1b\x6e\x4b\xa0\xf7\x5f\xe6\xb0\xec\x34\xb7\xff\x9c\x0c'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gkb00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void kb560GetArchiveLogDeviceInfo (
    tsp00_TaskId                         taskid,
    SAPDB_UInt4                          logno,
    pasbool               VAR_VALUE_REF  available,
    SAPDB_UInt4           VAR_VALUE_REF  deviceSize,
    SAPDB_UInt4           VAR_VALUE_REF  pagesUsed,
    SAPDB_UInt4           VAR_VALUE_REF  pagesNotSaved);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560GetArchiveLogQueueInfo (
    tsp00_TaskId                         taskid,
    SAPDB_UInt4                          logno,
    pasbool               VAR_VALUE_REF  available,
    SAPDB_UInt4           VAR_VALUE_REF  queueSize,
    SAPDB_UInt4           VAR_VALUE_REF  maxPagesUsedInQueue,
    SAPDB_UInt4           VAR_VALUE_REF  countReserveRequests,
    SAPDB_UInt4           VAR_VALUE_REF  auxCountWaitForIO,
    SAPDB_UInt4           VAR_VALUE_REF  auxCountGroupCommit,
    SAPDB_UInt4           VAR_VALUE_REF  countWaitForQueueFree,
    SAPDB_UInt4           VAR_VALUE_REF  maxWaitForPageIO);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560GetStatistics (
    tsp00_TaskId                         taskid,
    tkb00_LogDeviceInfo   VAR_VALUE_REF  LogDeviceInfo,
    tkb00_LogQueueInfo    VAR_VALUE_REF  LogQueueInfo);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560ResetStatistics (
    tsp00_TaskId                         taskid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560GetRestartVersion (
    tsp00_TaskId                         taskid,
    tsp00_Int4            VAR_VALUE_REF  firstiosequence,
    tsp00_Line            VAR_ARRAY_REF  dbident,
    pasbool               VAR_VALUE_REF  log_devspace_enabled);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560GetLogDBIdent (
    tsp00_Line            VAR_ARRAY_REF  dbident);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560GetLogInfo (
    tsp00_TaskId                         taskid,
    tsp00_Int4            VAR_VALUE_REF  date,
    tsp00_Int4            VAR_VALUE_REF  time,
    tsp00_Int4            VAR_VALUE_REF  overwritemode,
    tsp00_Int4            VAR_VALUE_REF  devicestate,
    tsp00_Uint4           VAR_VALUE_REF  queuecount,
    tsp00_Uint4           VAR_VALUE_REF  cycleendoffset,
    tsp00_Uint4           VAR_VALUE_REF  oldestnotsavedoffset,
    tsp00_Uint4           VAR_VALUE_REF  oldestnotsavedsequence,
    tsp00_Uint4           VAR_VALUE_REF  lastknownoffset,
    tsp00_Uint4           VAR_VALUE_REF  lastknownsequence,
    tsp00_Uint4           VAR_VALUE_REF  backupcount,
    tsp00_Int4            VAR_VALUE_REF  untildate,
    tsp00_Int4            VAR_VALUE_REF  untiltime,
    tsp00_Uint4           VAR_VALUE_REF  untilclearloweroffset,
    tsp00_Uint4           VAR_VALUE_REF  untilclearupperoffset,
    tsp00_Uint4           VAR_VALUE_REF  untilsequenceafterredo,
    tsp00_Uint4           VAR_VALUE_REF  savepointsequence,
    tsp00_Uint4           VAR_VALUE_REF  savepointdevoffset,
    tsp00_Uint4           VAR_VALUE_REF  savepointoffset);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560DumpTransaction (
    Log_Transaction*                     pTrans,
    void*&                               pData,
    SAPDB_UInt4&                         dataLength);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560VerifyOpenTransAndHistory (
    tgg00_TransContext    VAR_VALUE_REF  Trans,
    pasbool                              isCold);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560CreateHistoryManager (
    tgg00_TransContext    VAR_VALUE_REF  Trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560DropHistoryManager ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 kb560GetNumOfUserUKTs ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560FreeLog (
    tsp00_TaskId                         taskId,
    tsp00_Uint4                          oldLastSavedIOsequence,
    tsp00_Uint4                          oldLastSavedOffset,
    tsp00_Uint4                          newLastSavedIOsequence,
    tsp00_Uint4                          newLastSavedOffset);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560ExecuteFreeLogForPipe (
    tsp00_TaskId                         taskId,
    tsp00_Uint4                          firstSavedIOsequence,
    tsp00_Uint4                          lastSavedIOsequence,
    tgg00_BasisError      VAR_VALUE_REF  trError);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560TransactionIsOpen (
    void*                                TransPtr);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560InitSavepointParam (
    tkb00_SaveptParam     VAR_VALUE_REF  param);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560StartSavepointAndWait (
    tgg00_TransContext    VAR_VALUE_REF  Trans,
    tgg00_MessType2_Param                 MessType2);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560StartSavepoint (
    tgg00_TransContext    VAR_VALUE_REF  Trans,
    tgg00_MessType2_Param                 MessType2);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560SavepointCoordinator (
    tgg00_TransContext    VAR_VALUE_REF  Trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560AllocateArchiveLogManager (
    tsp00_TaskId                         TaskId);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560InitLogForRestart (
    tsp00_TaskId                         TaskId,
    tgg00_BasisError      VAR_VALUE_REF  TrError);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560InitLogForRestore (
    tsp00_TaskId                         TaskId,
    tgg00_BasisError      VAR_VALUE_REF  TrError);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560InitLogForLogSave (
    tsp00_TaskId                         TaskId,
    tgg00_BasisError      VAR_VALUE_REF  TrError);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560InitLogForNewDatabase (
    tsp00_TaskId                         TaskId);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560ClearArchiveLog (
    tsp00_TaskId                         TaskId);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560LogWriter (
    tsp00_TaskId                         TaskId);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560CreateLogTransaction (
    tgg00_TransContext    VAR_VALUE_REF  Trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560DeleteLogTransaction (
    tgg00_TransContext    VAR_VALUE_REF  Trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560CommitLogTransaction (
    tgg00_TransContext    VAR_VALUE_REF  Trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560RollbackLogTransAction (
    tgg00_TransContext    VAR_VALUE_REF  Trans,
    tgg00_MessType2_Param                 RollbackKind,
    tgg00_SubtransNo                     SubTransNo);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560BeginSubtransLogTransaction (
    tgg00_TransContext    VAR_VALUE_REF  Trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560EndSubtransLogTransaction (
    tgg00_TransContext    VAR_VALUE_REF  Trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560GetFirstKnownIOSeqBeforeRestoreLog (
    tsp00_PageNo          VAR_VALUE_REF  FirstIOSeq,
    pasbool               VAR_VALUE_REF  firstIOSeqIsValid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560CheckLogFull (
    tsp00_TaskId                         TaskId);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560LogIsFull (
    tsp00_TaskId                         TaskId);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560CheckLogTapeAndDataCompatibility (
    tgg00_TransContext    VAR_VALUE_REF  trans,
    const tkb00_Page&                    restartRecord,
    tsp00_Version         VAR_ARRAY_REF  backupVersion,
    tsp00_Line            VAR_ARRAY_REF  dbident,
    tsp00_PageNo                         firstIOSeq,
    tsp00_PageNo                         lastIOSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560SupressDBIdentCheckForMigration (
    tsp00_Version         VAR_ARRAY_REF  backupVersion);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560NewLogSize (
    tsp00_Int4                           NewLogSize);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k560check_logsave_allowed (
    tsp00_TaskId                         TaskId,
    tgg00_BasisError      VAR_VALUE_REF  BasisError);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 kb560GetLogDeviceSize ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560SetLogDevspace (
    tsp00_TaskId                         TaskId,
    pasbool                              isCold,
    tgg00_BasisError      VAR_VALUE_REF  TrError,
    pasbool                              on);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560IsLogDeviceEnabled (
    tsp00_TaskId                         TaskId);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560SetDeviceStateOkay (
    tsp00_TaskId                         taskid,
    pasbool                              isCold,
    tgg00_BasisError      VAR_VALUE_REF  TrError);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560GetHistFileInfo (
    tgg00_TransContext    VAR_VALUE_REF  Trans,
    tsp00_Int4            VAR_VALUE_REF  HistFileNo,
    tgg91_TransNo         VAR_VALUE_REF  FirstTransId,
    pasbool               VAR_VALUE_REF  FirstTransIsUsed,
    tgg91_TransNo         VAR_VALUE_REF  LastTransId,
    pasbool               VAR_VALUE_REF  LastTransIsUsed,
    tsp00_Int4            VAR_VALUE_REF  PageCount,
    pasbool               VAR_VALUE_REF  bFileIsEmpty);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560CheckKernelVersionForMigration (
    tsp00_Version         VAR_ARRAY_REF  version);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560RemoveCompleteHistory (
    tgg00_TransContext    VAR_VALUE_REF  Trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560AnyHistoryExists ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560StartGCAndWaitForNoHistoryExists (
    tgg00_TransContext    VAR_VALUE_REF  Trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560GetLogTransactionInfo (
    Log_Transaction*                     ptrans,
    tsp00_PageNo          VAR_VALUE_REF  undoroot,
    tsp00_PageNo          VAR_VALUE_REF  undolast,
    tsp00_Int4            VAR_VALUE_REF  undopagecount,
    tsp00_Int4            VAR_VALUE_REF  lastundosequence);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560NewDBIdentIfHistLost (
    tgg00_TransContext    VAR_VALUE_REF  trans,
    pasbool                              isCold);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560NewDBIdent (
    tgg00_TransContext    VAR_VALUE_REF  trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560ConvertInvalidIOSeqToLPNo (
    tsp00_PageNo          VAR_VALUE_REF  ioSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560InvalidateIOSeq (
    tsp00_PageNo          VAR_VALUE_REF  ioSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560IsValidIOSeq (
    tsp00_PageNo                         ioSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560IsGreaterIOSeq (
    tsp00_PageNo                         leftOperand,
    tsp00_PageNo                         rightOperand);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Uint4 kb560IncrementIOSeq (
    Log_IOSequenceNo                     ioSeq);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tgg00_BasisError kb560ConvertRollbackResultToBasisError (
    tsp00_Int4                           result);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tgg00_BasisError kb560ConvertWriteRedoEntryResultToBasisError (
    tsp00_Int4                           result);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560CheckForLogSaveAndSavepoint (
    tgg00_TransContext    VAR_VALUE_REF  trans);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560SuspendAndGetLastWrittenIOSequence (
    tsp00_TaskId                         taskid,
    tsp00_Uint4           VAR_VALUE_REF  iosequence);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void k560ResumeLogWriterByUser (
    tsp00_TaskId                         taskid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool k560IsSavepointAllowed ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560GetSavepointStatistics (
    tsp00_Int4            VAR_VALUE_REF  lastDurationSec,
    tsp00_Int4            VAR_VALUE_REF  lastDurationMicroSec,
    tsp00_Int4            VAR_VALUE_REF  avgWrittenPages,
    tsp00_Int4            VAR_VALUE_REF  avgIOcount);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560SetLogAutoOverwrite (
    tsp00_TaskId                         taskid,
    pasbool                              isAdminMode,
    pasbool                              on);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool kb560IsLogAutoOverwriteEnabled (
    tsp00_TaskId                         taskid,
    pasbool                              isAdminMode);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void kb560SetTraceMaxBufferLength (
    tsp00_Int4                           length);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

