/*!***************************************************************************

  module      : vkb511.cpp
  responsible : FerdiF
  special area: KB_LockListe
  last changed: 2003-06-17
  copyright   : Copyright by SAP AG, 2000
  see also    :
  description : methods to implement Reader/Writer ConsistView Region


    ========== licence begin  GPL
    Copyright (C) 2003 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*****************************************************************************/

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/
#include "RunTime/Synchronisation/RTESync_RWRegion.hpp"
#include "RunTime/MemoryManagement/RTEMem_RteAllocator.hpp"
#include "hgg08.h" 
#include "heo55k.h"     // vbegexcl, vendexcl

/*-----------------------------------------------------------------------------------*/
static RTESync_SpinlockPool *g_SpinLockPool   = NULL;
static RTESync_IRWRegion    *g_IRWLockRegion  = NULL;
/*-----------------------------------------------------------------------------------*/
/* PTS 1126667 FF 2003-12-22 */

externPascal void kb511InitRWConsistLocks(void)
{
    if ( NULL == g_SpinLockPool) {
        g_SpinLockPool = reinterpret_cast<RTESync_SpinlockPool*>(
            ( RTEMem_RteAllocator::Instance())
            .Allocate(sizeof(RTESync_SpinlockPool)) );
        g_SpinLockPool = new(g_SpinLockPool) RTESync_SpinlockPool( UTF8("kb511:ConsistViewRWLock"),1);
        g_IRWLockRegion = RTESync_CreateRWRegion( 1, *g_SpinLockPool, RTEMem_RteAllocator::Instance());
    }
}
/*-----------------------------------------------------------------------------------*/

externPascal void kb511EnterConsistView (tsp00_TaskId      Taskid,
                                         pasbool           exclusiveRequest)
{
    g_IRWLockRegion->enter((0 != exclusiveRequest), Taskid );
}

/*-----------------------------------------------------------------------------------*/

externPascal void kb511LeaveConsistView (tsp00_TaskId      Taskid,
                                         pasbool           exclusiveRequest)
{
    g_IRWLockRegion->leave((0 != exclusiveRequest), Taskid);
}