/*!**************************************************************************

    module      : vkb571.cpp

    -------------------------------------------------------------------------

    author      : JuergenA
    responsible : UweH

    special area: Logging
    description : KB_RefreshSurrogSeq_interface

    last changed: 2001-04-19

    -------------------------------------------------------------------------

    copyright:    Copyright by SAP AG, 2001

    ========== licence begin LGPL
    Copyright (C) 2001 SAP AG
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*****************************************************************************/

/*==========================================================================*
*  INCLUDES                                                                 *
*===========================================================================*/

#include "Logging/Log_ActionRefreshSurrogSeq.hpp"
#include "gsp00.h"
#include "ggg00.h"
#include "hkb571.h" // check of PASCAL header vkb571


/*==========================================================================*
* PASCAL INTERFACE                                                          *
*===========================================================================*/

externPascal void kb571WriteRefreshSeqAfterImage (tgg00_TransContext &TransContext,
                                                  tsp00_Int4          SequenceCount,
                                                  const tsp00_Addr    pSequenceList)
                                                  
{
    Log_ActionRefreshSequence AfterImage (SequenceCount, pSequenceList);
    
    AfterImage.WriteAfterImage (TransContext);
}

//----------------------------------------------------------------------------

externPascal void kb571WriteRefreshSurrogAfterImage (tgg00_TransContext    &TransContext,
                                                     const tgg00_Surrogate &Surrogate,
                                                     const tgg00_Surrogate &SysKey)
{
    Log_ActionRefreshSurrogate AfterImage (Surrogate, SysKey);
    
    AfterImage.WriteAfterImage (TransContext);
}

/*===========================================================================*
*  END OF CODE                                                               *
*============================================================================*/
