
/*!**************************************************************************

    module      : vkb921.cpp

    -------------------------------------------------------------------------

    author      : JuergenA
    responsible : UweH

    special area: Logging
    description : KB_LogReader_and_RedoTask

    last changed: 2001-03-21

    -------------------------------------------------------------------------

    copyright:    Copyright by SAP AG, 2001

    ========== licence begin LGPL
    Copyright (C) 2001 SAP AG
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*****************************************************************************/

/*==========================================================================*
*  INCLUDES                                                                 *
*===========================================================================*/

#include "SAPDBCommon/SAPDB_Types.hpp"
#include "Logging/Log_IRedoReadTask.hpp"
#include "Logging/Log_IRedoTrafficControl.hpp"
#include "ggg00.h"
#include "hkb921.h" // check of PASCAL header vkb921

#include "gsp00_0.h" // ROUTINE_DBG_MSP00

#if COMPILEMODE_MSP00 >= SLOW_MSP00	
#include "hta99.h"
#endif


/*==========================================================================*
* PASCAL INTERFACE                                                          *
*===========================================================================*/

externPascal void kb921RedoLogExecuteTask (tgg00_TransContext &TransContext)
{
    ROUTINE_DBG_MSP00 ("kb921RedoLogExecuteTask");
    
    Log_IRedoTrafficControl::Instance().ExecuteJobs (TransContext);
}

//---------------------------------------------------------------------------

externPascal void kb921RedoLogReadTask (tgg00_TransContext &TransContext)
{
    ROUTINE_DBG_MSP00 ("kb921RedoLogReadTask");
    
    Log_IRedoReadTask::Instance().ReadLogAndCreateRedoFiles (TransContext);    
}

/*===========================================================================*
*  END OF CODE                                                               *
*============================================================================*/
