/*!**************************************************************************

  module      : vos18u.c

  -------------------------------------------------------------------------

  responsible : RaymondR

  special area: character set mapping
  description : 


  last changed: 2001-09-21  12:42
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin LGPL
  Copyright (C) 2001 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/



//
// INCLUDE FILES
//
#include "gos00.h"
#include "heo00.h"
#include "heo46.h"
#include "vsp004.h"
#include "geo13.h"
#include "hos13u.h"


//
//  DEFINES
//

#define MOD__  "VOS18UC : "
#define MF__   MOD__"UNDEFINED"


//
//  MACROS
//


//
//  LOCAL TYPE AND STRUCT DEFINITIONS
//


//
// EXTERNAL VARIABLES
//


//
//  EXPORTED VARIABLES
//


//
// LOCAL VARIABLES
//


//
// LOCAL FUNCTION PROTOTYPES
//

//
// ========================== GLOBAL FUNCTIONS ================================
//


VOID sqlcharsetname ( tsp_knl_identifier acCharSetName )
  {
  #undef  MF__
  #define MF__ MOD__"sqlcharsetname"
  PSZ             pszCharSetName;
  #if defined ( _WIN32 )
   CHAR           szCharSetName[sizeof(tsp_knl_identifier) + 1];
   BOOL           fEnabled;
   APIRET         rc;
  #endif

  DBGIN;

  memset( acCharSetName, ' ', sizeof (tsp_knl_identifier));

  if( ( pszCharSetName = getenv ( CHAR_SET_ENV_VAR )) != NULL )
    {
    DBG3 (( MF__, "%s = '%s' ", CHAR_SET_ENV_VAR, pszCharSetName));
    eo46CtoP ( acCharSetName, pszCharSetName, sizeof(tsp_knl_identifier) );
    DBGOUT;
    return;
    }

  #if defined ( _WIN32 )
   rc = sql13u_get_options_char_set_map ( &fEnabled, szCharSetName,
                                          sizeof(tsp_knl_identifier) );
   if (( rc == NO_ERROR ) && ( fEnabled ))
     {
     eo46CtoP ( acCharSetName, szCharSetName, sizeof(tsp_knl_identifier) );
     DBGOUT;
     return;
     }
  #endif


  DBGOUT;
  return;
  }

//
// ========================== LOCAL FUNCTIONS =================================
//


//
// =============================== END ========================================
//
