/*!**************************************************************************

  module      : vos82k.c

  -------------------------------------------------------------------------

  responsible : RaymondR

  special area: CONSOLE Thread
  description : 


  last changed: 2001-09-21  14:31
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin  GPL
  Copyright (C) 2001 SAP AG

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  ========== licence end

*****************************************************************************/



/*
 * INCLUDE FILES
 */
//#include "gos00.h"
#include "gos41.h"
#include "heo00.h"
#include "heo46.h"
#include "geo007_1.h"
#include "gos00k.h"
#include "geo002.h"
#include "gos00cn.h"
#include "gos003.h"
#include "heo54k.h"
#include "heo92.h"
#include "heo670.h"
#include "RunTime/MemoryManagement/RTEMem_AWEAllocator.hpp"
#include "heo52.h"
#include "RunTime/System/RTESys_MicroTime.h"


/*
 *  DEFINES
 */
#define MOD__  "VOS82KC : "
#define MF__   MOD__"UNDEFINED"

/*
 *  MACROS
 */
#define OFFSET_OFF(_strct,_elem)   ((size_t)&(((_strct *)0)->_elem))

#define QW_TO_DBL(_ulHigh,_ulLow) (((double)_ulHigh * 4294967296.) +    \
                                    (double)_ulLow)

#define ALL_TASK_COUNTS   TRUE
#define TASK_STATES_ONLY  FALSE

/*
 *  LOCAL TYPE AND STRUCT DEFINITIONS
 */


/*
 * EXTERNAL VARIABLES
 */


/*
 *  EXPORTED VARIABLES
 */


/*
 * LOCAL VARIABLES
 */


/*
 * LOCAL FUNCTION PROTOTYPES
 */
VOID sql82k_set_ukt_affinity      ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_SetProcessorAffinityMask ( PCONSOLE_REC  pConsoleRec ); /* PTS 1107070 */
VOID sql82k_get_task_info         ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_io_info           ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_aio_info          ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_region_info       ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_storage_info      ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_rte_info          ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_queue_info        ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_task_count_info   ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_total_count_info  ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_set_debuglevel        ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_enable_time_measure   ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_disable_time_measure  ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_ukt_sl_stat_info  ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_cancel_task           ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_kill_task             ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_reset_io_info         ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_reset_region_info     ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_reset_task_count_info ( PCONSOLE_REC  pConsoleRec,
                                    BOOLEAN       fAllTaskCounts );
VOID sql82k_reset_ukt_sl_stat_info( PCONSOLE_REC  pConsoleRec );
VOID sql82k_reset_queue_info      ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_reset_suspends        ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_reset_all             ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_show_suspends         ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_show_param            ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_show_thread_times     ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_crash_dump            ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_force_io_error        ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_ukt_queues        ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_get_ukt_COM_queue     (
                      PTASK_CTRL_REC pFirstInCOMQue,
                      PCONS_SINGLE_UKT_QUEUES_INFO_REC  pUKTQueues,
                      ULONG                            *pulUKTSingleQueueOffset,
                      PCONS_SINGLE_QUEUE_INFO_REC       *ppUKTSingleQueue) ;

VOID sql82k_get_ukt_UKT_queue (
                      struct ukt_queue_record          *pLastUsedElem,
                      PCONS_SINGLE_UKT_QUEUES_INFO_REC  pUKTQueues,
                      ULONG                            *pulUKTSingleQueueOffset,
                      PCONS_SINGLE_QUEUE_INFO_REC      *ppUKTSingleQueue);

VOID sql82k_get_ukt_RUN_queue (
                      PUKT_CTRL_REC                     pUKT,
                      PCONS_SINGLE_UKT_QUEUES_INFO_REC  pUKTQueues,
                      ULONG                            *pulUKTSingleQueueOffset,
                      PCONS_SINGLE_QUEUE_INFO_REC      *ppUKTSingleQueue);
VOID sql82k_debug_break             ( PCONSOLE_REC           pConsoleRec );
VOID sql82k_debug_task              ( PCONSOLE_REC           pConsoleRec );
VOID sql82k_get_awe_info            ( PCONSOLE_REC           pConsoleRec );
VOID sql82k_get_connections_info    ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_show_task_move_info     ( PCONSOLE_REC  pConsoleRec );
VOID sql82k_show_set_check_interval ( PCONSOLE_REC  pConsoleRec );
LONG sql82k_min_shm_size                        ( VOID );
LONG sql82k_min_set_ukt_affinity                ( VOID );
LONG sql82k_MinSetProcessorAffinityMask         ( VOID );
LONG sql82k_min_crash_dump_shm_size             ( VOID );
LONG sql82k_min_cancel_task_shm_size            ( VOID );
LONG sql82k_min_kill_task_shm_size              ( VOID );
LONG sql82k_min_get_task_info_shm_size          ( VOID );
LONG sql82k_min_get_io_info_shm_size            ( VOID );
LONG sql82k_min_get_aio_info_shm_size           ( VOID );
LONG sql82k_min_get_region_info_shm_size        ( VOID );
LONG sql82k_min_get_storage_info_shm_size       ( VOID );
LONG sql82k_min_get_rte_info_shm_size           ( VOID );
LONG sql82k_min_get_queue_info_shm_size         ( VOID );
LONG sql82k_min_get_task_count_shm_size         ( VOID );
LONG sql82k_min_get_total_count_shm_size        ( VOID );
LONG sql82k_min_enable_time_measure_shm_size    ( VOID );
LONG sql82k_min_disable_time_measure_shm_size   ( VOID );
LONG sql82k_min_get_ukt_sl_stat_info_shm_size   ( VOID );
LONG sql82k_min_reset_region_info_shm_size      ( VOID );
LONG sql82k_min_reset_io_info_shm_size          ( VOID );
LONG sql82k_min_reset_task_count_info_shm_size  ( VOID );
LONG sql82k_min_reset_queue_info_shm_size       ( VOID );
LONG sql82k_min_reset_ukt_sl_stat_info_shm_size ( VOID );
LONG sql82k_min_reset_suspends_shm_size         ( VOID );
LONG sql82k_min_show_suspends_shm_size          ( VOID );
LONG sql82k_min_show_param_shm_size             ( VOID );
LONG sql82k_min_show_thread_times_size          ( VOID );
LONG sql82k_min_set_debuglevel_shm_size         ( VOID );
LONG sql82k_min_get_ukt_queues_shm_size         ( VOID );
LONG sql82k_min_force_io_error_shm_size         ( VOID );
LONG sql82k_min_debug_break_shm_size            ( VOID );
LONG sql82k_min_debug_task_shm_size             ( VOID );
LONG sql82k_min_get_awe_info_shm_size           ( VOID );
LONG sql82k_min_show_task_move_info_size        ( VOID );


/*
 * ========================== GLOBAL FUNCTIONS ================================
 */

VOID _System sql82k_console ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_console"
  APIRET                         rc          = NO_ERROR;
  PCONSOLE_REC                   pConsoleRec = NULL;
  HANDLE                         hConsoleRec = 0;
  ULONG                          ulConsoleRecLen;
  ULONG                          ulReqType;
  PSZ                            pszPath;
  PSZ                            pszName;
  CONS_REQUEST_REC               Request;

  DBGIN;

  __try 
   {
    // --- set the thread priority
    rc = SET_THREAD_PRIO ( kgs.Console.ThrdCtrlHeader.lThrdPrio,
                           kgs.Console.ThrdCtrlHeader.Tid,
                           kgs.Console.ThrdCtrlHeader.hThrd );

    if ( rc != NO_ERROR )
      {
      MSGD (( ERR_SETTING_THRD_PRIO, kgs.Console.ThrdCtrlHeader.Tid));
      DBG1 ((MF__, "Cannot set the thread priority, TID: %u",
                    kgs.Console.ThrdCtrlHeader.Tid));
      ABORT();
      }

    pkss->ulConsoleShmSize = sql82k_min_shm_size();
    pkss->ulConsoleShmSize = ALIGN( pkss->ulConsoleShmSize, kgs.ulSystemPageSize );

    //
    //
    // --- Create named queue / mailslot for console
    //
    //
    #if defined(_WIN32)
     pszPath = MAIL_CONS;
     pszName = kgs.szServerDB;
    #else
     pszPath = QUE_CONS;
     pszName = kgs.szServerDB;
    #endif

    rc = sql41c_create_queue_mailslot ( &kgs.Console.ThrdCtrlHeader.hComm,
                                        pszPath, pszName,
                                        sizeof (CONS_REQUEST_REC),     // - WIN32
                                        &kgs.WorldSA );                // - WIN32
    if (rc != NO_ERROR)
      ABORT();

    // --- set thread control info
    kgs.Console.ThrdCtrlHeader.ulStartTime = kgs.ulCurrTime;

    MSGD (( INFO_KERNEL_THREAD_STARTED, "CONSOLE" ));

    for (;;)
      {
      //
      //
      // --- get the next request
      //
      //
      kgs.Console.ThrdCtrlHeader.ThrdState   = KT_SLEEPING;

      rc = sql41c_read_queue_mailslot ( kgs.Console.ThrdCtrlHeader.hComm,
                                        &Request,
                                        sizeof (CONS_REQUEST_REC),
                                        &ulConsoleRecLen,               // - OS/2
                                        (PPVOID)&pConsoleRec );         // - OS/2

      if ( rc != NO_ERROR )
        continue;

      kgs.Console.ThrdCtrlHeader.ThrdState   = KT_RUNNING;


      #if defined(_WIN32)
       rc = sql41c_get_named_shrd_mem ( (PPVOID)&pConsoleRec,
                                        SHM_CONSREC, Request.szClientObjName,
                                        &hConsoleRec );

       if ( rc != NO_ERROR )
         continue;

       ulConsoleRecLen  = Request.ulConsoleRecLen;
       ulReqType        = Request.ulReqType;
      #else
       ulReqType        = Request;
      #endif

      if ((pConsoleRec == NULL) || (ulConsoleRecLen != pkss->ulConsoleShmSize))
        {
        MSGCD (( ERR_WRONG_CON_REC ));
        DBG1 ((MF__, "Wrong console record" ));
        continue;
        }

        __try
        {
          switch (ulReqType)
          {
          case CON_REQ_SET_UKT_AFFINITY:
            sql82k_set_ukt_affinity ( pConsoleRec );
            break;
          case CON_REQ_SET_PROCESSOR_MASK:
            sql82k_SetProcessorAffinityMask ( pConsoleRec ); /* PTS 1107070 */
            break;
          case CON_REQ_CRASH_DUMP:
            sql82k_crash_dump ( pConsoleRec );
            break;
          case CON_REQ_CANCEL:
            sql82k_cancel_task ( pConsoleRec );
            break;
          case CON_REQ_KILL:
            sql82k_kill_task ( pConsoleRec );
            break;
          case CON_REQ_TASK:
            sql82k_get_task_info ( pConsoleRec );
            break;
          case CON_REQ_IO:
            sql82k_get_io_info ( pConsoleRec );
            break;
          case CON_REQ_AIO:
            sql82k_get_aio_info ( pConsoleRec );
            break;
          case CON_REQ_REGION:
            sql82k_get_region_info ( pConsoleRec );
            break;
          case CON_REQ_STORAGE:
            sql82k_get_storage_info ( pConsoleRec );
            break;
          case CON_REQ_STATE:
            pConsoleRec->Data.StateInfo.ulTerminationTimeOut = kgs.ulTerminationTimeOut;
            pConsoleRec->Data.StateInfo.DatabaseState        = kgs.DatabaseState;
            break;
          case CON_REQ_RTE  :
            sql82k_get_rte_info ( pConsoleRec );
            break;
          case CON_REQ_TASK_COUNTS  :
            sql82k_get_task_count_info ( pConsoleRec );
            break;
          case CON_REQ_TOTAL_COUNTS  :
            sql82k_get_total_count_info ( pConsoleRec );
            break;
          case CON_REQ_QUEUE_STAT  :
            sql82k_get_queue_info ( pConsoleRec );
            break;
          case CON_REQ_SET_DEBUGLEVEL :
            sql82k_set_debuglevel ( pConsoleRec );
            break;
          case CON_REQ_ENABLE_TIME_MEASURE  :
            sql82k_enable_time_measure ( pConsoleRec );
            break;
          case CON_REQ_DISABLE_TIME_MEASURE :
            sql82k_disable_time_measure ( pConsoleRec );
            break;
          case CON_REQ_UKT_SLEEPTIME_STAT   :
            sql82k_get_ukt_sl_stat_info ( pConsoleRec );
            break;
          case CON_REQ_RES_IO               :
            sql82k_reset_io_info        ( pConsoleRec );
            break;
          case CON_REQ_RES_REGION           :
            sql82k_reset_region_info    ( pConsoleRec );
            break;
          case CON_REQ_RES_TASK_COUNTS      :
            sql82k_reset_task_count_info ( pConsoleRec , ALL_TASK_COUNTS );
            break;
          case CON_REQ_RES_UKT_SLEEPTIME_STAT :
            sql82k_reset_ukt_sl_stat_info( pConsoleRec );
            break;
          case CON_REQ_RES_QUEUE_STAT       :
            sql82k_reset_queue_info      ( pConsoleRec );
            break;
          case CON_REQ_RES_SUSPENDS         :
            sql82k_reset_suspends        ( pConsoleRec );
            break;
          case CON_REQ_RES_ALL              :
            sql82k_reset_all             ( pConsoleRec );
            break;
          case CON_REQ_SHOW_SUSPENDS        :
            sql82k_show_suspends         ( pConsoleRec );
            break;
          case CON_REQ_GETPARAM             :
            sql82k_show_param            ( pConsoleRec );
            break;
          case CON_REQ_THREAD_TIMES             :
            sql82k_show_thread_times     ( pConsoleRec );
            break;
          case CON_REQ_UKT_QUEUES           :
            sql82k_get_ukt_queues        ( pConsoleRec );
            break;
          case CON_REQ_FORCE_IO_ERROR       :
            sql82k_force_io_error        ( pConsoleRec );
            break;
          case  CON_REQ_DEBUG_BREAK          :
            sql82k_debug_break           ( pConsoleRec );
            break;
          case  CON_REQ_DEBUG_TASK          :
            sql82k_debug_task            ( pConsoleRec );
            break;
          case CON_REQ_AWE:
            sql82k_get_awe_info          ( pConsoleRec );
            break;
          case CON_REQ_CONNECTIONS:
            sql82k_get_connections_info  ( pConsoleRec );
            break;
          case CON_REQ_TASK_MOVE:
            sql82k_show_task_move_info     ( pConsoleRec );
            break;
          case CON_REQ_SET_CHECK_INTERVAL:
            sql82k_show_set_check_interval ( pConsoleRec );
            break;
          case CON_REQ_PUTPARAM             :
          default:
            MSGD (( ERR_WRONG_CON_REQUEST ));
            DBG1 ((MF__, "Wrong console thread request" ));
            break;
          }
        }
        __except( EXCEPTION_EXECUTE_HANDLER ) 
        {
          MSGD (( 19999, 1, "EXCEPT  ", "---> Console request aborted! <---" ));
          eo670_CTraceStack();
        }

      pConsoleRec->fDataAvailable = TRUE;

      rc = sql41c_free_shrd_mem( pConsoleRec,
                                 hConsoleRec );
                                                                       // - WIN32
      if( rc != NO_ERROR)
        {
        DBG1 ((MF__, "Cannot free memory, rc = %u", rc ));
        ABORT();
        }
      }
  }
  __except( sql50k_excepthandler(GetExceptionInformation()) ) {;}

  MSGD (( INFO_KERNEL_THREAD_STOPPED, "CONSOLE" ));

  DBGOUT;
  EXITPROCESS(0);
  }

/*
 * ========================== LOCAL FUNCTIONS =================================
 */

static LONG sql82k_min_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_shm_size"
  ULONG   ulMinShmSize;
  ULONG   ulShmSize = 0;

  DBGPAS;

  ulMinShmSize = sql82k_min_set_ukt_affinity ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_MinSetProcessorAffinityMask ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_crash_dump_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_cancel_task_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_kill_task_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_task_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_io_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_aio_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_region_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_storage_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_rte_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_show_thread_times_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_queue_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_task_count_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_total_count_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_enable_time_measure_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_disable_time_measure_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_ukt_sl_stat_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_reset_region_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_reset_io_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_reset_task_count_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_reset_queue_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_reset_ukt_sl_stat_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_reset_suspends_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_show_suspends_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_show_param_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_ukt_queues_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_force_io_error_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_debug_break_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_debug_task_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_get_awe_info_shm_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  ulMinShmSize = sql82k_min_show_task_move_info_size ();
  ulShmSize    = max( ulShmSize, ulMinShmSize );

  return ( ulShmSize );
  }

/*------------------------------*/

static LONG sql82k_min_crash_dump_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_crash_dump_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_CRASH_DUMP_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_crash_dump_thread ( ULONG Handle )
  {
  //
  // --- this thread is used to do 'async-abort'
  __try  { ABORT();} __except( sql50k_excepthandler(GetExceptionInformation()) ) {;}
  }

/*------------------------------*/

static VOID sql82k_crash_dump ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_crash_dump"
  TID                  Tid;
  HANDLE               hThrd;
  LONG                 rc = NO_ERROR;

  DBGIN;

  pConsoleRec->fDataAvailable = TRUE;

  if ( sql02_get_platform_id () == VER_PLATFORM_WIN32_NT )
    {
    if ( kgs.pTW->TaskState != TSK_INITIALIZED )
      {
      // --- don't block the console thread during crash phase, do an 'async-abort'
      rc = CREATE_THREAD( &Tid, &hThrd, sql82k_crash_dump_thread,
                          0, 0, 4096 );

      if ( rc == NO_ERROR )
        {
        SLEEP(500);
        CloseHandle(hThrd);
        }
      else
        {
        sql41c_close_queue_mailslot ( kgs.Console.ThrdCtrlHeader.hComm );
        ABORT();  // -- thread not started, do an abort directly.
        }
      }
    }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_cancel_task_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_cancel_task_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_CANCEL_TASK_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_cancel_task ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_cancel_task"
  ULONG            ulTask = pConsoleRec->Data.CancelTaskCtrl.ulTask;
  PTASK_CTRL_REC   pTaskCtrl;

  if (( ulTask < 1 ) || ( ulTask > kgs.ulNumOfTasks ) )
    pConsoleRec->Data.CancelTaskCtrl.usReturnCode = CON_WRONG_TASK;
  else
    {
    pTaskCtrl = kgs.pFirstTaskCtrl + ulTask - 1;

    if (( pTaskCtrl->TaskType != TT_UT ) &&
   	    ( pTaskCtrl->TaskType != TT_EV ) &&
   	    ( pTaskCtrl->TaskType != TT_SV ) &&
        ( pTaskCtrl->TaskType != TT_US ))
      {
      pConsoleRec->Data.CancelTaskCtrl.usReturnCode = CON_WRONG_TASK_TYPE;
      }
    else if ( pTaskCtrl->TaskType == TT_SV )
      {
        pTaskCtrl->KernelCtrlRecord.to_cancel = TRUE;
      }
    else if (sql53k_comm_cancel( pTaskCtrl, commErrOk_esp01 ) == TRUE )
      {
      pConsoleRec->Data.CancelTaskCtrl.usReturnCode = CON_NO_ERROR;
      }
    }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_debug_task_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_debug_task_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_DEBUG_TASK_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_debug_task ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_debug_task"
  ULONG            ulTask = pConsoleRec->Data.DebugTask.ulTask;
  PTASK_CTRL_REC   pTaskCtrl;
  PDLQ_REC         pRequest;

  if (( ulTask < 1 ) || ( ulTask > kgs.ulNumOfTasks ))
  {
    pConsoleRec->Data.DebugTask.usReturnCode = CON_WRONG_TASK;
  }
  else
    {
    pTaskCtrl = kgs.pFirstTaskCtrl + ulTask - 1;

    if ((( pTaskCtrl->TaskType == TT_UT ) ||
   	     ( pTaskCtrl->TaskType == TT_EV ) ||
   	     ( pTaskCtrl->TaskType == TT_SV ) ||
         ( pTaskCtrl->TaskType == TT_US )) && 
        ( pTaskCtrl->TaskState == TSK_INACTIVE ))
      {
      pConsoleRec->Data.DebugTask.usReturnCode = CON_TASK_INACTIVE;
      }
    else
      {
        SAPDB_UInt8 DispatcherCalls = pTaskCtrl->pUKT->DispatcherCalls;
        INT   i;

        // --- maximum wait time 5 seconds
        for ( i = 0; i < (5 * 4) && DispatcherCalls == pTaskCtrl->pUKT->DispatcherCalls; i++ )
        {
          SLEEP (250); // sleep 250 msec
        }


        if (( pTaskCtrl->pUKT->DispatcherCalls          == DispatcherCalls ) &&
            ( pTaskCtrl->pUKT->ThrdCtrlHeader.ThrdState != KT_SLEEPING ))
        { // the UKT might essentially stuck in an endless loop
          CONTEXT ThrdContext;

          SuspendThread( pTaskCtrl->pUKT->ThrdCtrlHeader.hThrd );

          memset( &ThrdContext, '\0', sizeof(ThrdContext) );
          ThrdContext.ContextFlags = CONTEXT_FULL;

          if ( GetThreadContext( pTaskCtrl->pUKT->ThrdCtrlHeader.hThrd, &ThrdContext ) )
          {
            if ( pTaskCtrl->pUKT->pCTask != NULL )
              MSGD(( ERR_DUMP_CALLSTACK_ENDLESS_LOOP_TASK, pTaskCtrl->pUKT->pCTask->ulTaskIndex ));

            eo670_CTraceContextStack( &ThrdContext );
          }

          ResumeThread( pTaskCtrl->pUKT->ThrdCtrlHeader.hThrd );
        }
        else
        {
          //
          // --- build up debug task request DLQ element
          //
          pRequest            = RESERVE_FREELIST_ELEM();
          pRequest->ulReqType = REQ_DEBUG_TASK;

          sql73k_UKT_enqu ( pTaskCtrl->pUKT, pTaskCtrl, pRequest );
          pConsoleRec->Data.DebugTask.usReturnCode = CON_NO_ERROR;
        }
      }
    }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_debug_break_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_debug_break_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_DEBUG_BREAK_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_debug_break ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_debug_break"
 
  if ( pConsoleRec->Data.DebugBreak.fClearPosition == TRUE )
    kgs.ulSingleDebugBreakPos = 0;
  else
    kgs.ulSingleDebugBreakPos = pConsoleRec->Data.DebugBreak.ulBreakPosition;

  if ( !(kgs.ulServiceType & SERVICE_INTERACTIVE_PROCESS) )
    pConsoleRec->Data.DebugBreak.usReturnCode = CON_NO_INTERACT_WITH_DECTOP;
  else
    pConsoleRec->Data.DebugBreak.usReturnCode = CON_NO_ERROR;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_kill_task_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_kill_task_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_KILL_TASK_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_kill_task ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_kill_task"
  ULONG     ulTask = pConsoleRec->Data.KillTaskCtrl.ulTask;
  PTASK_CTRL_REC   pTaskCtrl;

  if (( ulTask < 1 ) || ( ulTask > kgs.ulNumOfTasks ))
    pConsoleRec->Data.KillTaskCtrl.usReturnCode = CON_WRONG_TASK;
  else
    {
    pTaskCtrl = kgs.pFirstTaskCtrl + ulTask - 1;

    if (( pTaskCtrl->TaskType != TT_UT ) &&
   	    ( pTaskCtrl->TaskType != TT_EV ) &&
        ( pTaskCtrl->TaskType != TT_US ))
      {
      pConsoleRec->Data.KillTaskCtrl.usReturnCode = CON_WRONG_TASK_TYPE;
      }
    else if ( sql53k_comm_cancel ( pTaskCtrl, commErrCrash_esp01 ) == TRUE )
      {
      pConsoleRec->Data.KillTaskCtrl.usReturnCode = CON_NO_ERROR;
      }
    }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_get_task_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_task_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_TASK_INFO_REC), ALIGNMENT_VALUE) +
                 ALIGN( sizeof(CONS_SINGLE_TASK_INFO_REC) *
                        kgs.ulNumOfTasks, ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_task_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_task_info"
  ULONG                       ulIdx;
  PTASK_CTRL_REC              pCurrTaskCtrl;
  PCONS_SINGLE_TASK_INFO_REC  pTaskInfos;
  ULONG                       ulTaskInfoOffset;
  #if defined(_WIN32)
   BOOL                       fDeadApplFound  =  FALSE;
  #endif
  char                        *Hptr;
  SAPDB_UInt2                 PrevTimeVar = PREV_TIME_VAR(kgs.CurrTimeVar);
   
  DBGIN;

  ulTaskInfoOffset = ALIGN( sizeof(CONS_TASK_INFO_REC), ALIGNMENT_VALUE);
  pTaskInfos       = (PCONS_SINGLE_TASK_INFO_REC)
                         ((PCHAR)&pConsoleRec->Data + ulTaskInfoOffset);

  for (pCurrTaskCtrl =  kgs.pFirstTaskCtrl, ulIdx = 0;
       pCurrTaskCtrl <= kgs.pLastTaskCtrl;
       pCurrTaskCtrl++)
    {
    if ( IS_TASK_TO_SHOW_EO92(pCurrTaskCtrl->TaskType,
                              pCurrTaskCtrl->TaskState,
                              pCurrTaskCtrl->TaskOMSStat.OMSCallActive,             /* PTS 1116933 */
                              pCurrTaskCtrl->QueLocation,
                              pConsoleRec->Data.TaskInfo.TypeToShow,
                              pConsoleRec->Data.TaskInfo.StateToShow) )
      {
      pTaskInfos[ulIdx].ulTaskIndex  = pCurrTaskCtrl->ulTaskIndex;

      pTaskInfos[ulIdx].Tid          =
        pCurrTaskCtrl->pUKT->ThrdCtrlHeader.Tid;

      pTaskInfos[ulIdx].TaskState     = pCurrTaskCtrl->TaskState;
      pTaskInfos[ulIdx].TaskType      = pCurrTaskCtrl->TaskType;
      pTaskInfos[ulIdx].ulStateReason = pCurrTaskCtrl->ulStateReason ;
      pTaskInfos[ulIdx].lWaitForTask  = pCurrTaskCtrl->lWaitForTask ;
      pTaskInfos[ulIdx].lWaitForRoot  = pCurrTaskCtrl->lWaitForRoot ;
      pTaskInfos[ulIdx].lWaitForDevno = pCurrTaskCtrl->lWaitForDevno ;
      if ( (Hptr = pCurrTaskCtrl->DevNameWaitingFor) )
        strcpy ( pTaskInfos[ulIdx].DevNameWaitingFor, Hptr) ;

      pTaskInfos[ulIdx].ulTaskTimeOut           = pCurrTaskCtrl->ulCOMTimeOut;
      pTaskInfos[ulIdx].Sid                     = pCurrTaskCtrl->Sid;
      pTaskInfos[ulIdx].ulBegExclCnt            = pCurrTaskCtrl->ulBegExclCnt;
      pTaskInfos[ulIdx].PrioFlag                = pCurrTaskCtrl->PrioFlag;
      pTaskInfos[ulIdx].SavePrioFlag            = pCurrTaskCtrl->SavePrioFlag;
      pTaskInfos[ulIdx].QueLocation             = pCurrTaskCtrl->QueLocation;
      pTaskInfos[ulIdx].CancelFlag              = pCurrTaskCtrl->KernelCtrlRecord.to_cancel;     /* CR 1103476 */
      pTaskInfos[ulIdx].OmsCallbackActive       = pCurrTaskCtrl->TaskOMSStat.OMSCallActive ; /* CR 1106969 */
      pTaskInfos[ulIdx].TemporaryMoveLock       = pCurrTaskCtrl->MoveLock.Type.Temporary;
      pTaskInfos[ulIdx].LongTermMoveLock        = pCurrTaskCtrl->MoveLock.Type.LongTerm;
      pTaskInfos[ulIdx].RunnableMicroSeconds    = pCurrTaskCtrl->RunnableMicroSeconds[PrevTimeVar];
      pTaskInfos[ulIdx].MaxRunnableMicroSeconds = pCurrTaskCtrl->MaxRunnableMicroSeconds[PrevTimeVar];

      if (( pCurrTaskCtrl->TaskType  == TT_US ) ||
   	      ( pCurrTaskCtrl->TaskType  == TT_EV ) ||
          ( pCurrTaskCtrl->TaskType  == TT_UT ))
        { pTaskInfos[ulIdx].ApplPid = pCurrTaskCtrl->pUserCommCtrl->pidClientPID;
          strcpy ( pTaskInfos[ulIdx].szClientNode,
                   pCurrTaskCtrl->pUserCommCtrl->szClientNode) ;
        }
      else
        { pTaskInfos[ulIdx].ApplPid = (PID)UNDEF;
          pTaskInfos[ulIdx].szClientNode[0] = '\0' ;
        }

      pTaskInfos[ulIdx].LockedPageNo = pCurrTaskCtrl->lockedPageNo ; /* CR 1115172 */
      pTaskInfos[ulIdx].ulUktIndex = pCurrTaskCtrl->pUKT->ulUKTIndex ; /* CR 1115172 */
      pTaskInfos[ulIdx].UktSleepCount = pCurrTaskCtrl->pUKT->UKTRunningStat.ulCount; /* CR 1115172 */
      pTaskInfos[ulIdx].UktSleepingFlag = (pCurrTaskCtrl->pUKT->ThrdCtrlHeader.ThrdState == KT_SLEEPING) ; /* CR 1115172 */
      pTaskInfos[ulIdx].WaitTime = (LONG)(pCurrTaskCtrl->ulWaitTime ? (kgs.ulCurrTime - pCurrTaskCtrl->ulWaitTime) : 0); /* CR 1115172 */
      pTaskInfos[ulIdx].ulDynPrio = pCurrTaskCtrl->ulDynPrio;

      ulIdx++;
      }
    }
  pConsoleRec->Data.TaskInfo.ulTaskInfoOffset  = ulTaskInfoOffset;
  pConsoleRec->Data.TaskInfo.lNumOfActiveTasks = ulIdx;

  DBGOUT;
  return;
  }

/*------------------------------*/

static VOID sql82k_get_connections_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_connections_info"
  ULONG                            ulIdx;
  PTASK_CTRL_REC                   pCurrTaskCtrl;
  PCONS_SINGLE_CONNECTION_INFO_REC pConnectionInfos;
  ULONG                            ulConnectionInfoOffset;
   
  DBGIN;

  ulConnectionInfoOffset = ALIGN( sizeof(CONS_CONNECTION_INFO_REC), ALIGNMENT_VALUE);
  pConnectionInfos       = (PCONS_SINGLE_CONNECTION_INFO_REC)
                         ((PCHAR)&pConsoleRec->Data + ulConnectionInfoOffset);

  for (pCurrTaskCtrl =  kgs.pFirstTaskCtrl, ulIdx = 0;
       pCurrTaskCtrl <= kgs.pLastTaskCtrl;
       pCurrTaskCtrl++)
    {
    if ( pCurrTaskCtrl->pUserCommCtrl 
	  && pCurrTaskCtrl->TaskState != TSK_INACTIVE_EO00 
	  && pCurrTaskCtrl->TaskState != TSK_CONNECTWAIT_EO00 )
      {
      pConnectionInfos[ulIdx].taskIndex     = pCurrTaskCtrl->ulTaskIndex;
      pConnectionInfos[ulIdx].uktIndex      = pCurrTaskCtrl->pUKT->ulUKTIndex;
      pConnectionInfos[ulIdx].taskType      = pCurrTaskCtrl->TaskType;
      pConnectionInfos[ulIdx].connState     = sql53k_get_connection_state( pCurrTaskCtrl );
      pConnectionInfos[ulIdx].connectTime   = pCurrTaskCtrl->pUserCommCtrl->ulConnected;
      pConnectionInfos[ulIdx].peerPid       = pCurrTaskCtrl->pUserCommCtrl->pidLocalClientPID;
      pConnectionInfos[ulIdx].remotePid     = pCurrTaskCtrl->pUserCommCtrl->pidClientPID;
      strcpy( pConnectionInfos[ulIdx].clientNode, pCurrTaskCtrl->pUserCommCtrl->szClientNode );
      ulIdx++;
      }
    }
  pConsoleRec->Data.ConnectionInfo.ulConnectionInfoOffset = ulConnectionInfoOffset;
  pConsoleRec->Data.ConnectionInfo.lNumOfConnections      = ulIdx;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_get_io_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_io_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_IO_INFO_REC), ALIGNMENT_VALUE) +
                 ALIGN( sizeof(CONS_DEV_INFO_REC) *
                        XPARAM(lMaxDevspaces), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_io_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_io_info"
  ULONG              ulIdx = 0;
  ULONG              ulDevspace;
  ULONG              ulDevi;
  ULONG              ulReadCnt;
  ULONG              ulWriteCnt;
  PDEVI_CTRL_REC     pDeviCtrl;
  PUKT_CTRL_REC      pTmpUKTCtrl;
  ULONG              ulDevspaceInfoOffset;
  PCONS_DEV_INFO_REC pDevspaceInfos;

  DBGIN;

  ulDevspaceInfoOffset = ALIGN( sizeof(CONS_IO_INFO_REC), ALIGNMENT_VALUE);
  pDevspaceInfos       = (PCONS_DEV_INFO_REC)
                             ((PCHAR)&pConsoleRec->Data + ulDevspaceInfoOffset);

  for ( ulDevspace = 0;
        ulDevspace < (ULONG)XPARAM(lMaxDevspaces);
        ulDevspace++ )
    {
    if ( kgs.Dev0.pIOCtrl[ulDevspace].szDevspace[0] == '\0' )
      continue;

    ulReadCnt  = 0;
    ulWriteCnt = 0;

    for ( ulDevi = 0; ulDevi < (ULONG) XPARAM(lDeviPerDevspace); ulDevi++ )
      {
      pDeviCtrl = kgs.pFirstDeviCtrl +
                  ulDevspace * XPARAM(lDeviPerDevspace) + ulDevi;

      if ( pDeviCtrl->ThrdCtrlHeader.ThrdState != KT_INITIALIZED
        && !pDeviCtrl->DevIOStat.ResetPending )
        {
            ulReadCnt  += pDeviCtrl->DevIOStat.DevRead.IOStat.ulCount;
            ulWriteCnt += pDeviCtrl->DevIOStat.DevWrite.IOStat.ulCount;
        }
      }

    for (pTmpUKTCtrl  = kgs.pFirstUKTCtrl;
         pTmpUKTCtrl <= kgs.pLastUKTCtrl;
         pTmpUKTCtrl++)
       {
       ulReadCnt  += pTmpUKTCtrl->pSingleIO[ulDevspace].lReadCntr;
       ulWriteCnt += pTmpUKTCtrl->pSingleIO[ulDevspace].lWriteCntr;
       }

    if ( ulReadCnt || ulWriteCnt )
      {
      pDevspaceInfos[ ulIdx ].ulDevspaceNo = ulDevspace;
      pDevspaceInfos[ ulIdx ].ulReadCnt    = ulReadCnt;
      pDevspaceInfos[ ulIdx ].ulWriteCnt   = ulWriteCnt;
      strcpy( pDevspaceInfos[ ulIdx ].DevspaceName,
              kgs.Dev0.pIOCtrl[ulDevspace].szDevspace );
      ulIdx++;
      }
    }

  pConsoleRec->Data.IOInfo.ulDevspaceInfoOffset = ulDevspaceInfoOffset;
  pConsoleRec->Data.IOInfo.lNumOfDevspaces      = ulIdx;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_get_aio_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_aio_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_AIO_INFO_REC) +
                        sizeof(CONS_ASYNCI_INFO_REC) *
                        kgs.ulNumOfAsyncis,  ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }


/*------------------------------*/

static VOID sql82k_get_aio_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_aio_info"
  PASYNCI_CTRL_REC            pAsynciCtrl;
  PCONS_ASYNCI_INFO_REC       pASYNCiInfos;
  ULONG                       ulASYNCiInfoOffset;
  ULONG                       ulAsynci;
  ULONG                       lNumOfASYNCis;

  DBGIN;

  ulASYNCiInfoOffset = ALIGN( sizeof(CONS_AIO_INFO_REC), ALIGNMENT_VALUE);
  pASYNCiInfos       = (PCONS_ASYNCI_INFO_REC)
                           ((PCHAR)&pConsoleRec->Data + ulASYNCiInfoOffset);

  //
  // --- ASYNCi info
  //
  for ( ulAsynci = 0, lNumOfASYNCis = 0; ulAsynci < kgs.ulNumOfAsyncis ; ulAsynci++ )
    {
    pAsynciCtrl = kgs.pFirstAsynciCtrl + ulAsynci;

    if (( pAsynciCtrl->fAsyncClosePending       == TRUE ) ||
        ( pAsynciCtrl->ThrdCtrlHeader.ThrdState == KT_INITIALIZED ))
      continue;

    strcpy ( pASYNCiInfos[lNumOfASYNCis].szLogDeviceName,
             pAsynciCtrl->szLogDeviceName );

    pASYNCiInfos[lNumOfASYNCis].Tid           =
      pAsynciCtrl->ThrdCtrlHeader.Tid;

    pASYNCiInfos[lNumOfASYNCis].fForWriting   =
      pAsynciCtrl->fForWriting;

    pASYNCiInfos[lNumOfASYNCis].ulBlockSize   =
      pAsynciCtrl->ulBlockSize;

    pASYNCiInfos[lNumOfASYNCis].ulMaxBlockCnt =
      pAsynciCtrl->ulMaxBlockCnt;

    pASYNCiInfos[lNumOfASYNCis].DevIOStat = pAsynciCtrl->DevIOStat;
    /* will currently never be true, since Asynci are temporary resources only and the */
    /* statistic record will be resetted during initialization */
    if ( pAsynciCtrl->DevIOStat.ResetPending )
    {
        memset( &pASYNCiInfos[lNumOfASYNCis].DevIOStat.DevRead, 0, sizeof(teo52_IOStatisticRec));
        memset( &pASYNCiInfos[lNumOfASYNCis].DevIOStat.DevWrite, 0, sizeof(teo52_IOStatisticRec));
    }

    lNumOfASYNCis ++;
    }
  pConsoleRec->Data.AIOInfo.lNumOfASYNCis      = lNumOfASYNCis;
  pConsoleRec->Data.AIOInfo.ulASYNCiInfoOffset = ulASYNCiInfoOffset;

  DBGOUT;
  return;
  }


/*------------------------------*/

static LONG sql82k_min_get_region_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_region_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_SEM_INFO_REC), ALIGNMENT_VALUE) +
                 ALIGN( sizeof(CONS_SINGLE_SEM_INFO_REC) *
                        XPARAM(ulNoOfRegions),
                        ALIGNMENT_VALUE)                            +
                 ALIGN( sizeof(ULONG) *
                        XPARAM(ulNoOfRegions) * kgs.ulNumOfTasks,
                        ALIGNMENT_VALUE);


  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_region_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_region_info"
  ULONG                          lNumWaitTasks;
  ULONG                          ulIdx;
  ULONG                          ulSem;
  PSEM_CTRL_REC                  pSemCtrl;
  PSEM_QUEUE_REC                 pSemQueElem;

  PCONS_SINGLE_SEM_INFO_REC      pSingleSemInfos;
  ULONG                          ulSingleSemInfoOffset;
  PULONG                         pulWaitTasks;
  ULONG                          ulWaitTaskOffset;
  PTASK_CTRL_REC                 pOwnerTaskCtrl, pWaitTaskCtrl ;

  DBGIN;

#ifdef FHTEST
  // !!!!!!!!!!! FH_TEST !!!!!!!!!!!!!
  vTestGetRteInfo();
#endif

  ulSingleSemInfoOffset = ALIGN( sizeof(CONS_SEM_INFO_REC), ALIGNMENT_VALUE);
  pSingleSemInfos       = (PCONS_SINGLE_SEM_INFO_REC)
                              ((PCHAR)&pConsoleRec->Data + ulSingleSemInfoOffset);

  ulWaitTaskOffset      = ALIGN( sizeof(CONS_SEM_INFO_REC), ALIGNMENT_VALUE) +
                          ALIGN( sizeof(CONS_SINGLE_SEM_INFO_REC) *
                                 XPARAM(ulNoOfRegions),
                                 ALIGNMENT_VALUE);
  pulWaitTasks          = (PULONG)((PCHAR)&pConsoleRec->Data + ulWaitTaskOffset);

  for ( ulSem = 0, ulIdx = 0; ulSem < XPARAM(ulNoOfRegions); ulSem++ )
    {
    if ( kgs.pSemaphores[ ulSem ].szSemaName[ 0 ] == '\0' )
      continue;

    pSemCtrl = kgs.pSemaphores + ulSem;

    strncpy ( pSingleSemInfos[ulSem].szSemaName,
              pSemCtrl->szSemaName,
              sizeof( pSingleSemInfos[ulSem].szSemaName ) - 1 );

    if ( (pOwnerTaskCtrl = pSemCtrl->pOwnerTaskCtrl) )
       pSingleSemInfos[ulSem].ulOwnerTaskIndex = pOwnerTaskCtrl->ulTaskIndex;
      
    pSingleSemInfos[ulSem].ulSid            = ulSem + 1;
    pSingleSemInfos[ulSem].lGetCount        = pSemCtrl->lGetCount;
    pSingleSemInfos[ulSem].lBegExclTasCount = pSemCtrl->lBegExclTasCount;
    pSingleSemInfos[ulSem].lEndExclTasCount = pSemCtrl->lEndExclTasCount;
    pSingleSemInfos[ulSem].lCollisionCount  = pSemCtrl->lCollisionCount;
    pSingleSemInfos[ulSem].lWaitCount       = pSemCtrl->lWaitCount;
    pSingleSemInfos[ulSem].lExclusive       = pSemCtrl->SemaList.lExclusive;

    for ( pSemQueElem =  pSemCtrl->SemaList.pRemovePos, lNumWaitTasks = 0;
          (pWaitTaskCtrl = pSemQueElem->pTaskCtrl) != NULL ;
          pSemQueElem =  pSemQueElem->pNextElem, lNumWaitTasks++ )
      {
      pulWaitTasks[lNumWaitTasks] = pWaitTaskCtrl->ulTaskIndex;
      }

    pSingleSemInfos[ulSem].ulWaitTaskOffset = ulWaitTaskOffset;
    pSingleSemInfos[ulSem].lNumWaitTasks    = lNumWaitTasks;

    ulWaitTaskOffset += sizeof(ULONG) * kgs.ulNumOfTasks;
    pulWaitTasks     = (PULONG)((PCHAR)&pConsoleRec->Data + ulWaitTaskOffset);
    ulIdx++;
    }

  pConsoleRec->Data.SemInfo.ulSingleSemInfoOffset = ulSingleSemInfoOffset;
  pConsoleRec->Data.SemInfo.lNumOfSems            = ulIdx;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_get_storage_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_storage_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_STORAGE_INFO_REC), ALIGNMENT_VALUE) +
                 ALIGN( sizeof(CONS_TASK_STORAGE_INFO_REC) *
                        kgs.ulNumOfTasks, ALIGNMENT_VALUE);


  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_storage_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_storage_info"
  ULONG                       ulIdx;
  APIRET                      rc            = NO_ERROR;
  tsp00_Longuint              ulRegionSize  = 0;
  PTASK_CTRL_REC              pCurrTaskCtrl;
  PUCHAR                      pCurrStackPage;
  PCHAR                       pStackLimit;
  PCHAR                       pCurrStackPointer;
  PCHAR                       pStackBase;
  ULONG                       ulTaskStorInfoOffset;
  PCONS_TASK_STORAGE_INFO_REC pTaskStorInfos;

  #if defined(_WIN32)
   MEMORY_BASIC_INFORMATION   MemInfo;
  #else
   ULONG                      ulAttributeFlags;
  #endif

  DBGIN;

  ulTaskStorInfoOffset = ALIGN( sizeof(CONS_STORAGE_INFO_REC), ALIGNMENT_VALUE);
  pTaskStorInfos       = (PCONS_TASK_STORAGE_INFO_REC)
                             ((PCHAR)&pConsoleRec->Data + ulTaskStorInfoOffset);

  pConsoleRec->Data.StorageInfo.ulTasksTotal = kgs.ulNumOfTasks;
  pConsoleRec->Data.StorageInfo.lTaskStacks  = 0;

  for (pCurrTaskCtrl =  kgs.pFirstTaskCtrl, ulIdx = 0;
       pCurrTaskCtrl <= kgs.pLastTaskCtrl;
       pCurrTaskCtrl++)
    {
    // --- Do a dirty read first!
    if ((  pCurrTaskCtrl->TaskState == TSK_INITIALIZED        ) ||
        (  pCurrTaskCtrl->TaskState == TSK_INACTIVE           ) ||
        (  pCurrTaskCtrl->TaskState == TSK_MARKED_FOR_STARTUP ))
      {
      continue;
      }

    WAIT_UNTIL_ALONE( &pCurrTaskCtrl->pUKT->lExclusive );

    if (( pCurrTaskCtrl->TaskState != TSK_INITIALIZED ) &&
        ( pCurrTaskCtrl->TaskState != TSK_INACTIVE ) &&
        ( pCurrTaskCtrl->TaskState != TSK_MARKED_FOR_STARTUP ))
      {
      pTaskStorInfos[ulIdx].ulTaskIndex  =
         pCurrTaskCtrl->ulTaskIndex;
      pTaskStorInfos[ulIdx].TaskType     =
         pCurrTaskCtrl->TaskType;

      pStackLimit       = pCurrTaskCtrl->Context.pStackLimit;
      pCurrStackPointer = pCurrTaskCtrl->pCurrStackPointer;
      pStackBase        = pCurrTaskCtrl->Context.pStackBase;

      pTaskStorInfos[ulIdx].ulStackUsed  =
         (tsp00_Longuint)pStackLimit - (tsp00_Longuint)pCurrStackPointer;
      pTaskStorInfos[ulIdx].ulStackFree  =
         (tsp00_Longuint)pCurrStackPointer - (tsp00_Longuint)pStackBase;
      ulIdx++;
      }

    CLEARLOCK( &pCurrTaskCtrl->pUKT->lExclusive );
    }


  pConsoleRec->Data.StorageInfo.lDynDatAvail           =
    (tsp00_Longuint)kgs.pSharedDynDataTop - (tsp00_Longuint)kgs.pSharedDynDataPtr;
  pConsoleRec->Data.StorageInfo.lDynDatUsed            =
    (tsp00_Longuint)kgs.pSharedDynDataPtr - (tsp00_Longuint)kgs.pSharedDynDataBot;

  pConsoleRec->Data.StorageInfo.lDynPoolAvail          =
    (tsp00_Longuint)kgs.pSharedDynPoolTop - (tsp00_Longuint)kgs.pSharedDynPoolPtr;
  pConsoleRec->Data.StorageInfo.lDynPoolUsed           =
    (tsp00_Longuint)kgs.pSharedDynPoolPtr - (tsp00_Longuint)kgs.pSharedDynPoolBot;

  pConsoleRec->Data.StorageInfo.ulKGSSize            = sizeof( kgs );
  pConsoleRec->Data.StorageInfo.ulKSSSize            = ALIGN(kgs.ulKSSSize,
                                                        kgs.ulSystemPageSize);
  pConsoleRec->Data.StorageInfo.lNumOfTasks          = ulIdx;
  pConsoleRec->Data.StorageInfo.ulTaskStorInfoOffset = ulTaskStorInfoOffset;

  //
  //  --- query the allocated stack size of all tasks
  //
  for (pCurrTaskCtrl =  kgs.pFirstTaskCtrl, ulIdx = 0;
       pCurrTaskCtrl <= kgs.pLastTaskCtrl;
       pCurrTaskCtrl++)
    {
    // --- query allocated task stack
    for (pCurrStackPage  = pCurrTaskCtrl->Context.pStackBase;
         pCurrStackPage  < pCurrTaskCtrl->Context.pStackLimit;
         pCurrStackPage += ulRegionSize)
      {
      if (!VirtualQuery(pCurrStackPage, &MemInfo, sizeof(MemInfo)))
        rc = GetLastError ();

      if (rc != NO_ERROR)
        {
        rc = GetLastError ();
        MSGCD (( WRN_QUERY_TASK_STACK, rc ));
        DBG1  (( MF__, "Could not query the tasks stack size, rc = %d", rc ));
        break;
        }

      ulRegionSize = MemInfo.RegionSize;

      if (pCurrStackPage + ulRegionSize > pCurrTaskCtrl->Context.pStackLimit)
        {
        ulRegionSize = (tsp00_Longuint)(pCurrTaskCtrl->Context.pStackLimit -
                                       pCurrStackPage);
        }

      if (MemInfo.State & MEM_COMMIT)
        pConsoleRec->Data.StorageInfo.lTaskStacks += (LONG)ulRegionSize;
      }
    }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_get_rte_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_rte_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_RTE_INFO_REC), ALIGNMENT_VALUE) +
                 ALIGN( sizeof(CONS_DEV_WORKER_INFO_REC) *
                        kgs.ulNumOfDevWorker, ALIGNMENT_VALUE)      +
                 ALIGN( sizeof(CONS_UKT_INFO_REC) *
                        kgs.ulNumOfUKTs, ALIGNMENT_VALUE)           +
                 ALIGN( sizeof(CONS_DEV_INFO_REC) *
                        XPARAM(lMaxDevspaces) * kgs.ulNumOfUKTs,
                        ALIGNMENT_VALUE)                            +
                 ALIGN( sizeof(CONS_DEVI_INFO_REC) *
                        kgs.ulNumOfDevis,  ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_rte_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_rte_info"
  PUKT_CTRL_REC               pUKTCtrl;
  PDEV_WORKER_CTRL_REC        pDevWorkerCtrl;
  ULONG                       ulDevWorker;
  ULONG                       ulUKT;
  ULONG                       ulTotalTasks;
  CHAR                        szCluster[80];
  ULONG                       ulDevspace;
  ULONG                       lNumOfDev;
  ULONG                       lNumOfDEVis;
  ULONG                       ulDevi;
  PDEVI_CTRL_REC              pDeviCtrl;
  ULONG                       ulDevWorkerInfoOffset;
  PCONS_DEV_WORKER_INFO_REC   pDevWorkerInfos;
  ULONG                       ulUKTInfoOffset;
  PCONS_UKT_INFO_REC          pUKTInfos;
  ULONG                       ulDevspaceInfoOffset;
  PCONS_DEV_INFO_REC          pDevspaceInfos;
  ULONG                       ulDEViInfoOffset;
  PCONS_DEVI_INFO_REC         pDEViInfos;
  LONG                        lProcessorNumber ;

  DBGIN;

  //
  // --- Kernel thread info
  //
  pConsoleRec->Data.RTEInfo.CoordTid       =
    kgs.Coord.ThrdCtrlHeader.Tid;
  pConsoleRec->Data.RTEInfo.CoordState     =
    (UINT1)kgs.Coord.ThrdCtrlHeader.ThrdState;

  pConsoleRec->Data.RTEInfo.ConsoleTid     =
    kgs.Console.ThrdCtrlHeader.Tid;
  pConsoleRec->Data.RTEInfo.ConsoleState   =
    (UINT1)kgs.Console.ThrdCtrlHeader.ThrdState;

  pConsoleRec->Data.RTEInfo.TimerTid       =
    kgs.Timer.ThrdCtrlHeader.Tid;
  pConsoleRec->Data.RTEInfo.TimerState     =
    (UINT1)kgs.Timer.ThrdCtrlHeader.ThrdState;

  pConsoleRec->Data.RTEInfo.ClockTid       =
    kgs.Clock.ThrdCtrlHeader.Tid;
  pConsoleRec->Data.RTEInfo.ClockState     =
    (UINT1)kgs.Clock.ThrdCtrlHeader.ThrdState;

  pConsoleRec->Data.RTEInfo.Dev0Tid        =
    kgs.Dev0.ThrdCtrlHeader.Tid;
  pConsoleRec->Data.RTEInfo.Dev0State      =
    (UINT1)kgs.Dev0.ThrdCtrlHeader.ThrdState;

  pConsoleRec->Data.RTEInfo.Async0Tid      =
    kgs.Async0.ThrdCtrlHeader.Tid;
  pConsoleRec->Data.RTEInfo.Async0State    =
    (UINT1)kgs.Async0.ThrdCtrlHeader.ThrdState;

  pConsoleRec->Data.RTEInfo.RequestorTid   =
    kgs.Requestor.ThrdCtrlHeader.Tid;
  pConsoleRec->Data.RTEInfo.RequestorState =
    (UINT1)kgs.Requestor.ThrdCtrlHeader.ThrdState;

  ulDevWorkerInfoOffset = ALIGN( sizeof(CONS_RTE_INFO_REC), ALIGNMENT_VALUE);
  pDevWorkerInfos       = (PCONS_DEV_WORKER_INFO_REC)
                              ((PCHAR)&pConsoleRec->Data + ulDevWorkerInfoOffset);

  ulUKTInfoOffset       = ulDevWorkerInfoOffset +
                          ALIGN( sizeof(CONS_DEV_WORKER_INFO_REC) *
                                 kgs.ulNumOfDevWorker, ALIGNMENT_VALUE);
  pUKTInfos             = (PCONS_UKT_INFO_REC)
                              ((PCHAR)&pConsoleRec->Data + ulUKTInfoOffset);

  ulDevspaceInfoOffset  = ulUKTInfoOffset +
                          ALIGN( sizeof(CONS_UKT_INFO_REC) * kgs.ulNumOfUKTs,
                                 ALIGNMENT_VALUE);
  pDevspaceInfos        = (PCONS_DEV_INFO_REC)
                              ((PCHAR)&pConsoleRec->Data + ulDevspaceInfoOffset);

  ulDEViInfoOffset      = ulDevspaceInfoOffset +
                          ALIGN( sizeof(CONS_DEV_INFO_REC) *
                                 XPARAM(lMaxDevspaces)  * kgs.ulNumOfUKTs,
                                 ALIGNMENT_VALUE);
  pDEViInfos            = (PCONS_DEVI_INFO_REC)
                              ((PCHAR)&pConsoleRec->Data + ulDEViInfoOffset);

  for ( pDevWorkerCtrl =  kgs.pFirstDevWorkerCtrl, ulDevWorker = 0;
        kgs.ulNumOfDevWorker && (pDevWorkerCtrl <= kgs.pLastDevWorkerCtrl);
        pDevWorkerCtrl++, ulDevWorker++ )
    {
    pDevWorkerInfos[ulDevWorker].Tid       =
             pDevWorkerCtrl->ThrdCtrlHeader.Tid;
    pDevWorkerInfos[ulDevWorker].ThrdState =
             pDevWorkerCtrl->ThrdCtrlHeader.ThrdState;
    pDevWorkerInfos[ulDevWorker].ulIOCount =
             pDevWorkerCtrl->ulIOCount;
    }

  pConsoleRec->Data.RTEInfo.ulNumOfConcurrentDevWorkers =
                              kgs.ulNumOfConcurrentDevWorkers;

  pConsoleRec->Data.RTEInfo.lNumOfDevWorkers      = ulDevWorker;
  pConsoleRec->Data.RTEInfo.ulDevWorkerInfoOffset = ulDevWorkerInfoOffset;

  //
  // --- UKT Info
  //
  for ( pUKTCtrl =  kgs.pFirstUKTCtrl, ulUKT = 0;
        pUKTCtrl <= kgs.pLastUKTCtrl;
        pUKTCtrl++ )
    {

    ulTotalTasks = eo92CreateTaskcluster ( pUKTCtrl, 
                                           szCluster, sizeof ( szCluster ) ) ;

    strcpy ( pUKTInfos[ulUKT].szCluster, szCluster );

    pUKTInfos[ulUKT].ulProcessor = 0;

    #if defined(_WIN32)
    if ( pUKTCtrl->ThrdCtrlHeader.Processor )
      {
      for ( lProcessorNumber = 1, pUKTInfos[ulUKT].ulProcessor = 1;
          !(pUKTCtrl->ThrdCtrlHeader.Processor & lProcessorNumber ) ;
          pUKTInfos[ulUKT].ulProcessor++ ,
          lProcessorNumber = lProcessorNumber << 1 )
          { ; }
      }
    #endif

    pUKTInfos[ulUKT].ulTotalTasks      = ulTotalTasks;
    pUKTInfos[ulUKT].ulUKTIndex        = pUKTCtrl->ulUKTIndex;
    pUKTInfos[ulUKT].Tid               = pUKTCtrl->ThrdCtrlHeader.Tid;
    pUKTInfos[ulUKT].ThrdState         = pUKTCtrl->ThrdCtrlHeader.ThrdState;
    pUKTInfos[ulUKT].ulActiveTasks     = pUKTCtrl->ulActiveTasks;
    pUKTInfos[ulUKT].dDispatcherCalls  = (double)((SAPDB_Int8)pUKTCtrl->DispatcherCalls);

    //
    // --- get io info
    //
    for ( ulDevspace = 0, lNumOfDev = 0;
          ulDevspace < (ULONG) XPARAM(lMaxDevspaces);
          ulDevspace++ )
      {
      if ( pUKTCtrl->pSingleIO[ulDevspace].lReadCntr ||
           pUKTCtrl->pSingleIO[ulDevspace].lWriteCntr )
        {
        strcpy( pDevspaceInfos[lNumOfDev].DevspaceName,
            kgs.Dev0.pIOCtrl[ulDevspace].szDevspace );
        pDevspaceInfos[lNumOfDev].ulDevspaceNo = ulDevspace;
        pDevspaceInfos[lNumOfDev].ulReadCnt    =
            pUKTCtrl->pSingleIO[ulDevspace].lReadCntr;
        pDevspaceInfos[lNumOfDev].ulWriteCnt   =
            pUKTCtrl->pSingleIO[ulDevspace].lWriteCntr;

        lNumOfDev++;
        }
      }
    pUKTInfos[ulUKT].lNumOfDevspaces      = lNumOfDev;
    pUKTInfos[ulUKT].ulDevspaceInfoOffset = ulDevspaceInfoOffset;

    ulDevspaceInfoOffset += sizeof(CONS_DEV_INFO_REC) *
                            XPARAM(lMaxDevspaces);
    pDevspaceInfos        = (PCONS_DEV_INFO_REC)
                              ((PCHAR)&pConsoleRec->Data + ulDevspaceInfoOffset);
    ulUKT++;
    }

  pConsoleRec->Data.RTEInfo.lNumOfUKTs      = ulUKT;
  pConsoleRec->Data.RTEInfo.ulUKTInfoOffset = ulUKTInfoOffset;

  //
  // --- Devspace info
  //
  pConsoleRec->Data.RTEInfo.lTraceDevspaceNo = kgs.Dev0.lTraceDevspaceNo;

  for ( ulDevspace = 0, lNumOfDEVis = 0;
        ulDevspace < (ULONG) XPARAM(lMaxDevspaces);
        ulDevspace++ )
    {
    if ( kgs.Dev0.pIOCtrl[ulDevspace].szDevspace[0] == '\0' )
      continue;

    strcpy( pDEViInfos[lNumOfDEVis].DevspaceName,
            kgs.Dev0.pIOCtrl[ulDevspace].szDevspace );

    for ( ulDevi = 0; ulDevi < (ULONG) XPARAM(lDeviPerDevspace); ulDevi++ )
      {
      pDeviCtrl = kgs.pFirstDeviCtrl +
                  ulDevspace * XPARAM(lDeviPerDevspace) + ulDevi;

      if ( pDeviCtrl->ThrdCtrlHeader.ThrdState != KT_INITIALIZED )
        {
        pDEViInfos[lNumOfDEVis].Tid          = pDeviCtrl->ThrdCtrlHeader.Tid;
        pDEViInfos[lNumOfDEVis].ulDEViIndex  = ulDevi;
        pDEViInfos[lNumOfDEVis].ulDevspaceNo = ulDevspace;
        pDEViInfos[lNumOfDEVis].DevIOStat    = pDeviCtrl->DevIOStat;
        if ( pDEViInfos[lNumOfDEVis].DevIOStat.ResetPending )
        {
            memset( &pDEViInfos[lNumOfDEVis].DevIOStat.DevRead, 0, sizeof(teo52_IOStatisticRec));
            memset( &pDEViInfos[lNumOfDEVis].DevIOStat.DevWrite, 0, sizeof(teo52_IOStatisticRec));
        }
        lNumOfDEVis ++;
        }
      }
    }

  pConsoleRec->Data.RTEInfo.lNumOfDEVis          = lNumOfDEVis;
  pConsoleRec->Data.RTEInfo.ulDEViInfoOffset     = ulDEViInfoOffset;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_get_queue_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_queue_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_QUEUE_STAT_INFO_REC), ALIGNMENT_VALUE) +
                 ALIGN( sizeof(CONS_SINGLE_QUEUE_STAT_INFO_REC) * kgs.ulNumOfTasks,
                        ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_queue_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_queue_info"
  ULONG                            ulIdx;
  PTASK_CTRL_REC                   pCurrTaskCtrl;
  ULONG                            ulQueStatInfoOffset;
  PCONS_SINGLE_QUEUE_STAT_INFO_REC pQueStatInfo;
  #if defined(_WIN32)
   BOOL             fDeadApplFound  =  FALSE;
  #endif

  DBGIN;

  ulQueStatInfoOffset  = ALIGN( sizeof(CONS_QUEUE_STAT_INFO_REC),
                                ALIGNMENT_VALUE);
  pQueStatInfo         = (PCONS_SINGLE_QUEUE_STAT_INFO_REC)
                             ((PCHAR)&pConsoleRec->Data + ulQueStatInfoOffset);

  for (pCurrTaskCtrl =  kgs.pFirstTaskCtrl, ulIdx = 0;
       pCurrTaskCtrl <= kgs.pLastTaskCtrl;
       pCurrTaskCtrl++)
    {
/*
    if (( pCurrTaskCtrl->TaskState != TSK_INITIALIZED        ) &&
        ( pCurrTaskCtrl->TaskState != TSK_INACTIVE           ) &&
        ( pCurrTaskCtrl->TaskState != TSK_MARKED_FOR_STARTUP ) &&
*/
    if ( !pCurrTaskCtrl->QueueStatRecResetPending &&
        ( pCurrTaskCtrl->QueStat.ulCOMQueCount  ||
          pCurrTaskCtrl->QueStat.ulUKTQueCount  ||
          pCurrTaskCtrl->QueStat.ulUToUQueCount ) )
      {
      pQueStatInfo[ulIdx].ulTaskIndex  = pCurrTaskCtrl->ulTaskIndex;
      pQueStatInfo[ulIdx].QueStat      = pCurrTaskCtrl->QueStat;
      ulIdx++;
      }
    }

  pConsoleRec->Data.QueInfo.lNumOfActiveTasks   = ulIdx;
  pConsoleRec->Data.QueInfo.ulQueStatInfoOffset = ulQueStatInfoOffset;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_get_task_count_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_task_count_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_TASK_COUNTS_INFO_REC), ALIGNMENT_VALUE) +
                 ALIGN( sizeof(CONS_SINGLE_TASK_COUNTS_INFO_REC) *
                        kgs.ulNumOfTasks, ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_task_count_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_task_count_info"
  INT                               j1;
  INT                               j2;
  ULONG                             ulIdx = 0;
  PTASK_CTRL_REC                    pCurrTaskCtrl, pFirstTaskCtrl, pLastTaskCtrl;
  ULONG                             ulTaskCountsInfoOffset;
  LONG                              lTaskTypeToShow = 0 ;
  PCONS_SINGLE_TASK_COUNTS_INFO_REC pTaskCountsInfo;
  #if defined(_WIN32)
   BOOL             fDeadApplFound  =  FALSE;
  #endif

  DBGIN;

  ulTaskCountsInfoOffset  = ALIGN( sizeof(CONS_TASK_COUNTS_INFO_REC),
                                   ALIGNMENT_VALUE);
  pTaskCountsInfo         = (PCONS_SINGLE_TASK_COUNTS_INFO_REC)
                                ((PCHAR)&pConsoleRec->Data + ulTaskCountsInfoOffset);

  pConsoleRec->Data.TaskCountsInfo.usReturnCode = CON_NO_ERROR;

  if ( pConsoleRec->Data.TaskCountsInfo.lNumOfActiveTasks < 0 )
  {                                   /* <0 ==> taskindex to show */
    unsigned int TaskIdToShow = (-pConsoleRec->Data.TaskCountsInfo.lNumOfActiveTasks) ;

    /* PTS 1104727 */
    if ( TaskIdToShow < kgs.pFirstTaskCtrl->ulTaskIndex || 
         TaskIdToShow > kgs.pLastTaskCtrl->ulTaskIndex   )
      pConsoleRec->Data.TaskCountsInfo.usReturnCode = CON_WRONG_TASK;
    else
    {
      pFirstTaskCtrl = kgs.pFirstTaskCtrl + TaskIdToShow - 1 ;
      pLastTaskCtrl  = pFirstTaskCtrl;
    }
  }
  else
  {                                   /* >0 ==> taskindex to show */
    pFirstTaskCtrl  = kgs.pFirstTaskCtrl;
    pLastTaskCtrl   = kgs.pLastTaskCtrl;
    lTaskTypeToShow = pConsoleRec->Data.TaskCountsInfo.lNumOfActiveTasks ;
  }


  if ( pConsoleRec->Data.TaskCountsInfo.usReturnCode == CON_NO_ERROR ) 
    for (pCurrTaskCtrl =  pFirstTaskCtrl, ulIdx;
         pCurrTaskCtrl <= pLastTaskCtrl;
         pCurrTaskCtrl++)
    {
    if ( EO52_RESET_TASK_FULL_PENDING != pCurrTaskCtrl->TaskStatRecResetPending &&
        pCurrTaskCtrl->ulDispatcherCalls > 1 &&
        (lTaskTypeToShow == 0 || lTaskTypeToShow == pCurrTaskCtrl->TaskType))
      {
      pTaskCountsInfo[ulIdx].ulTaskIndex     = pCurrTaskCtrl->ulTaskIndex;
      pTaskCountsInfo[ulIdx].TaskType        = pCurrTaskCtrl->TaskType;
      pTaskCountsInfo[ulIdx].ulBegExclCalls  = pCurrTaskCtrl->ulBegExclCalls;
      pTaskCountsInfo[ulIdx].ulSelfSuspCount = pCurrTaskCtrl->ulSelfSuspCount;
      if ( EO52_NO_RESET_PENDING != pCurrTaskCtrl->TaskStatRecResetPending )
      {
          memset( &(pTaskCountsInfo[ulIdx].StateStat), 0, sizeof(teo52_TaskStateStatisticRec) );
      }
      else
      {
          pTaskCountsInfo[ulIdx].StateStat       = pCurrTaskCtrl->TaskStateStat;
      }
      pTaskCountsInfo[ulIdx].PrioStat        = pCurrTaskCtrl->PrioStat;
      pTaskCountsInfo[ulIdx].TaskOMSStat     = pCurrTaskCtrl->TaskOMSStat; // 1106969
      pTaskCountsInfo[ulIdx].ulDispatcherCalls = pCurrTaskCtrl->ulDispatcherCalls;
      if ( !pCurrTaskCtrl->QueueStatRecResetPending )
      {
          pTaskCountsInfo[ulIdx].ulCommands      = pCurrTaskCtrl->QueStat.ulCOMQueCount;
      }

      if (( pCurrTaskCtrl->TaskType  == TT_US ) ||
          ( pCurrTaskCtrl->TaskType  == TT_EV ) ||
          ( pCurrTaskCtrl->TaskType  == TT_UT ))
        { pTaskCountsInfo[ulIdx].ApplPid =
            pCurrTaskCtrl->pUserCommCtrl->pidClientPID;
          strcpy ( pTaskCountsInfo[ulIdx].szClientNode,
                   pCurrTaskCtrl->pUserCommCtrl->szClientNode) ;
        }
      else
        { pTaskCountsInfo[ulIdx].ApplPid = (PID)UNDEF;
          pTaskCountsInfo[ulIdx].szClientNode[0] = '\0' ;
        }


    for ( j1 = 0; j1 < MAX_SUSPEND_LEVEL; j1++ )
    {
      pTaskCountsInfo[ulIdx].lResumeCount[j1] = pCurrTaskCtrl->lResumeCount[j1];
      pTaskCountsInfo[ulIdx].totalResumerCount[j1] = pCurrTaskCtrl->totalResumerCount[j1];
      for ( j2 = 0; j2 < MAX_RESUMER_PIDS; j2++ )
      {
          pTaskCountsInfo[ulIdx].resumerPid[j2][j1] = pCurrTaskCtrl->resumerPid[j2][j1];
      }
    }

      ulIdx++;
      }
    }

  pConsoleRec->Data.TaskCountsInfo.lNumOfActiveTasks      = ulIdx;
  pConsoleRec->Data.TaskCountsInfo.ulTaskCountsInfoOffset = ulTaskCountsInfoOffset;
  pConsoleRec->Data.TaskCountsInfo.fTimeMeasureActive     = kgs.fTimeMeasure;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_get_total_count_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_total_count_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_TOTAL_COUNTS_INFO_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_total_count_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_total_count_info"
  PTASK_CTRL_REC                 pCurrTaskCtrl;
  ULONG                          ulSem;
  PSEM_CTRL_REC                  pSemCtrl;

  #if defined(_WIN32)
   BOOL             fDeadApplFound  =  FALSE;
  #endif

  for (pCurrTaskCtrl =  kgs.pFirstTaskCtrl ;
       pCurrTaskCtrl <= kgs.pLastTaskCtrl;
       pCurrTaskCtrl++)
    if ( EO52_RESET_TASK_FULL_PENDING != pCurrTaskCtrl->TaskStatRecResetPending &&
         pCurrTaskCtrl->ulDispatcherCalls > 0 )
    {
      pConsoleRec->Data.TotalCountsInfo.ulTotalDispCalls +=
                             pCurrTaskCtrl->ulDispatcherCalls;

      if ( !pCurrTaskCtrl->QueueStatRecResetPending )
      {
          pConsoleRec->Data.TotalCountsInfo.ulTotalCommands +=
                             pCurrTaskCtrl->QueStat.ulCOMQueCount;
      }

      if ( EO52_NO_RESET_PENDING == pCurrTaskCtrl->TaskStatRecResetPending )
      {
        pConsoleRec->Data.TotalCountsInfo.ulTotalVwait    +=
                             pCurrTaskCtrl->TaskStateStat.VwaitStat.ulCount;
        pConsoleRec->Data.TotalCountsInfo.ulTotalVsleep   +=
                             pCurrTaskCtrl->TaskStateStat.VsleepStat.ulCount;
        pConsoleRec->Data.TotalCountsInfo.ulTotalVsusp    +=
                             pCurrTaskCtrl->TaskStateStat.VsuspStat.ulCount;
        pConsoleRec->Data.TotalCountsInfo.ulTotalDevIO    +=
                             pCurrTaskCtrl->TaskStateStat.DevIOReadStat.IOStat.ulCount +
                             pCurrTaskCtrl->TaskStateStat.DevIOWriteStat.IOStat.ulCount;
        pConsoleRec->Data.TotalCountsInfo.ulTotalSelfIO   +=
                             pCurrTaskCtrl->TaskStateStat.SelfIOReadStat.IOStat.ulCount +
                             pCurrTaskCtrl->TaskStateStat.SelfIOWriteStat.IOStat.ulCount;
      }

      pConsoleRec->Data.TotalCountsInfo.TotalPrioStat.ulTotalCount   +=
                            pCurrTaskCtrl->PrioStat.ulTotalCount;
      pConsoleRec->Data.TotalCountsInfo.TotalPrioStat.ulOtherUkt   +=
                            pCurrTaskCtrl->PrioStat.ulOtherUkt;
    }

  for ( ulSem = 0 ; ulSem < XPARAM(ulNoOfRegions) ; ulSem++ )
   if ( kgs.pSemaphores[ ulSem ].szSemaName[ 0 ] != '\0' )
   {
      pSemCtrl = kgs.pSemaphores + ulSem;

      pConsoleRec->Data.TotalCountsInfo.ulTotalRegAccess   +=
                             pSemCtrl->lGetCount ;
      pConsoleRec->Data.TotalCountsInfo.ulTotalRegColl     +=
                             pSemCtrl->lCollisionCount ;
      pConsoleRec->Data.TotalCountsInfo.ulTotalRegWait     +=
                             pSemCtrl->lWaitCount  ;
      pConsoleRec->Data.TotalCountsInfo.ulTotalBegExclTasCount  +=
                             pSemCtrl->lBegExclTasCount  ;
      pConsoleRec->Data.TotalCountsInfo.ulTotalEndExclTasCount  +=
                             pSemCtrl->lEndExclTasCount  ;
   }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_enable_time_measure_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_enable_time_measure_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_TIME_MEASURE_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_enable_time_measure ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_enable_time_measure"

  #if defined(_WIN32)
   BOOL             fDeadApplFound  =  FALSE;
  #endif

  if ( !kgs.fTimeMeasure )
   {
   sql82k_reset_task_count_info  ( pConsoleRec , TASK_STATES_ONLY ) ;
   sql82k_reset_ukt_sl_stat_info ( pConsoleRec ) ;
   sql82k_reset_io_info ( pConsoleRec ) ;
   kgs.fTimeMeasure = TRUE ;
   }
  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_disable_time_measure_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_disable_time_measure_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_TIME_MEASURE_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_disable_time_measure ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_disable_time_measure"

  #if defined(_WIN32)
   BOOL             fDeadApplFound  =  FALSE;
  #endif

  kgs.fTimeMeasure = FALSE ;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_set_debuglevel_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_set_debuglevel_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_SET_DEBUGLEVEL_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_set_debuglevel ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_set_debuglevel"

  #if defined(_WIN32)
   BOOL             fDeadApplFound  =  FALSE;
  #endif

  kgs.ulDebugLevel = pConsoleRec->Data.SetDebugLevelCtrl.ulDebugLevel ;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_get_ukt_sl_stat_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_ukt_sl_stat_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_UKT_SLEEPTIME_REC), ALIGNMENT_VALUE) +
                 ALIGN( sizeof(CONS_SINGLE_UKT_SL_STAT_INFO_REC) *
                        kgs.ulNumOfUKTs, ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_ukt_sl_stat_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_ukt_sl_stat_info"
  ULONG                             ulUKT = 0;
  PUKT_CTRL_REC                     pTmpUKTCtrl;
  ULONG                             ulSleepStatInfoOffset;
  PCONS_SINGLE_UKT_SL_STAT_INFO_REC pSleepStatInfo;
  #if defined(_WIN32)
   BOOL             fDeadApplFound  =  FALSE;
  #endif

  DBGIN;

  if ( kgs.fTimeMeasure )
    {
    SAPDB_UInt8 actMicroSeconds = RTESys_MicroSecTimer();

    ulSleepStatInfoOffset = ALIGN( sizeof(CONS_UKT_SLEEPTIME_REC),
                                   ALIGNMENT_VALUE );
    pSleepStatInfo        = (PCONS_SINGLE_UKT_SL_STAT_INFO_REC)
                                   ((PCHAR)&pConsoleRec->Data + ulSleepStatInfoOffset);

    for (pTmpUKTCtrl  = kgs.pFirstUKTCtrl;
         pTmpUKTCtrl <= kgs.pLastUKTCtrl;
         pTmpUKTCtrl++ )
       {
       if ( !pTmpUKTCtrl->SleepStatRecResetPending 
          && (pTmpUKTCtrl->UKTRunningStat.ulCount > 0)
          && (actMicroSeconds > pTmpUKTCtrl->IdleTimeMeasureBeginMicroseconds) )
        {
        pSleepStatInfo[ulUKT].Tid           = pTmpUKTCtrl->ThrdCtrlHeader.Tid;
        pSleepStatInfo[ulUKT].ulUKTIndex    = pTmpUKTCtrl->ulUKTIndex;
        pSleepStatInfo[ulUKT].ulRUNQueueLen = pTmpUKTCtrl->ulRUNQueueLen;
        pSleepStatInfo[ulUKT].measuredMicroSeconds = actMicroSeconds - pTmpUKTCtrl->IdleTimeMeasureBeginMicroseconds;
        pSleepStatInfo[ulUKT].UKTIdleStat.ulCount = pTmpUKTCtrl->UKTRunningStat.ulCount;
        pSleepStatInfo[ulUKT].UKTIdleStat.ulAbsMicroSeconds =  pSleepStatInfo[ulUKT].measuredMicroSeconds
                                                             - pTmpUKTCtrl->UKTRunningStat.ulAbsMicroSeconds
                                                             - pTmpUKTCtrl->UKTIOWaitStat.ulAbsMicroSeconds;
        if ( (KT_RUNNING == pTmpUKTCtrl->ThrdCtrlHeader.ThrdState)
          && (pTmpUKTCtrl->RunningStateEnterMicroSeconds > actMicroSeconds) )
        {
            pSleepStatInfo[ulUKT].UKTIdleStat.ulAbsMicroSeconds -= (actMicroSeconds - pTmpUKTCtrl->RunningStateEnterMicroSeconds);
        }
        pSleepStatInfo[ulUKT].UKTIOWaitStat = pTmpUKTCtrl->UKTIOWaitStat;
        ulUKT++ ;
        }
      }
    }

  pConsoleRec->Data.UKTSleepTimeInfo.ulSleepStatInfoOffset = ulSleepStatInfoOffset;
  pConsoleRec->Data.UKTSleepTimeInfo.lNumOfActiveUKTs      = ulUKT;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_set_ukt_affinity ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_set_ukt_affinity"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_SET_UKT_AFFINITY_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static LONG sql82k_MinSetProcessorAffinityMask ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_MinSetProcessorAffinityMask"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_SET_PROCESSOR_MASK_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static LONG sql82k_min_show_thread_times_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_show_thread_times_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize =   ulMinShmSize = ALIGN( sizeof(CONS_THREAD_TIMES_INFO_REC), ALIGNMENT_VALUE) +
                                  ALIGN( sizeof(CONS_SINGLE_THREAD_TIMES_INFO_REC) * kgs.ulNumOfUKTs,
                                        ALIGNMENT_VALUE);
  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_show_thread_times     ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_show_thread_times"

  ULONG ulThreadTimesOffset       = ALIGN( sizeof(CONS_THREAD_TIMES_INFO_REC), 
                                           ALIGNMENT_VALUE) ;
  PCONS_SINGLE_THREAD_TIMES_INFO_REC pThreadTimesInfo ;
  PUKT_CTRL_REC                      pTmpUKTCtrl;
  FILETIME CreationTime;
  FILETIME ExitTime;    
  CHAR     szUktIndex[10];

  DBGIN;

  pThreadTimesInfo     = (PCONS_SINGLE_THREAD_TIMES_INFO_REC)
                             ((PCHAR)&pConsoleRec->Data + ulThreadTimesOffset);

  for (pTmpUKTCtrl  = kgs.pFirstUKTCtrl;
       pTmpUKTCtrl <= kgs.pLastUKTCtrl;
       pTmpUKTCtrl++, pThreadTimesInfo++ )
     {
       ltoa   ( pTmpUKTCtrl->ulUKTIndex, szUktIndex, 10 );
       strcpy ( pThreadTimesInfo->szThreadName, "UKT") ;
       strcat ( pThreadTimesInfo->szThreadName, szUktIndex );

       pThreadTimesInfo->Tid           = pTmpUKTCtrl->ThrdCtrlHeader.Tid;
       
       GetThreadTimes(pTmpUKTCtrl->ThrdCtrlHeader.hThrd, 
                      &CreationTime,&ExitTime, 
                      &(pThreadTimesInfo->SystemTime),
                      &(pThreadTimesInfo->UserTime) );

       eo92CreateTaskcluster ( pTmpUKTCtrl, pThreadTimesInfo->szCluster, 
                               sizeof ( pThreadTimesInfo->szCluster ) ) ;
     }

  pConsoleRec->Data.ThreadTimeInfo.ulThreadTimesOffset   = ulThreadTimesOffset;
  pConsoleRec->Data.ThreadTimeInfo.lNumOfUKTs            = kgs.ulNumOfUKTs;

  DBGOUT;
  return;
  }

/*------------------------------*/

/* PTS 1107070 */
static VOID sql82k_SetProcessorAffinityMask ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_SetCPUsToUse"
  DWORD          ProcessAffinityMask = (DWORD )pConsoleRec->Data.SetProcessorMask.ProcessAffinityMask;
  PUKT_CTRL_REC  pUKT;

  DBGPAS;

  if ( ProcessAffinityMask < 0 || 
	   ProcessAffinityMask >= (DWORD )(1<<kgs.ulNumOfProcessors) )
  {
    pConsoleRec->Data.SetProcessorMask.usReturnCode = CON_ERROR;
  }
  else
  {
    pConsoleRec->Data.SetProcessorMask.usReturnCode = CON_NO_ERROR;

	if ( pConsoleRec->Data.SetProcessorMask.TaskType == 0 ) 
	{
      for (pUKT  = kgs.pFirstUKTCtrl; pUKT <= kgs.pLastUKTCtrl; pUKT++)
        if ( !SetThreadAffinityMask( pUKT->ThrdCtrlHeader.hThrd ,
                                    ProcessAffinityMask))
		{
         MSGALL (( ERR_SETTING_PROCESSOR_MASK, ProcessAffinityMask, GetLastError() ));
         pConsoleRec->Data.SetProcessorMask.usReturnCode = CON_ERROR;
		 break;
         }
	}
	else
	{
    PTASK_CTRL_REC                 pCurrTaskCtrl;

    for (pCurrTaskCtrl =  kgs.pFirstTaskCtrl; pCurrTaskCtrl <= kgs.pLastTaskCtrl; pCurrTaskCtrl++)

      if ( pCurrTaskCtrl->TaskType == pConsoleRec->Data.SetProcessorMask.TaskType )
        if ( !SetThreadAffinityMask( pCurrTaskCtrl->pUKT->ThrdCtrlHeader.hThrd ,
                                     ProcessAffinityMask))
        {
          MSGALL (( ERR_SETTING_PROCESSOR_MASK, ProcessAffinityMask, GetLastError() ));
          pConsoleRec->Data.SetProcessorMask.usReturnCode = CON_ERROR;
          break;
        }
  }
  } 

  return;
  }

/*------------------------------*/

static VOID sql82k_set_ukt_affinity ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_set_ukt_affinity"
   tsp00_Longuint	SystemAffinityMask;
   tsp00_Longuint	ProcessAffinityMask;
   PUKT_CTRL_REC	pUKT;
   ULONG			ulUKT;
   tsp00_Longuint   Proccesor;
   LONG				rc;

   DBGPAS;

   ulUKT = pConsoleRec->Data.UKTAffinity.ulUKTIndex;

   if (( ulUKT < 1 ) || ( ulUKT > kgs.ulNumOfUKTs ))
     pConsoleRec->Data.UKTAffinity.usReturnCode = CON_WRONG_UKT;
   else
     {
     pUKT = &kgs.pFirstUKTCtrl[ulUKT - 1];

     if ( !GetProcessAffinityMask( GetCurrentProcess(),
                                   &ProcessAffinityMask,
                                   &SystemAffinityMask ))
       {
       ProcessAffinityMask = 1;
       }

     pConsoleRec->Data.UKTAffinity.usReturnCode = CON_NO_ERROR;

     if ( pUKT->ThrdCtrlHeader.Processor )
       {
       // --- set the thread priority
       rc = SET_THREAD_PRIO ( pUKT->ThrdCtrlHeader.lThrdPrio,
                              pUKT->ThrdCtrlHeader.Tid,
                              pUKT->ThrdCtrlHeader.hThrd );

       if ( rc != NO_ERROR )
         {
         MSGD (( ERR_SETTING_THRD_PRIO, pUKT->ThrdCtrlHeader.Tid));
         pConsoleRec->Data.UKTAffinity.usReturnCode = CON_ERROR;
         }

       if ( !SetThreadAffinityMask( pUKT->ThrdCtrlHeader.hThrd ,
                                    ProcessAffinityMask))
         {
         MSGALL (( ERR_SETTING_THREAD_AFFINITY, GetLastError() ));
         pConsoleRec->Data.UKTAffinity.usReturnCode = CON_ERROR;
         }
       else
         {
         kgs.AffinityMask              &= ~pUKT->ThrdCtrlHeader.Processor;
         pUKT->ThrdCtrlHeader.Processor = 0;
         }
       }
     else
       {
       // - find free processor
       for ( Proccesor = 1;
             !((~kgs.AffinityMask & ProcessAffinityMask) & Proccesor) &&
             (Proccesor < 0x8000);
             Proccesor <<= 1 ) { ; }

       // - check if this processor is not the last unused processor
       if (( Proccesor < 0x8000 ) &&
           ( (kgs.AffinityMask | Proccesor) != ProcessAffinityMask ))
         {
         if ( !SetThreadAffinityMask( pUKT->ThrdCtrlHeader.hThrd,
                                      Proccesor))
           {
           MSGALL (( ERR_SETTING_THREAD_AFFINITY, GetLastError() ));
           pConsoleRec->Data.UKTAffinity.usReturnCode = CON_ERROR;
           }
         else
           {
           // --- set the thread priority
           rc = SET_THREAD_PRIO ( THREAD_PRIORITY_TIME_CRITICAL,
                                  pUKT->ThrdCtrlHeader.Tid,
                                  pUKT->ThrdCtrlHeader.hThrd );

           if ( rc != NO_ERROR )
             {
             SetThreadAffinityMask( pUKT->ThrdCtrlHeader.hThrd,
                                    ProcessAffinityMask );
             MSGD (( ERR_SETTING_THRD_PRIO, pUKT->ThrdCtrlHeader.Tid));
             pConsoleRec->Data.UKTAffinity.usReturnCode = CON_ERROR;
             }
           else
             {
             kgs.AffinityMask                |= Proccesor;
             pUKT->ThrdCtrlHeader.Processor = Proccesor;
             }
           }
         }
       else
         pConsoleRec->Data.UKTAffinity.usReturnCode = CON_NO_PROCESSOR;
       }

     }

  return;
  }


/*------------------------------*/

static LONG sql82k_min_reset_region_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_reset_region_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_RESET_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_reset_region_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_reset_region_info"

  ULONG                          ulSem;
  PSEM_CTRL_REC                  pSemCtrl;

  for ( ulSem = 0; ulSem < XPARAM(ulNoOfRegions); ulSem++ )
    {
    if ( kgs.pSemaphores[ ulSem ].szSemaName[ 0 ] == '\0' )
      continue;
    pSemCtrl = kgs.pSemaphores + ulSem;
    pSemCtrl->lGetCount        = 0;
    pSemCtrl->lWaitCount       = 0;
    pSemCtrl->lCollisionCount  = 0;
    pSemCtrl->lBegExclTasCount = 0;
    pSemCtrl->lEndExclTasCount = 0;
    }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_reset_io_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_reset_io_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_RESET_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_reset_io_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_reset_io_info"
  ULONG           ulDevspace;
  ULONG           ulDevi;
  PDEVI_CTRL_REC  pDeviCtrl;
  PUKT_CTRL_REC   pTmpUKTCtrl;

  for ( ulDevspace = 0;
        ulDevspace < (ULONG)XPARAM(lMaxDevspaces);
        ulDevspace++ )
  {
    if ( kgs.Dev0.pIOCtrl[ulDevspace].szDevspace[0] == '\0' )
      continue;

    for ( ulDevi = 0; ulDevi < (ULONG) XPARAM(lDeviPerDevspace); ulDevi++ )
    {
      pDeviCtrl = kgs.pFirstDeviCtrl +
                  ulDevspace * XPARAM(lDeviPerDevspace) + ulDevi;

      if ( pDeviCtrl->ThrdCtrlHeader.ThrdState != KT_INITIALIZED )
      {
        pDeviCtrl->DevIOStat.ulMaxIOQueLen = 0;
        pDeviCtrl->DevIOStat.ResetPending = true;
      }
    }

    for (pTmpUKTCtrl  = kgs.pFirstUKTCtrl;
         pTmpUKTCtrl <= kgs.pLastUKTCtrl;
         pTmpUKTCtrl++)
    {
      pTmpUKTCtrl->pSingleIO[ulDevspace].lReadCntr  = 0;
      pTmpUKTCtrl->pSingleIO[ulDevspace].lWriteCntr = 0;
    }

  }
  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_reset_task_count_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_reset_task_count_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_RESET_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_reset_task_count_info ( PCONSOLE_REC  pConsoleRec ,
                                           BOOLEAN       fAllTaskCounts )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_reset_task_count_info"
  PTASK_CTRL_REC                 pCurrTaskCtrl;

  for (pCurrTaskCtrl =  kgs.pFirstTaskCtrl;
       pCurrTaskCtrl <= kgs.pLastTaskCtrl;
       pCurrTaskCtrl++)
  {
      pCurrTaskCtrl->TaskStatRecResetPending = ( fAllTaskCounts ? EO52_RESET_TASK_FULL_PENDING : EO52_RESET_TASK_PARTIAL_PENDING );
  }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_reset_queue_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_reset_queue_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_RESET_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_reset_queue_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_reset_queue_info"
  PTASK_CTRL_REC    pCurrTaskCtrl;

  for (pCurrTaskCtrl =  kgs.pFirstTaskCtrl ;
       pCurrTaskCtrl <= kgs.pLastTaskCtrl;
       pCurrTaskCtrl++)
  {
      pCurrTaskCtrl->QueueStatRecResetPending = true;
  }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_reset_ukt_sl_stat_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_reset_ukt_sl_stat_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_RESET_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_reset_ukt_sl_stat_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_reset_ukt_sl_stat_info"
  PUKT_CTRL_REC                  pTmpUKTCtrl;

  for (pTmpUKTCtrl  = kgs.pFirstUKTCtrl;
       pTmpUKTCtrl <= kgs.pLastUKTCtrl;
       pTmpUKTCtrl++)
  {
     pTmpUKTCtrl->SleepStatRecResetPending = true;
  }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_reset_suspends_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_reset_suspends_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_RESET_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_reset_suspends ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_reset_suspends"

  memset ( kgs.ulSuspendReasons, 0 , sizeof(ULONG) * MAX_SUSPEND_REASONS ) ;

  DBGOUT;
  return;
  }

/*------------------------------*/

static VOID sql82k_reset_all ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_reset_all"

  sql82k_reset_task_count_info  ( pConsoleRec, ALL_TASK_COUNTS  ) ;
  sql82k_reset_ukt_sl_stat_info ( pConsoleRec ) ;
  sql82k_reset_io_info          ( pConsoleRec ) ;
  sql82k_reset_region_info      ( pConsoleRec ) ;
  sql82k_reset_suspends         ( pConsoleRec ) ;

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_show_suspends_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_show_suspends_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_SHOW_SUSPEND_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_show_suspends ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_show_suspends"

  memcpy (pConsoleRec->Data.SuspendReasons.ulSuspends, kgs.ulSuspendReasons,
          sizeof ( pConsoleRec->Data.SuspendReasons ) );

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_show_param_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_show_param_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_GETPARAM_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_show_param    ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_show_param"

  memcpy (&pConsoleRec->Data.GetParamInfo.XParam , kgs.XParam ,
          sizeof ( RTE_XPARAM_REC ) );

  DBGOUT;
  return;
  }


/*------------------------------*/

static LONG sql82k_min_get_ukt_queues_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_ukt_queues_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_UKT_QUEUES_REC), ALIGNMENT_VALUE) +
                 ALIGN( sizeof(CONS_SINGLE_UKT_QUEUES_INFO_REC) *
                        kgs.ulNumOfUKTs, ALIGNMENT_VALUE)             +
                 ALIGN( sizeof(CONS_SINGLE_QUEUE_INFO_REC)      *
                        kgs.ulNumOfTasks, ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_ukt_queues ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_ukt_queues"
  PUKT_CTRL_REC                     pTmpUKTCtrl;
  ULONG                             ulUKTQueuesOffset;
  PCONS_SINGLE_UKT_QUEUES_INFO_REC  pUKTQueues;
  ULONG                             ulUKTSingleQueueOffset;
  PCONS_SINGLE_QUEUE_INFO_REC       pUKTSingleQueue;

  DBGIN;

  ulUKTQueuesOffset = ALIGN( sizeof(CONS_UKT_QUEUES_REC),
                                 ALIGNMENT_VALUE );
  pUKTQueues        = (PCONS_SINGLE_UKT_QUEUES_INFO_REC)
                                 ((PCHAR)&pConsoleRec->Data + ulUKTQueuesOffset);

  ulUKTSingleQueueOffset = ulUKTQueuesOffset +
                                 kgs.ulNumOfUKTs *
                                 sizeof ( CONS_SINGLE_UKT_QUEUES_INFO_REC) ;

  pUKTSingleQueue   = (PCONS_SINGLE_QUEUE_INFO_REC)
                                 ((PCHAR)&pConsoleRec->Data + ulUKTSingleQueueOffset);

  for (pTmpUKTCtrl  = kgs.pFirstUKTCtrl;
       pTmpUKTCtrl <= kgs.pLastUKTCtrl;
       pTmpUKTCtrl++, pUKTQueues++ )
     {
       pUKTQueues->Tid           = pTmpUKTCtrl->ThrdCtrlHeader.Tid;
       pUKTQueues->ulUKTIndex    = pTmpUKTCtrl->ulUKTIndex;

       sql82k_get_ukt_COM_queue ( pTmpUKTCtrl->pFirstInCOMQue, pUKTQueues,
                                  &ulUKTSingleQueueOffset, &pUKTSingleQueue ) ;

       sql82k_get_ukt_UKT_queue ( pTmpUKTCtrl->UKTQue.pLastUsedElem, pUKTQueues,
                                  &ulUKTSingleQueueOffset, &pUKTSingleQueue ) ;

       sql82k_get_ukt_RUN_queue ( pTmpUKTCtrl, pUKTQueues,
                                  &ulUKTSingleQueueOffset, &pUKTSingleQueue ) ;

     }

  pConsoleRec->Data.UKTQueues.ulUKTQueuesOffset = ulUKTQueuesOffset;
  pConsoleRec->Data.UKTQueues.lNumOfActiveUKTs  = kgs.ulNumOfUKTs;

  DBGOUT;
  return;
  }


/*------------------------------*/

static VOID sql82k_get_ukt_COM_queue (
                      PTASK_CTRL_REC                    pFirstInCOMQue,
                      PCONS_SINGLE_UKT_QUEUES_INFO_REC  pUKTQueues,
                      ULONG                            *pulUKTSingleQueueOffset,
                      PCONS_SINGLE_QUEUE_INFO_REC       *ppUKTSingleQueue)
{
  #undef  MF__
  #define MF__ MOD__"sql82k_get_ukt_COM_queue"

  PPTASK_CTRL_REC                   ppTmpTaskCtrl;

  DBGIN;

  for ( pUKTQueues->ulCOMQueueLen = 0,
        pUKTQueues->ulCOMQueueOffset = *pulUKTSingleQueueOffset,
        ppTmpTaskCtrl = &pFirstInCOMQue ;
        *ppTmpTaskCtrl;
        ppTmpTaskCtrl = &(*ppTmpTaskCtrl)->pNextInCOMQue )
             {
               (*ppUKTSingleQueue)->ulTaskIndex = (*ppTmpTaskCtrl)->ulTaskIndex;
               (*ppUKTSingleQueue)->PrioFlag    = (*ppTmpTaskCtrl)->PrioFlag;
               pUKTQueues->ulCOMQueueLen++ ;
               (*ppUKTSingleQueue)++ ;
               *pulUKTSingleQueueOffset += sizeof( CONS_SINGLE_QUEUE_INFO_REC );
             }
  DBGOUT;
  return;
}


/*------------------------------*/


static VOID sql82k_get_ukt_UKT_queue (
                      struct ukt_queue_record          *pLastUsedElem,
                      PCONS_SINGLE_UKT_QUEUES_INFO_REC  pUKTQueues,
                      ULONG                            *pulUKTSingleQueueOffset,
                      PCONS_SINGLE_QUEUE_INFO_REC      *ppUKTSingleQueue)
{
  #undef  MF__
  #define MF__ MOD__"sql82k_get_ukt_UKT_queue"

  PDLQ_REC                      pCurrReq;
  PTASK_CTRL_REC                pTmpTaskCtrl;

  DBGIN;

  pUKTQueues->ulUKTQueueLen    = 0;
  pUKTQueues->ulUKTQueueOffset = *pulUKTSingleQueueOffset;

  if ( pLastUsedElem != NULL )
    while ( (pCurrReq = pLastUsedElem->pRequest) != NULL )
      {
          if (NULL != (pTmpTaskCtrl = pCurrReq->pTaskCtrl))
          {
            (*ppUKTSingleQueue)->ulTaskIndex = pTmpTaskCtrl->ulTaskIndex;
            (*ppUKTSingleQueue)->PrioFlag    = pTmpTaskCtrl->PrioFlag;
            pUKTQueues->ulUKTQueueLen++ ;
            (*ppUKTSingleQueue)++ ;
            *pulUKTSingleQueueOffset += sizeof( CONS_SINGLE_QUEUE_INFO_REC );
          }

        pLastUsedElem           = pLastUsedElem->pNextElem;
      }

  DBGOUT;
  return;
}


/*------------------------------*/


static VOID sql82k_get_ukt_RUN_queue (
                      PUKT_CTRL_REC                     pUKT,
                      PCONS_SINGLE_UKT_QUEUES_INFO_REC  pUKTQueues,
                      ULONG                            *pulUKTSingleQueueOffset,
                      PCONS_SINGLE_QUEUE_INFO_REC      *ppUKTSingleQueue)
{
  #undef  MF__
  #define MF__ MOD__"sql82k_get_ukt_RUN_queue"

  PTASK_CTRL_REC                pTmpTaskCtrl;
  ULONG                         uldx;
  PUKT_RUN_QUEUE_REC            pRUNQue;
  PDLQ_REC                      pCurrReq;

  DBGIN;

  pRUNQue = pUKT->RUNQue;
  pUKTQueues->ulRUNQueueLen    = 0;
  pUKTQueues->ulRUNQueueOffset = *pulUKTSingleQueueOffset;

  for ( uldx = 0; uldx < pUKT->ulRUNQueueLen; uldx++ )
    {
        if (NULL != (pTmpTaskCtrl = pRUNQue[uldx].pTaskCtrl))
        {
            (*ppUKTSingleQueue)->ulTaskIndex = pTmpTaskCtrl->ulTaskIndex;
            (*ppUKTSingleQueue)->PrioFlag    = pTmpTaskCtrl->PrioFlag;
            (*ppUKTSingleQueue)->ulDynPrio   = pTmpTaskCtrl->ulDynPrio;
            (*ppUKTSingleQueue)->TaskState   = pTmpTaskCtrl->TaskState;
            pCurrReq = pRUNQue[uldx].pRequest ;
            (*ppUKTSingleQueue)->ulReqType   = pCurrReq ?
                                                pCurrReq->ulReqType : UNDEF ;
            pTmpTaskCtrl                     = pRUNQue[uldx].pFromTaskCtrl ;
            (*ppUKTSingleQueue)->ulFromTask  = pTmpTaskCtrl ?
                                                pTmpTaskCtrl->ulTaskIndex : UNDEF ;
            (*ppUKTSingleQueue)++ ;
            pUKTQueues->ulRUNQueueLen++;
            *pulUKTSingleQueueOffset += sizeof( CONS_SINGLE_QUEUE_INFO_REC );
        }
    }

  DBGOUT;
  return;
}

/*------------------------------*/

static LONG sql82k_min_force_io_error_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_force_io_error_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_FORCE_IO_ERROR_REC), ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_force_io_error ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_force_io_error"

  LONG lDevspaceNo = pConsoleRec->Data.ForceIOError.ulDevno ;

  if ( lDevspaceNo >= 0 && lDevspaceNo < XPARAM(lMaxDevspaces) )
    {
      PDEVI_CTRL_REC             pDeviCtrl ;
      pDeviCtrl = kgs.pFirstDeviCtrl + lDevspaceNo * XPARAM(lDeviPerDevspace) ;
      if ( pConsoleRec->Data.ForceIOError.fErrOnRead )
        pDeviCtrl->lForceIOError = 0x100 | DEV_READ  ;
      else
        pDeviCtrl->lForceIOError = 0x100 | DEV_WRITE ;
    }

  DBGOUT;
  return;
}

/*------------------------------*/

static LONG sql82k_min_get_awe_info_shm_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_get_awe_info_shm_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_AWE_INFO_REC), ALIGNMENT_VALUE)       +
                 ALIGN( sizeof(CONS_AWE_MAP_PAGE_INFO_REC) *
                        RTEMem_AWENumOfMapAreaPages(),  ALIGNMENT_VALUE)  +
                 ALIGN( sizeof(CONS_AWE_PHYS_PAGE_INFO_REC) *
                        RTEMem_AWENumOfPhysicalPages(),  ALIGNMENT_VALUE);

  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_get_awe_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_get_awe_info"
  ULONG                          ulIdx = 0;
  ULONG                          ulAWEPhysPageInfoOffset;
  ULONG                          ulAWEMapPageInfoOffset;
  PCONS_AWE_PHYS_PAGE_INFO_REC   pAWEPhysPageInfos;
  PCONS_AWE_MAP_PAGE_INFO_REC    pAWEMapPageInfos;
  SAPDB_UInt4                    MapPageIdx;
  SAPDB_UInt4                    NumOfAWEMapPageInfos = 0;
  SAPDB_UInt4                    PhysPageNo;
  SAPDB_UInt4                    ulNumOfPhysPages = RTEMem_AWENumOfPhysicalPages();
  bool                           Reserved;
  SAPDB_UInt8                    MapCount;
  void *                         pMappingPageAddr;
  bool                           Ok;

  DBGIN;

  if ( RTEMem_AWEAvailable() )
  {
    ulAWEMapPageInfoOffset  = ALIGN( sizeof(CONS_AWE_INFO_REC), ALIGNMENT_VALUE);
    pAWEMapPageInfos        = (PCONS_AWE_MAP_PAGE_INFO_REC)
                              ((PCHAR)&pConsoleRec->Data + ulAWEMapPageInfoOffset);

    pConsoleRec->Data.AWEInfo.AWEAvailable           = true;
    pConsoleRec->Data.AWEInfo.NumOfPhysPages         = RTEMem_AWENumOfPhysicalPages();
    pConsoleRec->Data.AWEInfo.NumOfFreePhysPages     = RTEMem_AWENumOfFreePhysicalPages();
    pConsoleRec->Data.AWEInfo.NumOfMapAreaPages      = RTEMem_AWENumOfMapAreaPages();
    pConsoleRec->Data.AWEInfo.NumOfFreeMapAreaPages  = RTEMem_AWENumOfFreeMapAreaPages();
    pConsoleRec->Data.AWEInfo.NumOfMaps              = RTEMem_AWENumOfMaps();
    pConsoleRec->Data.AWEInfo.NumOfUnMaps            = RTEMem_AWENumOfUnMaps();

    Ok = RTEMem_AWEGetFirstMapPageInfo( &MapPageIdx, &pMappingPageAddr, &PhysPageNo, &Reserved, &MapCount );

    while ( Ok )
    {
      pAWEMapPageInfos[NumOfAWEMapPageInfos].pMappingPageAddr = pMappingPageAddr;
      pAWEMapPageInfos[NumOfAWEMapPageInfos].PhysPageNo       = PhysPageNo;
      pAWEMapPageInfos[NumOfAWEMapPageInfos].Reserved         = Reserved ? 1 : 0;
      pAWEMapPageInfos[NumOfAWEMapPageInfos].MapCount         = MapCount;

      NumOfAWEMapPageInfos++;

      Ok = RTEMem_AWEGetNextMapPageInfo ( &MapPageIdx, &pMappingPageAddr, &PhysPageNo, &Reserved, &MapCount );
    }

    ulAWEPhysPageInfoOffset = ulAWEMapPageInfoOffset + 
                              ALIGN( sizeof(CONS_AWE_MAP_PAGE_INFO_REC) * NumOfAWEMapPageInfos, ALIGNMENT_VALUE);
    pAWEPhysPageInfos       = (PCONS_AWE_PHYS_PAGE_INFO_REC)
                              ((PCHAR)&pConsoleRec->Data + ulAWEPhysPageInfoOffset);

    for ( PhysPageNo = 0; 
          RTEMem_AWEGetPhysPageInfo(PhysPageNo, &Reserved, &MapCount );
          PhysPageNo++ )
    {
      pAWEPhysPageInfos[ PhysPageNo ].Reserved = Reserved ? 1 : 0;
      pAWEPhysPageInfos[ PhysPageNo ].MapCount = MapCount;
    }

    pConsoleRec->Data.AWEInfo.NumOfAWEPhysPageInfos   = PhysPageNo;
    pConsoleRec->Data.AWEInfo.NumOfAWEMapPageInfos    = NumOfAWEMapPageInfos;
    pConsoleRec->Data.AWEInfo.ulAWEMapPageInfoOffset  = ulAWEMapPageInfoOffset;
    pConsoleRec->Data.AWEInfo.ulAWEPhysPageInfoOffset = ulAWEPhysPageInfoOffset;
  }
  else
  {
    pConsoleRec->Data.AWEInfo.AWEAvailable = false;
  }

  DBGOUT;
  return;
  }

/*------------------------------*/

static LONG sql82k_min_show_task_move_info_size ( VOID )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_min_show_task_move_info_size"
  ULONG   ulMinShmSize;

  DBGPAS;

  ulMinShmSize = ALIGN( sizeof(CONS_TASK_MOVE_INFO_REC), ALIGNMENT_VALUE)                                  +
                 ALIGN( sizeof(CONS_SINGLE_UKT_MOVE_INFO_REC) * kgs.ulNumOfUKTs, ALIGNMENT_VALUE)          +
                 ALIGN( sizeof(CONS_SINGLE_UKT_MOVE_INFO_REC) * 
                        sizeof(kgs.LastTaskMoves.Entries) / sizeof(kgs.LastTaskMoves.Entries[0]), ALIGNMENT_VALUE);
  
  return ( ulMinShmSize );
  }

/*------------------------------*/

static VOID sql82k_show_set_check_interval ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_show_set_check_interval"

  if ( pConsoleRec->Data.SetCheckInterval.CheckIntervalTime < 15 )
    pConsoleRec->Data.SetCheckInterval.usReturnCode = CON_WRONG_VALUE;
  else
    {
    XPARAM(uLoadBalancingCheck) = pConsoleRec->Data.SetCheckInterval.CheckIntervalTime;
    sql72k_wake_kt ( &kgs.Timer.ThrdCtrlHeader );

    pConsoleRec->Data.SetCheckInterval.usReturnCode = CON_NO_ERROR;
    }
  }

/*------------------------------*/

static VOID sql82k_show_task_move_info ( PCONSOLE_REC  pConsoleRec )
  {
  #undef  MF__
  #define MF__ MOD__"sql82k_show_task_move_info"
  PUKT_CTRL_REC                   pUKTCtrl, pMoveTaskToUKT;
  ULONG                           ulUKT;
  SAPDB_UInt2                     CurrEntry;
  SAPDB_UInt2                     Entries;
  ULONG                           ulUKTInfoOffset;
  PCONS_SINGLE_UKT_MOVE_INFO_REC  pUKTInfos;
  ULONG                           ulLastMovesInfoOffset;
  PCONS_LAST_MOVES_ENTRY          pLastMoves;
  SAPDB_UInt2                     PrevTimeVar = PREV_TIME_VAR(kgs.CurrTimeVar);


  DBGIN;

  pConsoleRec->Data.TaskMoveInfo.CheckIntervalTime         = XPARAM(uLoadBalancingCheck);
  pConsoleRec->Data.TaskMoveInfo.TaskMoveIntervalStartTime = kgs.TaskMoveIntervalStartTimes[kgs.CurrTimeVar];
  pConsoleRec->Data.TaskMoveInfo.TaskMoveMeasIntervals     = kgs.TaskMoveMeasIntervals;
  pConsoleRec->Data.TaskMoveInfo.ValueEquality             = XPARAM(uLoadBalancingEquality);
  pConsoleRec->Data.TaskMoveInfo.MinimumDiff               = XPARAM(uLoadBalancingDiff);
  

  ulLastMovesInfoOffset = ALIGN( sizeof(CONS_TASK_MOVE_INFO_REC), ALIGNMENT_VALUE);
  pLastMoves            = (PCONS_LAST_MOVES_ENTRY)
                               ((PCHAR)&pConsoleRec->Data + ulLastMovesInfoOffset);


  WAIT_UNTIL_ALONE(&kgs.LastTaskMoves.lExclusive);

  for ( CurrEntry = NEXT_ENTRY( kgs.LastTaskMoves.CurrEntry, NUM_OF_TASK_MOVE_STAT_RECS), Entries = 0; 
        CurrEntry != kgs.LastTaskMoves.CurrEntry;
        CurrEntry = NEXT_ENTRY( CurrEntry, NUM_OF_TASK_MOVE_STAT_RECS) )
    {
      if (( kgs.LastTaskMoves.Entries[CurrEntry].MoveTime  != 0 )    &&
          ( kgs.LastTaskMoves.Entries[CurrEntry].pTaskCtrl != NULL ) &&
          ( kgs.LastTaskMoves.Entries[CurrEntry].pSrcUKT   != NULL ) &&
          ( kgs.LastTaskMoves.Entries[CurrEntry].pDstUKT   != NULL ))
        {
        pLastMoves[Entries].MoveTime                    = kgs.LastTaskMoves.Entries[CurrEntry].MoveTime;
        pLastMoves[Entries].ulTaskIndex                 = kgs.LastTaskMoves.Entries[CurrEntry].pTaskCtrl->ulTaskIndex;
        pLastMoves[Entries].TaskMaxRunnableMicroSeconds = kgs.LastTaskMoves.Entries[CurrEntry].TaskMaxRunnableMicroSeconds;
        pLastMoves[Entries].ulSrcUKTIndex               = kgs.LastTaskMoves.Entries[CurrEntry].pSrcUKT->ulUKTIndex;
        pLastMoves[Entries].SrcMaxRunnableMicroSeconds  = kgs.LastTaskMoves.Entries[CurrEntry].SrcMaxRunnableMicroSeconds;
        pLastMoves[Entries].ulDstUKTIndex               = kgs.LastTaskMoves.Entries[CurrEntry].pDstUKT->ulUKTIndex;
        pLastMoves[Entries].DstMaxRunnableMicroSeconds  = kgs.LastTaskMoves.Entries[CurrEntry].DstMaxRunnableMicroSeconds;
        Entries++;
        }
    }

  CLEARLOCK(&kgs.LastTaskMoves.lExclusive);

  pConsoleRec->Data.TaskMoveInfo.lNumOfLastRecs        = Entries;
  pConsoleRec->Data.TaskMoveInfo.ulLastMovesInfoOffset = ulLastMovesInfoOffset;


  ulUKTInfoOffset = ALIGN( sizeof(CONS_LAST_MOVES_ENTRY) * Entries, ALIGNMENT_VALUE) + ulLastMovesInfoOffset;
  pUKTInfos       = (PCONS_SINGLE_UKT_MOVE_INFO_REC)
                      ((PCHAR)&pConsoleRec->Data + ulUKTInfoOffset);

  //
  // --- UKT Info
  //
  for ( pUKTCtrl =  kgs.pFirstUKTCtrl, ulUKT = 0;
        pUKTCtrl <= kgs.pLastUKTCtrl;
        pUKTCtrl++  )
    {
    if ( pUKTCtrl->TasksAllowedToMoveTo )
      {
      pMoveTaskToUKT                             = pUKTCtrl->pMoveTaskToUKT;

      pUKTInfos[ulUKT].ulUKTIndex                = pUKTCtrl->ulUKTIndex;
      pUKTInfos[ulUKT].ulMoveTaskToUKTUKTIndex   = pMoveTaskToUKT ? pMoveTaskToUKT->ulUKTIndex : -1;
      pUKTInfos[ulUKT].NumOfMovableTasks         = pUKTCtrl->NumOfMovableTasks;
      pUKTInfos[ulUKT].TaskMoveIntervalStartTime = pUKTCtrl->TaskMoveIntervalStartTime;
      pUKTInfos[ulUKT].UKTSleepTimeMicroSeconds  = pUKTCtrl->UKTSleepTimeMicroSeconds[PrevTimeVar];
      pUKTInfos[ulUKT].RunnableMicroSeconds      = pUKTCtrl->RunnableMicroSeconds[PrevTimeVar];
      pUKTInfos[ulUKT].MaxRunnableMicroSeconds   = pUKTCtrl->MaxRunnableMicroSeconds[PrevTimeVar];
	    ulUKT++;
      }

    }

  pConsoleRec->Data.TaskMoveInfo.ulUKTInfoOffset = ulUKTInfoOffset;
  pConsoleRec->Data.TaskMoveInfo.lNumOfUKTs      = ulUKT;

  DBGOUT;
  return;
  }

/*
 * =============================== END ========================================
 */
