/*!**************************************************************************

  module      : vos903.c

  -------------------------------------------------------------------------

  responsible : RaymondR

  special area: 
  description : 


  last changed: 2001-09-21  15:00
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin LGPL
  Copyright (C) 2001 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/



#define MOD__ "vos903c"
#include "gsp00.h"
#include "gos00.h"
#include "gsp09.h"


/**\
--------------------------------------- MF__ MOD__ (imports)
\**/

/**\
--------------------------------------- MF__ MOD__ (module functions)
\**/

/**\
--------------------------------------- MF__ MOD__ (module variables)
\**/
tsp00_DbNamec                           dbname_MV;
char                                    dbroot_MV[512];

/**\
--------------------------------------- MF__ MOD__ (session)
\**/

    #undef MF__
    #define MF__ MOD__"sqlxinit"
void
sqlxinit (
    tsp9_cstr dbname,
    tsp9_cstr dbroot)
{
    if (dbname != NULL) {
        strcpy (dbname_MV, dbname);
    }
    else {
        dbname_MV [0] = '\0';
    }    
    if (dbroot != NULL) {
        strcpy (dbroot_MV, dbroot);
    }
    else {
        dbroot_MV [0] = '\0';
    }    

   /* disable message output */
   sql60_disable_GUI_console();
   sql60_disable_message_box ();
   sql60_disable_console ();
}

    #undef MF__
    #define MF__ MOD__"sqlxfinish"
void
sqlxfinish (void)
{
    dbname_MV [0] = '\0';
    dbroot_MV [0] = '\0';
}

/**\
--------------------------------------- MF__ MOD__ (session parameters)
\**/

tsp9_cstr
os903dbname (void)
{
    return dbname_MV;
}

tsp9_cstr
os903dbroot (void)
{
    return dbroot_MV;
}

/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/