/*!**************************************************************************

  module      : vos91c.c

  -------------------------------------------------------------------------

  responsible : RaymondR

  special area: Stop
  description : 


  last changed: 2001-09-21  15:39
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2001

  ========== licence begin LGPL
  Copyright (C) 2001 SAP AG

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  ========== licence end

*****************************************************************************/



/*
 * INCLUDE FILES
 */
#include "gos00.h"
#include "heo00.h"
#include "heo46.h"
#include "gos00k.h"
#include "geo007_2.h"

#include           <stdarg.h>


/*
 *  DEFINES
 */
#define MOD__  "VOS91CC : "
#define MF__   MOD__"UNDEFINED"


#if defined(_WIN32)
 #if defined(RUN_AS_SERVICE)
  #define OPTION_STRING             "d:n:p"
 #else
  #define OPTION_STRING             "d:p"
 #endif
#else
 #define OPTION_STRING             "d:p"
#endif

/*
 *  MACROS
 */


/*
 *  LOCAL TYPE AND STRUCT DEFINITIONS
 */


/*
 * EXTERNAL VARIABLES
 */

extern int        sql80_OptInd;
extern int        sql80_OptErr;
extern char*      sql80_OptArg;


/*
 *  EXPORTED VARIABLES
 */


/*
 * LOCAL VARIABLES
 */

/*
 * LOCAL FUNCTION PROTOTYPES
 */


/*
 * ========================== GLOBAL FUNCTIONS ================================
 */

INT main (INT    argc, CHAR   *argv[])
  {
  #undef  MF__
  #define MF__ MOD__"main"
  INT                                    OptionChar;
  APIRET                                 rc                    = NO_ERROR;
  PSZ                                    pszServerDB           = NULL;
  PSZ                                    pszNodeName           = NULL;
  BOOL                                   fCommandError         = FALSE;
  BOOL                                   fDump                 = FALSE;
   BOOL                                  fStopService          = TRUE;

  DBGIN;

  while ( (OptionChar = sql80_GetOpt ( argc, argv, OPTION_STRING )) != -1 )
    {
    switch ( OptionChar )
      {
      case 'd' :
              pszServerDB = sql80_OptArg;
              break;
      case 'n' :
              if ( fDump == FALSE )
                pszNodeName   = sql80_OptArg;
              else
                fCommandError = TRUE;
              break;

      case 'p' :
              if ( pszNodeName == NULL )
                {
                fDump        = TRUE;
                fStopService = FALSE;
                }
              else
                fCommandError = TRUE;
              break;
      default :
              fCommandError = TRUE;
      }
    }

  if (( argc - sql80_OptInd )   ||
      ( fCommandError == TRUE ) ||
      ( pszServerDB   == NULL ))
    {
    #if defined(_WIN32)
     if (( sql02_get_platform_id() == VER_PLATFORM_WIN32_NT ))
       {
       printf (XSTOP_USAGE_NT);
       exit(0);
       }
    #endif

    printf (XSTOP_USAGE);
    exit(0);
    }

  #if defined(_WIN32)
  if (( sql02_get_platform_id() == VER_PLATFORM_WIN32_NT ) &&
      ( fStopService            == TRUE ))
     {
     rc = sql90_stop_db_gw_service ( pszNodeName, pszServerDB );
     DBGOUT;
     return( rc );
     }
  #endif

  rc = sql90_stop_serverdb ( pszServerDB, fDump );


  DBGOUT;
  return( rc );
  }
/*
 * ========================== LOCAL FUNCTIONS =================================
 */

/*
 * =============================== END ========================================
 */
