/*!================================================================

  module:       vpi01GetModuleName.h

 -------------------------------------------------------------------

  responsible:  ThomasS

  special area: Gets module name of executable

  description:                 
                Gets the module name without use of argc, argv
		on Win and UNIX.


  see also:

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 ===================================================================*/

#ifndef __VPI01_GETMODULENAME_H__
#define __VPI01_GETMODULENAME_H__

/*==================================================================*
 *  INCLUDES                                                        *
 *==================================================================*/

/*==================================================================*
 *  DECLARATIONS                                                    *
 *==================================================================*/
#ifdef __cplusplus
extern "C" {                         /* Assume C declarations for C++ */
#endif  /* __cplusplus */

char *vpi01ModuleName (FILE *);
  
/*==================================================================*
 *  EXTERNAL PROTOTYPES                                             *
 *==================================================================*/
  
/*==================================================================*
 *  EXTERNAL VARIABLES                                              *
 *==================================================================*/

#ifdef __cplusplus
}                                    /* End of extern "C" { */
#endif  /* __cplusplus */
#endif /* __VPI01_GETMODULENAME__ */

