/* @lastChanged: "1998-05-08  13:57"
 * @filename:    gsp05.h
 * @purpose:     "virtual file basic_constants_and_types"
 * @release:     M.m.c.p
 * @see:         ""
 *
 * @copyright:   "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */


#ifndef GSP05_H
#define GSP05_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

#define  SP5VFW_NO_WARNING         0
#define  SP5VFW_NO_EOL_FOUND       1
#define  SP5VFW_NO_NEXT_TAPE       2
#define  SP5VFW_ALREADY_LOCKED     3
typedef  signed char tsp5_rte_filewarning;
 
 
typedef  struct tsp5_rte_fileerror {
 tsp_vf_return sp5fe_result;
 tsp5_rte_filewarning sp5fe_warning;
 tsp_c2 filler;
 tsp_c40 sp5fe_text;
} tsp5_rte_fileerror;
 
 
 
#define  SP5VF_TEXT        0
#define  SP5VF_BINARY      1
#define  SP5VF_ENCODED     2
typedef  signed char tsp5_rte_datakind;
 
 
#define  SP5VF_READ        0
#define  SP5VF_WRITE       1
#define  SP5VF_READWRITE   2
#define  SP5VF_APPEND      3
typedef  signed char tsp5_rte_filemode;
 
 
#define  SP5BK_BUFFERED    0
#define  SP5BK_UNBUFFERED  1
#define  SP5BK_DISKSYNCED  2
typedef  signed char tsp5_rte_buffering_kind;
 
 
#define  SP5VF_CLOSE_NORMAL        0
#define  SP5VF_CLOSE_REWIND        1
#define  SP5VF_CLOSE_NEXT_TAPE     2
typedef  signed char tsp5_rte_closeoption;
 
 
#define  SP5VF_SEEK_BEGIN  0
#define  SP5VF_SEEK_CUR    1
#define  SP5VF_SEEK_END    2
typedef  signed char tsp5_rte_seekkind;

typedef  struct tsp5_rte_fileinfo {
 boolean sp5fi_exists;
 boolean sp5fi_readable;
 boolean sp5fi_writeable;
 boolean sp5fi_is_link;
 tsp_longint sp5fi_size;
 tsp_longint sp5fi_size_x;
 teo00_Uint8 sp5fi_size64; /* PTS 1105446 */
 tsp_date sp5fi_date_modified;
 tsp_time sp5fi_time_modified;
 tsp_vf_type sp5fi_media_kind;
} tsp5_rte_fileinfo;

typedef enum tsp05_SpecialdevKind {
    sdk_none_sp05,
    sdk_tapes_sp05,
    sdk_drives_sp05
} tsp05_SpecialdevKind;

typedef struct tsp05_SpecialEnumeration tsp05_SpecialEnumeration;


#endif  /* GSP05_H */
