
/*******************************************************************************

  module:       hsp26.h

  ------------------------------------------------------------------------------

  responsible:  JuergenA

  purpose:      Packet_handling

  lastChanged:  1999-08-02

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

********************************************************************************/

#ifndef HSP26_H
#define HSP26_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\357\304\3761\202L\006\232\003d\336\300U@\362\027'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "vsp001.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void s26find_part (
    tsp1_segment          VAR_VALUE_REF segm,
    tsp1_part_kind_Param                part_kind,
    tsp1_part_ptr         VAR_VALUE_REF part_ptr);

externPascal void s26finish_part (
    tsp1_packet_ptr                     packet_ptr,
    tsp1_part             VAR_VALUE_REF finish_part);

externPascal void s26first_segment_init (
    tsp1_packet_ptr                     packet_ptr,
    tsp1_segment_kind_Param             segm_kind,
    tsp1_segment_ptr      VAR_VALUE_REF first_segm_ptr);

externPascal void s26init_cmd_packet (
    tsp1_packet_ptr                     packet_ptr,
    tsp1_segment_ptr      VAR_VALUE_REF first_segm_ptr);

externPascal void s26new_part_init (
    tsp1_packet_ptr                     packet_ptr,
    tsp1_segment          VAR_VALUE_REF segm,
    tsp1_part_ptr         VAR_VALUE_REF new_part_ptr);

externPascal void s26new_segment_init (
    tsp1_packet_ptr                     packet_ptr,
    tsp1_segment_kind_Param             segm_kind,
    tsp1_segment_ptr      VAR_VALUE_REF new_segm_ptr,
    tsp1_part_ptr         VAR_VALUE_REF first_part_ptr);

externPascal void s26next_segment (
    tsp1_segment_ptr      VAR_VALUE_REF segm_ptr);

externPascal void s26nextpart (
    tsp1_part_ptr         VAR_VALUE_REF part_ptr);

externPascal tsp_int4 s26packet_len (
    tsp1_packet_ptr                     packet_ptr);

externPascal tsp_int4 s26partlen (
    tsp1_part             VAR_VALUE_REF part);

externPascal tsp1_part_ptr s26partptr (
    tsp1_part             VAR_VALUE_REF part);

externPascal tsp1_segment_ptr s26segmptr (
    tsp1_segment          VAR_VALUE_REF segm);

externPascal tsp_int4 s26size_new_part (
    tsp1_packet_ptr                     packet_ptr,
    tsp1_segment          VAR_VALUE_REF segm);


#endif

