
/*******************************************************************************

  module:       hsp40.h.h

  ------------------------------------------------------------------------------

  responsible:  

  purpose:      Conversions from VDN-Numbers

  lastChanged:  2000-06-19

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

********************************************************************************/

#ifndef HSP40_H
#define HSP40_H


/*===========================================================================*
 *     RefType: Both                                                         *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: 'C5y\032\312\327\2454\363\034r0\030\352\262j'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void s40check (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40gsint (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    tsp_int2              VAR_VALUE_REF  dest,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40gsuns (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    tsp_int2              VAR_VALUE_REF  dest,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40glint (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    tsp_int4              VAR_VALUE_REF  dest,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40g4int (
    void                  *  buf,
    tsp_int4                             pos,
    tsp_int4              VAR_VALUE_REF  dest,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40g8int (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    tsp_longint           VAR_VALUE_REF  dest,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40gluns (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    tsp_int4              VAR_VALUE_REF  dest,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40gsrel (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    tsp_shortreal         VAR_VALUE_REF  dest,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40glrel (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    tsp_longreal          VAR_VALUE_REF  dest,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40gdec (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    tsp_decimal           VAR_ARRAY_REF  dest,
    integer                              dlen,
    integer                              dfrac,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40gzone (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_zoned             VAR_ARRAY_REF  dest,
    integer                              dlen,
    integer                              dfrac,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40glzon (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_zoned             VAR_ARRAY_REF  dest,
    integer                              dlen,
    integer                              dfrac,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40glszo (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_zoned             VAR_ARRAY_REF  dest,
    integer                              dlen,
    integer                              dfrac,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40gtszo (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_zoned             VAR_ARRAY_REF  dest,
    integer                              dlen,
    integer                              dfrac,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s40gbyte (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    void                  *  dest,
    tsp_int4                             dpos,
    integer                              dlen,
    pasbool               VAR_VALUE_REF  truncated);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

