
/*******************************************************************************

  module:       hsp41.h.h

  ------------------------------------------------------------------------------

  responsible:  

  purpose:      Conversions Into VDN-Numbers

  lastChanged:  2000-06-19

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

********************************************************************************/

#ifndef HSP41_H
#define HSP41_H


/*===========================================================================*
 *     RefType: Both                                                         *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\204\273\357\363\306\246B\027\356\342`\352\333\310a\261'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void s41psint (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_int2                             source,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41plint (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_int4                             source,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41p4int (
    void                  *  buf,
    tsp_int4                             pos,
    tsp_int4                             source,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41p8int (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_longint                          source,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41psuns (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_int2                             source,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41pluns (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_int4                             source,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41psrel (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_shortreal                        source,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41plrel (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_longreal                         source,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41pdec (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_decimal           VAR_ARRAY_REF  source,
    integer                              slen,
    integer                              sfrac,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41pzone (
    void                  *  buf,
    tsp_int4                             pos,
    integer                              len,
    integer                              frac,
    tsp_zoned             VAR_ARRAY_REF  source,
    integer                              slen,
    integer                              sfrac,
    tsp_num_error         VAR_VALUE_REF  res);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41pbyte (
    void                  *  buf,
    tsp_int4                             pos,
    integer               VAR_VALUE_REF  len,
    void                  *  source,
    tsp_int4                             spos,
    integer                              slen,
    pasbool               VAR_VALUE_REF  invalid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void s41p1byte (
    void                  *  buf,
    tsp_int4                             pos,
    integer               VAR_VALUE_REF  len,
    void                  *  source,
    tsp_int4                             spos,
    integer                              slen,
    pasbool               VAR_VALUE_REF  invalid);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

