/*!**********************************************************************

  module: hwd32hses.h

  -----------------------------------------------------------------------

  responsible:  Holger Bischoff
				Markus Oezgen

  special area: WebAgent

  description:  Session pool handle

  see also:

  -----------------------------------------------------------------------

                         Copyright by SAP AG, 1998


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

************************************************************************/

#ifndef HWD32HSES_H
#define HWD32HSES_H

/*=======================================================================
 *  INCLUDES
 *=====================================================================*/

#include "gwd00.h"
#include "hwd05wases.h"
#include "hwd26err.h"
#include "hwd30ses.h"

#if defined(__cplusplus)
extern "C" {
#endif

/*!**********************************************************************

  Chapter: sapdbwa_SessionPoolP

  description:
  
************************************************************************/

sapdbwa_SessionPoolP wd32CreatePoolHandle( twd30SessionPoolP	pool,
										   sapdbwa_UInt4		userDllId );

void wd32DestroyPoolHandle( sapdbwa_SessionPoolP	pool );

/* same as sapdbwa_DbConnect but with additional err parameter */
sapdbwa_DbConnectionP wd32DbConnect( sapdbwa_SessionPoolP	pool,
									 twd26ErrP				err	);

/* only allowed for implicitely allocated handles */    
sapdbwa_SessionPoolP wd32ClonePoolHandle( sapdbwa_SessionPoolP	source );

/*!**********************************************************************

  EndChapter: sapdbwa_SessionPoolP

************************************************************************/
#if defined(__cplusplus)
} /* extern "C" */
#endif

#endif
